local DGV = DugisGuideViewer
if not DGV then return end
local L = DugisLocals

local GA = DGV:RegisterModule("GearAdvisor")
GA.essential = true
local _
local StatLogic = LibStub("LibStatLogic-1.2-Dugi")
local TipHooker = LibStub("LibTipHooker-1.1")
local select, GetAuctionItemClasses, GetAuctionItemSubClasses, GetExpertise, GetCombatRatingBonus, GetHitModifier, GetSpellHitModifier, GetMeleeHaste, GetRangedHaste, UnitSpellHaste = 
	select, GetAuctionItemClasses, GetAuctionItemSubClasses, GetExpertise, GetCombatRatingBonus, GetHitModifier, GetSpellHitModifier, GetMeleeHaste, GetRangedHaste, UnitSpellHaste
local GetCritChance, GetSpellCritChance, GetRangedCritChance, GetQuestLogChoiceInfo, GetQuestLogRewardInfo, GetQuestLogItemLink, GetQuestItemLink, GetQuestItemInfo, GetNumBankSlots = 
	GetCritChance, GetSpellCritChance, GetRangedCritChance, GetQuestLogChoiceInfo, GetQuestLogRewardInfo, GetQuestLogItemLink, GetQuestItemLink, GetQuestItemInfo, GetNumBankSlots
local GetContainerItemLink, BANK_CONTAINER_INVENTORY_OFFSET, EQUIPPED_FIRST, EQUIPPED_LAST, NUM_BANKGENERIC_SLOTS, BACKPACK_CONTAINER = 
	GetContainerItemLink, BANK_CONTAINER_INVENTORY_OFFSET,EQUIPPED_FIRST, EQUIPPED_LAST, NUM_BANKGENERIC_SLOTS, BACKPACK_CONTAINER
local UnitClass, GetInventoryItemLink, GetItemInfo, UnitLevel, GetInventoryItemID, GetCreateTable, QueueInvocation, strformat, RegisterReaction, RegisterFunctionReaction, RegisterMemberFunctionReaction, RegisterStopwatchReaction, TryGetCacheReaction, ListContains, PackStrings = 
		UnitClass, GetInventoryItemLink, GetItemInfo, UnitLevel, GetInventoryItemID, DGV.GetCreateTable, DGV.QueueInvocation, string.format, DGV.RegisterReaction, DGV.RegisterFunctionReaction, DGV.RegisterMemberFunctionReaction, DGV.RegisterStopwatchReaction, DGV.TryGetCacheReaction, DGV.ListContains, DGV.PackStrings
local BeginAutoroutine, InterruptAutoroutine, YieldAutoroutine, tPool, DoOutOfCombat, GetRunningAutoroutine = 
	DGV.BeginAutoroutine, DGV.InterruptAutoroutine, DGV.YieldAutoroutine, DGV.tPool, DGV.DoOutOfCombat, DGV.GetRunningAutoroutine
    
    
DugisGuideViewer.defaultLevelingSpec = {
    ["DEATHKNIGHT"] = {["index"] = 1, ["orderIndex"] = 1},
    ["MONK"] = {["index"] = 3, ["orderIndex"] = 2},
    ["WARRIOR"] = {["index"] = 1, ["orderIndex"] = 3},
    ["PALADIN"] = {["index"] = 3, ["orderIndex"] = 4},
    ["DRUID"] = {["index"] = 2, ["orderIndex"] = 5},
    ["ROGUE"] = {["index"] = 1, ["orderIndex"] = 6},
    ["SHAMAN"] = {["index"] = 2, ["orderIndex"] = 7},
    ["HUNTER"] = {["index"] = 1, ["orderIndex"] = 8},
    ["MAGE"] = {["index"] = 1, ["orderIndex"] = 9},
    ["PRIEST"] = {["index"] = 3, ["orderIndex"] = 10},
    ["WARLOCK"] = {["index"] = 2, ["orderIndex"] = 11}
}    
        
local weightIdentifier2weightLabelMap = {
    ["AGI"] = "Agility"
    ,["AP"] = "Attack Power"
    ,["ARMOR"] = "Armor"
    ,["BONUS_ARMOR"] = "Bonus Armor"
    ,["AVOIDANCE_RATING"] = "Avoidance"
    ,["DPS"] = "DPS"
    ,["DPS|MAIN"] = "DPS - Main"
    ,["DPS|OFF"] = "DPS - Off"
    ,["INT"] = "Intellect"
    ,["LEECH_RATING"] = "Leech"
    ,["MASTERY_RATING"] = "Mastery"
    ,["MELEE_CRIT_RATING"] = "Critical Rating"
    ,["MELEE_HASTE_RATING"] = "Haste Rating"
    ,["MULTISTRIKE_RATING"] = "Multistrike"
    ,["RANGED_CRIT_RATING"] = "Critical Rating"
    ,["RANGED_HASTE_RATING"] = "Haste Rating"
    ,["SPELL_CRIT_RATING"] = "Critical Rating"
    ,["SPELL_HASTE_RATING"] = "Haste Rating"
    ,["SPELL_POWER"] = "Spell Power"
    ,["SPELL_DMG"] = "Spell Power"
    ,["SPI"] = "Spirit"
    ,["STA"] = "Stamina"
    ,["STR"] = "Strength"
    ,["VERSATILITY_RATING"] = "Versatility"
    ,["XP_BONUS"] = "XP Bonus"
}    
		
function GA:Initialize()

    if Storyline_NPCFrameRewardsItem then
        local oldOnClickScript = Storyline_NPCFrameRewardsItem:GetScript("OnClick")
        Storyline_NPCFrameRewardsItem:SetScript("OnClick", function() 
            oldOnClickScript(Storyline_NPCFrameRewardsItem)
            GA.EvaluateRewards()
        end) 
        
        Storyline_NPCFrameRewards.Content:SetScript("OnShow", function() 
            GA.EvaluateRewards()
        end)
    end
    
	--[[Dump: value=GetAuctionItemSubClasses(1)
	[1]="One-Handed Axes",
	[2]="Two-Handed Axes",
	[3]="Bows",
	[4]="Guns",
	[5]="One-Handed Maces",
	[6]="Two-Handed Maces",
	[7]="Polearms",
	[8]="One-Handed Swords",
	[9]="Two-Handed Swords",
	[10]="Staves",
	[11]="Fist Weapons",
	[12]="Miscellaneous",
	[13]="Daggers",
	[14]="Thrown",
	[15]="Crossbows",
	[16]="Wands",
	[17]="Fishing Poles"]]
	
	--[[Dump: value=GetAuctionItemSubClasses(2)
	[1]="Miscellaneous",
	[2]="Cloth",
	[3]="Leather",
	[4]="Mail",
	[5]="Plate",
	[6]="Cosmetic",
	[7]="Shields"]]
	local ITEM_CLASS_WEAPON, ITEM_CLASS_ARMOR = 1, 2
	local ARMOR_SUBCLASS_COSMETIC, ARMOR_SUBCLASS_SHIELDS = 6, 7
	local WEAPON_SUBCLASS_FISHING_POLE = 17
	local WEAPON_SUBCLASS_BOW, WEAPON_SUBCLASS_GUN, WEAPON_SUBCLASS_CROSSBOW = 3, 4, 15
	local WEAPON_SUBCLASS_POLEARMS, WEAPON_SUBCLASS_STAVES = 7, 10 
	local WEAPON_SUBCLASS_TWO_HANDED_AXES, WEAPON_SUBCLASS_TWO_HANDED_MACES, WEAPON_SUBCLASS_TWO_HANDED_SWORDS = 2, 6, 9
	
	local scoring = {
        ["DEATHKNIGHT:1"] =           "ARMOR_SPECIALIZATION_STAT,STA:ITEM_CLASS_WEAPON,1,2,5,6,7,8,9:ITEM_CLASS_ARMOR,1,2,3,4,5:XP_BONUS,1000:DPS,0.2:STR,1.0:STA,0.3:MASTERY_RATING,0.5:MULTISTRIKE_RATING,0.75:VERSATILITY_RATING,0.39:ARMOR,0.7:BONUS_ARMOR,0.8:MELEE_CRIT_RATING,0.4:AP,0.1:AVOIDANCE_RATING,0.15:LEECH_RATING,0:MELEE_HASTE_RATING,0.32:AGI,0:INT,0:SPELL_DMG,0:SPI,0",
        ["DEATHKNIGHT:1:PVP"] =       "ARMOR_SPECIALIZATION_STAT,STA:ITEM_CLASS_WEAPON,1,2,5,6,7,8,9:ITEM_CLASS_ARMOR,1,2,3,4,5:XP_BONUS,1000:DPS,0.2:STR,1.0:STA,0.3:MASTERY_RATING,0.5:MULTISTRIKE_RATING,0.75:VERSATILITY_RATING,0.39:ARMOR,0.7:BONUS_ARMOR,0.8:MELEE_CRIT_RATING,0.4:AP,0.1:AVOIDANCE_RATING,0.15:LEECH_RATING,0:MELEE_HASTE_RATING,0.32:AGI,0:INT,0:SPELL_DMG,0:SPI,0",
        ["DEATHKNIGHT:2"] =           "ARMOR_SPECIALIZATION_STAT,STR:ITEM_CLASS_WEAPON,1,2,5,6,7,8,9:ITEM_CLASS_ARMOR,1,2,3,4,5:XP_BONUS,1000:DPS,1.55:DPS|MAIN,0.95:DPS|OFF,0.46:STR,1:MULTISTRIKE_RATING,0.44:VERSATILITY_RATING,0.64:MASTERY_RATING,0.7:MELEE_HASTE_RATING,0.65:AP,0.71:MELEE_CRIT_RATING,0.5:STA,0:AGI,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0",
        ["DEATHKNIGHT:2:PVP"] =       "ARMOR_SPECIALIZATION_STAT,STR:ITEM_CLASS_WEAPON,1,2,5,6,7,8,9:ITEM_CLASS_ARMOR,1,2,3,4,5:XP_BONUS,1000:DPS,1.55:DPS|MAIN,0.95:DPS|OFF,0.46:STR,1:MULTISTRIKE_RATING,0.44:VERSATILITY_RATING,0.64:MASTERY_RATING,0.7:MELEE_HASTE_RATING,0.65:AP,0.71:MELEE_CRIT_RATING,0.5:STA,0:AGI,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0",
        ["DEATHKNIGHT:3"] =           "ARMOR_SPECIALIZATION_STAT,STR:ITEM_CLASS_WEAPON,1,2,5,6,7,8,9:ITEM_CLASS_ARMOR,1,2,3,4,5:XP_BONUS,1000:DPS,0.78:STR,1:MULTISTRIKE_RATING,0.89:VERSATILITY_RATING,0.64:MELEE_HASTE_RATING,0.82:MELEE_CRIT_RATING,0.65:AP,0.75:MASTERY_RATING,0.6:STA,0:AGI,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0",
        ["DEATHKNIGHT:3:PVP"] =       "ARMOR_SPECIALIZATION_STAT,STR:ITEM_CLASS_WEAPON,1,2,5,6,7,8,9:ITEM_CLASS_ARMOR,1,2,3,4,5:XP_BONUS,1000:DPS,0.78:STR,1:MULTISTRIKE_RATING,0.89:VERSATILITY_RATING,0.64:MELEE_HASTE_RATING,0.82:MELEE_CRIT_RATING,0.65:AP,0.75:MASTERY_RATING,0.6:STA,0:AGI,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0",
        ["MONK:1"] =                  "ARMOR_SPECIALIZATION_STAT,STA:ITEM_CLASS_WEAPON,1,5,7,8,10,11:ITEM_CLASS_ARMOR,1,2,3:XP_BONUS,1000:DPS,0.2:DPS|MAIN,0.2:DPS|OFF,0.1:AGI,0.9:MULTISTRIKE_RATING,0.4:VERSATILITY_RATING,0.58:MELEE_HASTE_RATING,0.24:MELEE_CRIT_RATING,0.56:ARMOR,1.6:BONUS_ARMOR,2:MASTERY_RATING,1.02:AVOIDANCE_RATING,0:AP,0.2:STA,0.65:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0:STR,0",
        ["MONK:1:PVP"] =              "ARMOR_SPECIALIZATION_STAT,STA:ITEM_CLASS_WEAPON,1,5,7,8,10,11:ITEM_CLASS_ARMOR,1,2,3:XP_BONUS,1000:DPS,0.2:DPS|MAIN,0.2:DPS|OFF,0.1:AGI,0.9:MULTISTRIKE_RATING,0.4:VERSATILITY_RATING,0.58:MELEE_HASTE_RATING,0.24:MELEE_CRIT_RATING,0.56:ARMOR,1.6:BONUS_ARMOR,2:MASTERY_RATING,1.02:AVOIDANCE_RATING,0:AP,0.2:STA,0.65:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0:STR,0",
        ["MONK:2"] =                  "ARMOR_SPECIALIZATION_STAT,INT:ITEM_CLASS_WEAPON,1,5,7,8,10,11:ITEM_CLASS_ARMOR,1,2,3:XP_BONUS,1000:INT,89:SPELL_DMG,1.68:SPI,1.41:SPELL_HASTE_RATING,0.61:SPELL_CRIT_RATING,0.98:MASTERY_RATING,0.34:MULTISTRIKE_RATING,1.09:VERSATILITY_RATING,0.92:DPS,0.01:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:LEECH_RATING,0:STR,0",
        ["MONK:2:PVP"] =              "ARMOR_SPECIALIZATION_STAT,INT:ITEM_CLASS_WEAPON,1,5,7,8,10,11:ITEM_CLASS_ARMOR,1,2,3:XP_BONUS,1000:INT,89:SPELL_DMG,1.68:SPI,1.41:SPELL_HASTE_RATING,0.61:SPELL_CRIT_RATING,0.98:MASTERY_RATING,0.34:MULTISTRIKE_RATING,1.09:VERSATILITY_RATING,0.92:DPS,0.01:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:LEECH_RATING,0:STR,0",
        ["MONK:3"] =                  "ARMOR_SPECIALIZATION_STAT,AGI:ITEM_CLASS_WEAPON,1,5,7,8,10,11:ITEM_CLASS_ARMOR,1,2,3:XP_BONUS,1000:DPS,2.68:DPS|MAIN,2.32:DPS|OFF,1.19:MULTISTRIKE_RATING,0.5:AGI,1:VERSATILITY_RATING,0.39:MELEE_HASTE_RATING,0.4:MELEE_CRIT_RATING,0.41:MASTERY_RATING,0.23:AP,0.9:STA,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0:STR,0",
        ["MONK:3:PVP"] =              "ARMOR_SPECIALIZATION_STAT,AGI:ITEM_CLASS_WEAPON,1,5,7,8,10,11:ITEM_CLASS_ARMOR,1,2,3:XP_BONUS,1000:DPS,2.68:DPS|MAIN,2.32:DPS|OFF,1.19:MULTISTRIKE_RATING,0.5:AGI,1:VERSATILITY_RATING,0.39:MELEE_HASTE_RATING,0.4:MELEE_CRIT_RATING,0.41:MASTERY_RATING,0.23:AP,0.9:STA,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0:STR,0",
        ["WARRIOR:1"] =               "ARMOR_SPECIALIZATION_STAT,STR:ITEM_CLASS_WEAPON,1,2,5,6,7,8,9,10,11,13:ITEM_CLASS_ARMOR,1,2,3,4,5|40,7:XP_BONUS,1000:DPS,2.51:STR,1:MULTISTRIKE_RATING,0.79:VERSATILITY_RATING,0.69:MELEE_CRIT_RATING,0.96:AP,0.89:MASTERY_RATING,0.86:MELEE_HASTE_RATING,0.63:STA,0:AGI,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0",
        ["WARRIOR:1:PVP"] =           "ARMOR_SPECIALIZATION_STAT,STR:ITEM_CLASS_WEAPON,1,2,5,6,7,8,9,10,11,13:ITEM_CLASS_ARMOR,1,2,3,4,5|40,7:XP_BONUS,1000:DPS,2.51:STR,1:MULTISTRIKE_RATING,0.79:VERSATILITY_RATING,0.69:MELEE_CRIT_RATING,0.96:AP,0.89:MASTERY_RATING,0.86:MELEE_HASTE_RATING,0.63:STA,0:AGI,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0",
        ["WARRIOR:2"] =               "ARMOR_SPECIALIZATION_STAT,STR:ITEM_CLASS_WEAPON,1,2,5,6,7,8,9,10,11,13:ITEM_CLASS_ARMOR,1,2,3,4,5|40,7:XP_BONUS,1000:DPS,1.78:DPS|MAIN,1.78:DPS|OFF,1.52:STR,1:MULTISTRIKE_RATING,0.75:VERSATILITY_RATING,0.73:MELEE_CRIT_RATING,0.85,0.30,0.7:MASTERY_RATING,0.82:MELEE_HASTE_RATING,0.77:AP,0.9:STA,0:AGI,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0",
        ["WARRIOR:2:PVP"] =           "ARMOR_SPECIALIZATION_STAT,STR:ITEM_CLASS_WEAPON,1,2,5,6,7,8,9,10,11,13:ITEM_CLASS_ARMOR,1,2,3,4,5|40,7:XP_BONUS,1000:DPS,1.78:DPS|MAIN,1.78:DPS|OFF,1.52:STR,1:MULTISTRIKE_RATING,0.75:VERSATILITY_RATING,0.73:MELEE_CRIT_RATING,0.85,0.30,0.7:MASTERY_RATING,0.82:MELEE_HASTE_RATING,0.77:AP,0.9:STA,0:AGI,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0",
        ["WARRIOR:3"] =               "ARMOR_SPECIALIZATION_STAT,STA:ITEM_CLASS_WEAPON,1,2,5,6,7,8,9,10,11,13:ITEM_CLASS_ARMOR,1,2,3,4,5|40,7:XP_BONUS,1000:DPS,2.0:STA,0.6:MASTERY_RATING,0.7:STR,0.65:AVOIDANCE_RATING,0.17:MULTISTRIKE_RATING,0.4:ARMOR,0.85:BONUS_ARMOR,1:MELEE_HASTE_RATING,0.28:MELEE_CRIT_RATING,0.57:AP,0.2:LEECH_RATING,0:VERSATILITY_RATING,0.54:AGI,0:INT,0:SPELL_DMG,0:SPI,0",
        ["WARRIOR:3:PVP"] =           "ARMOR_SPECIALIZATION_STAT,STA:ITEM_CLASS_WEAPON,1,2,5,6,7,8,9,10,11,13:ITEM_CLASS_ARMOR,1,2,3,4,5|40,7:XP_BONUS,1000:DPS,2.0:STA,0.6:MASTERY_RATING,0.7:STR,0.65:AVOIDANCE_RATING,0.17:MULTISTRIKE_RATING,0.4:ARMOR,0.85:BONUS_ARMOR,1:MELEE_HASTE_RATING,0.28:MELEE_CRIT_RATING,0.57:AP,0.2:LEECH_RATING,0:VERSATILITY_RATING,0.54:AGI,0:INT,0:SPELL_DMG,0:SPI,0",
        ["PALADIN:1"] =               "ARMOR_SPECIALIZATION_STAT,INT:ITEM_CLASS_WEAPON,1,2,5,6,7,8,9:ITEM_CLASS_ARMOR,1,2,3,4,5|40,7:XP_BONUS,1000:INT,2:SPELL_DMG,1.8:SPI,1.2:MASTERY_RATING,0.8:SPELL_CRIT_RATING,1.1:SPELL_HASTE_RATING,1:MULTISTRIKE_RATING,0.9:VERSATILITY_RATING,0.7:DPS,0.01:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:LEECH_RATING,0:STR,0",
        ["PALADIN:1:PVP"] =           "ARMOR_SPECIALIZATION_STAT,INT:ITEM_CLASS_WEAPON,1,2,5,6,7,8,9:ITEM_CLASS_ARMOR,1,2,3,4,5|40,7:XP_BONUS,1000:INT,2:SPELL_DMG,1.8:SPI,1.2:MASTERY_RATING,0.8:SPELL_CRIT_RATING,1.1:SPELL_HASTE_RATING,1:MULTISTRIKE_RATING,0.9:VERSATILITY_RATING,0.7:DPS,0.01:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:LEECH_RATING,0:STR,0",
        ["PALADIN:2"] =               "ARMOR_SPECIALIZATION_STAT,STA:ITEM_CLASS_WEAPON,1,2,5,6,7,8,9:ITEM_CLASS_ARMOR,1,2,3,4,5|40,7:XP_BONUS,1000:DPS,0.2:STA,0.5:MELEE_CRIT_RATING,0.4:VERSATILITY_RATING,0.45:MULTISTRIKE_RATING,0.44:MASTERY_RATING,0.59:ARMOR,0.6:BONUS_ARMOR,1:MELEE_HASTE_RATING,0.6:STR,0.75:AVOIDANCE_RATING,0.0:LEECH_RATING,0.00:AP,0.2:AGI,0:INT,0:SPELL_DMG,0:SPI,0",
        ["PALADIN:2:PVP"] =           "ARMOR_SPECIALIZATION_STAT,STA:ITEM_CLASS_WEAPON,1,2,5,6,7,8,9:ITEM_CLASS_ARMOR,1,2,3,4,5|40,7:XP_BONUS,1000:DPS,0.2:STA,0.5:MELEE_CRIT_RATING,0.4:VERSATILITY_RATING,0.45:MULTISTRIKE_RATING,0.44:MASTERY_RATING,0.59:ARMOR,0.6:BONUS_ARMOR,1:MELEE_HASTE_RATING,0.6:STR,0.75:AVOIDANCE_RATING,0.0:LEECH_RATING,0.00:AP,0.2:AGI,0:INT,0:SPELL_DMG,0:SPI,0",
        ["PALADIN:3"] =               "ARMOR_SPECIALIZATION_STAT,STR:ITEM_CLASS_WEAPON,1,2,5,6,7,8,9:ITEM_CLASS_ARMOR,1,2,3,4,5|40,7:XP_BONUS,1000:DPS,2.09:STR,1:MULTISTRIKE_RATING,0.778:VERSATILITY_RATING,0.7:MELEE_HASTE_RATING,0.76:MASTERY_RATING,0.8:AP,0.9:MELEE_CRIT_RATING,0.75:STA,0:AGI,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0",
        ["PALADIN:3:PVP"] =           "ARMOR_SPECIALIZATION_STAT,STR:ITEM_CLASS_WEAPON,1,2,5,6,7,8,9:ITEM_CLASS_ARMOR,1,2,3,4,5|40,7:XP_BONUS,1000:DPS,2.09:STR,1:MULTISTRIKE_RATING,0.778:VERSATILITY_RATING,0.7:MELEE_HASTE_RATING,0.76:MASTERY_RATING,0.8:AP,0.9:MELEE_CRIT_RATING,0.75:STA,0:AGI,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0",
        ["DRUID:1"] =                 "ARMOR_SPECIALIZATION_STAT,INT:ITEM_CLASS_WEAPON,5,6,7,10,11,12,13:ITEM_CLASS_ARMOR,1,2,3:XP_BONUS,1000:INT,1:MULTISTRIKE_RATING,0.61:SPELL_DMG,0.9:SPELL_HASTE_RATING,0.64:SPELL_CRIT_RATING,0.68:MASTERY_RATING,0.75:VERSATILITY_RATING,0.6:DPS,0.01:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:LEECH_RATING,0:SPI,0:STR,0",
        ["DRUID:1:PVP"] =             "ARMOR_SPECIALIZATION_STAT,INT:ITEM_CLASS_WEAPON,5,6,7,10,11,12,13:ITEM_CLASS_ARMOR,1,2,3:XP_BONUS,1000:INT,1:MULTISTRIKE_RATING,0.61:SPELL_DMG,0.9:SPELL_HASTE_RATING,0.64:SPELL_CRIT_RATING,0.68:MASTERY_RATING,0.75:VERSATILITY_RATING,0.6:DPS,0.01:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:LEECH_RATING,0:SPI,0:STR,0",
        ["DRUID:2"] =                 "ARMOR_SPECIALIZATION_STAT,AGI:ITEM_CLASS_WEAPON,5,6,7,10,11,12,13:ITEM_CLASS_ARMOR,1,2,3:XP_BONUS,1000:DPS,0.82:AGI,1:AP,0.88:VERSATILITY_RATING,0.46:MULTISTRIKE_RATING,0.49:MASTERY_RATING,0.54:MELEE_CRIT_RATING,0.61:MELEE_HASTE_RATING,0.42:STA,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0:STR,0",
        ["DRUID:2:PVP"] =             "ARMOR_SPECIALIZATION_STAT,AGI:ITEM_CLASS_WEAPON,5,6,7,10,11,12,13:ITEM_CLASS_ARMOR,1,2,3:XP_BONUS,1000:DPS,0.82:AGI,1:AP,0.88:VERSATILITY_RATING,0.46:MULTISTRIKE_RATING,0.49:MASTERY_RATING,0.54:MELEE_CRIT_RATING,0.61:MELEE_HASTE_RATING,0.42:STA,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0:STR,0",
        ["DRUID:3"] =                 "ARMOR_SPECIALIZATION_STAT,STA:ITEM_CLASS_WEAPON,5,6,7,10,11,12,13:ITEM_CLASS_ARMOR,1,2,3:XP_BONUS,1000:DPS,0.2:AGI,0.7:STA,0.4:MELEE_CRIT_RATING,0.21:VERSATILITY_RATING,0.39:MULTISTRIKE_RATING,0.65:MASTERY_RATING,0.44:AVOIDANCE_RATING,0:MELEE_HASTE_RATING,0.3:ARMOR,2:BONUS_ARMOR,0.8:AP,0.2:LEECH_RATING,0:INT,0:SPELL_DMG,0:SPI,0:STR,0",
        ["DRUID:3:PVP"] =             "ARMOR_SPECIALIZATION_STAT,STA:ITEM_CLASS_WEAPON,5,6,7,10,11,12,13:ITEM_CLASS_ARMOR,1,2,3:XP_BONUS,1000:DPS,0.2:AGI,0.7:STA,0.4:MELEE_CRIT_RATING,0.21:VERSATILITY_RATING,0.39:MULTISTRIKE_RATING,0.65:MASTERY_RATING,0.44:AVOIDANCE_RATING,0:MELEE_HASTE_RATING,0.3:ARMOR,2:BONUS_ARMOR,0.8:AP,0.2:LEECH_RATING,0:INT,0:SPELL_DMG,0:SPI,0:STR,0",
        ["DRUID:4"] =                 "ARMOR_SPECIALIZATION_STAT,INT:ITEM_CLASS_WEAPON,5,6,7,10,11,12,13:ITEM_CLASS_ARMOR,1,2,3:XP_BONUS,1000:INT,2:SPELL_DMG,1.8:SPELL_HASTE_RATING,1.1:SPI,1.2:MASTERY_RATING,1:SPELL_CRIT_RATING,0.8:MULTISTRIKE_RATING,0.9:VERSATILITY_RATING,0.7:DPS,0.01:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:LEECH_RATING,0:STR,0",
        ["DRUID:4:PVP"] =             "ARMOR_SPECIALIZATION_STAT,INT:ITEM_CLASS_WEAPON,5,6,7,10,11,12,13:ITEM_CLASS_ARMOR,1,2,3:XP_BONUS,1000:INT,2:SPELL_DMG,1.8:SPELL_HASTE_RATING,1.1:SPI,1.2:MASTERY_RATING,1:SPELL_CRIT_RATING,0.8:MULTISTRIKE_RATING,0.9:VERSATILITY_RATING,0.7:DPS,0.01:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:LEECH_RATING,0:STR,0",
        ["ROGUE:1"] =                 "ARMOR_SPECIALIZATION_STAT,AGI:ITEM_CLASS_WEAPON,13:ITEM_CLASS_ARMOR,1,2,3:XP_BONUS,1000:DPS,0.75:DPS|MAIN,0.75:DPS|OFF,0.22:AGI,1:MULTISTRIKE_RATING,0.5:VERSATILITY_RATING,0.48:MASTERY_RATING,0.57:MELEE_HASTE_RATING,0.44:AP,0.91:MELEE_CRIT_RATING,0.52:STA,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0:STR,0",
        ["ROGUE:1:PVP"] =             "ARMOR_SPECIALIZATION_STAT,AGI:ITEM_CLASS_WEAPON,13:ITEM_CLASS_ARMOR,1,2,3:XP_BONUS,1000:DPS,0.75:DPS|MAIN,0.75:DPS|OFF,0.22:AGI,1:MULTISTRIKE_RATING,0.5:VERSATILITY_RATING,0.48:MASTERY_RATING,0.57:MELEE_HASTE_RATING,0.44:AP,0.91:MELEE_CRIT_RATING,0.52:STA,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0:STR,0",
        ["ROGUE:2"] =                 "ARMOR_SPECIALIZATION_STAT,AGI:ITEM_CLASS_WEAPON,1,5,8,11,13:ITEM_CLASS_ARMOR,1,2,3:XP_BONUS,1000:DPS,0.78:DPS|MAIN,0.78:DPS|OFF,0.42:AGI,1:MULTISTRIKE_RATING,0.69:VERSATILITY_RATING,0.48:MELEE_HASTE_RATING,0.67:MASTERY_RATING,0.49:MELEE_CRIT_RATING,0.51:AP,0.91:STA,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0:STR,0",
        ["ROGUE:2:PVP"] =             "ARMOR_SPECIALIZATION_STAT,AGI:ITEM_CLASS_WEAPON,1,5,8,11,13:ITEM_CLASS_ARMOR,1,2,3:XP_BONUS,1000:DPS,0.78:DPS|MAIN,0.78:DPS|OFF,0.42:AGI,1:MULTISTRIKE_RATING,0.69:VERSATILITY_RATING,0.48:MELEE_HASTE_RATING,0.67:MASTERY_RATING,0.49:MELEE_CRIT_RATING,0.51:AP,0.91:STA,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0:STR,0",
        ["ROGUE:3"] =                 "ARMOR_SPECIALIZATION_STAT,AGI:ITEM_CLASS_WEAPON,13:ITEM_CLASS_ARMOR,1,2,3:XP_BONUS,1000:DPS,1.07:DPS|MAIN,1.07:DPS|OFF,0.22:AGI,1:MULTISTRIKE_RATING,0.49:VERSATILITY_RATING,0.4:MASTERY_RATING,0.51:MELEE_HASTE_RATING,0.41:AP,0.78:MELEE_CRIT_RATING,0.42:STA,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0:STR,0",
        ["ROGUE:3:PVP"] =             "ARMOR_SPECIALIZATION_STAT,AGI:ITEM_CLASS_WEAPON,13:ITEM_CLASS_ARMOR,1,2,3:XP_BONUS,1000:DPS,1.07:DPS|MAIN,1.07:DPS|OFF,0.22:AGI,1:MULTISTRIKE_RATING,0.49:VERSATILITY_RATING,0.4:MASTERY_RATING,0.51:MELEE_HASTE_RATING,0.41:AP,0.78:MELEE_CRIT_RATING,0.42:STA,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0:STR,0",
        ["SHAMAN:1"] =                "ARMOR_SPECIALIZATION_STAT,INT:ITEM_CLASS_WEAPON,1,2,5,6,10,11,13:ITEM_CLASS_ARMOR,1,2,3,4|40,7:XP_BONUS,1000:INT,1:SPELL_DMG,0.9:MULTISTRIKE_RATING,0.79:SPELL_HASTE_RATING,0.78:MASTERY_RATING,0.55:SPELL_CRIT_RATING,0.73:VERSATILITY_RATING,0.66:DPS,0.01:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:LEECH_RATING,0:SPI,0:STR,0",
        ["SHAMAN:1:PVP"] =            "ARMOR_SPECIALIZATION_STAT,INT:ITEM_CLASS_WEAPON,1,2,5,6,10,11,13:ITEM_CLASS_ARMOR,1,2,3,4|40,7:XP_BONUS,1000:INT,1:SPELL_DMG,0.9:MULTISTRIKE_RATING,0.79:SPELL_HASTE_RATING,0.78:MASTERY_RATING,0.55:SPELL_CRIT_RATING,0.73:VERSATILITY_RATING,0.66:DPS,0.01:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:LEECH_RATING,0:SPI,0:STR,0",
        ["SHAMAN:2"] =                "ARMOR_SPECIALIZATION_STAT,AGI:ITEM_CLASS_WEAPON,1,5,11,13:ITEM_CLASS_ARMOR,1,2,3,4|40,7:XP_BONUS,1000:DPS,0.51:DPS|MAIN,0.51:DPS|OFF,0.38:AGI,1:MULTISTRIKE_RATING,0.53:VERSATILITY_RATING,0.49:MELEE_HASTE_RATING,0.56:MASTERY_RATING,0.54:MELEE_CRIT_RATING,0.5:AP,0.91:STA,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0:STR,0",
        ["SHAMAN:2:PVP"] =            "ARMOR_SPECIALIZATION_STAT,AGI:ITEM_CLASS_WEAPON,1,5,11,13:ITEM_CLASS_ARMOR,1,2,3,4|40,7:XP_BONUS,1000:DPS,0.51:DPS|MAIN,0.51:DPS|OFF,0.38:AGI,1:MULTISTRIKE_RATING,0.53:VERSATILITY_RATING,0.49:MELEE_HASTE_RATING,0.56:MASTERY_RATING,0.54:MELEE_CRIT_RATING,0.5:AP,0.91:STA,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0:STR,0",
        ["SHAMAN:3"] =                "ARMOR_SPECIALIZATION_STAT,INT:ITEM_CLASS_WEAPON,1,2,5,6,10,11,13:ITEM_CLASS_ARMOR,1,2,3,4|40,7:XP_BONUS,1000:INT,2:SPELL_DMG,1.8:SPI,1.2:MULTISTRIKE_RATING,0.8:MASTERY_RATING,1.1:SPELL_CRIT_RATING,0.9:VERSATILITY_RATING,0.7:DPS,0.01:SPELL_HASTE_RATING,1.0:LEECH_RATING,0.6:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:STR,0",
        ["SHAMAN:3:PVP"] =            "ARMOR_SPECIALIZATION_STAT,INT:ITEM_CLASS_WEAPON,1,2,5,6,10,11,13:ITEM_CLASS_ARMOR,1,2,3,4|40,7:XP_BONUS,1000:INT,2:SPELL_DMG,1.8:SPI,1.2:MULTISTRIKE_RATING,0.8:MASTERY_RATING,1.1:SPELL_CRIT_RATING,0.9:VERSATILITY_RATING,0.7:DPS,0.01:SPELL_HASTE_RATING,1.0:LEECH_RATING,0.6:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:STR,0",
        ["HUNTER:1"] =                "ARMOR_SPECIALIZATION_STAT,AGI:ITEM_CLASS_WEAPON,3,4,15:ITEM_CLASS_ARMOR,1,2,3,4|40:XP_BONUS,1000:DPS,0.76:AGI,1:MULTISTRIKE_RATING,0.51:VERSATILITY_RATING,0.48:AP,0.9:RANGED_CRIT_RATING,0.49:RANGED_HASTE_RATING,0.53,0.1928,0.5:MASTERY_RATING,0.46:STA,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0:STR,0",
        ["HUNTER:1:PVP"] =            "ARMOR_SPECIALIZATION_STAT,AGI:ITEM_CLASS_WEAPON,3,4,15:ITEM_CLASS_ARMOR,1,2,3,4|40:XP_BONUS,1000:DPS,0.76:AGI,1:MULTISTRIKE_RATING,0.51:VERSATILITY_RATING,0.48:AP,0.9:RANGED_CRIT_RATING,0.49:RANGED_HASTE_RATING,0.53,0.1928,0.5:MASTERY_RATING,0.46:STA,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0:STR,0",
        ["HUNTER:2"] =                "ARMOR_SPECIALIZATION_STAT,AGI:ITEM_CLASS_WEAPON,3,4,15:ITEM_CLASS_ARMOR,1,2,3,4|40:XP_BONUS,1000:DPS,2.48:AGI,1:MULTISTRIKE_RATING,0.6:VERSATILITY_RATING,0.56:RANGED_CRIT_RATING,0.65:RANGED_HASTE_RATING,0.43:AP,0.9:MASTERY_RATING,0.55:STA,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0:STR,0",
        ["HUNTER:2:PVP"] =            "ARMOR_SPECIALIZATION_STAT,AGI:ITEM_CLASS_WEAPON,3,4,15:ITEM_CLASS_ARMOR,1,2,3,4|40:XP_BONUS,1000:DPS,2.48:AGI,1:MULTISTRIKE_RATING,0.6:VERSATILITY_RATING,0.56:RANGED_CRIT_RATING,0.65:RANGED_HASTE_RATING,0.43:AP,0.9:MASTERY_RATING,0.55:STA,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0:STR,0",
        ["HUNTER:3"] =                "ARMOR_SPECIALIZATION_STAT,AGI:ITEM_CLASS_WEAPON,3,4,15:ITEM_CLASS_ARMOR,1,2,3,4|40:XP_BONUS,1000:DPS,1:AGI,1:MULTISTRIKE_RATING,0.59:VERSATILITY_RATING,0.5:AP,0.9:RANGED_CRIT_RATING,0.49:RANGED_HASTE_RATING,0.42:MASTERY_RATING,0.41:STA,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0:STR,0",
        ["HUNTER:3:PVP"] =            "ARMOR_SPECIALIZATION_STAT,AGI:ITEM_CLASS_WEAPON,3,4,15:ITEM_CLASS_ARMOR,1,2,3,4|40:XP_BONUS,1000:DPS,1:AGI,1:MULTISTRIKE_RATING,0.59:VERSATILITY_RATING,0.5:AP,0.9:RANGED_CRIT_RATING,0.49:RANGED_HASTE_RATING,0.42:MASTERY_RATING,0.41:STA,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:INT,0:LEECH_RATING,0:SPELL_DMG,0:SPI,0:STR,0",
        ["MAGE:1"] =                  "ITEM_CLASS_WEAPON,8,10,12,13,16:ITEM_CLASS_ARMOR,1,2:XP_BONUS,1000:INT,1:SPELL_DMG,0.91:MULTISTRIKE_RATING,0.74:SPELL_HASTE_RATING,0.75:SPELL_CRIT_RATING,0.73:VERSATILITY_RATING,0.64:MASTERY_RATING,0.76:DPS,0.01:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:LEECH_RATING,0:SPI,0:STR,0",
        ["MAGE:1:PVP"] =              "ITEM_CLASS_WEAPON,8,10,12,13,16:ITEM_CLASS_ARMOR,1,2:XP_BONUS,1000:INT,1:SPELL_DMG,0.91:MULTISTRIKE_RATING,0.74:SPELL_HASTE_RATING,0.75:SPELL_CRIT_RATING,0.73:VERSATILITY_RATING,0.64:MASTERY_RATING,0.76:DPS,0.01:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:LEECH_RATING,0:SPI,0:STR,0",
        ["MAGE:2"] =                  "ITEM_CLASS_WEAPON,8,10,12,13,16:ITEM_CLASS_ARMOR,1,2:XP_BONUS,1000:INT,1:SPELL_DMG,0.91:MULTISTRIKE_RATING,0.65:SPELL_HASTE_RATING,0.61:SPELL_CRIT_RATING,0.85:VERSATILITY_RATING,0.53:MASTERY_RATING,0.75:DPS,0.01:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:LEECH_RATING,0:SPI,0:STR,0",
        ["MAGE:2:PVP"] =              "ITEM_CLASS_WEAPON,8,10,12,13,16:ITEM_CLASS_ARMOR,1,2:XP_BONUS,1000:INT,1:SPELL_DMG,0.91:MULTISTRIKE_RATING,0.65:SPELL_HASTE_RATING,0.61:SPELL_CRIT_RATING,0.85:VERSATILITY_RATING,0.53:MASTERY_RATING,0.75:DPS,0.01:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:LEECH_RATING,0:SPI,0:STR,0",
        ["MAGE:3"] =                  "ITEM_CLASS_WEAPON,8,10,12,13,16:ITEM_CLASS_ARMOR,1,2:XP_BONUS,1000:INT,1:SPELL_DMG,0.91:MULTISTRIKE_RATING,0.75:SPELL_HASTE_RATING,0.73:SPELL_CRIT_RATING,0.7:VERSATILITY_RATING,0.62:MASTERY_RATING,0.58:DPS,0.01:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:LEECH_RATING,0:SPI,0:STR,0",
        ["MAGE:3:PVP"] =              "ITEM_CLASS_WEAPON,8,10,12,13,16:ITEM_CLASS_ARMOR,1,2:XP_BONUS,1000:INT,1:SPELL_DMG,0.91:MULTISTRIKE_RATING,0.75:SPELL_HASTE_RATING,0.73:SPELL_CRIT_RATING,0.7:VERSATILITY_RATING,0.62:MASTERY_RATING,0.58:DPS,0.01:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:LEECH_RATING,0:SPI,0:STR,0",
        ["PRIEST:1"] =                "ITEM_CLASS_WEAPON,10,13,5,16:ITEM_CLASS_ARMOR,1,2:XP_BONUS,1000:INT,2:SPELL_DMG,1.8:SPI,1.4:SPELL_HASTE_RATING,0.8:SPELL_CRIT_RATING,1:MASTERY_RATING,1.2:MULTISTRIKE_RATING,0.9:VERSATILITY_RATING,0.7:DPS,0.01:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:LEECH_RATING,0:STR,0",
        ["PRIEST:1:PVP"] =            "ITEM_CLASS_WEAPON,10,13,5,16:ITEM_CLASS_ARMOR,1,2:XP_BONUS,1000:INT,2:SPELL_DMG,1.8:SPI,1.4:SPELL_HASTE_RATING,0.8:SPELL_CRIT_RATING,1:MASTERY_RATING,1.2:MULTISTRIKE_RATING,0.9:VERSATILITY_RATING,0.7:DPS,0.01:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:LEECH_RATING,0:STR,0",
        ["PRIEST:2"] =                "ITEM_CLASS_WEAPON,10,13,5,16:ITEM_CLASS_ARMOR,1,2:XP_BONUS,1000:INT,2:SPELL_DMG,1.8:SPI,1.2:SPELL_HASTE_RATING,1:SPELL_CRIT_RATING,0.8:MASTERY_RATING,0.9:MULTISTRIKE_RATING,1.1:VERSATILITY_RATING,0.7:DPS,0.01:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:LEECH_RATING,0:STR,0",
        ["PRIEST:2:PVP"] =            "ITEM_CLASS_WEAPON,10,13,5,16:ITEM_CLASS_ARMOR,1,2:XP_BONUS,1000:INT,2:SPELL_DMG,1.8:SPI,1.2:SPELL_HASTE_RATING,1:SPELL_CRIT_RATING,0.8:MASTERY_RATING,0.9:MULTISTRIKE_RATING,1.1:VERSATILITY_RATING,0.7:DPS,0.01:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:LEECH_RATING,0:STR,0",
        ["PRIEST:3"] =                "ITEM_CLASS_WEAPON,10,13,5,16:ITEM_CLASS_ARMOR,1,2:XP_BONUS,1000:INT,1:SPELL_DMG,0.9:MULTISTRIKE_RATING,0.71:SPELL_HASTE_RATING,0.84:SPELL_CRIT_RATING,0.97:MASTERY_RATING,0.55:VERSATILITY_RATING,0.65:DPS,0.01:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:LEECH_RATING,0:SPI,0:STR,0",
        ["PRIEST:3:PVP"] =            "ITEM_CLASS_WEAPON,10,13,5,16:ITEM_CLASS_ARMOR,1,2:XP_BONUS,1000:INT,1:SPELL_DMG,0.9:MULTISTRIKE_RATING,0.71:SPELL_HASTE_RATING,0.84:SPELL_CRIT_RATING,0.97:MASTERY_RATING,0.55:VERSATILITY_RATING,0.65:DPS,0.01:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:LEECH_RATING,0:SPI,0:STR,0",
        ["WARLOCK:1"] =               "ITEM_CLASS_WEAPON,8,10,12,13,16:ITEM_CLASS_ARMOR,1,2:XP_BONUS,1000:INT,1:SPELL_DMG,0.87:MULTISTRIKE_RATING,0.67:MASTERY_RATING,0.85:SPELL_HASTE_RATING,0.86:SPELL_CRIT_RATING,0.64:VERSATILITY_RATING,0.59:DPS,0.01:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:LEECH_RATING,0:SPI,0:STR,0",
        ["WARLOCK:1:PVP"] =           "ITEM_CLASS_WEAPON,8,10,12,13,16:ITEM_CLASS_ARMOR,1,2:XP_BONUS,1000:INT,1:SPELL_DMG,0.87:MULTISTRIKE_RATING,0.67:MASTERY_RATING,0.85:SPELL_HASTE_RATING,0.86:SPELL_CRIT_RATING,0.64:VERSATILITY_RATING,0.59:DPS,0.01:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:LEECH_RATING,0:SPI,0:STR,0",
        ["WARLOCK:2"] =               "ITEM_CLASS_WEAPON,8,10,12,13,16:ITEM_CLASS_ARMOR,1,2:XP_BONUS,1000:INT,1:SPELL_DMG,0.87:MULTISTRIKE_RATING,0.71:MASTERY_RATING,0.85:SPELL_HASTE_RATING,0.78:SPELL_CRIT_RATING,0.7:VERSATILITY_RATING,0.62:DPS,0.01:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:LEECH_RATING,0:SPI,0:STR,0",
        ["WARLOCK:2:PVP"] =           "ITEM_CLASS_WEAPON,8,10,12,13,16:ITEM_CLASS_ARMOR,1,2:XP_BONUS,1000:INT,1:SPELL_DMG,0.87:MULTISTRIKE_RATING,0.71:MASTERY_RATING,0.85:SPELL_HASTE_RATING,0.78:SPELL_CRIT_RATING,0.7:VERSATILITY_RATING,0.62:DPS,0.01:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:LEECH_RATING,0:SPI,0:STR,0",
        ["WARLOCK:3"] =               "ITEM_CLASS_WEAPON,8,10,12,13,16:ITEM_CLASS_ARMOR,1,2:XP_BONUS,1000:INT,1:SPELL_DMG,0.93:MULTISTRIKE_RATING,0.72:SPELL_CRIT_RATING,0.87:SPELL_HASTE_RATING,0.68:MASTERY_RATING,0.9:VERSATILITY_RATING,0.61:DPS,0.01:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:LEECH_RATING,0:SPI,0:STR,0",
        ["WARLOCK:3:PVP"] =           "ITEM_CLASS_WEAPON,8,10,12,13,16:ITEM_CLASS_ARMOR,1,2:XP_BONUS,1000:INT,1:SPELL_DMG,0.93:MULTISTRIKE_RATING,0.72:SPELL_CRIT_RATING,0.87:SPELL_HASTE_RATING,0.68:MASTERY_RATING,0.9:VERSATILITY_RATING,0.61:DPS,0.01:STA,0:AGI,0:AP,0:ARMOR,0:AVOIDANCE_RATING,0:BONUS_ARMOR,0:LEECH_RATING,0:SPI,0:STR,0",
		["tiebreaker"] = {{"ARMOR",1},{"DPS",1},{"STA",2}}
	}	
    
    
    -- [classIdentifier][specializationIndex] = {specializationId, }
    GA.classIdentifier2SpecializationsMap = {}
    
    
    LuaUtils:loop(500, function(specId)
	
		local switchId = specId
		if specId == 269 then switchId = 270 end 
		if specId == 270 then switchId = 269 end
		
        local id, name, description, icon, background, role, class = GetSpecializationInfoByID(switchId)
        
        if (class ~= nil) then
            if GA.classIdentifier2SpecializationsMap[class] == nil then
                GA.classIdentifier2SpecializationsMap[class] = {}
            end
            
            local classTable = GA.classIdentifier2SpecializationsMap[class]
            
            classTable[#classTable + 1] = {["name"] = name, ["id"] = id}
        end
    end)
    
    if DugisGuideUser.userCustomWeights == nil then
        DugisGuideUser.userCustomWeights = {}
    end
    
    function GetAllPossibleWeightIdentifiers(classId, specIndex)
        local excludeList = {
            "ARMOR_SPECIALIZATION_STAT"
            ,"ITEM_CLASS_WEAPON"
            ,"ITEM_CLASS_ARMOR"
            --,"XP_BONUS"
        }
    
        local weightNames = {}
        if scoring[PackStrings(classId, specIndex)] ~= nil then
            local weightValuePairs = {strsplit(":", scoring[PackStrings(classId, specIndex)])}
            LuaUtils:foreach(weightValuePairs, function(weightValuePair, index)
                local weightName_weightValue = {strsplit(",", weightValuePair)}
                local weightName = weightName_weightValue[1]
                if not LuaUtils:isInTable(weightName, excludeList) then
                    weightNames[#weightNames + 1] = weightName
                end
            end)
        else
            print("|cFF00FF00CANNOT FIND IN THE scoring TABLE (GearAdvisor) THE FOLLOWING ENTRY:", classId..":"..specIndex.."|r")
        end
        return weightNames
    end
    
    function GA:SpecExists(specIndex)
        local classId = GA:GetCurrentSelectedClassIdentifier()
        return scoring[PackStrings(classId, specIndex)] ~= nil
    end    
    
    local function InitializeUserCustomWeights()
        -- test:   /script print(DugisGuideViewer.Modules.GearAdvisor.userCustomWeights["WARLOCK"][1]["INT"])
        LuaUtils:foreach(DugisGuideViewer.defaultLevelingSpec, function(info, classId)
            local classIndex = info.index
            --max: 4. Userd 10 for compatibility with new releases/version
            LuaUtils:loop(10, function (specIndex)
                local classAndSpecId = PackStrings(classId, specIndex)
                if scoring[classAndSpecId] ~= nil then
                    local weightValuePairs = {strsplit(":", scoring[classAndSpecId])}
                    LuaUtils:foreach(weightValuePairs, function(weightValuePair)
                        local weightName_weightValue = {strsplit(",", weightValuePair)}
                        local weightName = weightName_weightValue[1]
                        local weightValue = weightName_weightValue[2]
                        
                        if not DugisGuideUser.userCustomWeights[classId] then
                            DugisGuideUser.userCustomWeights[classId] = {}
                        end
                        
                        if not DugisGuideUser.userCustomWeights[classId][specIndex] then
                            DugisGuideUser.userCustomWeights[classId][specIndex] = {}
                        end
                        
                        if DugisGuideUser.userCustomWeights[classId][specIndex][weightName] == nil then
                            DugisGuideUser.userCustomWeights[classId][specIndex][weightName] = weightValue
                        end
                    end)
                else
                    --print("CANNOT FIND IN THE sscoring TABLE THE FOLLOWING ENTRY:", classId..":"..specIndex)
                end
            end)
        end)
    end
    
    InitializeUserCustomWeights()
    
    local classDropDownIndex2classIdentifierMap = {
         [1] = "DEATHKNIGHT" 
        ,[2] = "MONK"
        ,[3] = "WARRIOR"
        ,[4] = "PALADIN"
        ,[5] = "DRUID" 
        ,[6] = "ROGUE" 
        ,[7] = "SHAMAN"
        ,[8] = "HUNTER" 
        ,[9] = "MAGE" 
        ,[10] = "PRIEST" 
        ,[11] = "WARLOCK"
    }
    
    function GA:GetCurrentSelectedClassIdentifier()
        return classDropDownIndex2classIdentifierMap[DugisGuideViewer.Modules.GearAdvisor.selectedClassIndex]
    end
    
    --["classId:specIndex"]= "AGI,INT..."
    --Please add tothis list all other stats that wou want to display only when "Display All Stats" is checked.
    local advancedList = {
        ["DEATHKNIGHT:1"]        = "AGI,INT,SPELL_DMG,SPI,XP_BONUS",
        ["DEATHKNIGHT:1:PVP"]    = "AGI,INT,SPELL_DMG,SPI,XP_BONUS",
        ["DEATHKNIGHT:2"]        = "STA,AGI,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,INT,LEECH_RATING,SPELL_DMG,SPI,XP_BONUS",
        ["DEATHKNIGHT:2:PVP"]    = "STA,AGI,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,INT,LEECH_RATING,SPELL_DMG,SPI,XP_BONUS",
        ["DEATHKNIGHT:3"]        = "STA,AGI,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,INT,LEECH_RATING,SPELL_DMG,SPI,XP_BONUS",
        ["DEATHKNIGHT:3:PVP"]    = "STA,AGI,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,INT,LEECH_RATING,SPELL_DMG,SPI,XP_BONUS",
        ["MONK:1"]               = "INT,LEECH_RATING,SPELL_DMG,SPI,STR,XP_BONUS",
        ["MONK:1:PVP"]           = "INT,LEECH_RATING,SPELL_DMG,SPI,STR,XP_BONUS",
        ["MONK:2"]               = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,LEECH_RATING,STR,XP_BONUS",
        ["MONK:2:PVP"]           = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,LEECH_RATING,STR,XP_BONUS",
        ["MONK:3"]               = "STA,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,INT,LEECH_RATING,SPELL_DMG,SPI,STR,XP_BONUS",
        ["MONK:3:PVP"]           = "STA,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,INT,LEECH_RATING,SPELL_DMG,SPI,STR,XP_BONUS",
        ["WARRIOR:1"]            = "STA,AGI,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,INT,LEECH_RATING,SPELL_DMG,SPI,XP_BONUS",
        ["WARRIOR:1:PVP"]        = "STA,AGI,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,INT,LEECH_RATING,SPELL_DMG,SPI,XP_BONUS",
        ["WARRIOR:2"]            = "STA,AGI,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,INT,LEECH_RATING,SPELL_DMG,SPI,XP_BONUS",
        ["WARRIOR:2:PVP"]        = "STA,AGI,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,INT,LEECH_RATING,SPELL_DMG,SPI,XP_BONUS",
        ["WARRIOR:3"]            = "AGI,INT,SPELL_DMG,SPI,XP_BONUS",
        ["WARRIOR:3:PVP"]        = "AGI,INT,SPELL_DMG,SPI,XP_BONUS",
        ["PALADIN:1"]            = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,LEECH_RATING,STR,XP_BONUS",
        ["PALADIN:1:PVP"]        = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,LEECH_RATING,STR,XP_BONUS",
        ["PALADIN:2"]            = "AGI,INT,SPELL_DMG,SPI,XP_BONUS",
        ["PALADIN:2:PVP"]        = "AGI,INT,SPELL_DMG,SPI,XP_BONUS",
        ["PALADIN:3"]            = "STA,AGI,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,INT,LEECH_RATING,SPELL_DMG,SPI,XP_BONUS",
        ["PALADIN:3:PVP"]        = "STA,AGI,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,INT,LEECH_RATING,SPELL_DMG,SPI,XP_BONUS",
        ["DRUID:1"]              = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,LEECH_RATING,SPI,STR,XP_BONUS",
        ["DRUID:1:PVP"]          = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,LEECH_RATING,SPI,STR,XP_BONUS",
        ["DRUID:2"]              = "STA,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,INT,LEECH_RATING,SPELL_DMG,SPI,STR,XP_BONUS",
        ["DRUID:2:PVP"]          = "STA,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,INT,LEECH_RATING,SPELL_DMG,SPI,STR,XP_BONUS",
        ["DRUID:3"]              = "INT,SPELL_DMG,SPI,STR,XP_BONUS",
        ["DRUID:3:PVP"]          = "INT,SPELL_DMG,SPI,STR,XP_BONUS",
        ["DRUID:4"]              = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,LEECH_RATING,STR,XP_BONUS",
        ["DRUID:4:PVP"]          = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,LEECH_RATING,STR,XP_BONUS",
        ["ROGUE:1"]              = "STA,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,INT,LEECH_RATING,SPELL_DMG,SPI,STR,XP_BONUS",
        ["ROGUE:1:PVP"]          = "STA,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,INT,LEECH_RATING,SPELL_DMG,SPI,STR,XP_BONUS",
        ["ROGUE:2"]              = "STA,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,INT,LEECH_RATING,SPELL_DMG,SPI,STR,XP_BONUS",
        ["ROGUE:2:PVP"]          = "STA,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,INT,LEECH_RATING,SPELL_DMG,SPI,STR,XP_BONUS",
        ["ROGUE:3"]              = "STA,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,INT,LEECH_RATING,SPELL_DMG,SPI,STR,XP_BONUS",
        ["ROGUE:3:PVP"]          = "STA,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,INT,LEECH_RATING,SPELL_DMG,SPI,STR,XP_BONUS",
        ["SHAMAN:1"]             = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,LEECH_RATING,SPI,STR,XP_BONUS",
        ["SHAMAN:1:PVP"]         = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,LEECH_RATING,SPI,STR,XP_BONUS",
        ["SHAMAN:2"]             = "STA,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,INT,LEECH_RATING,SPELL_DMG,SPI,STR,XP_BONUS",
        ["SHAMAN:2:PVP"]         = "STA,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,INT,LEECH_RATING,SPELL_DMG,SPI,STR,XP_BONUS",
        ["SHAMAN:3"]             = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,STR,XP_BONUS",
        ["SHAMAN:3:PVP"]         = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,STR,XP_BONUS",
        ["HUNTER:1"]             = "STA,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,INT,LEECH_RATING,SPELL_DMG,SPI,STR,XP_BONUS",
        ["HUNTER:1:PVP"]         = "STA,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,INT,LEECH_RATING,SPELL_DMG,SPI,STR,XP_BONUS",
        ["HUNTER:2"]             = "STA,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,INT,LEECH_RATING,SPELL_DMG,SPI,STR,XP_BONUS",
        ["HUNTER:2:PVP"]         = "STA,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,INT,LEECH_RATING,SPELL_DMG,SPI,STR,XP_BONUS",
        ["HUNTER:3"]             = "STA,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,INT,LEECH_RATING,SPELL_DMG,SPI,STR,XP_BONUS",
        ["HUNTER:3:PVP"]         = "STA,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,INT,LEECH_RATING,SPELL_DMG,SPI,STR,XP_BONUS",
        ["MAGE:1"]               = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,LEECH_RATING,SPI,STR,XP_BONUS",
        ["MAGE:1:PVP"]           = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,LEECH_RATING,SPI,STR,XP_BONUS",
        ["MAGE:2"]               = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,LEECH_RATING,SPI,STR,XP_BONUS",
        ["MAGE:2:PVP"]           = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,LEECH_RATING,SPI,STR,XP_BONUS",
        ["MAGE:3"]               = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,LEECH_RATING,SPI,STR,XP_BONUS",
        ["MAGE:3:PVP"]           = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,LEECH_RATING,SPI,STR,XP_BONUS",
        ["PRIEST:1"]             = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,LEECH_RATING,STR,XP_BONUS",
        ["PRIEST:1:PVP"]         = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,LEECH_RATING,STR,XP_BONUS",
        ["PRIEST:2"]             = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,LEECH_RATING,STR,XP_BONUS",
        ["PRIEST:2:PVP"]         = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,LEECH_RATING,STR,XP_BONUS",
        ["PRIEST:3"]             = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,LEECH_RATING,SPI,STR,XP_BONUS",
        ["PRIEST:3:PVP"]         = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,LEECH_RATING,SPI,STR,XP_BONUS",
        ["WARLOCK:1"]            = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,LEECH_RATING,SPI,STR,XP_BONUS",
        ["WARLOCK:1:PVP"]        = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,LEECH_RATING,SPI,STR,XP_BONUS",
        ["WARLOCK:2"]            = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,LEECH_RATING,SPI,STR,XP_BONUS",
        ["WARLOCK:2:PVP"]        = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,LEECH_RATING,SPI,STR,XP_BONUS",
        ["WARLOCK:3"]            = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,LEECH_RATING,SPI,STR,XP_BONUS",
        ["WARLOCK:3:PVP"]        = "STA,AGI,AP,ARMOR,AVOIDANCE_RATING,BONUS_ARMOR,LEECH_RATING,SPI,STR,XP_BONUS"
                
    }
          
    -- test:   /script DugisGuideViewer.Modules.GearAdvisor:UpdateWeightsTextboxes("WARLOCK", 1)   
    function GA:UpdateWeightsTextboxesForClassAndSpec(classId, specIndex)
        if DugisGuideUser.userCustomWeights == nil then
            return
        end
        
        specIndex = tonumber(specIndex)
        local possibleWeightIdentifiers = GetAllPossibleWeightIdentifiers(classId, specIndex)
        
        LuaUtils:loop(28, function(item)
            _G["GA_TextWeight"..item]:Hide()          
            _G["GA_EditBoxWeight"..item]:Hide()          
        end)
        
        local weightsTop = 10
        
        LuaUtils:foreach(possibleWeightIdentifiers, function (weightIdentifier, index)
             local weightValue = DugisGuideUser.userCustomWeights[classId][specIndex][weightIdentifier]
             
             local shouldDisplayWeigt = true
             local advancedListWeights = advancedList["" .. classId .. ":" .. specIndex]
             
             if advancedListWeights ~= nil then
                local advancedWeights = {strsplit(",", advancedListWeights)}
                
                if LuaUtils:isInTable(weightIdentifier, advancedWeights) then
                    if not DugisGuideViewer:UserSetting(DGV_DISPLAYALLSTATS) then
                        shouldDisplayWeigt = false
                    end
                end
             end
             
             if shouldDisplayWeigt then
                _G["GA_EditBoxWeight"..index]:SetText(weightValue) 
                _G["GA_TextWeight"..index]:SetText(weightIdentifier2weightLabelMap[weightIdentifier] or weightIdentifier)
                _G["GA_EditBoxWeight"..index]['weightIdentifier'] = weightIdentifier
                
                _G["GA_EditBoxWeight"..index]:Show()
                _G["GA_TextWeight"..index]:Show()
                
                _G["GA_TextWeight"..index]:ClearAllPoints( )
                _G["GA_TextWeight"..index]:SetPoint("TOPLEFT", DugisGuideViewer.Modules.GearAdvisor.scrollFrame.frame.content, "TOPLEFT", 6, weightsTop)
                weightsTop = weightsTop - 22     
            end
        end)
        
        DugisGuideViewer.Modules.GearAdvisor.scrollFrame.scrollBar:GetParent():SetVerticalScroll(0)
        DugisGuideViewer.Modules.GearAdvisor.scrollFrame.scrollBar:SetValue(0)
        local newScrollHeight = -weightsTop - 200
        if newScrollHeight < 0 then 
            newScrollHeight = 0
        end
        DugisGuideViewer.Modules.GearAdvisor.scrollFrame.scrollBar:SetMinMaxValues(0, newScrollHeight)
    end
    
    function GA:ResetWeights()
        DugisGuideUser.userCustomWeights = {}
        InitializeUserCustomWeights()
        GA:UpdateWeightsTextboxes() 
    end
    
    function GA:ApplyWeights()
        local specIndex = tonumber(DugisGuideViewer.Modules.GearAdvisor.selectedSpecIndex)
        local classId = GA:GetCurrentSelectedClassIdentifier()    
        local possibleWeightIdentifiers = GetAllPossibleWeightIdentifiers(classId, specIndex)

        LuaUtils:loop(28, function(index)
             if _G["GA_EditBoxWeight"..index]:IsShown() then
                 local weightIdentifier = _G["GA_EditBoxWeight"..index]['weightIdentifier']
                 local weightValue = tonumber(_G["GA_EditBoxWeight"..index]:GetText())
                 
                 --print("set", weightIdentifier, " to ",weightValue)
                 DugisGuideUser.userCustomWeights[classId][specIndex][weightIdentifier] = weightValue
             
             end
        end)
        
        GA:ResetCalculateScoreCache()
		DGV:ShowReloadUi()
    end
    
    -- test:   /script DugisGuideViewer.Modules.GearAdvisor:UpdateWeightsTextboxes("WARLOCK", 1)   
    function GA:UpdateWeightsTextboxes()
        if DugisGuideViewer.Modules.GearAdvisor.selectedClassIndex and DugisGuideViewer.Modules.GearAdvisor.selectedSpecIndex then
           GA:UpdateWeightsTextboxesForClassAndSpec(GA:GetCurrentSelectedClassIdentifier(), DugisGuideViewer.Modules.GearAdvisor.selectedSpecIndex)
        end
    end

    
	local defaultLevelingSpec = DugisGuideViewer.defaultLevelingSpec
    
	local SPELL_SCHOOL_HOLY = 2
	local SPELL_SCHOOL_FIRE = 3
	local SPELL_SCHOOL_NATURE = 4
	local SPELL_SCHOOL_FROST = 5
	local SPELL_SCHOOL_SHADOW = 6
	local SPELL_SCHOOL_ARCANE = 7
	local defaultSpellSchool = {
		["MONK:2"] = SPELL_SCHOOL_NATURE,
		["PALADIN:1"] = SPELL_SCHOOL_HOLY,
		["DRUID:1"] = SPELL_SCHOOL_NATURE,
		["DRUID:4"] = SPELL_SCHOOL_NATURE,
		["SHAMAN:1"] = SPELL_SCHOOL_NATURE,
		["SHAMAN:3"] = SPELL_SCHOOL_NATURE,
		["MAGE:1"] = SPELL_SCHOOL_ARCANE,
		["MAGE:2"] = SPELL_SCHOOL_FIRE,
		["MAGE:3"] = SPELL_SCHOOL_FROST,
		["PRIEST:1"] = SPELL_SCHOOL_HOLY,
		["PRIEST:2"] = SPELL_SCHOOL_HOLY,
		["PRIEST:3"] = SPELL_SCHOOL_SHADOW,
		["WARLOCK:1"] = SPELL_SCHOOL_SHADOW,
		["WARLOCK:2"] = SPELL_SCHOOL_SHADOW,
		["WARLOCK:3"] = SPELL_SCHOOL_SHADOW
	}
	
	--StatLogic:GetStatMod(stat, school, talentGroup, modTable, armorSpecOverride)
	local function sumStrength(sum, sumType, link, armorSpecOverride) return sum["STR"] and (sum["STR"] * StatLogic:GetStatMod("MOD_STR", nil, nil, nil, armorSpecOverride)) or 0 end
	local function sumAgility(sum, sumType, link, armorSpecOverride) return sum["AGI"] and (sum["AGI"] * StatLogic:GetStatMod("MOD_AGI", nil, nil, nil, armorSpecOverride)) or 0 end
	local function sumStamina(sum, sumType, link, armorSpecOverride) return sum["STA"] and (sum["STA"] * StatLogic:GetStatMod("MOD_STA", nil, nil, nil, armorSpecOverride)) or 0 end
	local function sumIntellect(sum, sumType, link, armorSpecOverride) return sum["INT"] and (sum["INT"] * StatLogic:GetStatMod("MOD_INT", nil, nil, nil, armorSpecOverride)) or 0 end
	local function sumSpirit(sum, sumType, link) return sum["SPI"] and (sum["SPI"] * StatLogic:GetStatMod("MOD_SPI")) or 0 end
	
	-- local function sumExpertise(sum, sumType, link, slot)
		-- local add = (slot~=INVSLOT_OFFHAND and sum["EXPERTISE"]) or 0 --exclude offhand for this calculation
		-- return StatLogic:GetEffectFromRating((sum["EXPERTISE_RATING"] or 0), "EXPERTISE_RATING")+add
	-- end
	local function sumMeleeAttackPower(sum, sumType, link) 
		local ap = sum["AP"] or 0 --deprecated 4.0.1 AFAIK
		ap = ap + StatLogic:GetAPFromStr(sumStrength(sum, sumType, link))
		ap = ap + StatLogic:GetAPFromAgi(sumAgility(sum, sumType, link))
	
		return ap * StatLogic:GetStatMod("MOD_AP")
	end
	-- local function sumSpellHit(sum, sumType, link, slot)
		-- local rating = sum["SPELL_HIT_RATING"] or 0
		-- local spi = sumSpirit(sum, sumType, link) 
		-- rating = rating + spi*StatLogic:GetStatMod("ADD_SPELL_HIT_RATING_MOD_SPI")
		-- local hit, _, ratingPerBonus = StatLogic:GetEffectFromRating(rating, "SPELL_HIT_RATING")
		-- local expertise = sumExpertise(sum, sumType, link, slot)
		-- hit = hit + expertise*StatLogic:GetStatMod("ADD_SPELL_HIT_MOD_EXPERTISE")
		-- return hit, ratingPerBonus
	-- end
	-- local function sumMeleeHit(sum, sumType, link)
		-- local rating = sum["MELEE_HIT_RATING"] or 0
		-- local spi = sumSpirit(sum, sumType, link) 
		-- rating = rating + spi*StatLogic:GetStatMod("ADD_SPELL_HIT_RATING_MOD_SPI")
		-- local bonus, _, ratingPerBonus = StatLogic:GetEffectFromRating(rating, "MELEE_HIT_RATING")
		-- return bonus, ratingPerBonus
	-- end
	local function sumMeleeCrit(sum, sumType, link) --GetCritFromAgi numbers don't seem right for monk.  No monk specs have crit cap before 1, se we can safely ignore this test failure.
		return StatLogic:GetCritFromAgi(sumAgility(sum, sumType, link))+StatLogic:GetEffectFromRating(sum["MELEE_CRIT_RATING"] or 0, "MELEE_CRIT_RATING")
	end
	local function sumMeleeHaste(sum, sumType, link)
		return StatLogic:GetEffectFromRating(sum["MELEE_HASTE_RATING"] or 0, "MELEE_HASTE_RATING")*StatLogic:GetStatMod("MOD_MELEE_HASTE")
	end
	local function sumMeleeDPS(sum, sumType, link, slot)
		local dps = sum["DPS"] or 0
		local ap = sumMeleeAttackPower(sum, sumType, link)
		if slot~=INVSLOT_OFFHAND then --exclude offhand for this calculation
			dps = dps + ap/ATTACK_POWER_MAGIC_NUMBER
		end
		dps = dps*StatLogic:GetStatMod("MOD_DMG")*StatLogic:GetStatMod("MOD_MELEE_HASTE")
		return dps
	end
	local function sumMastery(sum, sumType, link)
		local rating = sum["MASTERY_RATING"] or 0
		return StatLogic:GetEffectFromRating(rating, "MASTERY_RATING")*StatLogic:GetStatMod("MOD_MASTERY")
	end
	-- local function sumDodge(sum, sumType, link)
		-- local rating = sum["DODGE_RATING"] or 0
		-- return StatLogic:GetEffectFromRating(rating, "DODGE_RATING") + StatLogic:GetDodgeFromAgi(sumAgility(sum, sumType, link))
	-- end
	-- local function sumParry(sum, sumType, link)
		-- local rating = sum["PARRY_RATING"] or 0
		-- local str = sumStrength(sum, sumType, link)
		-- rating = rating + str*StatLogic:GetStatMod("ADD_PARRY_RATING_MOD_STR")
		-- return StatLogic:GetEffectFromRating(rating, "PARRY_RATING")
	-- end
	local function sumArmor(sum, sumType, link)
		return (sum["ARMOR"] or 0) * StatLogic:GetStatMod("MOD_ARMOR") + (sum["BONUS_ARMOR"] or 0)
	end
	
	--BASE_MISS_CHANCE_PHYSICAL
	--BASE_MISS_CHANCE_SPELL
	--DUAL_WIELD_HIT_PENALTY
	
	local orig_GetSpecialization
	local function GetSpecialization(...)
		if not orig_GetSpecialization then orig_GetSpecialization = _G.GetSpecialization end
		local spec = orig_GetSpecialization(...)
		if not spec and select("#", ...)==0 then return defaultLevelingSpec[select(2,UnitClass("player"))].index end
		return spec
	end
	
	-- local function VisitCSV(func, itemLink, spec, level, slot, itemSums, uncapped, ...)
		-- local returns = GetCreateTable()
		-- for i=1,select("#", ...) do
			-- returns:InsertList(func(itemLink, spec, level, slot, itemSums, uncapped, strsplit(",", (select(i,...)))))
			-- local last = returns[returns.n]
			-- if type(last)=="number" and last<0 then --allow short circuit on negative values
				-- returns:Pool()
				-- return last
			-- end
		-- end
		-- return returns:Pool()
	-- end
	
	local function GetAllCSV(...)
		local tbl = {}
		for i=1,select("#", ...) do
			tinsert(tbl, {strsplit(",", (select(i,...)))})
		end
		return tbl
	end
	
	local scoringSpecs = {}
	local function GetScoringInfo(spec, pvp)
		if not spec then
			spec = GetSpecialization()
		end
		local key = pvp and spec.."PVP" or spec
		if not scoringSpecs[key]  then
			local _, class = UnitClass("player")
			if pvp then
				scoringSpecs[spec.."PVP"] = GetAllCSV(strsplit(":", scoring[PackStrings(class, spec, "PVP")]))
			else
				scoringSpecs[spec] = GetAllCSV(strsplit(":", scoring[PackStrings(class, spec)]))
                LuaUtils:foreach(scoringSpecs[spec], function(row)
                    local weightName = row[1]
                    if DugisGuideUser.userCustomWeights[class] ~= nil 
                    and DugisGuideUser.userCustomWeights[class][spec] ~= nil 
                    and DugisGuideUser.userCustomWeights[class][spec][weightName] ~= nil then
                       local weightValue = DugisGuideUser.userCustomWeights[class][spec][weightName]
                       row[2] = weightValue
                    end
                end)
			end
		end
		return unpack(scoringSpecs[key])
	end
	GA.scoringSpecs = scoringSpecs
	
	local function GetTieBreakerScoringInfo()

		return unpack(scoring.tiebreaker)
	end
	
	local itemClassTable = {}
	local itemSubClassTable = {}
	do
		local classTable = GetCreateTable(GetAuctionItemClasses())
		for classIndex,className in classTable:IPairs() do
			itemClassTable[className] = classIndex
			itemSubClassTable[className] = {}
			local subClassTable = GetCreateTable(GetAuctionItemSubClasses(classIndex))
			for subClassIndex,subClassName in subClassTable:IPairs() do
				itemSubClassTable[className][subClassName] = subClassIndex
			end
			subClassTable:Pool()
		end
		classTable:Pool()
	end
	local function GetItemClassIndex(localizedItemClass, localizedItemSubclass)
		local classIndex = itemClassTable[localizedItemClass]
		if not classIndex then return end
		return classIndex, itemSubClassTable[localizedItemClass][localizedItemSubclass]
	end
	
	local function PlayerCanTitansGrip(weaponSubClass, spec, level)
		local hasTitansGrip = select(2,UnitClass("player"))=="WARRIOR" and spec==2 and level>=10
		if not hasTitansGrip then return end
		return weaponSubClass==WEAPON_SUBCLASS_TWO_HANDED_AXES or weaponSubClass==WEAPON_SUBCLASS_TWO_HANDED_MACES or weaponSubClass==WEAPON_SUBCLASS_TWO_HANDED_SWORDS or weaponSubClass==WEAPON_SUBCLASS_POLEARMS
	end
	
	local function PlayerCanDualWield(spec, level)
		local class = select(2,UnitClass("player"))
		if class=="DEATHKNIGHT" or class=="ROGUE" then
			return true
		elseif class=="SHAMAN" and level>=10 and spec==2 then
			return true
		elseif class=="MONK" and level>=10 and (spec==1 or spec==3) then
			return true
		elseif class=="WARRIOR" and level>=10 and spec==2 then
			return true
		end
	end
	

	local function PlayerShouldDualWieldWithMainHand(spec, level, equipSlot, itemSubclass)
		return 
			PlayerCanDualWield(spec, level) and 
			(equipSlot=="INVTYPE_WEAPON" or equipSlot=="INVTYPE_WEAPONMAINHAND" or PlayerCanTitansGrip(itemSubclass, spec, level))
	end
	
	local function GetValidKeyTransform(key, itemLink, spec, level, uniqueInventorySlot, itemClass, itemSubclass, equipSlot)



		if uniqueInventorySlot==INVSLOT_OFFHAND then
			if key=="DPS" or key=="DPS|MAIN" then return end
			if key=="DPS|OFF" and itemClass==ITEM_CLASS_WEAPON then
				if not PlayerCanDualWield(spec, level) then return end
				if 
					equipSlot=="INVTYPE_SHIELD" or equipSlot=="INVTYPE_WEAPONOFFHAND" or equipSlot=="INVTYPE_HOLDABLE" or equipSlot=="INVTYPE_WEAPON" or
					PlayerCanTitansGrip(itemSubclass, spec, level)
				then
					return "DPS"
				end
			end
		elseif uniqueInventorySlot==INVSLOT_MAINHAND then
			if key=="DPS|OFF" then return end
			if (key=="DPS" or key=="DPS|MAIN") and PlayerShouldDualWieldWithMainHand(spec, level, equipSlot, itemSubclass) then
				return key=="DPS|MAIN" and "DPS" or nil
			end
		end
		return key
	end
	
	local function nextValidSlot(includeEmpty, slot)
		if not slot then slot = EQUIPPED_FIRST
		else slot = slot+1 end
		
		for i=slot,EQUIPPED_LAST do
			local itemLink = GetInventoryItemLink("player", i)
			if includeEmpty or itemLink then return i,itemLink end
		end
		return
	end
	
	local function NextUniqueInventorySlot(invariant, control)
		if not control then return "INVTYPE_HEAD", INVSLOT_HEAD
		elseif control=="INVTYPE_HEAD" then return "INVTYPE_NECK", INVSLOT_NECK
		elseif control=="INVTYPE_NECK" then return "INVTYPE_SHOULDER", INVSLOT_SHOULDER
		elseif control=="INVTYPE_SHOULDER" then return "INVTYPE_CHEST", INVSLOT_CHEST
		elseif control=="INVTYPE_CHEST" then return "INVTYPE_WAIST", INVSLOT_WAIST
		elseif control=="INVTYPE_WAIST" then return "INVTYPE_LEGS", INVSLOT_LEGS
		elseif control=="INVTYPE_LEGS" then return "INVTYPE_FEET", INVSLOT_FEET
		elseif control=="INVTYPE_FEET" then return "INVTYPE_WRIST", INVSLOT_WRIST
		elseif control=="INVTYPE_WRIST" then return "INVTYPE_HAND", INVSLOT_HAND
		elseif control=="INVTYPE_HAND" then return "INVTYPE_FINGER", INVSLOT_FINGER1, INVSLOT_FINGER2
		elseif control=="INVTYPE_FINGER" and DGV:UserSetting(DGV_SUGGESTTRINKET) then 
			return "INVTYPE_TRINKET", INVSLOT_TRINKET1, INVSLOT_TRINKET2 --ignore trinkets
		elseif control=="INVTYPE_FINGER" and not DGV:UserSetting(DGV_SUGGESTTRINKET) then 
			return "INVTYPE_CLOAK", INVSLOT_BACK --ignore trinkets
		elseif control=="INVTYPE_TRINKET" and DGV:UserSetting(DGV_SUGGESTTRINKET) then 
			return "INVTYPE_CLOAK", INVSLOT_BACK --ignore trinkets
		--elseif control=="INVTYPE_FINGER" then return "INVTYPE_CLOAK", INVSLOT_BACK
		elseif control=="INVTYPE_CLOAK" then return INVSLOT_MAINHAND, INVSLOT_MAINHAND, INVSLOT_OFFHAND
		end
	end
	
	local function PoolItemSums(reaction)
		reaction:UnpackCache():Pool()
	end
	
	local function GetItemSums(itemLink)
		-- local cacheKey = "GetItemSums"..itemLink
		-- local cacheReaction = TryGetCacheReaction(cacheKey)
		-- if cacheReaction then
			-- return cacheReaction:UnpackCache()
		-- end
		
		local itemSums = GetCreateTable()
		StatLogic:GetSum(itemLink, itemSums)
		DGV.InitTable(itemSums)
--DGV:DebugFormat("GetItemSums", "itemLink", itemLink, "itemSums", itemSums)
		-- return RegisterReaction("BAG_UPDATE"):SetCache(cacheKey, itemSums):WithAction(PoolItemSums):UnpackCache()
		return itemSums
	end
	
	--Armor Specialization Stats
	--STA, AGI, INT, STR
	local function GetItemStatSum(key, itemLink, invSlot, itemSums)
		local poolItemSums
		if not itemSums then
			poolItemSums = true
			itemSums = GetItemSums(itemLink)
		end
		local itemSum--, bonus, ratingPerBonus, ratingId
		-- if key=="SPELL_HIT_RATING" then 									--Hit chance is a little special. It is awarded by expertise(spell) and spirit in order to aide hybrid classes
			-- bonus, ratingPerBonus = sumSpellHit(itemSums, nil, itemLink, uniqueInventorySlot) --So spirit and expertise (including racial weapon specializations) should be additionally scored
			-- itemSum = bonus*ratingPerBonus											--as hit chance, when a given spec cares about hit chance
			-- ratingId = CR_HIT_SPELL
		-- elseif key=="MELEE_HIT_RATING" then
			-- bonus, ratingPerBonus = sumMeleeHit(itemSums, nil, itemLink, uniqueInventorySlot)
			-- itemSum = bonus*ratingPerBonus
			-- ratingId = CR_HIT_MELEE
		-- elseif key=="RANGED_HIT_RATING" then
			-- bonus, ratingPerBonus = sumMeleeHit(itemSums, nil, itemLink, uniqueInventorySlot)
			-- itemSum = bonus*ratingPerBonus
			-- ratingId = CR_HIT_RANGED
		-- else
			itemSum = itemSums[key] or 0
			--bonus, ratingId, ratingPerBonus = StatLogic:GetEffectFromRating(itemSum, key)
		-- end
		if poolItemSums then itemSums:Pool() end
		return itemSum--, bonus, ratingPerBonus, ratingId
	end
	
	local function UniqueInventoryToInvSlot(uniqueInventorySlot)
		if type(uniqueInventorySlot)=="number" then
			return uniqueInventorySlot
		elseif uniqueInventorySlot=="INVTYPE_FINGER" then
			return INVSLOT_FINGER1, INVSLOT_FINGER2
		elseif uniqueInventorySlot=="INVTYPE_TRINKET" and DGV:UserSetting(DGV_SUGGESTTRINKET) then
			return INVSLOT_TRINKET1, INVSLOT_TRINKET2
		elseif uniqueInventorySlot=="INVTYPE_CLOAK" then
			return INVSLOT_BACK
		else
			return _G["INVSLOT"..strsub(uniqueInventorySlot, 8)]
		end
	end
	
	local function UnbindSpecDataTable(dataTable)
--DGV:DebugFormat("UnbindSpecDataTable")
		if dataTable.cacheInValid then
--DGV:DebugFormat("UnbindSpecDataTable", "dataTable", tostring(dataTable))
			dataTable:Pool()
			return
		end
	end
	
	_G["CalculateScore"] = nil 
	local function GetBestBaselineRating(key, spec, pvp, level, uniqueInventorySlot, itemLink)
--DGV:DebugFormat("GetBestBaselineRating", "key", key, "spec", spec, "level", level, "uniqueInventorySlot", uniqueInventorySlot)
		local dataTable = GA:GetSpecDataTable(spec, pvp, nil, nil, true):BindToAutoroutineLifetime(UnbindSpecDataTable)
--if true then return 0 end
		local invSlot
		local inv1, inv2 = UniqueInventoryToInvSlot(uniqueInventorySlot)
		local current1, current2 = GetInventoryItemLink("player", inv1), GetInventoryItemLink("player", inv2)
		local bestEquippedSlot = 
			(dataTable[inv1] == current1 and inv1) or 
			(dataTable[inv1] == current2 and inv1) or 
			(inv2 and dataTable[inv2] == current1 and inv2) or
			(inv2 and dataTable[inv2] == current2 and inv2)
--if true then return 0 end
		if not inv2 then
			invSlot = inv1
		elseif dataTable[inv1]==itemLink then
			invSlot = inv1
		elseif dataTable[inv2]==itemLink then
			invSlot = inv2
		elseif bestEquippedSlot then
			invSlot = bestEquippedSlot
		else
			local score1 = CalculateScore(dataTable[inv1], spec, pvp, level, uniqueInventorySlot, nil, nil, true)
			local score2 = CalculateScore(dataTable[inv2], spec, pvp, level, uniqueInventorySlot, nil, nil, true)
			-- local score1 = DGV:CalculateScore(nil, current1, spec, level, uniqueInventorySlot, nil, nil, nil, true)
			-- local score2 = DGV:CalculateScore(nil, current2, spec, level, uniqueInventorySlot, nil, nil, nil, true)
			invSlot = score1>=score2 and inv2 or inv1
		end
--if true then return 0 end
		local ratingCount = 0
		for unique,inv1,inv2 in NextUniqueInventorySlot do
			if invSlot~=inv1 then
				ratingCount = ratingCount + GetItemStatSum(key, dataTable[inv1], inv1)
			end
			if invSlot~=inv2 and inv2 and dataTable[inv2] then
				ratingCount = ratingCount + GetItemStatSum(key, dataTable[inv2], inv2)
			end
		end
		return ratingCount
	end
	
	local function GetCurrentRating(key)
		local cacheKey = "GetCurrentRating"..key
		local cacheReaction = TryGetCacheReaction(cacheKey)
		if cacheReaction then
			return cacheReaction:UnpackCache()
		end
		local ratingCount = 0
		for unique,inv1,inv2 in NextUniqueInventorySlot do
			local inv1Item = GetInventoryItemLink("player", inv1)
			if inv1Item then
				ratingCount = ratingCount + GetItemStatSum(key, inv1Item, inv1)
			end
			local inv2Item = GetInventoryItemLink("player", inv2)
			if inv2 and inv2Item then
				ratingCount = ratingCount + GetItemStatSum(key, inv2Item, inv2)
			end
		end
		RegisterReaction("PLAYER_EQUIPMENT_CHANGED"):SetCache(cacheKey, ratingCount)
		return ratingCount
	end
	
	local function GetSpecializationSpellSchool(spec)
		if not spec then
			spec = GetSpecialization()
		end
		local _, class = UnitClass("player")
		return defaultSpellSchool[PackStrings(class, spec)]
	end
	
	--EXPERTISE_RATING
	--MELEE_HIT_RATING
	--SPELL_HIT_RATING
	--RANGED_HIT_RATING
	--MELEE_HASTE_RATING
	--RANGED_HASTE_RATING
	--SPELL_HASTE_RATING
	--MELEE_CRIT_RATING
	--SPELL_CRIT_RATING
	--RANGED_CRIT_RATING
	local function GetCurrentRatingBonus(key, spec)
		local _, class = UnitClass("player")
		-- if key=="EXPERTISE_RATING" then
			-- local expertise, offhandExpertise, rangedExpertise = GetExpertise()
			-- return class=="HUNTER" and rangedExpertise or expertise
		-- elseif key=="MELEE_HIT_RATING" then
			-- return GetCombatRatingBonus(CR_HIT_MELEE) + GetHitModifier()
		-- elseif key=="SPELL_HIT_RATING" then
			-- return GetCombatRatingBonus(CR_HIT_SPELL) + GetSpellHitModifier()
		-- elseif key=="RANGED_HIT_RATING" then
			-- return GetCombatRatingBonus(CR_HIT_RANGED) - GetHitModifier()
		-- else
		if key=="MELEE_HASTE_RATING" then
			return GetMeleeHaste()
		elseif key=="RANGED_HASTE_RATING" then
			return GetRangedHaste()
		elseif key=="SPELL_HASTE_RATING" then
			return UnitSpellHaste("player")
		elseif key=="MELEE_CRIT_RATING" then
			return GetCritChance()
		elseif key=="SPELL_CRIT_RATING" then
			return GetSpellCritChance(GetSpecializationSpellSchool(spec))
		elseif key=="RANGED_CRIT_RATING" then
			return GetRangedCritChance()
		end
	end
	
	local function GetBestBaselineBonus(key, spec, pvp, level, uniqueInventorySlot, itemLink, ratingPerBonus)
		-- local cacheKey = strformat("%s%s%d%d%s", "GetBestBaselineBonus", key, spec, level, tostring(uniqueInventorySlot))
		-- local cacheReaction = TryGetCacheReaction(cacheKey)
		-- if cacheReaction then
			-- return cacheReaction:UnpackCache()
		-- end
		local currentBonus = GetCurrentRatingBonus(key, spec)
		if not currentBonus then return end
		local baseLineRating = GetBestBaselineRating(key, spec, pvp, level, uniqueInventorySlot, itemLink)
		local currentRating = GetCurrentRating(key)
		local ratingDifference = baseLineRating - currentRating
		local baselineBonus = currentBonus + ratingDifference/ratingPerBonus
--DGV:DebugFormat("GetBestBaselineBonus", "key", key, "baselineBonus", baselineBonus, "baseLineRating", baseLineRating, "currentRating", currentRating, "ratingDifference", ratingDifference, "currentBonus", currentBonus, "ratingDifference/ratingPerBonus", ratingDifference/ratingPerBonus)
		-- RegisterStopwatchReaction(0):SetCache(cacheKey, baselineBonus)
		return baselineBonus
	end
	
	local function GetCapValue(key, cap)
		local capNumber = tonumber(cap)
		if capNumber then return capNumber*100 end
		local levelDifference = DGV:UserSetting(DGV_GASTATCAPLEVELDIFFERENCE)
		if cap=="NO_MISS" then
			-- if key=="MELEE_HIT_RATING" or key=="RANGED_HIT_RATING" then
				-- capNumber = BASE_MISS_CHANCE_PHYSICAL[levelDifference]
			-- elseif key=="SPELL_HIT_RATING" then
				-- capNumber = BASE_MISS_CHANCE_SPELL[levelDifference]
			-- end
		elseif key=="EXPERTISE_RATING" then
			-- if cap=="NO_DODGE" then
				-- capNumber = BASE_ENEMY_DODGE_CHANCE[levelDifference]
			-- elseif cap=="NO_PARRY" then
				-- capNumber = BASE_ENEMY_DODGE_CHANCE[levelDifference]+BASE_ENEMY_PARRY_CHANCE[levelDifference]
			-- end
		end
--DGV:DebugFormat("GetCapValue", "key", key, "capNumber", capNumber)
		return capNumber
	end
	
	local function CalculateRatingScore(key, baseLineBonus, rating, bonus, ratingPerBonus, weight, cap, ...)
--DGV:DebugFormat("CalculateRatingScore", "baseLineBonus", baseLineBonus, "bonus", bonus, "rating", rating, "weight", weight, "cap", cap)
		weight = tonumber(weight)
		cap = GetCapValue(key, cap)
		local scoreBelowCap, scoreAboveCap = 0,0
--DGV:DebugFormat("CalculateRatingScore 1", "baseLineBonus", baseLineBonus, "rating", rating, "bonus", bonus)
		if not cap or (baseLineBonus+bonus)<cap then
			scoreBelowCap = rating*weight
		elseif baseLineBonus<cap then
			local bonusRatio = (cap-baseLineBonus)/bonus
			scoreBelowCap = (rating*bonusRatio)*weight
			bonus = (1-bonusRatio)*bonus
			rating = (1-bonusRatio)*rating
		end
		if cap and baseLineBonus+bonus>cap then
			scoreAboveCap = CalculateRatingScore(key, baseLineBonus, rating, bonus, ratingPerBonus, ...)
		end
		
--DGV:DebugFormat("CalculateRatingScore 2", "key", key, "baseLineBonus", baseLineBonus, "rating", rating, "bonus", bonus, "weight", weight, "cap", cap, "scoreBelowCap", scoreBelowCap, "scoreAboveCap", scoreAboveCap)
		return scoreBelowCap+scoreAboveCap
	end
	
	local function CheckSubclass(level, itemRarity, itemSubclass, ...)
		for i=1,select("#", ...) do
			local arg = select(i, ...)
			local number, requiredLevel = strsplit("|", arg)
			number = tonumber(number)
			requiredLevel = tonumber(requiredLevel) or 0
			local selectedArg = (requiredLevel<=level or itemRarity==7) and number or -1 --itemRarity==7 excuses heirlooms, so long as character can eventually use the armor type
			if selectedArg==itemSubclass then return true end
		end
	end

	
	local function IsArmorSpecSlot(slot)
		return
			slot==INVSLOT_CHEST or
			slot==INVSLOT_FEET or
			slot==INVSLOT_HAND or
			slot==INVSLOT_HEAD or
			slot==INVSLOT_LEGS or
			slot==INVSLOT_SHOULDER or
			slot==INVSLOT_WAIST or
			slot==INVSLOT_WRIST
	end

	local function ItemIsEquipped(itemLink, itemIteratorTable)
		if itemIteratorTable then
			return itemIteratorTable.player and not itemIteratorTable.bags
		else
			for slot,link in nextValidSlot do
				if link==itemLink then return true end
			end
		end
	end
	
	local function ItemIsBanned(itemLink, itemIteratorTable)
		return DGV.chardb.GA_Blacklist and DGV.chardb.GA_Blacklist[DGV:GetItemIdFromLink(itemLink)] and not ItemIsEquipped(itemLink, itemIteratorTable)
	end	

	local function ItemIsBannedWeapon(itemLink)
		if not itemLink then return end
		return DGV.chardb.GA_Blacklist and DGV.chardb.GA_Blacklist[DGV:GetItemIdFromLink(itemLink)]
	end	
	
	function CalculateScoreForInfo(itemLink, spec, pvp, level, uniqueInventorySlot, itemSums, enforceArmorSpecSubclass, uncapped, key, value, ...)
		if key == "ARMOR_SPECIALIZATION_STAT" then return 0 end
		local itemString = string.match(itemLink, "item[%-?%d:]+")
		local _, itemId = strsplit(":", itemString)
		local itemRarity, _, _, itemClass, itemSubclass, _, equipSlot = select(3, GetItemInfo(itemLink))

		itemClass, itemSubclass = GetItemClassIndex(itemClass, itemSubclass)
		if itemClass~=ITEM_CLASS_WEAPON and itemClass~=ITEM_CLASS_ARMOR then return -2 end
		
		if DGV:UserSetting(DGV_FISHINGPOLE) and ItemIsEquipped(itemLink) then 
			if itemClass==ITEM_CLASS_WEAPON and itemSubclass==WEAPON_SUBCLASS_FISHING_POLE then 
				return 2000000
			elseif tonumber(itemId) == 6256 or 
				tonumber(itemId) == 19969 or
				tonumber(itemId) == 50287 or
				tonumber(itemId) == 93732 or
				tonumber(itemId) == 118380 or
				tonumber(itemId) == 117405 or
				tonumber(itemId) == 88710 or
				tonumber(itemId) == 33820 or
				tonumber(itemId) == 118393						
				then 
				return 2000000
			end
		end
		
		if DGV:UserSetting(DGV_COOKINGITEM) and ItemIsEquipped(itemLink) then 
			if tonumber(itemId) == 46349 or 
				tonumber(itemId) == 86468 or 
				tonumber(itemId) == 86559 or 
				tonumber(itemId) == 86558 
				then
				return 2000000
			end
		end
		
		if DGV:UserSetting(DGV_DAILYITEM) and ItemIsEquipped(itemLink) then 
			if tonumber(itemId) == 46106 or --argent lance
				tonumber(itemId) == 46069 or --alliance lance
				tonumber(itemId) == 46070 --horde lance
				then
				return 2000000
			end
		end		
		
		if itemClass==ITEM_CLASS_ARMOR and itemSubclass==ARMOR_SUBCLASS_COSMETIC then return -2 end
		if (key == "ITEM_CLASS_WEAPON" and itemClass==ITEM_CLASS_WEAPON) or (key == "ITEM_CLASS_ARMOR" and itemClass==ITEM_CLASS_ARMOR) then
			if 
				enforceArmorSpecSubclass and 
				itemClass==ITEM_CLASS_ARMOR and 
				itemSubclass~=ARMOR_SUBCLASS_SHIELDS and 
				itemSubclass~=enforceArmorSpecSubclass and
				IsArmorSpecSlot(UniqueInventoryToInvSlot(uniqueInventorySlot))
			then
				return -4
			end
			return CheckSubclass(level, itemRarity, itemSubclass, value, ...) and 0 or -3
		elseif key ~= "ITEM_CLASS_WEAPON" and key ~= "ITEM_CLASS_ARMOR" then
			local keyTransform = GetValidKeyTransform(key, itemLink, spec, level, uniqueInventorySlot, itemClass, itemSubclass, equipSlot)
			if not keyTransform then return 0 end
			local itemSum = GetItemStatSum(keyTransform, itemLink, uniqueInventorySlot, itemSums)
--if true then return itemSum*value end
			local slot1, slot2 = UniqueInventoryToInvSlot(uniqueInventorySlot)
			if uncapped or itemSum==0 or not select(1, ...) or not GetCurrentRatingBonus(keyTransform, spec) then
				return itemSum*value, itemSum
			end
			local bonus, _, ratingPerBonus = StatLogic:GetEffectFromRating(itemSum, keyTransform)
			local baseLineBonus = GetBestBaselineBonus(keyTransform, spec, pvp, level, uniqueInventorySlot, itemLink, ratingPerBonus)
--if true then return itemSum*value end

			local score = CalculateRatingScore(keyTransform, baseLineBonus, itemSum, bonus, ratingPerBonus, value, ...)
			return score, itemSum
		end
	end

	
	local function GetUniqueID(control)
		return string.format("%s|%s|%d", tostring(control.func), tostring(control.bag), control.slot)
	end
	
	local function ItemWasFirst(control, link)
		if control.first==link then
			control.first = nil
			return true
		end
	end
	
	--GetContainerItemLink(container, slot)
	--BACKPACK_CONTAINER: Backpack (0)
	--1 through GetNumBankSlots(): Bag slots (as presented in the default UI, numbered right to left)
	--GetInventoryItemLink("unit", slot) EQUIPPED_FIRST, EQUIPPED_LAST
	--GetNumQuestRewards
	--GetNumQuestChoices
	--GetQuestLogItemLink("itemType", index)
	--GetQuestItemLink("itemType", index)
	--name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(itemID) or GetItemInfo("itemName") or GetItemInfo("itemLink")
	local ITEM_ITERATOR_SKIP_EQUIPPED = 1
	local ITEM_ITERATOR_SKIP_REWARDS = 2
	local ITEM_ITERATOR_SKIP_LOOT_ROLL = 4
	local ITEM_ITERATOR_SKIP_ENCOUNTER_JOURNAL = 8
	local ITEM_ITERATOR_SKIP_VENDOR = 16
	local ITEM_ITERATOR_SKIP_LOOT = 32
	local ITEM_ITERATOR_SKIP_ALL_EXTERNAL = bit.bor(ITEM_ITERATOR_SKIP_REWARDS, ITEM_ITERATOR_SKIP_LOOT_ROLL, ITEM_ITERATOR_SKIP_ENCOUNTER_JOURNAL, ITEM_ITERATOR_SKIP_VENDOR, ITEM_ITERATOR_SKIP_LOOT)
	local function ItemIterator(invariant, control)
		if not control then 
			if type(invariant)=="table" then
				control = invariant
				control:BindToAutoroutineLifetime(tPool)
				if control.first then
					return control, control.first
				end
			else
				control = GetCreateTable():BindToAutoroutineLifetime(tPool)
				control.skip = invariant
			end
		end
		if not control.func then
			control.func = GetInventoryItemLink
		end
		local skip = control.skip
		local skipEquipped = skip and bit.band(skip, ITEM_ITERATOR_SKIP_EQUIPPED)==ITEM_ITERATOR_SKIP_EQUIPPED
		local skipRewards = skip and bit.band(skip, ITEM_ITERATOR_SKIP_REWARDS)==ITEM_ITERATOR_SKIP_REWARDS
		local skipLootRoll = skip and bit.band(skip, ITEM_ITERATOR_SKIP_LOOT_ROLL)==ITEM_ITERATOR_SKIP_LOOT_ROLL
		local skipEncounterJournal = skip and bit.band(skip, ITEM_ITERATOR_SKIP_ENCOUNTER_JOURNAL)==ITEM_ITERATOR_SKIP_ENCOUNTER_JOURNAL
		local skipVendor = skip and bit.band(skip, ITEM_ITERATOR_SKIP_VENDOR)==ITEM_ITERATOR_SKIP_VENDOR
		local skipLoot = skip and bit.band(skip, ITEM_ITERATOR_SKIP_LOOT)==ITEM_ITERATOR_SKIP_LOOT
		while true do
			local func = control.func
			local slot = control.slot
			if func==GetInventoryItemLink then
				if not slot then control.slot = skipEquipped and BANK_CONTAINER_INVENTORY_OFFSET+1 or EQUIPPED_FIRST
				else control.slot = slot + 1 end
				if control.slot==EQUIPPED_LAST+1 then control.slot = BANK_CONTAINER_INVENTORY_OFFSET+1 end
				slot = control.slot
				if slot<=BANK_CONTAINER_INVENTORY_OFFSET+NUM_BANKGENERIC_SLOTS then
					local itemLink = GetInventoryItemLink("player", slot)
					if itemLink and select(9, GetItemInfo(itemLink))~="" and not ItemWasFirst(control, itemLink) then
						control.player = slot<=EQUIPPED_LAST
						control.bank = not control.player
						control.bags = false
						return control, itemLink
					end
				else
					control.player = nil
					control.bank = nil
					control.bags = nil
					control.func = GetContainerItemLink
					control.slot = nil
				end
			elseif func==GetContainerItemLink then
				if not slot then slot = 0 end
				slot = slot + 1
				control.slot = slot
				if not control.bag then control.bag = BACKPACK_CONTAINER end
				if slot<=GetContainerNumSlots(control.bag) then
					local itemLink = GetContainerItemLink(control.bag, slot)
					control.player = control.bag<=NUM_BAG_SLOTS
					control.bank = not control.player
					control.bags = true
					if itemLink then
						local itemName, _, _, _, _, _, _, _, itemEquipSlot = GetItemInfo(itemLink)
						if 
							itemName 
							and itemEquipSlot 
							and itemEquipSlot~="" 
							and not ItemWasFirst(control, itemLink)
						then 
							return control, itemLink 
						end
					end
				else
					control.bag = control.bag + 1
					if control.bag>NUM_BAG_SLOTS+GetNumBankSlots() then
						control.bag = nil
						control.player = nil
						control.bank = nil
						control.bags = nil
						control.func = GetNumQuestRewards
						control.itemType = "reward"
					end
					control.slot = nil
				end
			elseif control.itemType then 
				if 
					not skipRewards and 
					(QuestFrame:IsShown() or 
					QuestLogPopupDetailFrame:IsShown() or
					(WorldMapFrame:IsShown() and QuestMapFrame.DetailsFrame:IsShown())) then
					if not slot then slot = 0 end
					slot = slot + 1
					control.slot = slot
					if slot<=func() then
						local itemLink, itemName
						if QuestInfoFrame.questLog then 
							itemLink = GetQuestLogItemLink(control.itemType, slot)
							if control.itemType=="choice" then
								itemName = GetQuestLogChoiceInfo(slot)
							else
								itemName = GetQuestLogRewardInfo(slot)
							end
						else
							itemLink = GetQuestItemLink(control.itemType, slot)
							itemName = GetQuestItemInfo(control.itemType, slot)
						end
						local itemFrame = _G["QuestInfoItem"..control.slot]
						if 
							itemLink 
							and itemFrame 
							and itemFrame:IsShown() 
							and itemFrame.type==control.itemType 
							and itemFrame.name:GetText()==itemName
							and not ItemWasFirst(control, itemLink)
						then
							return control, itemLink
						end
					elseif func == GetNumQuestRewards then
						control.func = GetNumQuestChoices
						control.itemType = "choice"
						control.slot = nil
					elseif func == GetNumQuestChoices then
						control.func = GetNumQuestLogRewards
						control.itemType = "reward"
						control.slot = nil
					elseif func == GetNumQuestLogRewards then
						control.func = GetNumQuestLogChoices
						control.itemType = "choice"
						control.slot = nil
					else
						control.func = GetLootRollItemLink
						control.slot = nil
						control.itemType = nil
					end
				else
					control.func = GetLootRollItemLink
					control.slot = nil
					control.itemType = nil
				end
			elseif func==GetLootRollItemLink then
				if not slot then slot = 0 end
				slot = (not skipLootRoll) and slot + 1
				control.slot = slot
				if slot and slot<=NUM_GROUP_LOOT_FRAMES and GroupLootFrame1 and GroupLootFrame1:IsShown() then
					local lootFrame =  _G["GroupLootFrame"..slot]
					if lootFrame and lootFrame:IsShown() then
						local itemLink = func(lootFrame.rollID)
						if itemLink and not ItemWasFirst(control, itemLink) then
							return control, func(lootFrame.rollID)
						end
					end
				end
				control.func = EJ_GetLootInfoByIndex
				control.slot = nil
			elseif func==EJ_GetLootInfoByIndex then
				if not skipEncounterJournal and
					EncounterJournal and
					EncounterJournal:IsShown() and
					EncounterJournal.encounter.info.lootScroll:IsShown()
				then
					if not slot then slot = 0 end
					slot = slot + 1
					control.slot = slot
					local numLoot = EJ_GetNumLoot()
					if slot<=numLoot then
						local name, icon, slot, armorType, itemID, link, encounterID = func(slot)
						if link and not ItemWasFirst(control, link) then
							return control, link
						end
					end
				end
				control.func = GetMerchantItemLink
				control.slot = nil
			elseif func==GetMerchantItemLink then
				if 
					not skipVendor and
					MerchantFrame:IsShown()
				then
					if not slot then slot = 0 end
					slot = slot + 1
					control.slot = slot
					local link = func(slot)
					if link and not ItemWasFirst(control, link) then
						return control, link
					end
				end
				control.func = GetLootSlotLink
				control.slot = nil
			elseif func==GetLootSlotLink then
				if not slot then slot = 0 end

				slot = slot + 1
				control.slot = slot
				if 
					not skipLoot and
					LootFrame:IsShown()
				then
					local link = func(slot)
					if link and not ItemWasFirst(control, link) then
						return control, link
					end
				end
				if slot > GetNumLootItems() then
					control:Pool()
					return
				end
			else
				control:Pool()
				return
			end
		end
	end
	
	function GA.ItemChoiceIterator(invariant, control)
		if not control then control = 0 end
		control = control + 1
		local isLogFrame = QuestFrame:IsShown() or QuestLogPopupDetailFrame:IsShown() or (WorldMapFrame:IsShown() and QuestMapFrame.DetailsFrame:IsShown())
		local getNumChoices = isLogFrame and GetNumQuestLogChoices or GetNumQuestChoices
		local getItemLink = isLogFrame and GetQuestLogItemLink or GetQuestItemLink
		if control<=getNumChoices() then
			local itemLink = getItemLink("choice", control)
			if itemLink then
				return control, itemLink, QuestInfo_GetRewardButton(QuestInfoFrame.rewardsFrame, control)
			end
		else return end
	end
	
	function GA.LootRollIterator(invariant, control)
		if not control then control = 0 end
		control = control + 1
		if control<=NUM_GROUP_LOOT_FRAMES then
			local lootFrame =  _G["GroupLootFrame"..control]
			if lootFrame and lootFrame:IsShown() then
				local itemLink = GetLootRollItemLink(lootFrame.rollID)
				if itemLink then
					return control, itemLink, lootFrame
				end
			end
		end
		return
	end
	
	local ejLootScroll
	function GA.EncounterJournalIterator(invariant, control)
--DGV:DebugFormat("EncounterJournalIterator", "control", control)
		local EncounterJournal = EncounterJournal
		if not EncounterJournal then return end
		ejLootScroll = ejLootScroll or EncounterJournal.encounter.info.lootScroll
		if 
			EncounterJournal and
			EncounterJournal:IsShown() and
			ejLootScroll:IsShown()
		then
			if not control then control = 0 end
			control = control + 1
			
			if control<=EJ_GetNumLoot() then
				local name, icon, slot, armorType, itemID, link, encounterID = EJ_GetLootInfoByIndex(control)
				local items = ejLootScroll.buttons;
				local offset = HybridScrollFrame_GetOffset(ejLootScroll)
				local buttonIndex = control-offset
				local button
				if buttonIndex>=1 and buttonIndex<=#items then
					button = items[buttonIndex]
				end
--DGV:DebugFormat("EncounterJournalIterator", "link", link ,"has frame", button~=nil, "#items", #items, "buttonIndex", buttonIndex)
				return control, link, button
			end
		end
	end
	
	function GA.VendorIterator(invariant, control)
		if not control then control = 0 end
		control = control + 1
		local link = GetMerchantItemLink(control)
		if link then
			local buttonIndex = control % MERCHANT_ITEMS_PER_PAGE
			if buttonIndex==0 then buttonIndex = MERCHANT_ITEMS_PER_PAGE end
			local lootFrame =  _G["MerchantItem"..buttonIndex.."ItemButton"]
			lootFrame = lootFrame and lootFrame:IsShown() and lootFrame.link==link and lootFrame
			return control, link, lootFrame
		end
		return
	end
	
	function GA.LootIterator(invariant, control)
		if not control then control = 0 end
		local numItems = GetNumLootItems()
		while control < numItems do
			control = control + 1
			local link = GetLootSlotLink(control)
			if link then
				local numLootToShow = LOOTFRAME_NUMBUTTONS;
				if ( numItems > LOOTFRAME_NUMBUTTONS ) then
					numLootToShow = numLootToShow - 1;
				end
				local buttonIndex = control % numLootToShow
				if buttonIndex==0 then buttonIndex = numLootToShow end
				local lootFrame =  _G["LootButton"..buttonIndex]
				lootFrame = lootFrame and lootFrame:IsShown() and lootFrame.slot==control and lootFrame
				return control, link, lootFrame
			end
		end
	end
	
	local function EvaluateWinCriteron(criterion, itemLink)
		if criterion:Predicate(itemLink, unpack(criterion)) then
			local win, altWinner, score, altScore, uniqueSlot = criterion:GetScore(itemLink, unpack(criterion))
			if win then
				return score, altWinner, altScore, uniqueSlot
			end
		end
	end
	
	math.sum = function(...)
		local sum = 0
		for i=1,select("#", ...) do
			sum = sum + (select(i,...))
		end
		return sum
	end
	
	local function MainHandBlocksSecondarySlot(itemSubclass, equipSlot, link, spec, level)
		if PlayerCanTitansGrip(itemSubclass, spec, level) then

			return false
		elseif itemSubclass==WEAPON_SUBCLASS_CROSSBOW or itemSubclass==WEAPON_SUBCLASS_GUN or itemSubclass==WEAPON_SUBCLASS_BOW or itemSubclass==WEAPON_SUBCLASS_POLEARMS or itemSubclass==WEAPON_SUBCLASS_STAVES then --crossbow does, but wands (another INVTYPE_RANGEDRIGHT) don't
			return true
		elseif equipSlot=="INVTYPE_RANGED" or equipSlot=="INVTYPE_2HWEAPON" then
			return true
		end
		return false

	end
	
	function GetDefaultUniqueInventorySlot(equipSlot)
		if equipSlot=="" then return end
		if equipSlot=="INVTYPE_ROBE" then
			return "INVTYPE_CHEST"
		elseif 
			equipSlot=="INVTYPE_WEAPON" or equipSlot=="INVTYPE_RANGED" or equipSlot=="INVTYPE_2HWEAPON" or 
			equipSlot=="INVTYPE_WEAPONMAINHAND" or equipSlot=="INVTYPE_RANGEDRIGHT"
		then
			return INVSLOT_MAINHAND
		elseif equipSlot=="INVTYPE_SHIELD" or equipSlot=="INVTYPE_WEAPONOFFHAND" or equipSlot=="INVTYPE_HOLDABLE" then
			return INVSLOT_OFFHAND
		end
		return equipSlot
	end
	
	local function CanAdornUniqueInventorySlot(uniqueInventorySlot, itemClass, itemSubclass, equipSlot, spec, level)
		local class = select(2,UnitClass("player"))
		if not equipSlot or equipSlot=="" then return false end
		if equipSlot=="INVTYPE_WEAPONOFFHAND" and not PlayerCanDualWield(spec, level) then return false end
		if uniqueInventorySlot==GetDefaultUniqueInventorySlot(equipSlot) then
			return true
		elseif uniqueInventorySlot==INVSLOT_OFFHAND and itemClass==ITEM_CLASS_WEAPON then
			if (equipSlot=="INVTYPE_WEAPONOFFHAND" or equipSlot=="INVTYPE_WEAPON") and PlayerCanDualWield(spec, level) then
				return true
			elseif equipSlot=="INVTYPE_SHIELD" or equipSlot=="INVTYPE_HOLDABLE" and class~="HUNTER" then
				return true
			elseif PlayerCanTitansGrip(itemSubclass, spec, level) then
				return true
			end
		end
		return false
	end
	
	local function DualWieldPreferenceIsMainhandDPS()
		local class = select(2,UnitClass("player"))
		local spec = GetSpecialization()
		return class=="MONK" or (class=="ROGUE" and spec==1) --Combat Rogue
	end
	
	local function DualWieldPreferenceIsOffhandDPH()
		local class = select(2,UnitClass("player"))
		return class=="SHAMAN" 
	end
	
	local function DualWieldPreferenceIsMainhandDagger()
		local class = select(2,UnitClass("player"))
		local spec = GetSpecialization()
		return class=="ROGUE" and spec==3 --Subtlety Rogue
	end
	
	local function ShouldSwapMainOffWeapons(mainLink, offLink, spec, level)
		if not mainLink or not offLink then return end
		if ItemIsBannedWeapon(mainLink) or ItemIsBannedWeapon(offLink) then return end --don't swap hands if item is banned
		local mainSums, offSums = GetItemSums(mainLink), GetItemSums(offLink)
		local mainItemClass, mainItemSubclass = select(6, GetItemInfo(mainLink))
		local offItemClass, offItemSubclass = select(6, GetItemInfo(offLink))
		mainItemClass, mainItemSubclass = GetItemClassIndex(mainItemClass, mainItemSubclass)
		offItemClass, offItemSubclass = GetItemClassIndex(offItemClass, offItemSubclass)

		local continueSwap = false
		if DualWieldPreferenceIsMainhandDPS() and DGV:UserSetting(DGV_WEAPONPREF)=="Auto" then
			continueSwap = (mainSums["DPS"] or 0) < (offSums["DPS"] or 0)
		elseif DualWieldPreferenceIsOffhandDPH() or DGV:UserSetting(DGV_WEAPONPREF)=="Fast / Slow" then
			continueSwap = (mainSums["MAX_DAMAGE"] or 0) > (offSums["MAX_DAMAGE"] or 0)
		elseif DGV:UserSetting(DGV_WEAPONPREF)=="Slow / Fast" and PlayerCanDualWield(spec, level) then
			continueSwap = (mainSums["MAX_DAMAGE"] or 0) < (offSums["MAX_DAMAGE"] or 0)
		elseif DualWieldPreferenceIsMainhandDagger() and (mainItemSubclass == 13 or offItemSubclass == 13) then
			continueSwap = mainItemSubclass ~= 13 and (mainSums["MAX_DAMAGE"] or 0) < ((offSums["MAX_DAMAGE"]*1.5) or 0) --Dagger unless other item does 50% more MAX_DAMAGE 
		else
			continueSwap = (mainSums["MAX_DAMAGE"] or 0) < (offSums["MAX_DAMAGE"] or 0)
		end
		mainSums:Pool()

		offSums:Pool()
		if not continueSwap then return end
		local itemClass, itemSubclass, _, itemEquipSlot = select(6, GetItemInfo(mainLink))
		itemClass, itemSubclass = GetItemClassIndex(itemClass, itemSubclass)
		if not CanAdornUniqueInventorySlot(INVSLOT_OFFHAND, itemClass, itemSubclass, itemEquipSlot, spec, level) then return end
		itemClass, itemSubclass, _, itemEquipSlot = select(6, GetItemInfo(offLink))
		itemClass, itemSubclass = GetItemClassIndex(itemClass, itemSubclass)
		if not CanAdornUniqueInventorySlot(INVSLOT_MAINHAND, itemClass, itemSubclass, itemEquipSlot, spec, level) then return end
		return true
	end
	
	local function IsEnforcedTableComplete(enforcedTable)
		for unique,inv1,inv2 in NextUniqueInventorySlot do
			if IsArmorSpecSlot(inv1) and not enforcedTable[inv1] then return end
		end
		return true
	end
	
	local function StandardTableGrantsArmorSpecialization(standardTable, enforcedTable)
		for unique,inv1,inv2 in NextUniqueInventorySlot do
			if IsArmorSpecSlot(inv1) and (not standardTable[inv1]) or enforcedTable[inv1]~=standardTable[inv1] then return end
		end
		return true
	end
	
	local function StatKeyToUnitStatIndex(statKey)
		if statKey=="STR" then return 1 
		elseif statKey=="AGI" then return 2
		elseif statKey=="STA" then return 3 
		elseif statKey=="INT" then return 4 
		elseif statKey=="SPI" then return 5 
		end
	end
	
	local function EstimateStatBaseValue(statKey, spec)
		local stat, effectiveStat, posBuff, negBuff = UnitStat("player", StatKeyToUnitStatIndex(statKey))
		local base =  stat - posBuff - negBuff
		local coefficient = 1
		if StatLogic.GetArmorSpecActive()==spec then
			coefficient = coefficient + .05
		end
		if statKey=="STA" then
			if IsSpellKnown(29144) then --Unwavering Sentinel
				coefficient = coefficient + .15
			elseif UnitBuff("player", (GetSpellInfo(5487))) then --Bear Form
				coefficient = coefficient + .2
			else
				if IsSpellKnown(50029) then --Veteran of the Third War
					coefficient = coefficient + .09
				end
				if StatLogic.SlotHasEnchant(3847, INVSLOT_MAINHAND) then --Rune of the Stoneskin Gargoyle
					coefficient = coefficient + .02
				elseif StatLogic.SlotHasEnchant(3883, INVSLOT_MAINHAND) then --Rune of the Nerubian Carapace Mainhand
					coefficient = coefficient + .01
				end
				if StatLogic.SlotHasEnchant(3883, INVSLOT_OFFHAND) then --Rune of the Nerubian Carapace Mainhand Offhand
					coefficient = coefficient + .01
				end
			end
		elseif statKey=="STR" and IsSpellKnown(91107) then --Unholy Might
			coefficient = coefficient + .1
		end
		base = base/coefficient
--DGV:DebugFormat("EstimateStatBaseValue", "statKey", statKey, "spec", spec, "base", base)
		return base
	end
	
	local function GetArmorSpecStat(data)
		if data[1]=="ARMOR_SPECIALIZATION_STAT" then
			return data[2]
		end
	end
	
	local function GetArmorSpecStatWeight(...)
		local armorSpecStatKey
		for i=1,select("#", ...) do
			local data = (select(i, ...))
			armorSpecStatKey = armorSpecStatKey or GetArmorSpecStat(data)
			if armorSpecStatKey and data[1]==armorSpecStatKey then
				return armorSpecStatKey, data[2]
			end
		end
	end
	
	local function ArmorSpecializationBonusWins(spec, standardTable, enforcedTable)
		local armorSpecStatKey, armorSpecStatWeight = GetArmorSpecStatWeight(GetScoringInfo(spec))
		local bonusStatValue = (enforcedTable.ArmorSpecStatTotal + EstimateStatBaseValue(armorSpecStatKey, spec))*.05
--DGV:DebugFormat("ArmorSpecializationBonusWins", "bonusStatValue", bonusStatValue, "enforcedTable.ArmorSpecStatTotal", enforcedTable.ArmorSpecStatTotal, "EstimateStatBaseValue(armorSpecStatKey, spec)", EstimateStatBaseValue(armorSpecStatKey, spec))
		local bonusScore = bonusStatValue * armorSpecStatWeight
		local enforcedTableScore = enforcedTable.ScoreTotal + bonusScore
-- if not standardTable.ScoreTotal	then
-- DGV:DebugFormat("ArmorSpecializationBonusWins", "standardTable", tostring(standardTable), "standardTable:IsBoundToAutoroutineLifetime()", standardTable:IsBoundToAutoroutineLifetime())
-- end

        if enforcedTableScore == nil then
            enforcedTableScore = 0
        end
        
        local scoreTotal = standardTable.ScoreTotal	
        
        if scoreTotal == nil then
            scoreTotal = 0
        end     

		return enforcedTableScore>scoreTotal	
	end
	
	local function GetArmorSpecSubclassFrom(data)
		if data[1]=="ITEM_CLASS_ARMOR" then
			local greatest
			for i=2,#data do
				local value = data[i]
				value = tonumber(value:match("%d"))
				if 	
					value
					and value~=ARMOR_SUBCLASS_SHIELDS 
					and value~=ARMOR_SUBCLASS_COSMETIC
					and (not greatest or value>greatest)
				then
					greatest = value
				end
			end
			return greatest
		end
	end
	
	local function GetArmorSpecSubclass(...)
		for i=1,select("#", ...) do
			local data = (select(i, ...))
			local subclass = GetArmorSpecSubclassFrom(data)
			if subclass then return subclass end
		end
	end
    

    --{id=itemobject}
    ItemCache = {}
    
    local function GetItemInfoById(itemId)
    
        if ItemCache[itemId] then  
            return ItemCache[itemId]  
        end
    
        local itemlink="item:"..itemId..":0:0:0:0:0:0:0:0:0:0:0"
		local name,link,quality,ilevel, reqlevel, class, subclass, maxstack, equipslot, texture, vendorprice = GetItemInfo(itemlink)
        
		if not name then 
            return nil 
        end

		-- Loads stats into item.stats
		local stats = GetItemStats(itemlink)
        
		if not stats then 
            return nil 
        end
        
        local item = {
			info={
            itemid = itemId
            , name = name
            , itemlink = itemlink
            , prettylink = link
            , quality = quality
            , ilevel = ilevel
            , reqlevel = reqlevel
            , class = class
            , subclass = subclass
            , equipslot = equipslot
            , vendorprice = vendorprice
            },
			stats = stats,
			tooltip={}
		}
        
        ItemCache[itemId] = item
        
        return item
    end
    
    --/run CacheItemsForGearAdvisor()
    --/run GetAllOwnedItems()
    --/run GetAllOwnedItems(true)
    function GetAllOwnedItems(onlyBelowPlayerLevel)
        local result = {}
        for control, iteratedItemLink in ItemIterator, itemInvariant do
            
            local itemString = string.match(iteratedItemLink, "item[%-?%d:]+")
            local _, itemId = strsplit(":", itemString)   
            
            local item = GetItemInfoById(itemId)
            
            --SCORE
            local level = UnitLevel("player")

            local uniqueInventorySlot = GetDefaultUniqueInventorySlot(item.info.equipslot)
            
            local score = CalculateScore("item:"..itemId, nil, nil, level, uniqueInventorySlot)
            
            if (not onlyBelowPlayerLevel) or level >= item.info.reqlevel then
                
                result[#result + 1] = {link=iteratedItemLink, itemId = itemId, item = item, score = score}
            end
        end
        
        return result
    end
        
    --/run CacheItemsForGearAdvisor()
    --/run GetTheBestOwnedItemBySlot("INVTYPE_WRIST")
    --/run GetTheBestOwnedItemBySlot("INVTYPE_FEET")
    --/run GetTheBestOwnedItemBySlot("INVTYPE_FINGER")
    --/run GetTheBestOwnedItemBySlot("INVTYPE_TRINKET")
    --/run GetTheBestOwnedItemBySlot("INVTYPE_SHIELD")
    --/run GetTheBestOwnedItemBySlot("INVTYPE_NECK")
    function GetTheBestOwnedItemBySlot(slot, onlyBelowPlayerLevel)
        local allOwnedItems = GetAllOwnedItems(onlyBelowPlayerLevel)
        
        if #allOwnedItems == 0 then
            return nil
        end
        
        local theBest = nil
        print("-------------------------")
        print("POSSESSED items for ",slot," slot:")
        LuaUtils:foreach(allOwnedItems, function(item, index)
            if item.item.info.equipslot == slot then
                print(item.link, " itemId:", item.item.info.itemid, " SCORE:", item.score)
            end
        
            if item.item.info.equipslot == slot and (theBest == nil or item.score > theBest.score) then
                theBest = item
            end
        end)
        
        if not theBest then
            print("-none")
        end
        
        
        if theBest then
            print("AMONG POSSESSED THE BEST IS:"..theBest.link, " itemId:", theBest.item.info.itemid, " (SCORE: ", theBest.score, ")")
        else
            print("THE BEST WAS NOT FOUND AMONG POSSESSED")
        end
        
        return theBest
    end
    
    ItemsForWhichGuideExists = {
            17717,17718,17719,17754,17755,17752,17732,17730,17728,17736,17943,17737,17734,17710,17711,17714,17713,17707,17715,17780,17766,17744,17745,17746,17750,17751,17749,17748,10796,12466,10797,12243,12464,10795,12465,12463,10806,10808,10807,10803,10805,10804,65931,10838,10842,10846,10843,10844,10845,12462,10796,12466,12463,12464,10795,12465,10797,10828,10829,10836,10847,10837,10833,10835,82891,82892,82893,82894,82895,82881,82882,82877,82879,82880,82772,82888,82883,82886,82878,82885,82884,66021,66012,66030,66039,16886,16887,65938,65912,65986,65962,56699,56697,56698,7000,6998,56682,56679,56681,56680,56660,56658,56659,6743,1155,6903,6905,6906,6907,6908,6910,6911,6909,6901,6902,6904,11121,3078,888,11625,11624,11626,22240,12791,12793,11731,11677,11685,11662,22270,11678,11686,11702,11679,11633,11703,11665,11824,11635,22257,22271,11728,11729,11675,11730,11722,22266,11634,11726,22204,11931,11933,11815,11924,11928,11930,11932,11934,22207,11684,11745,22212,11744,11823,11822,11819,11669,12556,12554,12553,12557,22242,11755,22208,11935,11746,11631,11632,22234,11923,11920,11927,11921,11925,11922,11926,11929,11805,11807,11803,11802,11748,11750,11749,11747,11832,11808,11812,11809,11814,11628,11627,11629,11623,11766,11765,11767,11764,22223,11841,11839,11842,11816,11820,11817,11821,11810,11784,11783,11782,22241,18044,11735,18043,22275,10710,65996,65975,65926,66009,65951,10772,10774,10766,10760,10761,10765,10762,10763,10764,10776,10775,10777,10770,10769,10771,13244,13183,13213,13206,13208,13205,12582,22231,13177,13179,13169,13166,13170,13167,13168,22313,13211,13210,13212,22232,13259,13258,13178,12651,13257,12653,12626,13255,13162,13163,13143,13161,22321,13253,13252,12609,12606,12589,12603,12960,12587,12936,12953,12940,18102,12935,18103,22247,12590,12952,12939,18104,12583,22225,12602,22253,22269,13141,13098,12592,22268,22267,13142,12966,12963,12967,12964,12709,12965,12969,12968,12952,12953,16669,12960,22225,12927,12929,12926,12905,6748,6750,6749,65968,65918,66007,65991,65944,6679,6685,2816,6682,6688,6689,6697,6695,6696,6679,6686,6687,6691,6690,6681,6694,6692,6693,65989,65915,65941,65965,1929,4676,5967,1959,1934,2168,63344,63346,63345,66004,65987,65939,65963,9453,9452,9454,9445,9449,9450,9447,9446,9448,9459,9458,9461,9492,65972,65948,65993,65922,18366,18367,18368,18369,18354,18319,18313,18308,18323,18306,18305,18307,18322,18324,18317,18311,18302,18301,18325,18326,18315,18327,18309,18328,18321,18310,18314,18318,18312,65973,65924,65994,65949,18394,18372,18391,18384,18377,18381,18385,18389,18370,18379,18375,18376,18380,18388,18392,18396,18395,18378,18382,18373,18397,18350,18351,18374,18371,18383,18386,18349,18347,18353,18393,18352,18390,18480,18477,18475,18482,18479,18478,18528,18529,18476,18500,18481,18532,18530,18531,18499,18533,18537,18495,18534,18538,65976,65952,65927,65997,18485,18483,18484,18490,18450,18458,18462,18496,18459,18463,18497,18464,18460,18494,18498,18451,18493,18503,18507,18502,18505,18425,18450,18458,18462,18496,18459,18463,18497,18464,18460,18494,18498,18451,18493,18450,18458,18462,18496,18459,18463,18497,18464,18460,18494,18498,18451,18493,18522,18523,18524,18525,18526,18520,18521,18527,65971,65921,65947,9408,9407,9409,11310,9419,9412,11311,9390,9389,9388,9387,9411,9410,9414,9416,9415,11118,9413,9418,9403,9400,9404,9401,9398,9394,9394,9398,9403,9404,65985,65937,65961,66003,65911,6469,6459,5970,10411,13245,6447,6463,6461,6627,6460,6465,10410,6472,6473,5404,10412,6631,6629,6630,6448,6449,65928,65977,65953,65998,22406,13382,22403,22407,18721,22404,13381,22405,13380,13401,13400,13402,13403,13404,13409,13408,13405,13383,13379,13384,13378,13397,13954,13399,13386,13385,13387,18716,18720,13369,18717,13360,18718,13353,13359,13358,12103,13348,13393,13390,13391,13388,13392,13389,13372,13373,13374,18723,13375,13515,18730,13537,13534,13538,18729,13539,13535,18728,22410,13345,22411,13344,13349,22408,13368,13505,13346,22409,13361,13340,22412,13533,18740,13530,13531,18739,13532,18738,13529,13526,18735,18734,13524,13528,18737,13527,13525,18725,18726,18727,18722,13376,65954,65929,65978,12470,9477,9478,9479,11086,9476,12471,18082,18083,9639,9641,9379,9640,9467,9469,9474,9470,9475,9473,27536,27540,27529,27533,27537,27474,27538,27527,27531,27535,27528,27534,27524,27868,27526,27802,27525,27521,27519,27520,27517,27536,27540,27529,27533,27537,27474,27538,27527,27531,27535,27528,27534,27524,27868,27526,27802,27525,30710,30707,30705,30709,30708,27517,27520,27521,24465,24466,24481,24463,24464,24458,24459,24460,24461,24462,24452,24450,24451,24453,24454,24455,24456,24457,32081,29265,27769,27938,27896,27781,27770,27780,30541,27907,27771,29350,27779,27768,27772,27773,27755,27757,27758,27759,27760,27761,27748,27743,27745,27746,27747,27762,27763,27764,27765,27766,27767,27426,27427,27428,27430,27424,27420,27436,27423,27417,27418,27433,27434,27431,27432,27440,28217,28218,28219,28220,28221,28216,28210,28211,28212,28213,28214,28215,28226,29250,27904,28223,28227,30534,30536,28344,27911,29246,28401,28225,28224,28233,28222,28191,34789,34791,34788,34790,34792,34705,34707,34704,34706,34708,34703,34799,34807,34793,34794,34795,34796,34809,34797,34625,34798,34810,34808,34698,34700,34702,34697,34699,34701,34472,34471,34473,34470,34607,34606,34608,34605,34612,34614,34616,34609,34610,34615,34611,34613,34601,34602,34604,27806,27510,27799,27804,27805,27737,27801,27475,27874,27738,27795,28203,27790,27791,27792,27793,27794,27783,27784,27787,27508,27789,29243,30543,29351,29463,27790,27791,27792,27793,27794,27783,27784,27787,27508,27789,31465,31461,31464,31462,31460,28301,28311,28306,28304,28350,28343,28347,28370,28228,28348,28367,28341,28345,28349,28229,28342,28371,28322,28323,28324,28325,28327,28338,28339,28340,27739,28328,28315,28316,28317,28318,28321,31465,31461,31464,31462,31460,28301,28304,28306,28311,28343,29258,28345,28347,29262,28348,28349,28350,28367,28228,28229,28370,28371,28341,28342,32072,29359,28322,28323,28324,28325,28327,28338,28339,28340,27739,28328,28315,28316,28317,28318,28321,29341,29340,29339,29337,25964,27408,27409,27410,26055,27412,27413,27414,27415,27416,27411,29341,29340,29339,29337,27846,27847,27493,27865,27866,27845,27870,27867,27871,29244,27523,27872,29354,29257,27869,29333,29334,29335,29336,29330,29332,29329,27914,27918,27919,27915,27776,27946,27875,27838,27925,27981,27985,27986,27948,27980,27936,27986,29355,32073,27980,27946,27875,29259,27838,27776,27936,27985,29249,27948,27981,27925,32780,32779,32781,32769,32778,27918,27919,27914,27915,31747,31748,31749,28392,28386,28387,28390,28391,28393,28394,28396,28397,28398,28406,28414,28403,28407,28231,28205,28419,28412,28416,28413,28418,28415,28373,28374,28375,28384,28392,28386,28387,28390,28391,28393,28394,28396,28397,28398,28406,28205,28407,29248,28412,28413,28414,29360,29252,28416,28231,28418,28403,28419,29241,28415,28373,28374,28375,28384,27888,27889,27884,27885,27887,27897,27898,27900,27901,27775,27468,28134,27890,27891,27892,27893,29261,28230,27902,27803,27912,27908,27905,27909,27778,28232,29353,27910,29357,27903,30532,27913,27887,27888,27889,27884,27885,27901,27897,27775,27900,27898,27891,28134,27892,27468,27893,29261,30532,29357,29353,27905,28230,27912,27908,28232,27803,27902,27910,27778,27909,27913,25942,25943,25939,28166,25941,25950,25944,25952,25946,25947,25945,25956,25957,25953,25954,25955,25962,29333,29334,29335,29336,29330,29332,29329,27818,27813,27814,27816,27817,27828,27840,27844,29352,32082,27837,28400,30535,27843,27842,27831,27835,27827,27798,29240,27829,27825,27826,27821,27822,27823,27824,31920,31924,31921,31554,31562,31570,31919,31923,31578,31922,25714,25713,25712,25701,25702,25710,25711,24388,24384,24385,24387,24389,24390,24391,24392,24393,24395,24396,24397,24398,24394,27485,27483,27487,27488,27489,27490,27848,27492,27491,27506,27495,28264,27788,27507,28121,29245,29239,27514,27512,27497,27505,27494,27522,29347,32080,27993,27987,27995,27996,27988,27994,28184,28185,28186,28187,28034,28033,28189,28193,28190,28194,27873,27977,28206,27839,27509,28188,28192,28207,27988,27994,27993,27987,27996,27995,28033,28034,28185,28186,28184,28187,29253,29247,29356,30531,24362,24363,24364,24365,24366,24381,24376,24378,24379,24380,24360,24361,24356,24357,24359,27683,27740,29242,27713,27672,27796,27800,29349,27673,28337,27741,30538,27742,27714,27712,32078,27547,27548,27549,27550,27551,28124,27545,27546,27541,27542,27543,25716,25715,25718,25717,24024,24020,24021,24022,24023,24045,24064,24083,24046,24155,24154,24044,24063,24151,24150,24073,24096,24069,24091,24090,24094,27447,27448,27449,27450,27451,27461,27454,27458,32077,27455,27459,27453,27452,27456,27460,29264,29238,27457,29346,27476,27465,27477,27466,27463,27467,27906,27895,27539,27478,27462,27464,31465,31461,31464,31462,31460,28286,28275,28204,28265,28269,28288,28202,28266,28285,27899,28278,28267,28262,28260,28259,28263,28253,28254,28255,28256,28257,28250,28251,28252,28249,31465,31461,31464,31462,31460,28266,28267,28269,28285,30533,28286,27899,28288,29251,28275,29362,28278,32076,28202,28265,28204,28259,28260,28262,28263,28253,28254,28255,28256,28257,28250,28251,28252,28249,38223,38222,38221,43181,43182,43183,43184,42760,42762,42766,42767,42768,44354,44355,44356,44357,42758,42761,42763,42765,35597,35596,35595,35600,35599,35598,35617,35604,35605,35603,35602,35601,37730,37729,37728,37731,37150,37141,37149,37144,37139,37135,37134,37138,37162,37171,37166,37172,37170,37165,37167,37169,37151,37153,37152,37155,44338,44339,44340,44341,44334,44336,44335,44337,36973,36975,36961,36972,36974,36969,36971,36962,36947,36949,36948,36950,36953,36952,36951,36954,36944,36943,36945,36946,37292,37360,37362,37294,37363,37291,37293,37361,37262,37261,37260,37263,37289,37288,37264,37195,37256,37258,37257,37255,44342,44343,44344,44345,43387,43382,35651,35650,35649,35645,35646,35643,35647,43358,43353,35642,35644,43363,43375,43409,43408,43410,37883,37876,37873,37875,37884,37886,37874,43500,37871,37870,37872,37862,43401,37869,43403,43402,43404,37868,37861,37867,43406,43405,43407,44396,44397,44398,44399,37113,37108,37110,37112,37107,37109,37111,37114,37082,37081,37083,37079,37088,37084,37086,37095,37106,37096,37105,37099,37694,37695,37696,37689,37690,37691,37692,43085,37693,37679,37678,37680,37675,37682,37684,37683,37681,37688,37687,37686,37685,49783,49787,49784,49786,49788,49785,49799,49792,49800,49793,49794,49795,49796,49789,49797,49790,49798,49791,49784,49785,50191,49787,50193,49786,50194,49788,50197,49783,50196,50212,50213,50206,50214,50207,50215,50208,50209,50210,50203,50211,50198,44350,44351,44352,44353,35606,35608,35607,43277,43279,43278,35609,35611,35610,35612,35614,35613,37592,37594,37593,37591,43280,43282,43281,43283,37617,37619,37622,37623,37618,37620,37615,37616,43286,43285,43284,43287,37595,37612,37614,37613,43164,43165,43167,43168,43309,43305,43306,35591,35590,35592,35588,35587,35589,35585,35584,35583,43310,43312,43311,43313,37628,37627,37626,37629,37631,37633,37632,37630,37645,37640,37642,37644,37639,37641,37643,37638,37634,37636,37635,37637,39676,39678,39679,39680,38218,38219,38220,44374,44375,44376,44377,44400,44401,44403,44402,38218,38219,38220,39676,39678,39679,39680,35573,35575,35574,35570,35572,35571,35576,35578,35577,37181,37183,37182,37184,37178,37177,37179,37180,37190,37192,37194,37189,37191,37193,37188,37186,49834,49836,49838,49833,49835,49837,49832,49827,49829,49831,49828,49830,49844,49845,49846,49839,49847,49840,49848,49841,49849,49842,49843,49851,50296,50298,50300,50260,50297,50299,50294,50291,50293,50295,50290,50292,50309,50302,50310,50303,50311,50304,50312,50305,50313,50306,50314,50308,44404,44405,44407,44406,44408,44409,44410,44412,44411,37052,37051,37050,37048,37064,37066,37061,37058,37065,37060,37062,37067,37037,37043,37038,37040,37055,37057,37053,37056,37373,37371,37374,37376,37407,37395,37397,37390,37401,37408,37398,37409,37370,37369,37368,37367,37379,37389,37377,37384,43193,43194,43195,43197,43198,42844,43207,43208,43209,36980,36982,36979,36983,36985,36984,36986,39536,39535,39657,39534,36994,36996,36991,36993,36988,36995,36992,36989,37814,37825,37818,37826,37841,37843,37842,37840,37847,37846,37845,37844,37848,37850,37852,37854,37849,37851,37853,37855,44362,44363,44364,44365,44358,44359,44360,44361,35663,35662,35661,35660,35659,35658,35657,35656,35655,37237,37238,37232,37240,37241,37242,37235,37236,37220,37222,37230,37221,37217,37219,37218,37216,44370,44371,44372,44373,35675,35676,35677,35672,35670,35673,38614,38613,38611,35675,35677,35676,35678,35680,35679,37653,37655,37656,37654,37652,37651,37650,37649,38615,38617,38616,38618,37655,37654,37653,37656,37666,37668,37670,37658,37667,37669,37657,37660,40758,40755,40757,40756,44366,44367,44368,44369,35618,35620,35619,35630,35632,35631,35636,35638,35637,35633,35635,35634,37715,37714,37712,37717,37718,40490,37722,37721,37791,37732,37733,37798,37784,37788,37734,37735,37724,37726,37725,37723,47170,47173,47171,47175,47174,47172,47227,47220,47228,47221,47229,47222,47230,47231,47232,47216,47226,47215,47219,47212,47213,47176,47214,47177,47185,47178,47217,47218,47211,47181,47197,47213,47176,47199,47177,47185,47178,47201,47202,47210,47181,47200,47172,47174,47171,47173,47175,47170,47493,47249,47243,47244,47250,47248,47564,47527,47565,47566,47529,49682,47560,47568,47561,47569,47562,47563,47567,47497,47498,47514,47522,47245,47512,47494,47511,47510,47495,47496,47500,47504,47497,47498,47500,47508,47501,47494,47502,47495,47503,47496,47509,47249,47244,47493,47250,47243,47248,49804,49806,49801,49803,49805,49802,49811,49808,49810,49812,49807,49809,49822,49823,49816,49824,49817,49825,49818,49826,49819,49820,49813,49821,50233,50228,50230,50234,50229,50227,50266,50263,50265,50262,50264,50235,50272,50273,50259,50267,50268,50271,50269,50284,50270,50283,50286,50285,66917,66921,66915,66913,66911,66914,55997,55999,55998,56000,55887,55889,55886,55888,55890,56099,56107,56100,56108,56101,56102,56104,56105,56098,56106,57856,57858,57860,57855,57857,55992,55994,55996,55993,55995,56097,56094,56096,56093,56095,57861,57863,57865,57862,57864,56417,56419,56421,56418,56407,56409,56411,56408,56410,56429,56430,56431,56432,56433,56434,56427,56435,56428,56436,57868,57870,57867,57869,57866,56412,56414,56416,56413,56415,56426,56423,56425,56422,56424,57875,57872,57874,57871,57873,65656,65655,65654,65657,65659,65658,55259,55252,55253,55254,55255,55256,55249,55250,55258,55251,55205,55228,55204,55206,55207,55235,55237,55236,55229,55201,55203,55198,55195,55202,56284,56281,56283,56290,56288,56282,56286,56285,56289,56291,56288,56281,56289,56282,56290,56283,56291,56284,56285,56286,56272,56274,56271,56273,56275,56276,56278,56277,56280,56267,56269,56266,56268,56270,66892,66893,66891,66894,66896,66897,55797,55799,55801,55798,55796,55793,55795,55792,55794,55814,55815,55816,55817,55818,55819,55812,55820,55813,55803,55802,55804,55810,55811,56333,56336,56328,56330,56332,56329,56331,56347,56348,56349,56343,56351,56344,56352,56345,56346,56342,56339,56341,56338,56340,72831,72828,72832,72829,72830,72827,72838,72835,72836,72833,72837,72834,72898,72839,72840,72841,72842,72843,72844,72845,72846,72847,72848,72899,66890,66889,66887,66886,66885,66884,57270,57269,57268,55271,55268,55270,55272,55269,55273,55275,55277,55274,55276,55784,55785,55786,55779,55787,55780,55788,55781,55782,55278,55777,55279,55778,55776,55264,55266,55263,55265,55267,56300,56302,56304,56301,56303,56307,56309,56306,56308,56305,56324,56317,56318,56319,56320,56321,56322,56315,56323,56314,56311,56313,56310,56312,56295,56297,56299,56296,56298,66898,66899,66900,66902,66901,66903,55838,55840,55835,55839,55841,55831,55833,55830,55832,55834,55844,55845,55853,55846,55847,55848,55849,55842,55850,55851,56363,56365,56361,56356,56358,56360,56357,56359,56369,56370,56371,56373,56366,56374,56367,56375,56368,56376,69604,69601,69602,69603,69600,69627,69628,69629,69620,69621,69622,69623,69624,69625,69626,69632,69633,69630,69638,69639,69631,69608,69605,69609,69606,69607,69618,69615,69619,69616,69617,69632,69633,69630,69641,69631,69640,69632,69633,69630,69634,69631,69635,69611,69612,69613,69610,69614,69632,69636,69633,69637,69631,69630,66907,66905,66906,66910,66908,66909,55874,55875,55876,55877,55878,55871,55879,55872,55880,55873,55861,55863,55865,55862,55864,55866,55868,55870,55867,55869,55859,55856,55858,55860,55857,56399,56400,56401,56394,56402,56395,56403,56396,56397,56398,56384,56386,56388,56385,56387,56391,56393,56390,56392,56389,56379,56381,56383,56380,56382,65935,65959,65983,66019,66028,66037,5198,5193,5202,5197,5192,5444,5195,2169,872,1156,5196,5201,5187,1937,5191,5443,5199,5200,65171,65173,65177,65172,65174,63468,63470,63467,65163,63471,65168,65170,65169,65165,65167,65166,63482,63484,63479,65178,63483,63478,63486,63485,63475,65164,63474,63476,63473,6220,6641,6318,3748,3191,6320,5254,6321,6314,6324,6323,3230,6341,1292,6642,63464,63457,63465,63458,63459,63461,63462,63463,63456,63447,63449,63446,63448,63445,63440,63444,63439,63441,63438,63433,63435,63437,63434,63436,63454,63453,63455,63450,63452,72807,72810,72811,72798,72799,72800,72801,72802,72803,72804,72805,72806,72807,72812,72813,72799,72800,72801,72802,72803,72804,72805,72806,72798,72822,72823,72824,72825,72826,72816,72817,72818,72819,72820,72821,72897,72807,72799,72798,72814,72800,72801,72802,72803,72804,72805,72806,72815,72807,72808,72809,72798,72799,72800,72801,72802,72803,72804,72805,72806,66934,66935,66933,66937,66936,66938,56125,56127,56124,56126,56123,56118,56120,56122,56119,56121,56129,56137,56130,56138,56131,56132,56133,56135,56128,56136,56113,56115,56112,56114,56116,56454,56451,56453,56450,56452,56447,56449,56446,56448,56445,56459,56460,56461,56462,56455,56463,56456,56464,56457,56458,56440,56442,56444,56441,56443,69596,69595,69594,69599,69598,69555,69556,69557,69554,69558,69566,69567,69564,69568,69565,69562,69559,69563,69560,69561,69552,69549,69553,69550,69551,69582,69583,69574,69575,69576,69577,69578,69579,69580,69581,70080,69573,69570,69571,69572,69569,72859,72856,72860,72857,76151,72855,72867,72868,72869,72870,72901,72861,72862,72863,72864,72865,72866,72900,72849,76150,72850,72854,72851,72853,60245,60247,60248,60250,60255,60257,60261,60275,60278,60280,60283,60285,60288,60290,60298,60300,60305,60307,60310,60312,60314,60316,60319,60321,60324,60326,60330,60332,60340,60342,60345,60347,60350,60352,60355,60357,60361,60363,60409,60411,60414,60416,60419,60421,60424,60426,60429,60431,60434,60436,60439,60441,60443,60445,60448,60450,60453,60455,60459,60461,60463,60465,60468,60470,60473,60475,60478,60480,60505,60508,60509,60513,60516,60521,60533,60534,60536,60539,60540,60554,60555,60557,60564,60567,60580,60581,60583,60586,60587,60589,60593,60602,60604,60607,60612,60613,60626,60628,60630,60634,60636,60637,60645,60647,60649,60650,60651,60658,60659,60661,60662,60664,60668,60669,60670,60673,60776,60778,60779,60783,60786,60787,60788,60794,60799,60800,61026,61031,61032,61033,61047,70245,70247,70250,70252,70255,70257,70260,70262,70265,70267,70270,70272,70275,70277,70279,70281,70284,70286,70289,70291,70295,70297,70299,70301,70304,70306,70309,70311,70314,70316,70319,70320,70321,70322,70323,70324,70325,70326,70327,70328,70329,70330,70331,70332,70333,70334,70335,70336,70337,70338,70339,70340,70341,70342,70343,70344,70345,70346,70347,70348,70349,70350,70351,70352,70354,70356,70358,70359,70360,70361,70362,70363,70364,70365,70366,70367,70368,70369,70370,70371,70372,70373,70374,70375,70376,70377,70378,70379,70380,70381,70382,70383,70384,70385,70386,70387,70388,70389,70390,70391,70392,70396,70397,70398,70399,70400,70401,70402,70403,70404,70942,70943,70947,70949,70952,70953,71046,71048,71050,71052,71059,71061,71064,71066,71069,71071,71092,71094,71097,71099,71102,71104,71107,71109,71271,71273,71276,71278,71281,71283,71286,71288,71292,71294,71297,71299,71302,71304,73479,73481,73485,73487,73488,73489,73491,73492,73493,73494,73495,73496,73497,73498,73503,73505,73507,73509,73511,73514,73516,73518,73519,73520,73521,73522,73524,73526,73528,73529,73530,73531,73532,73533,73535,73536,73539,73542,73544,73547,73549,73550,73551,73552,73553,73554,73555,73557,73559,73561,73562,73563,73564,73565,73566,73568,73570,73574,73576,73581,73583,73585,73586,73587,73588,73589,73590,73591,73592,73593,73597,73599,73600,73601,73602,73605,73607,73608,73609,73610,73613,73615,73617,73619,73621,73622,73623,73625,73626,73627,73628,73629,73630,73631,73632,73633,73634,73635,73636,73637,73638,73639,73640,73641,73643,73644,73645,73646,73647,73648,76212,76214,76341,76343,76346,76348,76357,76359,76749,76751,76757,76759,76766,76768,76875,76877,76975,76977,76985,76986,76989,76991,77004,77006,77009,77011,77014,77016,77018,77020,77024,77026,77029,77031,77036,77038,77041,77043,60245,60247,60248,60250,60255,60257,60261,60275,60278,60280,60283,60285,60288,60290,60298,60300,60305,60307,60310,60312,60314,60316,60319,60321,60324,60326,60330,60332,60340,60342,60345,60347,60350,60352,60355,60357,60361,60363,60409,60411,60414,60416,60419,60421,60424,60426,60429,60431,60434,60436,60439,60441,60443,60445,60448,60450,60453,60455,60459,60461,60463,60465,60468,60470,60473,60475,60478,60480,60505,60508,60509,60513,60516,60521,60533,60534,60536,60539,60540,60554,60555,60557,60564,60567,60580,60581,60583,60586,60587,60589,60593,60602,60604,60607,60612,60613,60626,60628,60630,60634,60636,60637,60645,60647,60649,60650,60651,60658,60659,60661,60662,60664,60668,60669,60670,60673,60776,60778,60779,60783,60786,60787,60788,60794,60799,60800,61026,61031,61032,61033,61047,70245,70247,70250,70252,70255,70257,70260,70262,70265,70267,70270,70272,70275,70277,70279,70281,70284,70286,70289,70291,70295,70297,70299,70301,70304,70306,70309,70311,70314,70316,70319,70320,70321,70322,70323,70324,70325,70326,70327,70328,70329,70330,70331,70332,70333,70334,70335,70336,70337,70338,70339,70340,70341,70342,70343,70344,70345,70346,70347,70348,70349,70350,70351,70352,70354,70356,70358,70359,70360,70361,70362,70363,70364,70365,70366,70367,70368,70369,70370,70371,70372,70373,70374,70375,70376,70377,70378,70379,70380,70381,70382,70383,70384,70385,70386,70387,70388,70389,70390,70391,70392,70396,70397,70398,70399,70400,70401,70402,70403,70404,70942,70943,70947,70949,70952,70953,71046,71048,71050,71052,71059,71061,71064,71066,71069,71071,71092,71094,71097,71099,71102,71104,71107,71109,71271,71273,71276,71278,71281,71283,71286,71288,71292,71294,71297,71299,71302,71304,73479,73481,73485,73487,73488,73489,73491,73492,73493,73494,73495,73496,73497,73498,73503,73505,73507,73509,73511,73514,73516,73518,73519,73520,73521,73522,73524,73526,73528,73529,73530,73531,73532,73533,73535,73536,73539,73542,73544,73547,73549,73550,73551,73552,73553,73554,73555,73557,73559,73561,73562,73563,73564,73565,73566,73568,73570,73574,73576,73581,73583,73585,73586,73587,73588,73589,73590,73591,73592,73593,73597,73599,73600,73601,73602,73605,73607,73608,73609,73610,73613,73615,73617,73619,73621,73622,73623,73625,73626,73627,73628,73629,73630,73631,73632,73633,73634,73635,73636,73637,73638,73639,73640,73641,73643,73644,73645,73646,73647,73648,76212,76214,76341,76343,76346,76348,76357,76359,76749,76751,76757,76759,76766,76768,76875,76877,76975,76977,76985,76986,76989,76991,77004,77006,77009,77011,77014,77016,77018,77020,77024,77026,77029,77031,77036,77038,77041,77043,60245,60247,60248,60250,60255,60257,60261,60275,60278,60280,60283,60285,60288,60290,60298,60300,60305,60307,60310,60312,60314,60316,60319,60321,60324,60326,60330,60332,60340,60342,60345,60347,60350,60352,60355,60357,60361,60363,60409,60411,60414,60416,60419,60421,60424,60426,60429,60431,60434,60436,60439,60441,60443,60445,60448,60450,60453,60455,60459,60461,60463,60465,60468,60470,60473,60475,60478,60480,60505,60508,60509,60513,60516,60521,60533,60534,60536,60539,60540,60554,60555,60557,60564,60567,60580,60581,60583,60586,60587,60589,60593,60602,60604,60607,60612,60613,60626,60628,60630,60634,60636,60637,60645,60647,60649,60650,60651,60658,60659,60661,60662,60664,60668,60669,60670,60673,60776,60778,60779,60783,60786,60787,60788,60794,60799,60800,61026,61031,61032,61033,61047,70245,70247,70250,70252,70255,70257,70260,70262,70265,70267,70270,70272,70275,70277,70279,70281,70284,70286,70289,70291,70295,70297,70299,70301,70304,70306,70309,70311,70314,70316,70319,70320,70321,70322,70323,70324,70325,70326,70327,70328,70329,70330,70331,70332,70333,70334,70335,70336,70337,70338,70339,70340,70341,70342,70343,70344,70345,70346,70347,70348,70349,70350,70351,70352,70354,70356,70358,70359,70360,70361,70362,70363,70364,70365,70366,70367,70368,70369,70370,70371,70372,70373,70374,70375,70376,70377,70378,70379,70380,70381,70382,70383,70384,70385,70386,70387,70388,70389,70390,70391,70392,70396,70397,70398,70399,70400,70401,70402,70403,70404,70942,70943,70947,70949,70952,70953,71046,71048,71050,71052,71059,71061,71064,71066,71069,71071,71092,71094,71097,71099,71102,71104,71107,71109,71271,71273,71276,71278,71281,71283,71286,71288,71292,71294,71297,71299,71302,71304,73479,73481,73485,73487,73488,73489,73491,73492,73493,73494,73495,73496,73497,73498,73503,73505,73507,73509,73511,73514,73516,73518,73519,73520,73521,73522,73524,73526,73528,73529,73530,73531,73532,73533,73535,73536,73539,73542,73544,73547,73549,73550,73551,73552,73553,73554,73555,73557,73559,73561,73562,73563,73564,73565,73566,73568,73570,73574,73576,73581,73583,73585,73586,73587,73588,73589,73590,73591,73592,73593,73597,73599,73600,73601,73602,73605,73607,73608,73609,73610,73613,73615,73617,73619,73621,73622,73623,73625,73626,73627,73628,73629,73630,73631,73632,73633,73634,73635,73636,73637,73638,73639,73640,73641,73643,73644,73645,73646,73647,73648,76212,76214,76341,76343,76346,76348,76357,76359,76749,76751,76757,76759,76766,76768,76875,76877,76975,76977,76985,76986,76989,76991,77004,77006,77009,77011,77014,77016,77018,77020,77024,77026,77029,77031,77036,77038,77041,77043,60245,60247,60248,60250,60255,60257,60261,60275,60278,60280,60283,60285,60288,60290,60298,60300,60305,60307,60310,60312,60314,60316,60319,60321,60324,60326,60330,60332,60340,60342,60345,60347,60350,60352,60355,60357,60361,60363,60409,60411,60414,60416,60419,60421,60424,60426,60429,60431,60434,60436,60439,60441,60443,60445,60448,60450,60453,60455,60459,60461,60463,60465,60468,60470,60473,60475,60478,60480,60505,60508,60509,60513,60516,60521,60533,60534,60536,60539,60540,60554,60555,60557,60564,60567,60580,60581,60583,60586,60587,60589,60593,60602,60604,60607,60612,60613,60626,60628,60630,60634,60636,60637,60645,60647,60649,60650,60651,60658,60659,60661,60662,60664,60668,60669,60670,60673,60776,60778,60779,60783,60786,60787,60788,60794,60799,60800,61026,61031,61032,61033,61047,70245,70247,70250,70252,70255,70257,70260,70262,70265,70267,70270,70272,70275,70277,70279,70281,70284,70286,70289,70291,70295,70297,70299,70301,70304,70306,70309,70311,70314,70316,70319,70320,70321,70322,70323,70324,70325,70326,70327,70328,70329,70330,70331,70332,70333,70334,70335,70336,70337,70338,70339,70340,70341,70342,70343,70344,70345,70346,70347,70348,70349,70350,70351,70352,70354,70356,70358,70359,70360,70361,70362,70363,70364,70365,70366,70367,70368,70369,70370,70371,70372,70373,70374,70375,70376,70377,70378,70379,70380,70381,70382,70383,70384,70385,70386,70387,70388,70389,70390,70391,70392,70396,70397,70398,70399,70400,70401,70402,70403,70404,70942,70943,70947,70949,70952,70953,71046,71048,71050,71052,71059,71061,71064,71066,71069,71071,71092,71094,71097,71099,71102,71104,71107,71109,71271,71273,71276,71278,71281,71283,71286,71288,71292,71294,71297,71299,71302,71304,73479,73481,73485,73487,73488,73489,73491,73492,73493,73494,73495,73496,73497,73498,73503,73505,73507,73509,73511,73514,73516,73518,73519,73520,73521,73522,73524,73526,73528,73529,73530,73531,73532,73533,73535,73536,73539,73542,73544,73547,73549,73550,73551,73552,73553,73554,73555,73557,73559,73561,73562,73563,73564,73565,73566,73568,73570,73574,73576,73581,73583,73585,73586,73587,73588,73589,73590,73591,73592,73593,73597,73599,73600,73601,73602,73605,73607,73608,73609,73610,73613,73615,73617,73619,73621,73622,73623,73625,73626,73627,73628,73629,73630,73631,73632,73633,73634,73635,73636,73637,73638,73639,73640,73641,73643,73644,73645,73646,73647,73648,76212,76214,76341,76343,76346,76348,76357,76359,76749,76751,76757,76759,76766,76768,76875,76877,76975,76977,76985,76986,76989,76991,77004,77006,77009,77011,77014,77016,77018,77020,77024,77026,77029,77031,77036,77038,77041,77043,65004,65076,65077,65078,65079,65080,65081,65082,65083,65084,65085,65086,65007,65020,65041,65042,65044,65045,65046,65047,65048,65049,65050,65051,65052,65053,65054,65055,65056,65058,65059,65060,65061,65062,65063,65066,67429,67430,67431,65021,65028,65064,65065,65067,65068,65069,65070,65071,65072,65073,65075,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65040,67426,67427,67428,65000,65001,65002,65003,65017,65018,65019,65022,65023,65024,65025,65026,65027,65043,65057,65074,65004,65076,65077,65078,65079,65080,65081,65082,65083,65084,65085,65086,65007,65020,65041,65042,65044,65045,65046,65047,65048,65049,65050,65051,65052,65053,65054,65055,65056,65058,65059,65060,65061,65062,65063,65066,67429,67430,67431,65021,65028,65064,65065,65067,65068,65069,65070,65071,65072,65073,65075,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65040,67426,67427,67428,65000,65001,65002,65003,65017,65018,65019,65022,65023,65024,65025,65026,65027,65043,65057,65074,59117,59118,59119,59120,59121,59122,59216,59217,59218,59219,59220,63540,59328,59329,59331,59332,59333,59334,59335,59336,59340,59341,59452,59492,59312,59315,59316,59317,59318,59319,59320,59322,59324,59325,59326,59327,59221,59223,59224,59225,59233,59234,59310,59311,59313,59314,59355,59451,59342,59343,59344,59346,59347,59348,59349,59350,59351,59352,59353,59354,59222,59321,59337,59356,59441,59442,59443,59444,59450,59454,59457,59459,63679,63682,63683,63684,59117,59118,59119,59120,59121,59122,59216,59217,59218,59219,59220,63540,59328,59329,59331,59332,59333,59334,59335,59336,59340,59341,59452,59492,59312,59315,59316,59317,59318,59319,59320,59322,59324,59325,59326,59327,59221,59223,59224,59225,59233,59234,59310,59311,59313,59314,59355,59451,59342,59343,59344,59346,59347,59348,59349,59350,59351,59352,59353,59354,59222,59321,59337,59356,59441,59442,59443,59444,59450,59454,59457,59459,63679,63682,63683,63684,65133,65134,65135,65136,65137,65138,65139,65140,65141,65142,65143,65144,67423,67424,67425,65091,65092,65093,65094,65095,65096,65105,65106,65107,65108,65109,65112,65110,65111,65113,65114,65115,65116,65117,65118,65119,65120,65121,65122,65087,65088,65089,65090,65123,65124,65125,65126,65127,65128,65129,65130,65131,65132,65145,68600,60226,60227,60228,60229,60230,60231,60232,60233,60234,60235,60236,60237,60238,65133,65134,65135,65136,65137,65138,65139,65140,65141,65142,65143,65144,67423,67424,67425,65091,65092,65093,65094,65095,65096,65105,65106,65107,65108,65109,65112,65110,65111,65113,65114,65115,65116,65117,65118,65119,65120,65121,65122,65087,65088,65089,65090,65123,65124,65125,65126,65127,65128,65129,65130,65131,65132,65145,68600,60226,60227,60228,60229,60230,60231,60232,60233,60234,60235,60236,60237,60238,59469,59470,59471,59472,59473,59474,59475,59476,59481,59482,59483,59484,59512,59515,59516,59517,59518,59519,63531,63532,63533,63534,63535,63536,59502,59503,59504,59505,59506,59507,59508,59509,59510,59511,59513,59514,59330,59485,59486,59487,59490,59494,59495,59497,59498,59499,59500,59501,63680,64314,64315,64316,59469,59470,59471,59472,59473,59474,59475,59476,59481,59482,59483,59484,59512,59515,59516,59517,59518,59519,63531,63532,63533,63534,63535,63536,59502,59503,59504,59505,59506,59507,59508,59509,59510,59511,59513,59514,59330,59485,59486,59487,59490,59494,59495,59497,59498,59499,59500,59501,63680,64314,64315,64316,65367,65368,65369,65370,65371,65372,65373,65374,65375,65376,65377,63041,65000,65001,65002,65087,65088,65089,65378,65379,65380,65381,65382,65383,65384,65385,65386,66998,68130,68131,68132,69878,69879,69880,69881,69882,69883,69884,69885,65367,65368,65369,65370,65371,65372,65373,65374,65375,65376,65377,63041,65000,65001,65002,65087,65088,65089,65378,65379,65380,65381,65382,65383,65384,65385,65386,66998,68130,68131,68132,69878,69879,69880,69881,69882,69883,69884,69885,63488,63489,63490,63491,63492,63493,63494,63495,63496,63497,63498,63041,63499,63500,63501,63502,63503,63504,63505,63506,63507,63682,63683,63684,64314,64315,64316,68127,68128,68129,69827,69828,69829,69830,69831,69833,69834,69835,63488,63489,63490,63491,63492,63493,63494,63495,63496,63497,63498,63041,63499,63500,63501,63502,63503,63504,63505,63506,63507,63682,63683,63684,64314,64315,64316,68127,68128,68129,69827,69828,69829,69830,69831,69833,69834,69835,69138,69237,71401,71402,71403,71404,71405,71406,71407,71408,71409,71410,71411,71412,71413,71617,71774,71777,71778,71781,71783,71784,71786,69237,71414,71415,71416,71417,71418,71419,71420,71421,71422,71423,71424,71425,71426,71617,71774,71777,71778,71781,71783,71784,71786,69149,69237,71427,71428,71429,71430,71431,71432,71433,71434,71435,71436,71437,71438,71439,71617,71665,71672,71679,71686,71774,71777,71778,71781,71783,71784,71786,69237,71440,71441,71442,71443,71444,71445,71446,71447,71448,71449,71450,71451,71452,71453,71617,71671,71678,71685,71774,71777,71778,71781,71783,71784,71786,69139,69237,71454,71455,71456,71457,71458,71459,71460,71461,71462,71463,71464,71465,71617,71669,71676,71683,71774,71777,71778,71781,71783,71784,71786,69111,69112,69237,71466,71467,71468,71469,71470,71471,71472,71473,71474,71475,71617,71673,71680,71687,71774,71777,71778,71781,71783,71784,71786,69110,69150,69167,69224,69237,70723,71610,71611,71612,71613,71614,71615,71616,71617,71670,71677,71684,71774,71777,71778,71781,71783,71784,71786,71797,69138,69237,71401,71402,71403,71404,71405,71406,71407,71408,71409,71410,71411,71412,71413,71617,71774,71777,71778,71781,71783,71784,71786,69237,71414,71415,71416,71417,71418,71419,71420,71421,71422,71423,71424,71425,71426,71617,71774,71777,71778,71781,71783,71784,71786,69149,69237,71427,71428,71429,71430,71431,71432,71433,71434,71435,71436,71437,71438,71439,71617,71665,71672,71679,71686,71774,71777,71778,71781,71783,71784,71786,69237,71440,71441,71442,71443,71444,71445,71446,71447,71448,71449,71450,71451,71452,71453,71617,71671,71678,71685,71774,71777,71778,71781,71783,71784,71786,69139,69237,71454,71455,71456,71457,71458,71459,71460,71461,71462,71463,71464,71465,71617,71669,71676,71683,71774,71777,71778,71781,71783,71784,71786,69111,69112,69237,71466,71467,71468,71469,71470,71471,71472,71473,71474,71475,71617,71673,71680,71687,71774,71777,71778,71781,71783,71784,71786,69110,69150,69167,69224,69237,70723,71610,71611,71612,71613,71614,71615,71616,71617,71670,71677,71684,71774,71777,71778,71781,71783,71784,71786,71797,68981,69237,70914,70922,71029,71030,71031,71032,71038,71039,71040,71041,71042,71043,71044,71775,71776,71779,71780,71782,71785,71787,69237,70912,70991,70992,70993,71003,71004,71005,71006,71007,71009,71010,71011,71012,71775,71776,71779,71780,71782,71785,71787,68983,69237,70733,70734,70735,70736,70737,70738,70739,70985,70986,70987,70988,70989,70990,71665,71775,71776,71779,71780,71782,71785,71787,69237,70913,71013,71014,71018,71019,71020,71021,71022,71023,71024,71025,71026,71027,71028,71775,71776,71779,71780,71782,71785,71787,68982,69237,70915,70916,70917,71312,71314,71315,71323,71340,71341,71342,71343,71345,71775,71776,71779,71780,71782,71785,71787,68926,68927,69237,69897,70920,71313,71344,71346,71347,71348,71349,71350,71351,71674,71681,71688,71775,71776,71779,71780,71782,71785,71787,68925,68994,68995,69224,69237,70921,71352,71353,71354,71355,71356,71357,71358,71668,71675,71682,71775,71776,71779,71780,71782,71785,71787,71798,68981,69237,70914,70922,71029,71030,71031,71032,71038,71039,71040,71041,71042,71043,71044,71775,71776,71779,71780,71782,71785,71787,69237,70912,70991,70992,70993,71003,71004,71005,71006,71007,71009,71010,71011,71012,71775,71776,71779,71780,71782,71785,71787,68983,69237,70733,70734,70735,70736,70737,70738,70739,70985,70986,70987,70988,70989,70990,71665,71775,71776,71779,71780,71782,71785,71787,69237,70913,71013,71014,71018,71019,71020,71021,71022,71023,71024,71025,71026,71027,71028,71775,71776,71779,71780,71782,71785,71787,68982,69237,70915,70916,70917,71312,71314,71315,71323,71340,71341,71342,71343,71345,71775,71776,71779,71780,71782,71785,71787,68926,68927,69237,69897,70920,71313,71344,71346,71347,71348,71349,71350,71351,71674,71681,71688,71775,71776,71779,71780,71782,71785,71787,68925,68994,68995,69224,69237,70921,71352,71353,71354,71355,71356,71357,71358,71668,71675,71682,71775,71776,71779,71780,71782,71785,71787,71798,71998,77207,77208,77209,77210,77211,77212,77214,77228,77229,77230,77231,77232,77261,77262,77263,77265,77266,77267,77268,77269,77270,77271,71998,77204,77207,77208,77209,77210,77211,77215,77216,77228,77229,77230,77231,77232,77255,77257,77258,77259,77260,78173,78178,78183,71998,77203,77206,77207,77208,77209,77210,77211,77217,77218,77219,77228,77229,77230,77231,77232,77252,77253,77254,78171,78176,78181,71998,77207,77208,77209,77210,77211,77220,77221,77228,77229,77230,77231,77232,77248,77249,77250,77251,78011,78012,78170,78175,78180,71998,77205,77207,77208,77209,77210,77211,77223,77228,77229,77230,77231,77232,77242,77243,77244,77245,77246,77247,78013,78174,78179,78184,78919,71998,77202,77207,77208,77209,77210,77211,77224,77225,77226,77227,77228,77229,77230,77231,77232,77234,77239,77240,77241,78172,78177,78182,71998,77197,77198,77199,77200,77201,77235,77236,77237,77238,78357,71998,77067,77188,77189,77190,77191,77193,77194,77195,77196,78359,71998,77207,77208,77209,77210,77211,77212,77214,77228,77229,77230,77231,77232,77261,77262,77263,77265,77266,77267,77268,77269,77270,77271,71998,77204,77207,77208,77209,77210,77211,77215,77216,77228,77229,77230,77231,77232,77255,77257,77258,77259,77260,78173,78178,78183,71998,77203,77206,77207,77208,77209,77210,77211,77217,77218,77219,77228,77229,77230,77231,77232,77252,77253,77254,78171,78176,78181,71998,77207,77208,77209,77210,77211,77220,77221,77228,77229,77230,77231,77232,77248,77249,77250,77251,78011,78012,78170,78175,78180,71998,77205,77207,77208,77209,77210,77211,77223,77228,77229,77230,77231,77232,77242,77243,77244,77245,77246,77247,78013,78174,78179,78184,78919,71998,77202,77207,77208,77209,77210,77211,77224,77225,77226,77227,77228,77229,77230,77231,77232,77234,77239,77240,77241,78172,78177,78182,71998,77197,77198,77199,77200,77201,77235,77236,77237,77238,78357,71998,77067,77188,77189,77190,77191,77193,77194,77195,77196,78359,71998,77999,78000,78001,78002,78003,78361,78362,78363,78364,78365,78366,78367,78368,78370,78371,78372,78373,78489,78490,78491,78492,78493,71998,77989,77999,78000,78001,78002,78003,78387,78388,78389,78390,78391,78392,78393,78489,78490,78491,78492,78493,78853,78854,78855,71998,77990,77991,77999,78000,78001,78002,78003,78401,78402,78403,78404,78405,78406,78489,78490,78491,78492,78493,78856,78857,78858,71998,77999,78000,78001,78002,78003,78413,78414,78415,78416,78417,78418,78419,78420,78489,78490,78491,78492,78493,78859,78860,78861,71998,77992,77999,78000,78001,78002,78003,78429,78430,78431,78432,78433,78434,78435,78436,78489,78490,78491,78492,78493,78847,78848,78849,78919,71998,77993,77999,78000,78001,78002,78003,78445,78446,78447,78448,78449,78450,78451,78452,78489,78490,78491,78492,78493,78850,78851,78852,71998,77994,77995,77996,77997,77998,78461,78462,78463,78464,78465,71998,77067,77069,78471,78472,78473,78474,78475,78476,78477,78478,78479,71998,77999,78000,78001,78002,78003,78361,78362,78363,78364,78365,78366,78367,78368,78370,78371,78372,78373,78489,78490,78491,78492,78493,71998,77989,77999,78000,78001,78002,78003,78387,78388,78389,78390,78391,78392,78393,78489,78490,78491,78492,78493,78853,78854,78855,71998,77990,77991,77999,78000,78001,78002,78003,78401,78402,78403,78404,78405,78406,78489,78490,78491,78492,78493,78856,78857,78858,71998,77999,78000,78001,78002,78003,78413,78414,78415,78416,78417,78418,78419,78420,78489,78490,78491,78492,78493,78859,78860,78861,71998,77992,77999,78000,78001,78002,78003,78429,78430,78431,78432,78433,78434,78435,78436,78489,78490,78491,78492,78493,78847,78848,78849,78919,71998,77993,77999,78000,78001,78002,78003,78445,78446,78447,78448,78449,78450,78451,78452,78489,78490,78491,78492,78493,78850,78851,78852,71998,77994,77995,77996,77997,77998,78461,78462,78463,78464,78465,71998,77067,77069,78471,78472,78473,78474,78475,78476,78477,78478,78479,77979,77980,77981,77982,77983,78375,78376,78377,78378,78380,78381,78382,78384,78385,78386,78494,78495,78496,78497,78498,78862,78863,78864,78865,78866,78867,78868,78869,78870,78871,78872,78873,78874,78875,78876,77969,77979,77980,77981,77982,77983,78395,78396,78397,78398,78399,78400,78494,78495,78496,78497,78498,78862,78863,78864,78865,78866,78867,78868,78869,78870,78871,78872,78873,78874,78875,78876,77970,77971,77979,77980,77981,77982,77983,78408,78411,78412,78494,78495,78496,78497,78498,78862,78863,78864,78865,78866,78867,78868,78869,78870,78871,78872,78873,78874,78875,78876,77979,77980,77981,77982,77983,78421,78422,78423,78424,78425,78427,78428,78494,78495,78496,78497,78498,78862,78863,78864,78865,78866,78867,78868,78869,78870,78871,78872,78873,78874,78875,78876,77972,77979,77980,77981,77982,77983,78438,78439,78440,78441,78442,78443,78444,78494,78495,78496,78497,78498,78862,78863,78864,78865,78866,78867,78868,78869,78870,78871,78872,78873,78874,78875,78876,78919,77973,77979,77980,77981,77982,77983,78454,78455,78456,78457,78458,78460,78494,78495,78496,78497,78498,78862,78863,78864,78865,78866,78867,78868,78869,78870,78871,78872,78873,78874,78875,78876,77974,77975,77976,77977,77978,78466,78467,78468,78469,78470,78480,78481,78482,78483,78484,78485,78486,78487,78488,87333,87334,87335,87336,87337,87338,87339,87340,87341,85178,85175,85176,85179,85177,87342,87343,87344,87345,87346,87347,87348,87349,87350,85179,85176,85177,85178,85175,85183,85180,85184,85181,85182,85185,85186,85187,85188,85189,85190,85191,85192,85193,85194,87342,87343,87344,87345,87346,87347,87348,87349,87350,87333,87334,87335,87336,87337,87338,87339,87340,87341,81240,81237,81238,81241,81239,81238,81239,81240,81237,81241,81245,81242,81246,81243,81244,81252,81253,81254,81255,81256,81257,81247,81248,81249,81251,87542,88266,88267,88264,88268,88265,88273,88270,88271,88272,88269,88274,88275,88276,88277,88278,88279,88280,88281,88282,88283,87370,87371,87372,87373,87374,87375,87376,87377,87378,81693,81694,81695,81696,81563,81700,81697,81568,81698,81699,82812,82813,82814,82815,82816,82817,82818,82819,81564,81565,87550,88357,88361,88358,88362,88359,88356,88360,88355,88343,88340,88344,88341,88342,88347,88348,88345,88349,88346,88350,88354,88351,88352,88353,88336,88337,88338,88335,88339,87379,87380,87381,87382,87383,87384,87385,87386,87387,82857,81268,82859,82860,82861,82862,81267,81266,82858,82827,82824,82828,82825,82826,82848,82852,82850,82847,82851,82855,82856,82853,82854,81567,82820,82821,82822,81566,82823,87292,87293,87294,87295,87296,87297,87298,87299,87300,87283,87284,87285,87286,87287,87288,87289,87290,87291,80865,80863,80864,80874,80871,80868,80869,80873,80870,80862,80860,80861,80872,80867,80866,87292,87293,87294,87295,87296,87297,87298,87299,87300,87283,87284,87285,87286,87287,87288,87289,87290,87291,81126,81060,81058,81125,81073,81132,81074,81063,87544,81079,81082,81071,81069,81130,81131,81129,81123,81075,81072,81083,81124,81070,81067,81127,81128,81084,87351,87352,87353,87354,87355,81095,81190,81191,81104,81090,81091,81112,81094,81100,87546,81097,81233,81234,81235,81236,81109,81098,81085,81229,81111,81192,81105,81088,81106,81230,81232,87356,87357,87358,87359,87360,81273,81277,81274,81275,81276,81270,81271,81272,81262,81263,81280,81281,81264,81282,81279,81283,81284,81285,81286,81287,81288,81289,81290,81291,87547,81292,88287,88284,88288,88285,88286,88291,88292,88289,88293,88290,88302,88303,88294,88295,88296,88297,88298,88299,88300,88301,87361,87362,87363,87364,87365,87366,87367,87368,87369,81560,81571,81572,81569,81570,81574,81575,81576,81573,81561,81687,81688,81689,81690,81691,81692,81577,81578,81265,87551,81562,87315,87316,87317,87318,87319,87320,87321,87322,87323,87324,87325,87326,87327,87328,87329,87330,87331,87332,80910,80908,80909,80913,80915,80883,80937,80911,80912,80916,80917,80935,80918,80936,80919,87315,87316,87317,87318,87319,87320,87321,87322,87323,87324,87325,87326,87327,87328,87329,87330,87331,87332,81179,81092,81110,81086,81180,81102,81113,81089,81184,81185,81182,81108,81181,81087,81101,81103,81107,87543,81186,81096,81187,81188,81099,81189,81114,81093,87310,87311,87312,87313,87314,87301,87302,87303,87304,87305,87306,87307,87308,87309,80898,80899,80893,80902,80903,80900,80894,80901,80895,80892,80896,80897,87310,87311,87312,87313,87314,87301,87302,87303,87304,87305,87306,87307,87308,87309,81077,81065,81076,81136,81135,81059,81062,81078,81139,87545,81066,81068,81138,81141,81140,81081,81133,81064,81061,81080,81134,84801,84802,84803,84804,84805,84806,84807,84808,84809,84810,84811,84812,84813,84814,84815,84816,84817,84818,84819,84820,84821,84822,84823,84824,84825,84826,84827,84828,84829,84830,84831,84832,84833,84834,84835,84836,84837,84838,84839,84840,84841,84842,84843,84844,84845,84846,84847,84886,84887,84888,84889,84890,84891,84892,84946,84947,84948,84949,84950,84951,84952,84953,84954,84955,84956,84957,84958,84959,84960,84972,84973,84974,84975,84976,84977,84978,84979,84980,84981,84982,84983,84984,84985,84986,85285,85287,85290,85292,85295,85297,85300,85302,85306,85308,85310,85312,85315,85317,85320,85322,85325,85327,85330,85331,85335,85337,85340,85342,85345,85347,85350,85352,85356,85358,85361,85363,85364,85366,85369,85371,85376,85378,85380,85382,85385,85387,85389,85391,85395,85397,87771,90839,89783,90408,90409,90410,90411,90412,90413,90414,90415,90416,90417,90418,90419,90420,90421,90422,90423,90424,90425,90429,90430,90431,90432,90433,90434,90435,90436,90437,90438,90439,90440,90441,90442,90443,90444,90445,90446,90447,90448,90449,90450,90451,90452,90453,90454,90455,90456,90840,91100,91101,91102,91103,91105,91106,91109,91111,91113,91115,91117,91119,91121,91122,91123,91124,91125,91126,91135,91136,91137,91138,91139,91140,91149,91153,91157,91161,91167,91169,91171,91172,91176,91184,91186,91188,91189,91193,91212,91214,91216,91218,91220,91221,91224,91228,91232,91236,91242,91244,91246,91247,91251,91257,91261,91269,91273,91277,91279,91281,91283,91285,91286,91289,91293,91297,91299,91301,91303,91305,91306,91309,91313,91319,91323,91335,91337,91339,91342,91346,91350,91352,91354,91356,91357,91360,91364,91370,91374,91378,91382,91386,91411,91412,91413,91414,91416,91417,91420,91424,91432,91436,94328,94330,94331,94333,94334,94336,94337,94340,94343,94344,94351,94352,94353,94354,94355,94357,94358,94359,94360,94362,94363,94364,94365,94368,94370,94371,94374,94376,94377,94378,94379,94380,94382,94383,94384,94390,94391,94393,94394,94395,94399,94400,94402,94403,94404,94407,94408,94410,94411,94412,94414,94417,94418,94420,94421,94423,94424,94425,94427,94432,94435,94438,94439,94440,94441,94445,94446,94448,94449,94451,94452,94453,94455,94458,94461,94462,94464,94465,94468,94469,94470,94471,94472,94473,94474,94476,94477,94478,94480,94481,94483,94484,94485,94486,94487,94488,94489,94490,94491,94494,94496,94497,95057,95226,95228,95231,95233,95236,95238,95240,95242,95245,95247,95251,95253,95256,95258,95260,95262,95266,95268,95270,95272,95276,95278,95281,95283,95286,95288,95291,95293,95295,95297,95300,95302,95306,95308,95311,95313,95316,95318,95321,95323,95325,95327,95332,95333,95336,95338,94228,95147,95148,95149,95150,95151,95152,95153,95163,95164,95165,95166,95167,95177,95178,95179,95180,95181,95182,95183,95184,95185,95186,95187,95188,95189,95190,95191,95192,95193,95194,95195,95196,95197,95198,95199,95200,95201,102615,102617,102618,102620,102621,102623,102624,102627,102630,102631,102638,102639,102640,102641,102642,102644,102645,102646,102647,102648,102649,102650,102651,102654,102656,102657,102660,102662,102663,102664,102665,102666,102668,102669,102670,102674,102675,102677,102678,102679,102683,102684,102686,102687,102688,102691,102692,102694,102695,102696,102698,102701,102702,102704,102705,102707,102708,102709,102711,102716,102719,102722,102723,102724,102725,102729,102730,102732,102733,102735,102736,102737,102739,102742,102745,102746,102748,102749,102752,102753,102754,102755,102756,102757,102758,102760,102761,102762,102764,102765,102767,102768,102769,102770,102771,102772,102773,102774,102775,102778,102780,102781,103343,103344,103345,103346,103348,103349,103351,103352,103353,103354,103355,103356,103357,103358,103359,103360,103361,103362,103367,103368,103369,103370,103371,103372,103377,103379,103381,103383,103386,103387,103388,103389,103391,103395,103396,103397,103398,103400,103410,103411,103412,103413,103414,103415,103417,103419,103421,103423,103426,103427,103428,103429,103431,103434,103436,103440,103442,103444,103445,103446,103447,103448,103449,103451,103453,103455,103456,103457,103458,103459,103460,103462,103464,103467,103469,103472,103473,103474,103476,103478,103480,103481,103482,103483,103484,103486,103488,103491,103493,103495,103497,103499,103512,103513,103514,103515,103517,103518,103520,103522,103526,103528,99092,99094,99096,99098,99099,99102,99104,99108,99113,99115,99118,99121,99123,99124,99127,99129,99131,99134,99137,99139,99141,99143,99145,99147,99149,99155,99158,99160,99162,99163,99165,99168,99171,99174,99176,99181,99183,99185,99186,99189,99191,99193,99195,99198,99199,99202,102615,102617,102618,102620,102621,102623,102624,102627,102630,102631,102638,102639,102640,102641,102642,102644,102645,102646,102647,102648,102649,102650,102651,102654,102656,102657,102660,102662,102663,102664,102665,102666,102668,102669,102670,102674,102675,102677,102678,102679,102683,102684,102686,102687,102688,102691,102692,102694,102695,102696,102698,102701,102702,102704,102705,102707,102708,102709,102711,102716,102719,102722,102723,102724,102725,102729,102730,102732,102733,102735,102736,102737,102739,102742,102745,102746,102748,102749,102752,102753,102754,102755,102756,102757,102758,102760,102761,102762,102764,102765,102767,102768,102769,102770,102771,102772,102773,102774,102775,102778,102780,102781,103343,103344,103345,103346,103348,103349,103351,103352,103353,103354,103355,103356,103357,103358,103359,103360,103361,103362,103367,103368,103369,103370,103371,103372,103377,103379,103381,103383,103386,103387,103388,103389,103391,103395,103396,103397,103398,103400,103410,103411,103412,103413,103414,103415,103417,103419,103421,103423,103426,103427,103428,103429,103431,103434,103436,103440,103442,103444,103445,103446,103447,103448,103449,103451,103453,103455,103456,103457,103458,103459,103460,103462,103464,103467,103469,103472,103473,103474,103476,103478,103480,103481,103482,103483,103484,103486,103488,103491,103493,103495,103497,103499,103512,103513,103514,103515,103517,103518,103520,103522,103526,103528,99092,99094,99096,99098,99099,99102,99104,99108,99113,99115,99118,99121,99123,99124,99127,99129,99131,99134,99137,99139,99141,99143,99145,99147,99149,99155,99158,99160,99162,99163,99165,99168,99171,99174,99176,99181,99183,99185,99186,99189,99191,99193,99195,99198,99199,99202,102615,102617,102618,102620,102621,102623,102624,102627,102630,102631,102638,102639,102640,102641,102642,102644,102645,102646,102647,102648,102649,102650,102651,102654,102656,102657,102660,102662,102663,102664,102665,102666,102668,102669,102670,102674,102675,102677,102678,102679,102683,102684,102686,102687,102688,102691,102692,102694,102695,102696,102698,102701,102702,102704,102705,102707,102708,102709,102711,102716,102719,102722,102723,102724,102725,102729,102730,102732,102733,102735,102736,102737,102739,102742,102745,102746,102748,102749,102752,102753,102754,102755,102756,102757,102758,102760,102761,102762,102764,102765,102767,102768,102769,102770,102771,102772,102773,102774,102775,102778,102780,102781,103343,103344,103345,103346,103348,103349,103351,103352,103353,103354,103355,103356,103357,103358,103359,103360,103361,103362,103367,103368,103369,103370,103371,103372,103377,103379,103381,103383,103386,103387,103388,103389,103391,103395,103396,103397,103398,103400,103410,103411,103412,103413,103414,103415,103417,103419,103421,103423,103426,103427,103428,103429,103431,103434,103436,103440,103442,103444,103445,103446,103447,103448,103449,103451,103453,103455,103456,103457,103458,103459,103460,103462,103464,103467,103469,103472,103473,103474,103476,103478,103480,103481,103482,103483,103484,103486,103488,103491,103493,103495,103497,103499,103512,103513,103514,103515,103517,103518,103520,103522,103526,103528,99092,99094,99096,99098,99099,99102,99104,99108,99113,99115,99118,99121,99123,99124,99127,99129,99131,99134,99137,99139,99141,99143,99145,99147,99149,99155,99158,99160,99162,99163,99165,99168,99171,99174,99176,99181,99183,99185,99186,99189,99191,99193,99195,99198,99199,99202,102615,102617,102618,102620,102621,102623,102624,102627,102630,102631,102638,102639,102640,102641,102642,102644,102645,102646,102647,102648,102649,102650,102651,102654,102656,102657,102660,102662,102663,102664,102665,102666,102668,102669,102670,102674,102675,102677,102678,102679,102683,102684,102686,102687,102688,102691,102692,102694,102695,102696,102698,102701,102702,102704,102705,102707,102708,102709,102711,102716,102719,102722,102723,102724,102725,102729,102730,102732,102733,102735,102736,102737,102739,102742,102745,102746,102748,102749,102752,102753,102754,102755,102756,102757,102758,102760,102761,102762,102764,102765,102767,102768,102769,102770,102771,102772,102773,102774,102775,102778,102780,102781,103343,103344,103345,103346,103348,103349,103351,103352,103353,103354,103355,103356,103357,103358,103359,103360,103361,103362,103367,103368,103369,103370,103371,103372,103377,103379,103381,103383,103386,103387,103388,103389,103391,103395,103396,103397,103398,103400,103410,103411,103412,103413,103414,103415,103417,103419,103421,103423,103426,103427,103428,103429,103431,103434,103436,103440,103442,103444,103445,103446,103447,103448,103449,103451,103453,103455,103456,103457,103458,103459,103460,103462,103464,103467,103469,103472,103473,103474,103476,103478,103480,103481,103482,103483,103484,103486,103488,103491,103493,103495,103497,103499,103512,103513,103514,103515,103517,103518,103520,103522,103526,103528,99092,99094,99096,99098,99099,99102,99104,99108,99113,99115,99118,99121,99123,99124,99127,99129,99131,99134,99137,99139,99141,99143,99145,99147,99149,99155,99158,99160,99162,99163,99165,99168,99171,99174,99176,99181,99183,99185,99186,99189,99191,99193,99195,99198,99199,99202,105754,105755,105756,105757,105758,105759,105760,105761,105762,105763,105764,105765,105766,105767,105768,105769,105770,105771,105772,105773,105774,105775,105776,105777,105778,105779,105780,105781,105782,105783,105784,105785,105786,105787,105788,105789,105790,105791,105792,105793,105794,105795,105796,105797,105798,105799,105800,105801,105802,105803,105804,105805,105806,105807,105808,105809,105810,105811,85922,85923,85924,85925,85926,85975,85976,85977,85978,85979,86134,89766,89767,89768,85980,85982,85983,85984,85985,85986,85987,85988,85989,85990,86082,89424,89802,89803,85991,85992,85993,85994,85995,85996,85997,86027,86038,86039,86040,86041,89817,86047,86071,86075,86076,86080,86081,86083,86084,86086,86127,86128,86129,89818,89819,86131,86132,86133,86135,86136,86137,86138,86139,86140,86141,87777,89821,89822,89824,86142,86144,86145,86146,86147,86148,86149,86150,86151,86152,87827,89820,89823,89825,85922,85923,85924,85925,85926,85975,85976,85977,85978,85979,86134,89766,89767,89768,85980,85982,85983,85984,85985,85986,85987,85988,85989,85990,86082,89424,89802,89803,85991,85992,85993,85994,85995,85996,85997,86027,86038,86039,86040,86041,89817,86047,86071,86075,86076,86080,86081,86083,86084,86086,86127,86128,86129,89818,89819,86131,86132,86133,86135,86136,86137,86138,86139,86140,86141,87777,89821,89822,89824,86142,86144,86145,86146,86147,86148,86149,86150,86151,86152,87827,89820,89823,89825,87012,87013,87014,87015,87016,87017,87018,87019,87020,87021,87060,89929,89930,89931,87022,87023,87024,87025,87026,87027,87028,87029,87030,87031,87044,89425,89932,89933,87032,87033,87034,87035,87036,87037,87038,87039,87040,87041,87042,87043,89934,87045,87046,87047,87048,87049,87050,87051,87052,87053,87054,87055,87056,89935,89936,87057,87058,87059,87061,87062,87063,87064,87065,87066,87067,87068,87777,89937,89938,89939,87069,87070,87071,87072,87073,87074,87075,87076,87077,87078,87825,89940,89941,89942,87012,87013,87014,87015,87016,87017,87018,87019,87020,87021,87060,89929,89930,89931,87022,87023,87024,87025,87026,87027,87028,87029,87030,87031,87044,89425,89932,89933,87032,87033,87034,87035,87036,87037,87038,87039,87040,87041,87042,87043,89934,87045,87046,87047,87048,87049,87050,87051,87052,87053,87054,87055,87056,89935,89936,87057,87058,87059,87061,87062,87063,87064,87065,87066,87067,87068,87777,89937,89938,89939,87069,87070,87071,87072,87073,87074,87075,87076,87077,87078,87825,89940,89941,89942,86739,86740,86741,86742,86743,86744,86745,86746,86747,86748,86793,89964,89965,89966,86749,86750,86751,86752,86753,86754,86755,86756,86757,86758,86782,89426,89967,89968,86759,86760,86761,86762,86763,86764,86765,86766,86767,86768,86769,86770,89969,86776,86777,86778,86779,86780,86781,86783,86784,86785,86786,86787,86788,89970,89971,86789,86790,86791,86792,86794,86795,86796,86797,86798,86799,86800,89972,89973,89974,86801,86802,86803,86804,86805,86806,86807,86808,86809,86810,87826,89975,89976,89977,86153,86154,86155,86156,86157,86158,86159,86160,86161,86203,87824,89826,89827,89829,86162,86163,86164,86165,86166,86167,86168,86169,86170,86171,89828,89830,89831,90738,86172,86173,86174,86175,86176,86177,86178,86179,86180,86181,86182,89832,89833,89834,86200,86201,86202,86204,86205,86513,86514,89240,89241,89242,86210,86211,86212,86213,86214,86217,86219,89243,89244,89245,86226,86227,86228,86229,89237,89238,89239,89835,89836,89837,86153,86154,86155,86156,86157,86158,86159,86160,86161,86203,87824,89826,89827,89829,86162,86163,86164,86165,86166,86167,86168,86169,86170,86171,89828,89830,89831,90738,86172,86173,86174,86175,86176,86177,86178,86179,86180,86181,86182,89832,89833,89834,86200,86201,86202,86204,86205,86513,86514,89240,89241,89242,86210,86211,86212,86213,86214,86217,86219,89243,89244,89245,86226,86227,86228,86229,89237,89238,89239,89835,89836,89837,86943,86944,86945,86946,86947,86948,86949,86950,86951,86952,87822,89917,89918,89919,86953,86954,86955,86956,86957,86958,86959,86960,86961,86962,89920,89921,89922,90740,86963,86964,86965,86966,86967,86968,86969,86970,86971,86972,86973,89923,89924,89925,86974,86975,86976,86977,86978,86979,86980,89255,89256,89257,86981,86982,86983,86984,86985,86986,86987,89252,89253,89254,86988,86989,86990,86991,89249,89250,89251,89926,89927,89928,86943,86944,86945,86946,86947,86948,86949,86950,86951,86952,87822,89917,89918,89919,86953,86954,86955,86956,86957,86958,86959,86960,86961,86962,89920,89921,89922,90740,86963,86964,86965,86966,86967,86968,86969,86970,86971,86972,86973,89923,89924,89925,86974,86975,86976,86977,86978,86979,86980,89255,89256,89257,86981,86982,86983,86984,86985,86986,86987,89252,89253,89254,86988,86989,86990,86991,89249,89250,89251,89926,89927,89928,86811,86812,86813,86814,86815,86816,86817,86818,86819,86854,87823,89952,89953,89954,86820,86821,86822,86823,86824,86825,86826,86827,86828,86829,89955,89956,89957,90739,86830,86831,86832,86833,86834,86835,86836,86837,86838,86839,86840,89958,89959,89960,86851,86852,86853,86855,86856,86911,86912,89270,89271,89272,86857,86858,86859,86860,86861,86862,86863,89267,89268,89269,86864,86865,86866,86867,89264,89265,89266,89961,89962,89963,86230,86231,86232,86233,86234,86315,86316,86317,86318,86319,86320,86390,89841,89885,90517,90518,90519,90520,90521,90522,90523,90524,90525,90526,90527,90528,90529,90530,86321,86322,86323,86324,86325,86326,86327,86328,86329,86330,86337,86338,86339,86340,86341,86342,86343,86383,86384,86385,89842,89843,89883,89884,86331,86332,86333,86334,86335,86336,86337,86338,86339,86340,86341,86342,86343,86383,86384,86385,86391,89246,89247,89248,86386,86387,86388,86389,89234,89235,89236,89839,89886,89887,86230,86231,86232,86233,86234,86315,86316,86317,86318,86319,86320,86390,89841,89885,90517,90518,90519,90520,90521,90522,90523,90524,90525,90526,90527,90528,90529,90530,86321,86322,86323,86324,86325,86326,86327,86328,86329,86330,86337,86338,86339,86340,86341,86342,86343,86383,86384,86385,89842,89843,89883,89884,86331,86332,86333,86334,86335,86336,86337,86338,86339,86340,86341,86342,86343,86383,86384,86385,86391,89246,89247,89248,86386,86387,86388,86389,89234,89235,89236,89839,89886,89887,87144,87145,87146,87147,87148,87149,87150,87151,87152,87153,87154,87155,89943,89944,90503,90504,90505,90506,90507,90508,90509,90510,90511,90512,90513,90514,90515,90516,87156,87157,87158,87159,87160,87161,87162,87163,87164,87165,87177,87178,87179,87180,87181,87182,87183,87184,87185,87186,89945,89946,89947,89948,87166,87167,87168,87169,87170,87171,87172,87177,87178,87179,87180,87181,87182,87183,87184,87185,87186,89261,89262,89263,87173,87174,87175,87176,89258,89259,89260,89949,89950,89951,87144,87145,87146,87147,87148,87149,87150,87151,87152,87153,87154,87155,89943,89944,90503,90504,90505,90506,90507,90508,90509,90510,90511,90512,90513,90514,90515,90516,87156,87157,87158,87159,87160,87161,87162,87163,87164,87165,87177,87178,87179,87180,87181,87182,87183,87184,87185,87186,89945,89946,89947,89948,87166,87167,87168,87169,87170,87171,87172,87177,87178,87179,87180,87181,87182,87183,87184,87185,87186,89261,89262,89263,87173,87174,87175,87176,89258,89259,89260,89949,89950,89951,86868,86869,86870,86871,86872,86873,86874,86875,86876,86877,86878,86909,89978,89979,86879,86880,86881,86882,86883,86884,86885,86886,86887,86888,86895,86896,86897,86898,86899,86900,86901,86902,86903,86904,89980,89981,89982,89983,86889,86890,86891,86892,86893,86894,86895,86896,86897,86898,86899,86900,86901,86902,86903,86904,86910,89276,89277,89278,86905,86906,86907,86908,89273,89274,89275,89984,89985,89986,94512,94722,94723,94724,94725,94726,94727,94728,94729,94730,94731,94732,94733,94734,94735,94736,94737,94738,94739,95510,93666,94514,94526,94574,94740,94741,94742,94743,94744,94745,94746,94747,94748,94749,94750,94751,94752,94753,94754,94755,94756,94975,95514,94513,94516,94523,94758,94759,94760,94761,94762,94763,94764,94765,94766,94767,95570,95575,95580,94768,94769,94770,94771,94772,94773,94774,94775,94776,94777,94778,94779,94780,94781,94782,94783,94784,94785,94786,94787,94520,94521,94788,94789,94790,94791,94792,94793,94794,94795,94796,94797,94798,94799,94800,94801,94802,94803,94804,94515,94527,94805,94806,94807,94808,94809,94810,94811,94812,94813,94835,95059,95572,95576,95581,94814,94815,94816,94817,94818,94819,94820,94821,94822,94922,94923,94924,94925,94926,94927,94928,94929,94930,94931,95511,94519,94522,94525,94937,94938,94939,94940,94941,94942,94943,94944,94945,94946,94947,94948,94949,94950,94951,94952,94953,95513,97960,94152,94518,94531,94954,94955,94956,94957,94958,94959,94960,94961,94962,95569,95574,95579,94963,94964,94965,94966,94967,94968,94969,94970,94971,94972,95512,95573,95578,95583,94529,94757,94973,94974,94976,94977,94978,94979,94980,94981,95515,95571,95577,95582,94524,94528,94530,94532,94982,94983,94984,94985,94986,94987,94988,94989,94990,94991,94992,94993,94994,95472,95473,95535,94512,94722,94723,94724,94725,94726,94727,94728,94729,94730,94731,94732,94733,94734,94735,94736,94737,94738,94739,95510,93666,94514,94526,94574,94740,94741,94742,94743,94744,94745,94746,94747,94748,94749,94750,94751,94752,94753,94754,94755,94756,94975,95514,94513,94516,94523,94758,94759,94760,94761,94762,94763,94764,94765,94766,94767,95570,95575,95580,94768,94769,94770,94771,94772,94773,94774,94775,94776,94777,94778,94779,94780,94781,94782,94783,94784,94785,94786,94787,94520,94521,94788,94789,94790,94791,94792,94793,94794,94795,94796,94797,94798,94799,94800,94801,94802,94803,94804,94515,94527,94805,94806,94807,94808,94809,94810,94811,94812,94813,94835,95059,95572,95576,95581,94814,94815,94816,94817,94818,94819,94820,94821,94822,94922,94923,94924,94925,94926,94927,94928,94929,94930,94931,95511,94519,94522,94525,94937,94938,94939,94940,94941,94942,94943,94944,94945,94946,94947,94948,94949,94950,94951,94952,94953,95513,97960,94152,94518,94531,94954,94955,94956,94957,94958,94959,94960,94961,94962,95569,95574,95579,94963,94964,94965,94966,94967,94968,94969,94970,94971,94972,95512,95573,95578,95583,94529,94757,94973,94974,94976,94977,94978,94979,94980,94981,95515,95571,95577,95582,94524,94528,94530,94532,94982,94983,94984,94985,94986,94987,94988,94989,94990,94991,94992,94993,94994,95472,95473,95535,96368,96369,96370,96371,96372,96373,96374,96375,96376,96377,96378,96379,96380,96381,96382,96383,96384,96386,96387,96388,93666,94574,96385,96389,96390,96391,96392,96393,96394,96395,96396,96397,96398,96399,96400,96401,96402,96403,96404,96405,96406,96407,96408,96409,96410,96411,96412,96413,96414,96415,96416,96417,96418,96419,96420,96421,96599,96600,96601,96422,96423,96424,96425,96426,96427,96428,96429,96430,96431,96432,96433,96434,96435,96436,96437,96438,96439,96440,96441,96442,96443,96444,96445,96446,96447,96448,96449,96450,96451,96452,96453,96454,96455,96456,96457,96458,96459,96460,94835,95059,96461,96462,96463,96464,96465,96466,96467,96468,96469,96470,96471,96631,96632,96633,96472,96473,96474,96475,96476,96477,96478,96479,96480,96481,96482,96483,96484,96485,96486,96487,96488,96489,96490,96491,96492,96493,96494,96495,96496,96497,96498,96499,96500,96501,96502,96503,96504,96505,96506,96507,96508,96509,96510,96511,96512,97960,94152,96513,96514,96515,96516,96517,96518,96519,96520,96521,96522,96523,96566,96567,96568,96524,96525,96526,96527,96528,96529,96530,96531,96532,96533,96534,96699,96700,96701,96535,96536,96537,96538,96539,96540,96541,96542,96543,96544,96545,96623,96624,96625,96546,96547,96548,96549,96550,96551,96552,96553,96554,96555,96556,96557,96558,96559,96560,96561,96562,96563,96564,96565,94995,94996,94997,94998,94999,95000,95001,95002,95003,95004,95005,95006,95007,95008,95009,95010,95011,95012,95013,95014,95015,95016,95017,95018,95019,95020,95021,95022,95023,95024,95025,95026,95027,95028,95029,95030,95031,95032,95033,95034,95035,95036,95037,95038,95039,95040,96368,96369,96370,96371,96372,96373,96374,96375,96376,96377,96378,96379,96380,96381,96382,96383,96384,96386,96387,96388,93666,94574,96385,96389,96390,96391,96392,96393,96394,96395,96396,96397,96398,96399,96400,96401,96402,96403,96404,96405,96406,96407,96408,96409,96410,96411,96412,96413,96414,96415,96416,96417,96418,96419,96420,96421,96599,96600,96601,96422,96423,96424,96425,96426,96427,96428,96429,96430,96431,96432,96433,96434,96435,96436,96437,96438,96439,96440,96441,96442,96443,96444,96445,96446,96447,96448,96449,96450,96451,96452,96453,96454,96455,96456,96457,96458,96459,96460,94835,95059,96461,96462,96463,96464,96465,96466,96467,96468,96469,96470,96471,96631,96632,96633,96472,96473,96474,96475,96476,96477,96478,96479,96480,96481,96482,96483,96484,96485,96486,96487,96488,96489,96490,96491,96492,96493,96494,96495,96496,96497,96498,96499,96500,96501,96502,96503,96504,96505,96506,96507,96508,96509,96510,96511,96512,97960,94152,96513,96514,96515,96516,96517,96518,96519,96520,96521,96522,96523,96566,96567,96568,96524,96525,96526,96527,96528,96529,96530,96531,96532,96533,96534,96699,96700,96701,96535,96536,96537,96538,96539,96540,96541,96542,96543,96544,96545,96623,96624,96625,96546,96547,96548,96549,96550,96551,96552,96553,96554,96555,96556,96557,96558,96559,96560,96561,96562,96563,96564,96565,94995,94996,94997,94998,94999,95000,95001,95002,95003,95004,95005,95006,95007,95008,95009,95010,95011,95012,95013,95014,95015,95016,95017,95018,95019,95020,95021,95022,95023,95024,95025,95026,95027,95028,95029,95030,95031,95032,95033,95034,95035,95036,95037,95038,95039,95040,95624,95625,95626,95627,95628,95629,95630,95631,95632,95633,95634,95635,95636,95637,95638,95639,95640,95642,95643,95644,94574,95641,95645,95646,95647,95648,95649,95650,95651,95652,95653,95654,95655,95656,95657,95658,95659,95660,95661,95662,95663,95664,95665,95666,95667,95668,95669,95670,95671,95672,95673,95674,95675,95676,95677,95855,95856,95857,95678,95679,95680,95681,95682,95683,95684,95685,95686,95687,95688,95689,95690,95691,95692,95693,95694,95695,95696,95697,95698,95699,95700,95701,95702,95703,95704,95705,95706,95707,95708,95709,95710,95711,95712,95713,95714,95715,95716,94835,95717,95718,95719,95720,95721,95722,95723,95724,95725,95726,95727,95887,95888,95889,95728,95729,95730,95731,95732,95733,95734,95735,95736,95737,95738,95739,95740,95741,95742,95743,95744,95745,95746,95747,95748,95749,95750,95751,95752,95753,95754,95755,95756,95757,95758,95759,95760,95761,95762,95763,95764,95765,95766,95767,95768,97959,94152,95769,95770,95771,95772,95773,95774,95775,95776,95777,95778,95779,95822,95823,95824,95780,95781,95782,95783,95784,95785,95786,95787,95788,95789,95790,95955,95956,95957,95791,95792,95793,95794,95795,95796,95797,95798,95799,95800,95801,95879,95880,95881,95802,95803,95804,95805,95806,95807,95808,95809,95810,95811,95812,95813,95814,95815,95816,95817,95818,95819,95820,95821,110761,110784,110785,112382,112383,112416,112417,112418,112419,112420,112421,112422,112423,112424,112425,112426,112427,112428,112429,112445,112447,112448,112476,112477,112478,112479,112480,112481,112482,112483,112484,112485,112486,112487,112488,112489,112490,112491,112492,112493,112494,112495,112496,112503,112545,112546,112547,112548,112549,112550,112551,112552,112553,112554,112555,112556,112557,112558,112559,112560,112561,112562,112563,112564,112565,104162,104163,112702,112947,112948,112949,112950,112951,112952,112953,112954,112955,99742,99743,99744,112703,112704,112705,112706,112707,112709,112710,112711,112712,112713,112714,112715,112716,112717,112718,112719,112721,112723,112725,112726,112727,112728,112729,112731,112732,112733,112734,112735,112736,112739,112740,112741,112742,112743,112744,112745,112746,112747,112748,112749,112750,112751,112752,112946,112754,112755,112756,112757,112758,112759,112760,112761,112762,112763,112764,112765,112766,112767,112768,112769,112770,112771,112772,112773,112774,112778,112779,112780,112781,112782,112783,112785,112787,112788,112789,112790,99745,99746,99747,112792,112793,112794,112795,112796,112797,112803,112804,112805,112806,112807,112808,112813,112814,112815,112816,112817,112818,112819,112820,112821,112823,112825,112826,112827,112828,112829,112831,112832,112833,112834,112835,112836,112837,112838,112839,112841,112842,112843,112844,112845,112846,112847,112849,112850,112851,112852,112853,112854,112855,112856,112861,112862,112866,99748,99749,99750,104158,112877,112879,112882,112883,112890,112892,112894,112895,112896,112897,112898,99754,99755,99756,104165,112913,112914,112915,112916,112917,112918,112919,112920,112921,112922,112923,99751,99752,99753,105863,105864,105865,112924,112925,112926,112927,112928,112929,112930,112931,112932,112933,112934,112936,112937,112938,112939,112940,112941,112942,112943,112944,112945,110761,110784,110785,112382,112383,112416,112417,112418,112419,112420,112421,112422,112423,112424,112425,112426,112427,112428,112429,112445,112447,112448,112476,112477,112478,112479,112480,112481,112482,112483,112484,112485,112486,112487,112488,112489,112490,112491,112492,112493,112494,112495,112496,112503,112545,112546,112547,112548,112549,112550,112551,112552,112553,112554,112555,112556,112557,112558,112559,112560,112561,112562,112563,112564,112565,104162,112702,112947,112948,112949,112950,112951,112952,112953,112954,112955,99714,99715,99716,112703,112704,112705,112706,112707,112709,112710,112711,112712,112713,112714,112715,112716,112717,112718,112719,112721,112723,112725,112726,112727,112728,112729,112731,112732,112733,112734,112735,112736,112739,112740,112741,112742,112743,112744,112745,112746,112747,112748,112749,112750,112751,112752,112946,112754,112755,112756,112757,112758,112759,112760,112761,112762,112763,112764,112765,112766,112767,112768,112769,112770,112771,112772,112773,112774,112778,112779,112780,112781,112782,112783,112785,112787,112788,112789,112790,99720,99721,99722,112792,112793,112794,112795,112796,112797,112803,112804,112805,112806,112807,112808,112813,112814,112815,112816,112817,112818,112819,112820,112821,112823,112825,112826,112827,112828,112829,112831,112832,112833,112834,112835,112836,112837,112838,112839,112841,112842,112843,112844,112845,112846,112847,112849,112850,112851,112852,112853,112854,112855,112856,112861,112862,112866,99723,99724,99725,104158,112877,112879,112882,112883,112890,112892,112894,112895,112896,112897,112898,99717,99718,99719,104165,112913,112914,112915,112916,112917,112918,112919,112920,112921,112922,112923,99712,99713,99726,104253,105866,105867,105868,112924,112925,112926,112927,112928,112929,112930,112931,112932,112933,112934,112935,112936,112937,112938,112939,112940,112941,112942,112943,112944,112945,110761,110784,110785,112382,112383,112416,112417,112418,112419,112420,112421,112422,112423,112424,112425,112426,112427,112428,112429,112445,112447,112448,112476,112477,112478,112479,112480,112481,112482,112483,112484,112485,112486,112487,112488,112489,112490,112491,112492,112493,112494,112495,112496,112503,112545,112546,112547,112548,112549,112550,112551,112552,112553,112554,112555,112556,112557,112558,112559,112560,112561,112562,112563,112564,112565,104162,104163,112702,112947,112948,112949,112950,112951,112952,112953,112954,112955,99677,99678,99679,112703,112704,112705,112706,112707,112709,112710,112711,112712,112713,112714,112715,112716,112717,112718,112719,112721,112723,112725,112726,112727,112728,112729,112731,112732,112733,112734,112735,112736,112739,112740,112741,112742,112743,112744,112745,112746,112747,112748,112749,112750,112751,112752,112946,112754,112755,112756,112757,112758,112759,112760,112761,112762,112763,112764,112765,112766,112767,112768,112769,112770,112771,112772,112773,112774,112778,112779,112780,112781,112782,112783,112785,112787,112788,112789,112790,99667,99680,99681,112792,112793,112794,112795,112796,112797,112803,112804,112805,112806,112807,112808,112813,112814,112815,112816,112817,112818,112819,112820,112821,112823,112825,112826,112827,112828,112829,112831,112832,112833,112834,112835,112836,112837,112838,112839,112841,112842,112843,112844,112845,112846,112847,112849,112850,112851,112852,112853,112854,112855,112856,112861,112862,112866,99671,99672,99673,104158,112877,112879,112882,112883,112890,112892,112894,112895,112896,112897,112898,99668,99669,99670,104165,112913,112914,112915,112916,112917,112918,112919,112920,112921,112922,112923,99674,99675,99676,105860,105861,105862,112924,112925,112926,112927,112928,112929,112930,112931,112932,112933,112934,112936,112937,112938,112939,112940,112941,112942,112943,112944,112945,110761,110784,110785,112382,112383,112416,112417,112418,112419,112420,112421,112422,112423,112424,112425,112426,112427,112428,112429,112445,112447,112448,112476,112477,112478,112479,112480,112481,112482,112483,112484,112485,112486,112487,112488,112489,112490,112491,112492,112493,112494,112495,112496,112503,112545,112546,112547,112548,112549,112550,112551,112552,112553,112554,112555,112556,112557,112558,112559,112560,112561,112562,112563,112564,112565,104162,112702,112947,112948,112949,112950,112951,112952,112953,112954,112955,99686,99691,99696,112703,112704,112705,112706,112707,112709,112710,112711,112712,112713,112714,112715,112716,112717,112718,112719,112721,112723,112725,112726,112727,112728,112729,112731,112732,112733,112734,112735,112736,112739,112740,112741,112742,112743,112744,112745,112746,112747,112748,112749,112750,112751,112752,112946,112754,112755,112756,112757,112758,112759,112760,112761,112762,112763,112764,112765,112766,112767,112768,112769,112770,112771,112772,112773,112774,112778,112779,112780,112781,112782,112783,112785,112787,112788,112789,112790,99682,99687,99692,112792,112793,112794,112795,112796,112797,112803,112804,112805,112806,112807,112808,112813,112814,112815,112816,112817,112818,112819,112820,112821,112823,112825,112826,112827,112828,112829,112831,112832,112833,112834,112835,112836,112837,112838,112839,112841,112842,112843,112844,112845,112846,112847,112849,112850,112851,112852,112853,112854,112855,112856,112861,112862,112866,99683,99689,99694,104158,112877,112879,112882,112883,112890,112892,112894,112895,112896,112897,112898,99685,99690,99695,104165,112913,112914,112915,112916,112917,112918,112919,112920,112921,112922,112923,99684,99688,99693,105857,105858,105859,112924,112925,112926,112927,112928,112929,112930,112931,112932,112933,112934,112935,112936,112937,112938,112939,112940,112941,112942,112943,112944,112945,109759,109760,109761,109762,109763,109764,109765,109766,109767,109768,109769,109770,109771,109772,109773,109774,109775,109776,109777,109778,109779,109780,109781,109782,109783,109824,109825,109826,109827,109828,109829,109830,109831,109832,109833,109834,109835,109836,109837,109838,109839,109840,109841,109842,109843,110045,109884,109885,109886,109887,109888,109889,109890,109891,109892,109893,109894,109895,109896,109897,109898,109899,109900,109901,109902,109903,109950,109951,109952,109953,109954,109955,109956,109957,109958,109959,109960,109961,109962,109963,109964,109965,109966,109967,109968,109969,110046,110047,109844,109845,109846,109847,109848,109849,109850,109851,109852,109853,109854,109855,109856,109857,109858,109859,109860,109861,109862,109863,109864,109865,109866,109867,109868,109869,109870,109871,109872,109873,109874,109875,109876,109877,109878,109879,109880,109881,109882,109883,109995,110048,109784,109785,109786,109787,109788,109789,109790,109791,109792,109793,109794,109795,109796,109797,109798,109799,109800,109801,109802,109803,109804,109805,109806,109807,109808,109809,109810,109811,109812,109813,109814,109815,109816,109817,109818,109819,109820,109821,109822,109823,109904,109905,109906,109907,109908,109909,109910,109911,109912,109913,109914,109915,109916,109917,109918,109925,109926,109927,109928,109929,110005,110010,110049,110050,109759,109760,109761,109762,109763,109764,109765,109766,109767,109768,109769,109770,109771,109772,109773,109774,109775,109776,109777,109778,109779,109780,109781,109782,109783,109824,109825,109826,109827,109828,109829,109830,109831,109832,109833,109834,109835,109836,109837,109838,109839,109840,109841,109842,109843,110045,109884,109885,109886,109887,109888,109889,109890,109891,109892,109893,109894,109895,109896,109897,109898,109899,109900,109901,109902,109903,109950,109951,109952,109953,109954,109955,109956,109957,109958,109959,109960,109961,109962,109963,109964,109965,109966,109967,109968,109969,110046,110047,109844,109845,109846,109847,109848,109849,109850,109851,109852,109853,109854,109855,109856,109857,109858,109859,109860,109861,109862,109863,109864,109865,109866,109867,109868,109869,109870,109871,109872,109873,109874,109875,109876,109877,109878,109879,109880,109881,109882,109883,109995,110048,109784,109785,109786,109787,109788,109789,109790,109791,109792,109793,109794,109795,109796,109797,109798,109799,109800,109801,109802,109803,109804,109805,109806,109807,109808,109809,109810,109811,109812,109813,109814,109815,109816,109817,109818,109819,109820,109821,109822,109823,109904,109905,109906,109907,109908,109909,109910,109911,109912,109913,109914,109915,109916,109917,109918,109925,109926,109927,109928,109929,110005,110010,110049,110050,109759,109760,109761,109762,109763,109764,109765,109766,109767,109768,109769,109770,109771,109772,109773,109774,109775,109776,109777,109778,109779,109780,109781,109782,109783,109824,109825,109826,109827,109828,109829,109830,109831,109832,109833,109834,109835,109836,109837,109838,109839,109840,109841,109842,109843,110045,109884,109885,109886,109887,109888,109889,109890,109891,109892,109893,109894,109895,109896,109897,109898,109899,109900,109901,109902,109903,109950,109951,109952,109953,109954,109955,109956,109957,109958,109959,109960,109961,109962,109963,109964,109965,109966,109967,109968,109969,110046,110047,109844,109845,109846,109847,109848,109849,109850,109851,109852,109853,109854,109855,109856,109857,109858,109859,109860,109861,109862,109863,109864,109865,109866,109867,109868,109869,109870,109871,109872,109873,109874,109875,109876,109877,109878,109879,109880,109881,109882,109883,109995,110048,109784,109785,109786,109787,109788,109789,109790,109791,109792,109793,109794,109795,109796,109797,109798,109799,109800,109801,109802,109803,109804,109805,109806,109807,109808,109809,109810,109811,109812,109813,109814,109815,109816,109817,109818,109819,109820,109821,109822,109823,109904,109905,109906,109907,109908,109909,109910,109911,109912,109913,109914,109915,109916,109917,109918,109925,109926,109927,109928,109929,110005,110010,110049,110050,109844,109845,109846,109847,109848,109849,109850,109851,109852,109853,109854,109855,109856,109857,109858,109859,109860,109861,109862,109863,109884,109885,109886,109887,109888,109889,109890,109891,109892,109893,109894,109895,109896,109897,109898,109899,109900,109901,109902,109903,109804,109805,109806,109807,109808,109809,109810,109811,109812,109813,109814,109815,109816,109817,109818,109819,109820,109821,109822,109823,109864,109865,109866,109867,109868,109869,109870,109871,109872,109873,109874,109875,109876,109877,109878,109879,109880,109881,109882,109883,109939,110000,110040,109784,109785,109786,109787,109788,109789,109790,109791,109792,109793,109794,109795,109796,109797,109798,109799,109800,109801,109802,109803,109904,109905,109906,109907,109908,109909,109910,109911,109912,109913,109914,109915,109916,109917,109918,109925,109926,109927,109928,109929,110015,110041,109759,109760,109761,109762,109763,109764,109765,109766,109767,109768,109769,109770,109771,109772,109773,109774,109775,109776,109777,109778,109779,109780,109781,109782,109783,109930,109931,109932,109933,109934,109935,109936,109937,109938,109939,109940,109941,109942,109943,109944,109945,109946,109947,109948,109949,109970,109971,109972,109973,109974,109975,109976,109977,109978,109979,109980,109981,109982,109983,109984,109985,109986,109987,109988,109989,110042,110043,110044,109844,109845,109846,109847,109848,109849,109850,109851,109852,109853,109854,109855,109856,109857,109858,109859,109860,109861,109862,109863,109884,109885,109886,109887,109888,109889,109890,109891,109892,109893,109894,109895,109896,109897,109898,109899,109900,109901,109902,109903,109804,109805,109806,109807,109808,109809,109810,109811,109812,109813,109814,109815,109816,109817,109818,109819,109820,109821,109822,109823,109864,109865,109866,109867,109868,109869,109870,109871,109872,109873,109874,109875,109876,109877,109878,109879,109880,109881,109882,109883,109939,110000,110040,109784,109785,109786,109787,109788,109789,109790,109791,109792,109793,109794,109795,109796,109797,109798,109799,109800,109801,109802,109803,109904,109905,109906,109907,109908,109909,109910,109911,109912,109913,109914,109915,109916,109917,109918,109925,109926,109927,109928,109929,110015,110041,109759,109760,109761,109762,109763,109764,109765,109766,109767,109768,109769,109770,109771,109772,109773,109774,109775,109776,109777,109778,109779,109780,109781,109782,109783,109930,109931,109932,109933,109934,109935,109936,109937,109938,109939,109940,109941,109942,109943,109944,109945,109946,109947,109948,109949,109970,109971,109972,109973,109974,109975,109976,109977,109978,109979,109980,109981,109982,109983,109984,109985,109986,109987,109988,109989,110042,110043,110044,109844,109845,109846,109847,109848,109849,109850,109851,109852,109853,109854,109855,109856,109857,109858,109859,109860,109861,109862,109863,109884,109885,109886,109887,109888,109889,109890,109891,109892,109893,109894,109895,109896,109897,109898,109899,109900,109901,109902,109903,109804,109805,109806,109807,109808,109809,109810,109811,109812,109813,109814,109815,109816,109817,109818,109819,109820,109821,109822,109823,109864,109865,109866,109867,109868,109869,109870,109871,109872,109873,109874,109875,109876,109877,109878,109879,109880,109881,109882,109883,109939,110000,110040,109784,109785,109786,109787,109788,109789,109790,109791,109792,109793,109794,109795,109796,109797,109798,109799,109800,109801,109802,109803,109904,109905,109906,109907,109908,109909,109910,109911,109912,109913,109914,109915,109916,109917,109918,109925,109926,109927,109928,109929,110015,110041,109759,109760,109761,109762,109763,109764,109765,109766,109767,109768,109769,109770,109771,109772,109773,109774,109775,109776,109777,109778,109779,109780,109781,109782,109783,109930,109931,109932,109933,109934,109935,109936,109937,109938,109939,109940,109941,109942,109943,109944,109945,109946,109947,109948,109949,109970,109971,109972,109973,109974,109975,109976,109977,109978,109979,109980,109981,109982,109983,109984,109985,109986,109987,109988,109989,110042,110043,110044,109759,109760,109761,109762,109763,109764,109765,109766,109767,109768,109769,109770,109771,109772,109773,109774,109775,109776,109777,109778,109779,109780,109781,109782,109783,109824,109825,109826,109827,109828,109829,109830,109831,109832,109833,109834,109835,109836,109837,109838,109839,109840,109841,109842,109843,110051,109884,109885,109886,109887,109888,109889,109890,109891,109892,109893,109894,109895,109896,109897,109898,109899,109900,109901,109902,109903,109950,109951,109952,109953,109954,109955,109956,109957,109958,109959,109960,109961,109962,109963,109964,109965,109966,109967,109968,109969,109996,110052,109804,109805,109806,109807,109808,109809,109810,109811,109812,109813,109814,109815,109816,109817,109818,109819,109820,109821,109822,109823,109844,109845,109846,109847,109848,109849,109850,109851,109852,109853,109854,109855,109856,109857,109858,109859,109860,109861,109862,109863,109864,109865,109866,109867,109868,109869,109870,109871,109872,109873,109874,109875,109876,109877,109878,109879,109880,109881,109882,109883,110001,110053,110054,109759,109760,109761,109762,109763,109764,109765,109766,109767,109768,109769,109770,109771,109772,109773,109774,109775,109776,109777,109778,109779,109780,109781,109782,109783,109824,109825,109826,109827,109828,109829,109830,109831,109832,109833,109834,109835,109836,109837,109838,109839,109840,109841,109842,109843,110051,109884,109885,109886,109887,109888,109889,109890,109891,109892,109893,109894,109895,109896,109897,109898,109899,109900,109901,109902,109903,109950,109951,109952,109953,109954,109955,109956,109957,109958,109959,109960,109961,109962,109963,109964,109965,109966,109967,109968,109969,109996,110052,109804,109805,109806,109807,109808,109809,109810,109811,109812,109813,109814,109815,109816,109817,109818,109819,109820,109821,109822,109823,109844,109845,109846,109847,109848,109849,109850,109851,109852,109853,109854,109855,109856,109857,109858,109859,109860,109861,109862,109863,109864,109865,109866,109867,109868,109869,109870,109871,109872,109873,109874,109875,109876,109877,109878,109879,109880,109881,109882,109883,110001,110053,110054,109759,109760,109761,109762,109763,109764,109765,109766,109767,109768,109769,109770,109771,109772,109773,109774,109775,109776,109777,109778,109779,109780,109781,109782,109783,109824,109825,109826,109827,109828,109829,109830,109831,109832,109833,109834,109835,109836,109837,109838,109839,109840,109841,109842,109843,110051,109884,109885,109886,109887,109888,109889,109890,109891,109892,109893,109894,109895,109896,109897,109898,109899,109900,109901,109902,109903,109950,109951,109952,109953,109954,109955,109956,109957,109958,109959,109960,109961,109962,109963,109964,109965,109966,109967,109968,109969,109996,110052,109804,109805,109806,109807,109808,109809,109810,109811,109812,109813,109814,109815,109816,109817,109818,109819,109820,109821,109822,109823,109844,109845,109846,109847,109848,109849,109850,109851,109852,109853,109854,109855,109856,109857,109858,109859,109860,109861,109862,109863,109864,109865,109866,109867,109868,109869,109870,109871,109872,109873,109874,109875,109876,109877,109878,109879,109880,109881,109882,109883,110001,110053,110054,109950,109951,109952,109953,109954,109955,109956,109957,109958,109959,109960,109961,109962,109963,109964,109965,109966,109967,109968,109969,109970,109971,109972,109973,109974,109975,109976,109977,109978,109979,109980,109981,109982,109983,109984,109985,109986,109987,109988,109989,110017,110056,109824,109825,109826,109827,109828,109829,109830,109831,109832,109833,109834,109835,109836,109837,109838,109839,109840,109841,109842,109843,109864,109865,109866,109867,109868,109869,109870,109871,109872,109873,109874,109875,109876,109877,109878,109879,109880,109881,109882,109883,109997,110057,109804,109805,109806,109807,109808,109809,109810,109811,109812,109813,109814,109815,109816,109817,109818,109819,109820,109821,109822,109823,109844,109845,109846,109847,109848,109849,109850,109851,109852,109853,109854,109855,109856,109857,109858,109859,109860,109861,109862,109863,109930,109931,109932,109933,109934,109935,109936,109937,109938,109939,109940,109941,109942,109943,109944,109945,109946,109947,109948,109949,110058,110059,110060,109759,109760,109761,109762,109763,109764,109765,109766,109767,109768,109769,109770,109771,109772,109773,109774,109775,109776,109777,109778,109779,109780,109781,109782,109783,109884,109885,109886,109887,109888,109889,109890,109891,109892,109893,109894,109895,109896,109897,109898,109899,109900,109901,109902,109903,110002,110055,109950,109951,109952,109953,109954,109955,109956,109957,109958,109959,109960,109961,109962,109963,109964,109965,109966,109967,109968,109969,109970,109971,109972,109973,109974,109975,109976,109977,109978,109979,109980,109981,109982,109983,109984,109985,109986,109987,109988,109989,110017,110056,109824,109825,109826,109827,109828,109829,109830,109831,109832,109833,109834,109835,109836,109837,109838,109839,109840,109841,109842,109843,109864,109865,109866,109867,109868,109869,109870,109871,109872,109873,109874,109875,109876,109877,109878,109879,109880,109881,109882,109883,109997,110057,109804,109805,109806,109807,109808,109809,109810,109811,109812,109813,109814,109815,109816,109817,109818,109819,109820,109821,109822,109823,109844,109845,109846,109847,109848,109849,109850,109851,109852,109853,109854,109855,109856,109857,109858,109859,109860,109861,109862,109863,109930,109931,109932,109933,109934,109935,109936,109937,109938,109939,109940,109941,109942,109943,109944,109945,109946,109947,109948,109949,110058,110059,110060,109759,109760,109761,109762,109763,109764,109765,109766,109767,109768,109769,109770,109771,109772,109773,109774,109775,109776,109777,109778,109779,109780,109781,109782,109783,109884,109885,109886,109887,109888,109889,109890,109891,109892,109893,109894,109895,109896,109897,109898,109899,109900,109901,109902,109903,110002,110055,109950,109951,109952,109953,109954,109955,109956,109957,109958,109959,109960,109961,109962,109963,109964,109965,109966,109967,109968,109969,109970,109971,109972,109973,109974,109975,109976,109977,109978,109979,109980,109981,109982,109983,109984,109985,109986,109987,109988,109989,110017,110056,109824,109825,109826,109827,109828,109829,109830,109831,109832,109833,109834,109835,109836,109837,109838,109839,109840,109841,109842,109843,109864,109865,109866,109867,109868,109869,109870,109871,109872,109873,109874,109875,109876,109877,109878,109879,109880,109881,109882,109883,109997,110057,109804,109805,109806,109807,109808,109809,109810,109811,109812,109813,109814,109815,109816,109817,109818,109819,109820,109821,109822,109823,109844,109845,109846,109847,109848,109849,109850,109851,109852,109853,109854,109855,109856,109857,109858,109859,109860,109861,109862,109863,109930,109931,109932,109933,109934,109935,109936,109937,109938,109939,109940,109941,109942,109943,109944,109945,109946,109947,109948,109949,110058,110059,110060,109759,109760,109761,109762,109763,109764,109765,109766,109767,109768,109769,109770,109771,109772,109773,109774,109775,109776,109777,109778,109779,109780,109781,109782,109783,109884,109885,109886,109887,109888,109889,109890,109891,109892,109893,109894,109895,109896,109897,109898,109899,109900,109901,109902,109903,110002,110055,109864,109865,109866,109867,109868,109869,109870,109871,109872,109873,109874,109875,109876,109877,109878,109879,109880,109881,109882,109883,109884,109885,109886,109887,109888,109889,109890,109891,109892,109893,109894,109895,109896,109897,109898,109899,109900,109901,109902,109903,110007,110036,109759,109760,109761,109762,109763,109764,109765,109766,109767,109768,109769,109770,109771,109772,109773,109774,109775,109776,109777,109778,109779,109780,109781,109782,109783,109784,109785,109786,109787,109788,109789,109790,109791,109792,109793,109794,109795,109796,109797,109798,109799,109800,109801,109802,109803,109970,109971,109972,109973,109974,109975,109976,109977,109978,109979,109980,109981,109982,109983,109984,109985,109986,109987,109988,109989,110038,110039,109904,109905,109906,109907,109908,109909,109910,109911,109912,109913,109914,109915,109916,109917,109918,109925,109926,109927,109928,109929,109950,109951,109952,109953,109954,109955,109956,109957,109958,109959,109960,109961,109962,109963,109964,109965,109966,109967,109968,109969,110035,109824,109825,109826,109827,109828,109829,109830,109831,109832,109833,109834,109835,109836,109837,109838,109839,109840,109841,109842,109843,109844,109845,109846,109847,109848,109849,109850,109851,109852,109853,109854,109855,109856,109857,109858,109859,109860,109861,109862,109863,110012,110037,109864,109865,109866,109867,109868,109869,109870,109871,109872,109873,109874,109875,109876,109877,109878,109879,109880,109881,109882,109883,109884,109885,109886,109887,109888,109889,109890,109891,109892,109893,109894,109895,109896,109897,109898,109899,109900,109901,109902,109903,110007,110036,109759,109760,109761,109762,109763,109764,109765,109766,109767,109768,109769,109770,109771,109772,109773,109774,109775,109776,109777,109778,109779,109780,109781,109782,109783,109784,109785,109786,109787,109788,109789,109790,109791,109792,109793,109794,109795,109796,109797,109798,109799,109800,109801,109802,109803,109970,109971,109972,109973,109974,109975,109976,109977,109978,109979,109980,109981,109982,109983,109984,109985,109986,109987,109988,109989,110038,110039,109904,109905,109906,109907,109908,109909,109910,109911,109912,109913,109914,109915,109916,109917,109918,109925,109926,109927,109928,109929,109950,109951,109952,109953,109954,109955,109956,109957,109958,109959,109960,109961,109962,109963,109964,109965,109966,109967,109968,109969,110035,109824,109825,109826,109827,109828,109829,109830,109831,109832,109833,109834,109835,109836,109837,109838,109839,109840,109841,109842,109843,109844,109845,109846,109847,109848,109849,109850,109851,109852,109853,109854,109855,109856,109857,109858,109859,109860,109861,109862,109863,110012,110037,109864,109865,109866,109867,109868,109869,109870,109871,109872,109873,109874,109875,109876,109877,109878,109879,109880,109881,109882,109883,109884,109885,109886,109887,109888,109889,109890,109891,109892,109893,109894,109895,109896,109897,109898,109899,109900,109901,109902,109903,110007,110036,109759,109760,109761,109762,109763,109764,109765,109766,109767,109768,109769,109770,109771,109772,109773,109774,109775,109776,109777,109778,109779,109780,109781,109782,109783,109784,109785,109786,109787,109788,109789,109790,109791,109792,109793,109794,109795,109796,109797,109798,109799,109800,109801,109802,109803,109970,109971,109972,109973,109974,109975,109976,109977,109978,109979,109980,109981,109982,109983,109984,109985,109986,109987,109988,109989,110038,110039,109904,109905,109906,109907,109908,109909,109910,109911,109912,109913,109914,109915,109916,109917,109918,109925,109926,109927,109928,109929,109950,109951,109952,109953,109954,109955,109956,109957,109958,109959,109960,109961,109962,109963,109964,109965,109966,109967,109968,109969,110035,109824,109825,109826,109827,109828,109829,109830,109831,109832,109833,109834,109835,109836,109837,109838,109839,109840,109841,109842,109843,109844,109845,109846,109847,109848,109849,109850,109851,109852,109853,109854,109855,109856,109857,109858,109859,109860,109861,109862,109863,110012,110037,109759,109760,109761,109762,109763,109764,109765,109766,109767,109768,109769,109770,109771,109772,109773,109774,109775,109776,109777,109778,109779,109780,109781,109782,109783,109804,109805,109806,109807,109808,109809,109810,109811,109812,109813,109814,109815,109816,109817,109818,109819,109820,109821,109822,109823,109930,109931,109932,109933,109934,109935,109936,109937,109938,109939,109940,109941,109942,109943,109944,109945,109946,109947,109948,109949,110011,110033,110034,109844,109845,109846,109847,109848,109849,109850,109851,109852,109853,109854,109855,109856,109857,109858,109859,109860,109861,109862,109863,109864,109865,109866,109867,109868,109869,109870,109871,109872,109873,109874,109875,109876,109877,109878,109879,109880,109881,109882,109883,110006,110032,109824,109825,109826,109827,109828,109829,109830,109831,109832,109833,109834,109835,109836,109837,109838,109839,109840,109841,109842,109843,109970,109971,109972,109973,109974,109975,109976,109977,109978,109979,109980,109981,109982,109983,109984,109985,109986,109987,109988,109989,110030,109784,109785,109786,109787,109788,109789,109790,109791,109792,109793,109794,109795,109796,109797,109798,109799,109800,109801,109802,109803,109950,109951,109952,109953,109954,109955,109956,109957,109958,109959,109960,109961,109962,109963,109964,109965,109966,109967,109968,109969,110016,110031,109759,109760,109761,109762,109763,109764,109765,109766,109767,109768,109769,109770,109771,109772,109773,109774,109775,109776,109777,109778,109779,109780,109781,109782,109783,109804,109805,109806,109807,109808,109809,109810,109811,109812,109813,109814,109815,109816,109817,109818,109819,109820,109821,109822,109823,109930,109931,109932,109933,109934,109935,109936,109937,109938,109939,109940,109941,109942,109943,109944,109945,109946,109947,109948,109949,110011,110033,110034,109844,109845,109846,109847,109848,109849,109850,109851,109852,109853,109854,109855,109856,109857,109858,109859,109860,109861,109862,109863,109864,109865,109866,109867,109868,109869,109870,109871,109872,109873,109874,109875,109876,109877,109878,109879,109880,109881,109882,109883,110006,110032,109824,109825,109826,109827,109828,109829,109830,109831,109832,109833,109834,109835,109836,109837,109838,109839,109840,109841,109842,109843,109970,109971,109972,109973,109974,109975,109976,109977,109978,109979,109980,109981,109982,109983,109984,109985,109986,109987,109988,109989,110030,109784,109785,109786,109787,109788,109789,109790,109791,109792,109793,109794,109795,109796,109797,109798,109799,109800,109801,109802,109803,109950,109951,109952,109953,109954,109955,109956,109957,109958,109959,109960,109961,109962,109963,109964,109965,109966,109967,109968,109969,110016,110031,109759,109760,109761,109762,109763,109764,109765,109766,109767,109768,109769,109770,109771,109772,109773,109774,109775,109776,109777,109778,109779,109780,109781,109782,109783,109804,109805,109806,109807,109808,109809,109810,109811,109812,109813,109814,109815,109816,109817,109818,109819,109820,109821,109822,109823,109930,109931,109932,109933,109934,109935,109936,109937,109938,109939,109940,109941,109942,109943,109944,109945,109946,109947,109948,109949,110011,110033,110034,109844,109845,109846,109847,109848,109849,109850,109851,109852,109853,109854,109855,109856,109857,109858,109859,109860,109861,109862,109863,109864,109865,109866,109867,109868,109869,109870,109871,109872,109873,109874,109875,109876,109877,109878,109879,109880,109881,109882,109883,110006,110032,109824,109825,109826,109827,109828,109829,109830,109831,109832,109833,109834,109835,109836,109837,109838,109839,109840,109841,109842,109843,109970,109971,109972,109973,109974,109975,109976,109977,109978,109979,109980,109981,109982,109983,109984,109985,109986,109987,109988,109989,110030,109784,109785,109786,109787,109788,109789,109790,109791,109792,109793,109794,109795,109796,109797,109798,109799,109800,109801,109802,109803,109950,109951,109952,109953,109954,109955,109956,109957,109958,109959,109960,109961,109962,109963,109964,109965,109966,109967,109968,109969,110016,110031,109804,109805,109806,109807,109808,109809,109810,109811,109812,109813,109814,109815,109816,109817,109818,109819,109820,109821,109822,109823,109824,109825,109826,109827,109828,109829,109830,109831,109832,109833,109834,109835,109836,109837,109838,109839,109840,109841,109842,109843,110009,119176,109844,109845,109846,109847,109848,109849,109850,109851,109852,109853,109854,109855,109856,109857,109858,109859,109860,109861,109862,109863,109904,109905,109906,109907,109908,109909,109910,109911,109912,109913,109914,109915,109916,109917,109918,109925,109926,109927,109928,109929,109999,119175,109864,109865,109866,109867,109868,109869,109870,109871,109872,109873,109874,109875,109876,109877,109878,109879,109880,109881,109882,109883,109970,109971,109972,109973,109974,109975,109976,109977,109978,109979,109980,109981,109982,109983,109984,109985,109986,109987,109988,109989,110014,119174,109784,109785,109786,109787,109788,109789,109790,109791,109792,109793,109794,109795,109796,109797,109798,109799,109800,109801,109802,109803,109884,109885,109886,109887,109888,109889,109890,109891,109892,109893,109894,109895,109896,109897,109898,109899,109900,109901,109902,109903,110019,119173,109759,109760,109761,109762,109763,109764,109765,109766,109767,109768,109769,109770,109771,109772,109773,109774,109775,109776,109777,109778,109779,109780,109781,109782,109783,109930,109931,109932,109933,109934,109935,109936,109937,109938,109939,109940,109941,109942,109943,109944,109945,109946,109947,109948,109949,109950,109951,109952,109953,109954,109955,109956,109957,109958,109959,109960,109961,109962,109963,109964,109965,109966,109967,109968,109969,110004,119181,109804,109805,109806,109807,109808,109809,109810,109811,109812,109813,109814,109815,109816,109817,109818,109819,109820,109821,109822,109823,109824,109825,109826,109827,109828,109829,109830,109831,109832,109833,109834,109835,109836,109837,109838,109839,109840,109841,109842,109843,110009,119176,109844,109845,109846,109847,109848,109849,109850,109851,109852,109853,109854,109855,109856,109857,109858,109859,109860,109861,109862,109863,109904,109905,109906,109907,109908,109909,109910,109911,109912,109913,109914,109915,109916,109917,109918,109925,109926,109927,109928,109929,109999,119175,109864,109865,109866,109867,109868,109869,109870,109871,109872,109873,109874,109875,109876,109877,109878,109879,109880,109881,109882,109883,109970,109971,109972,109973,109974,109975,109976,109977,109978,109979,109980,109981,109982,109983,109984,109985,109986,109987,109988,109989,110014,119174,109784,109785,109786,109787,109788,109789,109790,109791,109792,109793,109794,109795,109796,109797,109798,109799,109800,109801,109802,109803,109884,109885,109886,109887,109888,109889,109890,109891,109892,109893,109894,109895,109896,109897,109898,109899,109900,109901,109902,109903,110019,119173,109759,109760,109761,109762,109763,109764,109765,109766,109767,109768,109769,109770,109771,109772,109773,109774,109775,109776,109777,109778,109779,109780,109781,109782,109783,109930,109931,109932,109933,109934,109935,109936,109937,109938,109939,109940,109941,109942,109943,109944,109945,109946,109947,109948,109949,109950,109951,109952,109953,109954,109955,109956,109957,109958,109959,109960,109961,109962,109963,109964,109965,109966,109967,109968,109969,110004,119181,109804,109805,109806,109807,109808,109809,109810,109811,109812,109813,109814,109815,109816,109817,109818,109819,109820,109821,109822,109823,109824,109825,109826,109827,109828,109829,109830,109831,109832,109833,109834,109835,109836,109837,109838,109839,109840,109841,109842,109843,110009,119176,109844,109845,109846,109847,109848,109849,109850,109851,109852,109853,109854,109855,109856,109857,109858,109859,109860,109861,109862,109863,109904,109905,109906,109907,109908,109909,109910,109911,109912,109913,109914,109915,109916,109917,109918,109925,109926,109927,109928,109929,109999,119175,109864,109865,109866,109867,109868,109869,109870,109871,109872,109873,109874,109875,109876,109877,109878,109879,109880,109881,109882,109883,109970,109971,109972,109973,109974,109975,109976,109977,109978,109979,109980,109981,109982,109983,109984,109985,109986,109987,109988,109989,110014,119174,109784,109785,109786,109787,109788,109789,109790,109791,109792,109793,109794,109795,109796,109797,109798,109799,109800,109801,109802,109803,109884,109885,109886,109887,109888,109889,109890,109891,109892,109893,109894,109895,109896,109897,109898,109899,109900,109901,109902,109903,110019,119173,109759,109760,109761,109762,109763,109764,109765,109766,109767,109768,109769,109770,109771,109772,109773,109774,109775,109776,109777,109778,109779,109780,109781,109782,109783,109930,109931,109932,109933,109934,109935,109936,109937,109938,109939,109940,109941,109942,109943,109944,109945,109946,109947,109948,109949,109950,109951,109952,109953,109954,109955,109956,109957,109958,109959,109960,109961,109962,109963,109964,109965,109966,109967,109968,109969,110004,119181,109804,109805,109806,109807,109808,109809,109810,109811,109812,109813,109814,109815,109816,109817,109818,109819,109820,109821,109822,109823,109950,109951,109952,109953,109954,109955,109956,109957,109958,109959,109960,109961,109962,109963,109964,109965,109966,109967,109968,109969,110003,118737,109824,109825,109826,109827,109828,109829,109830,109831,109832,109833,109834,109835,109836,109837,109838,109839,109840,109841,109842,109843,109864,109865,109866,109867,109868,109869,109870,109871,109872,109873,109874,109875,109876,109877,109878,109879,109880,109881,109882,109883,109970,109971,109972,109973,109974,109975,109976,109977,109978,109979,109980,109981,109982,109983,109984,109985,109986,109987,109988,109989,110013,118738,118739,118740,109784,109785,109786,109787,109788,109789,109790,109791,109792,109793,109794,109795,109796,109797,109798,109799,109800,109801,109802,109803,109904,109905,109906,109907,109908,109909,109910,109911,109912,109913,109914,109915,109916,109917,109918,109925,109926,109927,109928,109929,109998,118719,109759,109760,109761,109762,109763,109764,109765,109766,109767,109768,109769,109770,109771,109772,109773,109774,109775,109776,109777,109778,109779,109780,109781,109782,109783,109930,109931,109932,109933,109934,109935,109936,109937,109938,109939,109940,109941,109942,109943,109944,109945,109946,109947,109948,109949,110018,118724,109844,109845,109846,109847,109848,109849,109850,109851,109852,109853,109854,109855,109856,109857,109858,109859,109860,109861,109862,109863,109884,109885,109886,109887,109888,109889,109890,109891,109892,109893,109894,109895,109896,109897,109898,109899,109900,109901,109902,109903,110008,118725,118726,109804,109805,109806,109807,109808,109809,109810,109811,109812,109813,109814,109815,109816,109817,109818,109819,109820,109821,109822,109823,109950,109951,109952,109953,109954,109955,109956,109957,109958,109959,109960,109961,109962,109963,109964,109965,109966,109967,109968,109969,110003,118737,109824,109825,109826,109827,109828,109829,109830,109831,109832,109833,109834,109835,109836,109837,109838,109839,109840,109841,109842,109843,109864,109865,109866,109867,109868,109869,109870,109871,109872,109873,109874,109875,109876,109877,109878,109879,109880,109881,109882,109883,109970,109971,109972,109973,109974,109975,109976,109977,109978,109979,109980,109981,109982,109983,109984,109985,109986,109987,109988,109989,110013,118738,118739,118740,109784,109785,109786,109787,109788,109789,109790,109791,109792,109793,109794,109795,109796,109797,109798,109799,109800,109801,109802,109803,109904,109905,109906,109907,109908,109909,109910,109911,109912,109913,109914,109915,109916,109917,109918,109925,109926,109927,109928,109929,109998,118719,109759,109760,109761,109762,109763,109764,109765,109766,109767,109768,109769,109770,109771,109772,109773,109774,109775,109776,109777,109778,109779,109780,109781,109782,109783,109930,109931,109932,109933,109934,109935,109936,109937,109938,109939,109940,109941,109942,109943,109944,109945,109946,109947,109948,109949,110018,118724,109844,109845,109846,109847,109848,109849,109850,109851,109852,109853,109854,109855,109856,109857,109858,109859,109860,109861,109862,109863,109884,109885,109886,109887,109888,109889,109890,109891,109892,109893,109894,109895,109896,109897,109898,109899,109900,109901,109902,109903,110008,118725,118726,109804,109805,109806,109807,109808,109809,109810,109811,109812,109813,109814,109815,109816,109817,109818,109819,109820,109821,109822,109823,109950,109951,109952,109953,109954,109955,109956,109957,109958,109959,109960,109961,109962,109963,109964,109965,109966,109967,109968,109969,110003,118737,109824,109825,109826,109827,109828,109829,109830,109831,109832,109833,109834,109835,109836,109837,109838,109839,109840,109841,109842,109843,109864,109865,109866,109867,109868,109869,109870,109871,109872,109873,109874,109875,109876,109877,109878,109879,109880,109881,109882,109883,109970,109971,109972,109973,109974,109975,109976,109977,109978,109979,109980,109981,109982,109983,109984,109985,109986,109987,109988,109989,110013,118738,118739,118740,109784,109785,109786,109787,109788,109789,109790,109791,109792,109793,109794,109795,109796,109797,109798,109799,109800,109801,109802,109803,109904,109905,109906,109907,109908,109909,109910,109911,109912,109913,109914,109915,109916,109917,109918,109925,109926,109927,109928,109929,109998,118719,109759,109760,109761,109762,109763,109764,109765,109766,109767,109768,109769,109770,109771,109772,109773,109774,109775,109776,109777,109778,109779,109780,109781,109782,109783,109930,109931,109932,109933,109934,109935,109936,109937,109938,109939,109940,109941,109942,109943,109944,109945,109946,109947,109948,109949,110018,118724,109844,109845,109846,109847,109848,109849,109850,109851,109852,109853,109854,109855,109856,109857,109858,109859,109860,109861,109862,109863,109884,109885,109886,109887,109888,109889,109890,109891,109892,109893,109894,109895,109896,109897,109898,109899,109900,109901,109902,109903,110008,118725,118726,115425,115426,115427,115428,115429,115430,115431,115432,120083,120084,120085,120086,120087,115425,115426,115427,115428,115429,115430,115431,115432,120088,120089,120090,120091,115433,115434,115435,115436,115437,115438,115439,115440,115441,116771,120111,120112,120113,120114,124545,124546,127971,127972,127973,127974,127975,127976,127977,127978,127979,127980,127981,127982,127983,127984,113591,113592,113593,113595,113596,113598,113599,113600,113601,113602,113604,113605,113606,113607,113608,113609,113610,113611,113612,113632,113633,113634,113636,113637,113638,113639,113640,113641,113642,113643,113644,113645,113646,113647,113648,113649,113650,113651,113652,113653,113654,113655,113656,113657,113658,113659,113660,113661,113662,113664,113666,113667,113826,113827,113828,113829,113830,113831,113832,113833,113834,113835,113836,113837,113838,113839,113840,113841,113842,113843,113844,113845,113846,113847,113848,113849,113850,113851,113852,113853,113854,113855,113856,113857,113858,113859,113860,113861,113591,113592,113593,113595,113596,113598,113599,113600,113601,113602,113604,113605,113606,113607,113608,113609,113610,113611,113612,113632,113633,113634,113636,113637,113638,113639,113640,113641,113642,113643,113644,113645,113646,113647,113648,113649,113650,113651,113652,113653,113654,113655,113656,113657,113658,113659,113660,113661,113662,113664,113666,113667,113826,113827,113828,113829,113830,113831,113832,113833,113834,113835,113836,113837,113838,113839,113840,113841,113842,113843,113844,113845,113846,113847,113848,113849,113850,113851,113852,113853,113854,113855,113856,113857,113858,113859,113860,113861,116003,116030,116205,116236,116282,116289,116298,116360,115998,116026,116209,116230,116281,116290,116297,116361,116000,116032,116210,116237,116279,116285,116292,116362,116363,115999,116028,116208,116233,116288,116291,116294,115997,116025,116211,116234,116283,116286,116364,116365,115996,116029,116212,116231,116284,116293,116295,116366,116367,116368,116002,116027,116206,116235,116280,116287,116296,116372,116373,113591,113592,113593,113595,113596,113598,113599,113600,113601,113602,113604,113605,113606,113607,113608,113609,113610,113611,113612,113632,113633,113634,113636,113637,113638,113639,113640,113641,113642,113643,113644,113645,113646,113647,113648,113649,113650,113651,113652,113653,113654,113655,113656,113657,113658,113659,113660,113661,113662,113664,113666,113667,113826,113827,113828,113829,113830,113831,113832,113833,113834,113835,113836,113837,113838,113839,113840,113841,113842,113843,113844,113845,113846,113847,113848,113849,113850,113851,113852,113853,113854,113855,113856,113857,113858,113859,113860,113861,113874,113875,113876,113877,113878,113879,113880,113881,113882,113883,113884,119194,119448,113897,113898,113899,113900,113901,113902,113903,113904,113905,113906,113907,113908,113910,113939,113940,113941,113942,113943,113944,113945,113946,113947,113948,113949,113950,113951,113952,119192,113862,113863,113864,113865,113866,113867,113868,113869,113870,113871,113872,113873,118114,120078,113913,113914,113915,113916,113917,113918,113919,113920,113921,113922,113923,113924,113925,119193,119305,119315,119318,120077,113953,113954,113955,113956,113957,113958,113959,113960,113961,113962,113963,113964,119309,119314,119322,113885,113886,113887,113888,113889,113890,113891,113892,113893,113894,113895,113896,119307,119313,119320,113926,113927,113928,113929,113930,113931,113932,113933,113934,113935,113936,113937,113938,119308,119312,119321,113965,113966,113967,113968,113969,113970,113971,113972,113973,113974,113975,113976,113977,113978,119306,119311,119319,113979,113980,113981,113982,113983,113984,113985,113986,113987,113988,113989,113990,120277,120278,120279,113874,113875,113876,113877,113878,113879,113880,113881,113882,113883,113884,119194,119448,113897,113898,113899,113900,113901,113902,113903,113904,113905,113906,113907,113908,113910,113939,113940,113941,113942,113943,113944,113945,113946,113947,113948,113949,113950,113951,113952,119192,113862,113863,113864,113865,113866,113867,113868,113869,113870,113871,113872,113873,118114,120078,113913,113914,113915,113916,113917,113918,113919,113920,113921,113922,113923,113924,113925,119193,119305,119315,119318,120077,113953,113954,113955,113956,113957,113958,113959,113960,113961,113962,113963,113964,119309,119314,119322,113885,113886,113887,113888,113889,113890,113891,113892,113893,113894,113895,113896,119307,119313,119320,113926,113927,113928,113929,113930,113931,113932,113933,113934,113935,113936,113937,113938,119308,119312,119321,113965,113966,113967,113968,113969,113970,113971,113972,113973,113974,113975,113976,113977,113978,119306,119311,119319,113979,113980,113981,113982,113983,113984,113985,113986,113987,113988,113989,113990,116660,120277,120278,120279,116007,116021,116033,116046,116215,116240,116257,116308,116310,116380,116381,116012,116034,116217,116227,116238,116256,116305,116311,116016,116019,116038,116048,116213,116223,116255,116262,116302,116306,116009,116018,116039,116045,116216,116229,116242,116299,116307,116011,116040,116047,116226,116245,116253,116264,116313,116316,116384,116385,120375,120380,120389,120393,116013,116014,116049,116239,116252,116265,116301,116304,116388,116389,120376,120381,120388,120395,116004,116015,116037,116041,116214,116228,116241,116303,116315,116379,116382,120377,120379,120385,120391,116006,116008,116035,116044,116218,116222,116243,116254,116300,116318,116386,116387,120378,120383,120387,120394,116010,116017,116050,116051,116220,116225,116250,116263,116312,116314,116390,120374,120384,120386,120392,116005,116022,116036,116042,116219,116224,116244,116251,116309,116317,116391,116393,120373,120382,120390,120396,113874,113875,113876,113877,113878,113879,113880,113881,113882,113883,113884,119194,119448,113897,113898,113899,113900,113901,113902,113903,113904,113905,113906,113907,113908,113910,113939,113940,113941,113942,113943,113944,113945,113946,113947,113948,113949,113950,113951,113952,119192,113862,113863,113864,113865,113866,113867,113868,113869,113870,113871,113872,113873,118114,120078,113913,113914,113915,113916,113917,113918,113919,113920,113921,113922,113923,113924,113925,119193,119305,119315,119318,120077,113953,113954,113955,113956,113957,113958,113959,113960,113961,113962,113963,113964,119309,119314,119322,113885,113886,113887,113888,113889,113890,113891,113892,113893,113894,113895,113896,119307,119313,119320,113926,113927,113928,113929,113930,113931,113932,113933,113934,113935,113936,113937,113938,119308,119312,119321,113965,113966,113967,113968,113969,113970,113971,113972,113973,113974,113975,113976,113977,113978,119306,119311,119319,113979,113980,113981,113982,113983,113984,113985,113986,113987,113988,113989,113990,120277,120278,120279,124132,124136,124168,124183,124190,124201,124207,124216,124231,124270,124278,124289,124298,124320,124324,124335,124356,124365,124370,124145,124148,124174,124196,124213,124223,124227,124249,124253,124264,124285,124309,124315,124351,124354,124373,124139,124151,124160,124161,124162,124180,124187,124211,124217,124235,124239,124243,124261,124262,124263,124296,124297,124304,124332,124333,124334,124341,124358,124363,124377,124133,124142,124163,124184,124193,124220,124224,124228,124258,124271,124299,124312,124336,124347,124383,124385,124388,124137,124152,124169,124197,124208,124232,124240,124250,124279,124281,124305,124321,124325,124330,124364,124366,124379,124140,124146,124157,124165,124166,124167,124188,124205,124236,124244,124267,124268,124269,124290,124301,124302,124338,124339,124340,124342,124348,124359,124380,124391,124134,124170,124175,124194,124198,124202,124218,124229,124241,124259,124275,124282,124286,124294,124316,124352,124387,124390,127749,124141,124143,124154,124155,124156,124185,124191,124221,124225,124233,124245,124255,124256,124257,124292,124293,124313,124327,124328,124329,124331,124357,124362,124384,124386,124138,124149,124181,124203,124209,124214,124237,124265,124280,124283,124310,124337,124360,124368,124369,124147,124158,124177,124178,124179,124189,124199,124212,124234,124260,124272,124273,124274,124295,124307,124308,124344,124345,124346,124353,124371,124374,124381,124153,124186,124192,124195,124219,124226,124242,124251,124287,124300,124306,124326,124355,124375,124376,124135,124164,124171,124172,124173,124204,124206,124215,124230,124238,124246,124247,124248,124266,124284,124303,124314,124317,124318,124319,124349,124361,124367,124378,124144,124159,124176,124200,124210,124222,124254,124276,124291,124322,124343,124372,124382,124389,124513,124514,124515,124516,124517,124518,124519,124520,124521,124522,124523,124132,124136,124168,124183,124190,124201,124207,124216,124231,124270,124278,124289,124298,124320,124324,124335,124356,124365,124370,124145,124148,124174,124196,124213,124223,124227,124249,124253,124264,124285,124309,124315,124351,124354,124373,124139,124151,124160,124161,124162,124180,124187,124211,124217,124235,124239,124243,124261,124262,124263,124296,124297,124304,124332,124333,124334,124341,124358,124363,124377,124133,124142,124163,124184,124193,124220,124224,124228,124258,124271,124299,124312,124336,124347,124383,124385,124388,124137,124152,124169,124197,124208,124232,124240,124250,124279,124281,124305,124321,124325,124330,124364,124366,124379,124140,124146,124157,124165,124166,124167,124188,124205,124236,124244,124267,124268,124269,124290,124301,124302,124338,124339,124340,124342,124348,124359,124380,124391,124134,124170,124175,124194,124198,124202,124218,124229,124241,124259,124275,124282,124286,124294,124316,124352,124387,124390,127749,124141,124143,124154,124155,124156,124185,124191,124221,124225,124233,124245,124255,124256,124257,124292,124293,124313,124327,124328,124329,124331,124357,124362,124384,124386,124138,124149,124181,124203,124209,124214,124237,124265,124280,124283,124310,124337,124360,124368,124369,124147,124158,124177,124178,124179,124189,124199,124212,124234,124260,124272,124273,124274,124295,124307,124308,124344,124345,124346,124353,124371,124374,124381,124153,124186,124192,124195,124219,124226,124242,124251,124287,124300,124306,124326,124355,124375,124376,124135,124164,124171,124172,124173,124204,124206,124215,124230,124238,124246,124247,124248,124266,124284,124303,124314,124317,124318,124319,124349,124361,124367,124378,123890,124144,124159,124176,124200,124210,124222,124254,124276,124291,124322,124343,124372,124382,124389,124513,124514,124515,124516,124517,124518,124519,124520,124521,124522,124523,128028,128029,128030,128031,128050,128071,128073,128081,128092,128098,128110,128111,128142,128033,128053,128058,128060,128067,128075,128076,128094,128102,128105,128118,128141,128168,128056,128057,128059,128064,128103,128104,128107,128117,128128,128130,128132,128134,128143,128040,128061,128062,128065,128068,128077,128089,128095,128097,128100,128114,128115,128140,128184,128191,128042,128047,128049,128070,128074,128078,128087,128093,128109,128113,128116,128144,128147,128167,128192,128069,128072,128079,128101,128106,128129,128131,128133,128135,128148,128196,128200,127749,128041,128055,128063,128082,128083,128086,128096,128146,128179,128180,128186,128296,128035,128036,128046,128051,128084,128085,128088,128119,128145,128182,128190,128195,128197,128038,128043,128066,128174,128175,128178,128183,128185,128189,128202,128299,128300,128032,128052,128054,128080,128091,128176,128187,128295,128298,128045,128090,128099,128108,128136,128137,128138,128139,128149,128181,128188,128034,128037,128112,128120,128121,128122,128123,128170,128177,128193,128194,128198,128297,128039,128044,128048,128124,128125,128126,128127,128150,128151,128152,128153,128154,128171,128199,128201,124132,124136,124168,124183,124190,124201,124207,124216,124231,124270,124278,124289,124298,124320,124324,124335,124356,124365,124370,124145,124148,124174,124196,124213,124223,124227,124249,124253,124264,124285,124309,124315,124351,124354,124373,124139,124151,124160,124161,124162,124180,124187,124211,124217,124235,124239,124243,124261,124262,124263,124296,124297,124304,124332,124333,124334,124341,124358,124363,124377,124133,124142,124163,124184,124193,124220,124224,124228,124258,124271,124299,124312,124336,124347,124383,124385,124388,124137,124152,124169,124197,124208,124232,124240,124250,124279,124281,124305,124321,124325,124330,124364,124366,124379,124140,124146,124157,124165,124166,124167,124188,124205,124236,124244,124267,124268,124269,124290,124301,124302,124338,124339,124340,124342,124348,124359,124380,124391,124134,124170,124175,124194,124198,124202,124218,124229,124241,124259,124275,124282,124286,124294,124316,124352,124387,124390,127749,124141,124143,124154,124155,124156,124185,124191,124221,124225,124233,124245,124255,124256,124257,124292,124293,124313,124327,124328,124329,124331,124357,124362,124384,124386,124138,124149,124181,124203,124209,124214,124237,124265,124280,124283,124310,124337,124360,124368,124369,124147,124158,124177,124178,124179,124189,124199,124212,124234,124260,124272,124273,124274,124295,124307,124308,124344,124345,124346,124353,124371,124374,124381,124153,124186,124192,124195,124219,124226,124242,124251,124287,124300,124306,124326,124355,124375,124376,124135,124164,124171,124172,124173,124204,124206,124215,124230,124238,124246,124247,124248,124266,124284,124303,124314,124317,124318,124319,124349,124361,124367,124378,124144,124159,124176,124200,124210,124222,124254,124276,124291,124322,124343,124372,124382,124389,124513,124514,124515,124516,124517,124518,124519,124520,124521,124522,124523       
       }
    
    retry_queue = {}
    
    local ItemsCache = {}
    
    --{slot1 = {itemId1 = item1, itemId2 =item2,}, slot2 = {itemId1 = item1, itemId2 =item2,}}
    ItemsBySlot = {}
    
    local CACHE_INTENSITY = 50
    
    function CacheItemsForGearAdvisor()
        print("in CacheItemsForGearAdvisor...")
        LuaUtils:CreateThread("CacheItemsForGearAdvisor", function()
                    GA.cachingItems = true

                    -- Catchs items that shouldn't be in the guides. Gems/Throwing/Idols/Bags etc
                    GA.retry_counter = {}

                    local t = debugprofilestop()
                    local init_cache_len = #ItemsForWhichGuideExists
                    local numGood=0
                    
                    while #ItemsForWhichGuideExists ~= 0 do
                        local itemId = tremove(ItemsForWhichGuideExists, 1)
                        local item = GetItemInfoById(itemId)
                        
                        if item then
                            -- Caching was successful so remove the counter.
                            GA.retry_counter[itemId] = nil
                            numGood = numGood + 1
                            
                            local equipslot = item.info.equipslot
                
                            if IsEquipment(equipslot) then
                                --print("addedX " , itemId, equipslot, item.info.reqlevel)
                                if not ItemsBySlot[equipslot] then
                                    ItemsBySlot[equipslot] = {}
                                end
                                
                                ItemsBySlot[equipslot][itemId] = item
                            else
                                --print("not added ", itemId, equipslot)
                            end
                                
                            -- Item is a valid equipible item
                            --[[if ItemScore:IsGoodEquipSlot(item.info.equipslot) then
                                self:AddItemToBase(item)
                            else
                                -- Can't equip the item? We should just remove it from the guides.
                                self.baditems[itemId] = item.info.equipslot
                            end]]
                        else
                            --print("not found " , itemId)
                            
                            if not GA.retry_counter[itemId] then 
                                GA.retry_counter[itemId] = 0 
                            end
                            
                            GA.retry_counter[itemId] = GA.retry_counter[itemId] + 1

                            if GA.retry_counter[itemId] >= 20 then
                                -- Same item has failed to cache 20 times. Time to exit because it isn't going to work.
                                -- Return number of items unable to be cached.
                                -- Well we are done caching, just report these items as failures and continue as usual.
                                GA.cached = true
                                --print("failure", #ItemsForWhichGuideExists + 1)
                                return "failure", #ItemsForWhichGuideExists + 1
                            end

                            -- Couldn't get the info this time, try again later
                            tinsert(retry_queue, itemId)
                        end

                        -- Take a break. Will resume on next OnUpdate.
                        if debugprofilestop() - t > CACHE_INTENSITY then
                            coroutine.yield()
                            t = debugprofilestop()
                        end

                        -- Cache is empty. Give yield to give GetItemInfo() to arrive for items in retry.  -- 2015-01-01 sinus: give what the what??
                        if #ItemsForWhichGuideExists == 0 and #retry_queue>0 then
                            ItemsForWhichGuideExists, retry_queue = retry_queue, {}
                            coroutine.yield()
                            t = debugprofilestop()
                        end
                    end
                    
                    GA.cachingItems = true
                    print("CacheItemsForGearAdvisor done.")
                    
                    return "success"
            
        end, nil, 1, 0.01)
    end
        
    
equipementSlots = {
    "INVTYPE_WEAPON" ,
    "INVTYPE_WEAPONMAINHAND",
    "INVTYPE_RANGEDRIGHT",
    "INVTYPE_2HWEAPON",
    "INVTYPE_RANGED",
    "INVTYPE_WEAPONOFFHAND",
    "INVTYPE_SHIELD",
    "INVTYPE_HOLDABLE",
    "INVTYPE_HEAD",
    "INVTYPE_NECK",
    "INVTYPE_SHOULDER",
    "INVTYPE_CLOAK",
    "INVTYPE_CHEST",
    "INVTYPE_ROBE",
    "INVTYPE_WRIST",
    "INVTYPE_HAND",
    "INVTYPE_WAIST",
    "INVTYPE_LEGS",
    "INVTYPE_FEET",
    "INVTYPE_FINGER",
    "INVTYPE_TRINKET"
}
        
    --/run print("INVTYPE_HAND")
    --/run CacheItemsForGearAdvisor()
    --/run GetSuggesedItemGuidebySlot("INVTYPE_WRIST")
    --/run GetSuggesedItemGuidebySlot("INVTYPE_FEET")
    --/run GetSuggesedItemGuidebySlot("INVTYPE_NECK")
    --/run GetSuggesedItemGuidebySlot("INVTYPE_HAND")
    --/run GetSuggesedItemGuidebySlot("INVTYPE_FINGER")
    --/run GetSuggesedItemGuidebySlot("INVTYPE_WEAPON")
    --/run GetSuggesedItemGuidebySlot("INVTYPE_TRINKET")
    --/run GetSuggesedItemGuidebySlot("INVTYPE_LEGS")
    --/run GetSuggesedItemGuidebySlot("INVTYPE_CHEST")
    --/run GetSuggesedItemGuidebySlot("INVTYPE_HEAD")
    function GetSuggesedItemGuidebySlot(invslot)
        if not ItemsBySlot[invslot] then
            return invslot, " -"
        end
        
        local ownedItems = GetAllOwnedItems(onlyBelowPlayerLevel)
        
        local ownedItemsIds = {}
        
        LuaUtils:foreach(ownedItems, function(value, index)
           ownedItemsIds[tonumber(value.itemId)] = true
        end)
        
        local level = UnitLevel("player")
        
        if not ItemsBySlot[invslot] then return end
        local itemsBelowPlayerLevel = {}
        local itemsAbovePlayerLevel = {}	-- upgrades with restrictions
        
        local theBestForSlot = GetTheBestOwnedItemBySlot(invslot, true)

        LuaUtils:foreach(ItemsBySlot[invslot], function(item, itemId) 
            local uniqueInventorySlot = GetDefaultUniqueInventorySlot(invslot)
            
            local score = CalculateScore("item:"..itemId, nil, nil, level, uniqueInventorySlot)

             local tooLowPlayerLevel = (level < item.info.reqlevel)
            
            --Filtering already owned:
            local itemAlreadyOwned = ownedItemsIds[itemId]
             
            if not itemAlreadyOwned then
                if tooLowPlayerLevel then
                    tinsert (itemsAbovePlayerLevel,{item=item,score=score})
                else
                    tinsert (itemsBelowPlayerLevel,{item=item,score=score})
                end
            else
            end
        end)
        
        --Sorting itemsBelowPlayerLevel by score (from hight to low)  {highest, ..., lowest}
        table.sort(itemsBelowPlayerLevel, function(a,b)  
            return a.score > b.score  
        end)
        
         --Sorting itemsAbovePlayerLevel by required level  Sorted from love to high
        table.sort(itemsAbovePlayerLevel, function(a,b) 
            return a.item.info.reqlevel < b.item.info.reqlevel 
        end)
        
        print("-------------------------")
        print("SET  \"Below\" of items:   (please see google doc, possessed are excluded, limit 25 items, so some may not be displayed)")
        print("-------------------------")
        for i=1, #itemsBelowPlayerLevel do
            if i < 25 then
                print("#",i, invslot, itemsBelowPlayerLevel[i].item.info.name, itemsBelowPlayerLevel[i].item.info.itemid, "SCORE: ", itemsBelowPlayerLevel[i].score, " LEVEL:", itemsBelowPlayerLevel[1].item.info.reqlevel  )
            end
        end
        
        print("-------------------------")
        print("SET \"Above\" of items:   (please see google doc, possessed are excluded, limit 5 items, so some may not be displayed)")
        print("-------------------------")
        for i=1, #itemsAbovePlayerLevel do
            if i < 5 then
                print("#",i, invslot, itemsAbovePlayerLevel[i].item.info.name, itemsAbovePlayerLevel[i].item.info.itemid, "SCORE: ", itemsAbovePlayerLevel[i].score, " LEVEL:", itemsAbovePlayerLevel[1].item.info.reqlevel  )
            end
        end
        
        print("-------------------------")
        
        -- STEP 1 (https://docs.google.com/document/d/1pPHzCCmkcLuFGGat8qZJTc54uPpldOFJWSlH8aoa610/edit)
        if theBestForSlot == nil then
            --todo descruption - log
            print("STEP 1 (the best possessed for slot doesn't exist)...")
            local lastIndex = #itemsBelowPlayerLevel
            print("-------------------------")
            print("**** SUGGESTED GUIDE: ",invslot, itemsBelowPlayerLevel[lastIndex].item.info.name, itemsBelowPlayerLevel[lastIndex].item.info.itemid, " Required player level:", itemsBelowPlayerLevel[lastIndex].item.info.reqlevel)
            print("-------------------------")
            return invslot, itemsBelowPlayerLevel[lastIndex].item.info.name, itemsBelowPlayerLevel[lastIndex].item.info.itemid 
        else
            print("STEP 1 (taking into account the best possessed)...")
            --print("trying BB...", #itemsBelowPlayerLevel, " THE BEST SCORE:", theBestForSlot.score)
            for i=1, #itemsBelowPlayerLevel do
                if itemsBelowPlayerLevel[i].score <= theBestForSlot.score then
                   --Going back to search for the first item with higher score than already possesed
                   for j = i, 1, -1 do
                        if j == 1 or itemsBelowPlayerLevel[j].score > theBestForSlot.score then
                            --print("BB  STEP 1")
                            print("-------------------------")
                            print("**** SUGGESTED GUIDE: ", invslot, itemsBelowPlayerLevel[j].item.info.name, itemsBelowPlayerLevel[j].item.info.itemid, " SCORE:", itemsBelowPlayerLevel[j].score)
                            print("-------------------------")
                            return invslot, itemsBelowPlayerLevel[j].item.info.name, itemsBelowPlayerLevel[j].item.info.itemid  
                        end
                   end
                end
            end
        end
        
        -- STEP 2
        if #itemsBelowPlayerLevel > 0 then
            print("STEP 2")
            print("-------------------------")
            print("**** SUGGESTED GUIDE: ", invslot, itemsAbovePlayerLevel[1].item.info.name..("avilable at Level "..itemsAbovePlayerLevel[1].item.info.reqlevel), itemsAbovePlayerLevel[1].item.info.itemid)
            print("-------------------------")
            return  invslot, itemsAbovePlayerLevel[1].item.info.name..("avilable at Level "..itemsAbovePlayerLevel[1].item.info.reqlevel), itemsAbovePlayerLevel[1].item.info.itemid
        end
        
    end
    
  -- function GetItemScoreInfo(anyItemLink)
  -- end
	
	local function GetCurrentBestInSlot(uniqueInventorySlot, spec, pvp, level, skip, enforceArmorSpecSubclass, uncapped, ignoreLevelRequirement, itemMustWin)
		level = level or UnitLevel("player")
		spec = spec or GetSpecialization()
		local armorSpecSubclass =  itemMustWin and GetArmorSpecSubclass(GetScoringInfo(spec, pvp))
		local winner, winScore, winArmorSpecStatValue, winnerGrantsArmorSpecSubclass,
			altWinner, altScore, altArmorSpecStatValue,
			mainHandWinner, mainHandScore, mainHandOffHandScore, mainHandArmorSpecStatValue,
			offHandWinner, offHandScore, offHandArmorSpecStatValue,
			twoHandWinner, twoHandScore, twoHandArmorSpecStatValue,
			mustWinGrantsArmorSpecSubclass
		local itemInvariant = GetCreateTable()
		itemInvariant.first = itemMustWin
		itemInvariant.skip = skip
		for control,iteratedItemLink in ItemIterator,itemInvariant do
			local reqLevel, itemClass, itemSubclass, itemEquipSlot
			if not ItemIsBanned(iteratedItemLink, control) then
				local score, armorSpecStatValue
				reqLevel, itemClass, itemSubclass, _, itemEquipSlot = select(5, GetItemInfo(iteratedItemLink))
				if not ignoreLevelRequirement then
					if not level or not reqLevel or level<reqLevel then score = -1 end
				end
				itemClass, itemSubclass = GetItemClassIndex(itemClass, itemSubclass)
				if iteratedItemLink==itemMustWin and itemClass==ITEM_CLASS_ARMOR and itemSubclass==armorSpecSubclass then
					mustWinGrantsArmorSpecSubclass = true
				end
				local canAdornOffHand
				local canAdornSlot = CanAdornUniqueInventorySlot(uniqueInventorySlot, itemClass, itemSubclass, itemEquipSlot, spec, level)
				if uniqueInventorySlot==INVSLOT_MAINHAND then
					canAdornOffHand = CanAdornUniqueInventorySlot(INVSLOT_OFFHAND, itemClass, itemSubclass, itemEquipSlot, spec, level)
				end
				if not canAdornSlot then
					if not canAdornOffHand then
						score = -4
					end
				end
				if not score then
					score, armorSpecStatValue = CalculateScore(iteratedItemLink, spec, pvp, level, uniqueInventorySlot, nil, enforceArmorSpecSubclass, uncapped)
				end
				 
				if score>=0 then--pair holdable, ring and trinket slots
					if uniqueInventorySlot==INVSLOT_MAINHAND then
						if canAdornSlot and MainHandBlocksSecondarySlot(itemSubclass, itemEquipSlot, iteratedItemLink, spec, level) then
							if not twoHandScore or twoHandScore<score then 
								twoHandScore=score
								twoHandWinner=iteratedItemLink
								twoHandArmorSpecStatValue=armorSpecStatValue
							end
						else
							if canAdornSlot and (not mainHandScore or mainHandScore<score) then 
								if mainHandOffHandScore and (not offHandScore or offHandScore<mainHandOffHandScore) then
									offHandScore = mainHandOffHandScore
									offHandWinner = mainHandWinner
									offHandArmorSpecStatValue = mainHandArmorSpecStatValue
								end
								mainHandScore=score
								mainHandWinner=iteratedItemLink
								mainHandArmorSpecStatValue=armorSpecStatValue
								if canAdornOffHand then
									mainHandOffHandScore = CalculateScore(iteratedItemLink, spec, pvp, level, INVSLOT_OFFHAND, nil, enforceArmorSpecSubclass, uncapped)
								end
							elseif canAdornOffHand then
								score = CalculateScore(iteratedItemLink, spec, pvp, level, INVSLOT_OFFHAND, nil, enforceArmorSpecSubclass, uncapped)
								if not offHandScore or offHandScore<score then
									offHandScore = score
									offHandWinner = iteratedItemLink
									offHandArmorSpecStatValue = armorSpecStatValue
								end
							end
						end
					else
						local iteratedItemWonTieBreaker
						if score==winScore then
							local winnerTieBreaker = CalculateScore(winner, spec, pvp, level, uniqueInventorySlot, true, enforceArmorSpecSubclass, uncapped)
							local iteratedItemTieBreaker = CalculateScore(iteratedItemLink, spec, pvp, level, uniqueInventorySlot, true, enforceArmorSpecSubclass, uncapped)
							if iteratedItemTieBreaker>winnerTieBreaker then 

								iteratedItemWonTieBreaker = true
							end
						end
						if not winScore then
							winScore = score
							winner = iteratedItemLink
							winArmorSpecStatValue = armorSpecStatValue
							winnerGrantsArmorSpecSubclass = itemClass==ITEM_CLASS_ARMOR and itemSubclass==armorSpecSubclass
						elseif winScore<score or iteratedItemWonTieBreaker then
							altScore = winScore
							altWinner = winner
							altArmorSpecStatValue = winArmorSpecStatValue
							winScore = score
							winner = iteratedItemLink
							winArmorSpecStatValue = armorSpecStatValue
							winnerGrantsArmorSpecSubclass = itemClass==ITEM_CLASS_ARMOR and itemSubclass==armorSpecSubclass
						elseif not altScore or altScore<score then
							altScore = score
							altWinner = iteratedItemLink
							altArmorSpecStatValue = armorSpecStatValue
						end
					end
				end
			end
			if 
				itemMustWin 
				and (winner~=itemMustWin and ((not mustWinGrantsArmorSpecSubclass) or winnerGrantsArmorSpecSubclass))
				and altWinner~=itemMustWin
				and mainHandWinner~=itemMustWin
				and offHandWinner~=itemMustWin
				and twoHandWinner~=itemMustWin
			then
				control:Pool()
				return
			end
			YieldAutoroutine()
		end
		if uniqueInventorySlot~="INVTYPE_FINGER" and uniqueInventorySlot~="INVTYPE_TRINKET" then
			altScore = nil
			altWinner = nil
			altArmorSpecStatValue = nil
		end
		if uniqueInventorySlot==INVSLOT_MAINHAND then
			offHandScore = offHandScore or 0
			mainHandScore = mainHandScore or -1
			twoHandScore = twoHandScore or -1
			if mainHandScore+offHandScore>=twoHandScore then
				if 
					itemMustWin 
					and mainHandWinner~=itemMustWin
					and offHandWinner~=itemMustWin
				then
					return
				end
				if DGV:UserSetting(DGV_WEAPONPREF)~="Never Swap" then
					if ShouldSwapMainOffWeapons(mainHandWinner, offHandWinner, spec, level) then
						winner, winScore, altWinner, altScore = offHandWinner, mainHandScore+offHandScore, mainHandWinner, mainHandScore
						winArmorSpecStatValue, altArmorSpecStatValue = offHandArmorSpecStatValue, mainHandArmorSpecStatValue
					elseif not ItemIsBannedWeapon(mainHandWinner) and not ItemIsBannedWeapon(offHandWinner) then
						winner, winScore, altWinner, altScore = mainHandWinner, mainHandScore+offHandScore, offHandWinner, offHandScore
						winArmorSpecStatValue, altArmorSpecStatValue = mainHandArmorSpecStatValue, offHandArmorSpecStatValue
					end
				end
			else
				if 
					itemMustWin
					and twoHandWinner~=itemMustWin
				then
					return
				end
				winner, winScore, winArmorSpecStatValue = twoHandWinner, twoHandScore, twoHandArmorSpecStatValue
			end
		end
		local invSlot = UniqueInventoryToInvSlot(uniqueInventorySlot)
		if 
			enforceArmorSpecSubclass==nil and 
			not winnerGrantsArmorSpecSubclass and
			IsArmorSpecSlot(invSlot)
		then
			local standardTable = GA:GetSpecDataTable(spec, pvp, nil, false, uncapped):BindToAutoroutineLifetime(UnbindSpecDataTable)
--DGV:DebugFormat("GetCurrentBestInSlot", "standardTable", tostring(standardTable), "standardTable:IsBoundToAutoroutineLifetime()", standardTable:IsBoundToAutoroutineLifetime())
			local enforcedTable = GA:GetSpecDataTable(spec, pvp, nil, true, uncapped):BindToAutoroutineLifetime(UnbindSpecDataTable)
			if 
				IsEnforcedTableComplete(enforcedTable) and 
				not StandardTableGrantsArmorSpecialization(standardTable, enforcedTable) 
				and UnitStat("player", 1) --check if working... sometime this can fail during level up event. 
				and ArmorSpecializationBonusWins(spec, standardTable, enforcedTable)
			then
				winner = enforcedTable[invSlot]
				local score, armorSpecStatValue = CalculateScore(winner, spec, pvp, level, uniqueInventorySlot, nil, enforceArmorSpecSubclass, uncapped)
				return winner, score, nil, nil, armorSpecStatValue
			end
		end
		if winScore and winScore>=0 then
			return winner, winScore, altWinner, altScore, (winArmorSpecStatValue or 0) + (altArmorSpecStatValue or 0)
		end
	end
	
	local function CalculateByScoringInfo(itemLink, spec, pvp, level, uniqueInventorySlot, itemSums, enforceArmorSpecSubclass, uncapped, ...)
		local total, armorSpecStatKey, armorSpecStatValue = 0
		for i=1,select("#", ...) do
			local data = (select(i, ...))
			if enforceArmorSpecSubclass then
				enforceArmorSpecSubclass = GetArmorSpecSubclassFrom(data) or enforceArmorSpecSubclass
			end
			armorSpecStatKey = armorSpecStatKey or GetArmorSpecStat(data)
			local score, statSum = CalculateScoreForInfo(itemLink, spec, pvp, level, uniqueInventorySlot, itemSums, enforceArmorSpecSubclass, uncapped, unpack(data))
			local itemLevel, _, _, _, _, equipSlot = select(4, GetItemInfo(itemLink))
			if equipSlot == "INVTYPE_TRINKET" and DGV:UserSetting(DGV_SUGGESTTRINKET) then
				if score and score>0 then 
					score = score + itemLevel
				end
			end
			
			if armorSpecStatKey and data[1]==armorSpecStatKey then
				armorSpecStatValue = statSum
			end
			if score then
				if score<0 then return score end
				total = total + score
			end
			YieldAutoroutine()
		end
		return total, armorSpecStatValue
	end
	
	CalculateScore =  function(itemLink, spec, pvp, level, uniqueInventorySlot, tiebreaker, enforceArmorSpecSubclass, uncapped)
		--uncapped = true
		local cacheKey = not tiebreaker and strformat("%s%s%d%s%d%s%s%s", "CalculateScore", itemLink, spec, pvp and "true" or "false", level, tostring(uniqueInventorySlot), enforceArmorSpecSubclass and tostring(enforceArmorSpecSubclass) or "nil", uncapped and "0" or "1")
		if cacheKey then
			local cacheReaction = TryGetCacheReaction(cacheKey)
			if cacheReaction then
--DGV:DebugFormat("CalculateScore cached", "itemLink", itemLink, "uncapped", uncapped,  "score", (cacheReaction:UnpackCache()))
				return cacheReaction:UnpackCache()
			end
		end
		
		local itemSums = GetItemSums(itemLink):BindToAutoroutineLifetime(tPool)
		--StatLogic:GetSum(itemLink, itemSums)
		--DGV.InitTable(itemSums)
		local levelLimit = itemSums["PLAYER_LEVEL_LIMIT"]
		if levelLimit and level>levelLimit then
			itemSums["XP_BONUS"] = 0 -- Heirloom XP Bonus stops working after Level limit
			--itemSums:Pool()
			--return -6
		end
		local score, armorSpecStatValue
		if not tiebreaker then
			score, armorSpecStatValue = CalculateByScoringInfo(itemLink, spec, pvp, level, uniqueInventorySlot, itemSums, enforceArmorSpecSubclass, uncapped, GetScoringInfo(spec, pvp))
		else
			score = CalculateByScoringInfo(itemLink, spec, pvp, level, uniqueInventorySlot, itemSums, enforceArmorSpecSubclass, uncapped, GetTieBreakerScoringInfo())

		end
		itemSums:Pool()
		
		if cacheKey then
			RegisterReaction("BAG_UPDATE")
				:Or(RegisterMemberFunctionReaction("DugisGuideViewer.Modules.GearAdvisor", "ResetCalculateScoreCache"))
				:SetCache(cacheKey, score, armorSpecStatValue)
		end
--DGV:DebugFormat("CalculateScore", "itemLink", itemLink,"uncapped", uncapped, "score", score)
		return score, armorSpecStatValue
	end
	
	function GA.ResetCalculateScoreCache()
		QueueInvocation(GA.AutoEquipSmartSet, false)
	end
	
	local function StandardCompare(criterion, link, level)
		local uniqueSlot = GetDefaultUniqueInventorySlot(select(9, GetItemInfo(link)))
		local winningItem, winningScore, altWinner, altScore = GetCurrentBestInSlot(uniqueSlot, criterion.specNum, criterion.pvp, level, nil, nil, nil, true, link)
		return winningItem==link or altWinner==link, altWinner==link and winningItem or altWinner, winningItem==link and winningScore or altScore, winningItem==link and altScore or winningScore, uniqueSlot
	end
	
	local function CoinCompare(criterion, link)
		local highest, value = true, select(11, GetItemInfo(link))
		for _, choice in GA.ItemChoiceIterator do
			local choiceValue = select(11, GetItemInfo(choice))
			highest = highest and choiceValue<=value
		end
		return highest, value, value
	end
    
    local function GetStorylineButtonByRewardName(rewardName)
        for i = 1, 50 do
            if _G["Storyline_ItemButton"..i] and _G["Storyline_ItemButton"..i].Name:GetText() == rewardName then
                return _G["Storyline_ItemButton"..i]
            end
        end
    end
	
	local function StandardRewardAdorner(criterion, link, rewardFrame)
        if Storyline_NPCFrame and Storyline_NPCFrame:IsShown() then
            local storyLineRewardFrame = GetStorylineButtonByRewardName(rewardFrame.Name:GetText())
            if storyLineRewardFrame then
                rewardFrame = storyLineRewardFrame
            end
        end
    
		local chosenColor
		if not DugisGreenArrowRewardAdornment:IsShown() then
			chosenColor = DugisGreenArrowRewardAdornment
		elseif not DugisYellowArrowRewardAdornment:IsShown() then
			if DugisGreenArrowRewardAdornment:IsShown() then
				local _,relativeTo = DugisGreenArrowRewardAdornment:GetPoint()
				if relativeTo==rewardFrame then return end
			end
			chosenColor = DugisYellowArrowRewardAdornment
		end
		if not chosenColor then return end
		chosenColor:SetParent(rewardFrame)
		chosenColor:ClearAllPoints()
		chosenColor:SetSize(28, 28)
		chosenColor:SetPoint("TOP", rewardFrame, "BOTTOMLEFT", 30, 25)
        chosenColor:SetFrameStrata("DIALOG") 
        chosenColor:SetFrameLevel(501)
		chosenColor:Show()
	end
	
	local function StandardLootRollAdorner(criterion, link, groupLootFrame)
		if not groupLootFrame.dugisGreenArrow then
			groupLootFrame.dugisGreenArrow = CreateFrame("Frame", nil, groupLootFrame.IconFrame, "DugisGreenArrowAdornmentTemplate")
		end
		groupLootFrame.dugisGreenArrow:ClearAllPoints()
		groupLootFrame.dugisGreenArrow:SetSize(28, 28)
		groupLootFrame.dugisGreenArrow:SetPoint("TOP", groupLootFrame.IconFrame, "BOTTOMLEFT", 30, 25)
		groupLootFrame.dugisGreenArrow.link = link
		groupLootFrame.dugisGreenArrow:Show()
	end
	
	local function StandardItemButtonAdorner(criterion, link, buttonFrame, color)
		local frame
		if color=="green" then
			if not buttonFrame.dugisGreenArrow then
				buttonFrame.dugisGreenArrow = CreateFrame("Frame", nil, buttonFrame, "DugisGreenArrowAdornmentTemplate")
			end
			frame = buttonFrame.dugisGreenArrow
		else
			if buttonFrame.dugisGreenArrow and buttonFrame.dugisGreenArrow:IsShown() then return end
			if not buttonFrame.dugisYellowArrow then
				buttonFrame.dugisYellowArrow = CreateFrame("Frame", nil, buttonFrame, "DugisYellowArrowAdornmentTemplate")
			end
			frame = buttonFrame.dugisYellowArrow
		end
	
		frame:ClearAllPoints()
		frame:SetSize(28, 28)
		frame:SetPoint("TOP", buttonFrame.icon, "BOTTOMLEFT", 30, 25)
		frame:Show()
	end
	
	function StandardTiebreaker(criterion, linkA, linkB, level)
		level = level or UnitLevel("player")
		local uniqueInventorySlotA = GetDefaultUniqueInventorySlot(select(9, GetItemInfo(linkA)))
		local uniqueInventorySlotB = GetDefaultUniqueInventorySlot(select(9, GetItemInfo(linkB)))
	
		local tieBreakerA = CalculateScore(linkA, criterion.specNum, criterion.pvp, level, uniqueInventorySlotA, true)
		local tieBreakerB = CalculateScore(linkB, criterion.specNum, criterion.pvp, level, uniqueInventorySlotB, true)
		return tieBreakerA>tieBreakerB and linkA or linkB
	end
	
	local function FallbackTooltipAdorner(tooltip, option)
		tooltip:AddLine(option)
	end
	
	local function IsQuestRewardLootRollOrEJItem(link)
		for control,iteratedItemLink in ItemIterator,ITEM_ITERATOR_SKIP_EQUIPPED do
			if link==iteratedItemLink then
				local pass = control.itemType or control.func==GetLootRollItemLink or control.func==EJ_GetLootInfoByIndex
				control:Pool()
				return pass
			end
		end
	end
	
	local function StandardTooltipAdorner(criterion, tooltip, link, altWinner, score, altScore)
		local color = RAID_CLASS_COLORS[select(2,UnitClass("player"))].colorStr
		if altWinner then
			tooltip:AddLine(L["Best in slot with %s - |c%s%s|r"]:format(altWinner, color, criterion.specName))
		else

			tooltip:AddLine(L["Best in slot - |c%s%s|r"]:format(color, criterion.specName))
		end
		--if IsQuestRewardLootRollOrEJItem(link) then
			local uniqueInventorySlot = GetDefaultUniqueInventorySlot(select(9, GetItemInfo(link)))
			if uniqueInventorySlot ~= "INVTYPE_TRINKET" and not DGV:UserSetting(DGV_SUGGESTTRINKET) then
				local currentWinningItem, currentWinningScore, currentAltWinner, currentAltScore = GetCurrentBestInSlot(uniqueInventorySlot, criterion.specNum, criterion.pvp, nil, ITEM_ITERATOR_SKIP_ALL_EXTERNAL)
				if not currentWinningItem or currentWinningScore==0 or score==0 then return end
				local upgrade, upgradeOver, upgradeOverAlt
				if altWinner==currentWinningItem then
					if not currentAltScore then return end 
					upgradeOver, upgrade, upgradeOverAlt  = currentAltWinner, (1-currentAltScore/score)*100, currentWinningItem
				else
					upgradeOver, upgrade, upgradeOverAlt = currentWinningItem, (1-currentWinningScore/score)*100, currentAltWinner
				end
	--DGV:DebugFormat("StandardTooltipAdorner", "link", link, "altWinner", altWinner, "currentWinningItem",currentWinningItem, "currentAltWinner", currentAltWinner, "upgrade", upgrade, "currentWinningScore", currentWinningScore, "score", score, "altScore", altScore, "currentAltScore", currentAltScore)
				if upgradeOverAlt and upgradeOver and upgrade > 0 then
					tooltip:AddLine(L["|TInterface\\AddOns\\DugisGuideViewerZ\\Artwork\\UpgradeArrow:0|t|cff1eff00+%d%%|r upgrade over %s with %s"]:format(upgrade, upgradeOver, upgradeOverAlt))
				elseif upgradeOver and upgrade > 0 then
					
					tooltip:AddLine(L["|TInterface\\AddOns\\DugisGuideViewerZ\\Artwork\\UpgradeArrow:0|t|cff1eff00+%d%%|r upgrade over %s"]:format(upgrade, upgradeOver))
				end
			end
		--end
	end
	
	local function CoinRewardAdorner(criterion, link, rewardFrame)
        if Storyline_NPCFrame and Storyline_NPCFrame:IsShown() then
            local storyLineRewardFrame = GetStorylineButtonByRewardName(rewardFrame.Name:GetText())
            if storyLineRewardFrame then
                rewardFrame = storyLineRewardFrame
            end
        end
        
		DugisCoinRewardAdornment:ClearAllPoints()
		DugisCoinRewardAdornment:SetParent(rewardFrame)
		--DugisCoinRewardAdornment:SetFrameLevel(129)
		DugisCoinRewardAdornment:SetSize(35, 35)
		DugisCoinRewardAdornment:SetPoint("TOPRIGHT", rewardFrame, 5, 9)
        
        DugisCoinRewardAdornment:SetFrameStrata("DIALOG") 
        DugisCoinRewardAdornment:SetFrameLevel(501)
		DugisCoinRewardAdornment:Show()
	end
	
	local function SpecFromLocalizedName(name)
		for specNum=1,GetNumSpecializations() do
			local specName = select(2,GetSpecializationInfo(specNum))
			if specName==name then
				return specNum
			end
		end
	end
	
	function IsEquipment(equipLoc)
		if invType=="" then return end
		local uniqueInventorySlot = GetDefaultUniqueInventorySlot(equipLoc)
		return 
			uniqueInventorySlot=="INVTYPE_HEAD" or
			uniqueInventorySlot=="INVTYPE_NECK" or
			uniqueInventorySlot=="INVTYPE_SHOULDER" or
			uniqueInventorySlot=="INVTYPE_CHEST" or
			uniqueInventorySlot=="INVTYPE_WAIST" or
			uniqueInventorySlot=="INVTYPE_LEGS" or
			uniqueInventorySlot=="INVTYPE_FEET" or
			uniqueInventorySlot=="INVTYPE_WRIST" or
			uniqueInventorySlot=="INVTYPE_HAND" or
			uniqueInventorySlot=="INVTYPE_FINGER" or
			(uniqueInventorySlot=="INVTYPE_TRINKET" and DGV:UserSetting(DGV_SUGGESTTRINKET)) or
			uniqueInventorySlot=="INVTYPE_CLOAK" or
			uniqueInventorySlot==INVSLOT_MAINHAND or
			uniqueInventorySlot==INVSLOT_OFFHAND
	end
	
	local function StandardPredicate(criterion, link)
		return IsEquipment((select(9, GetItemInfo(link))))
	end
	
	local function CoinPredicate(criterion, item)
		for _, choice in GA.ItemChoiceIterator do
			if choice==item then return true end
		end
		return false
	end
	
	local WIN_CRITERIA_CURRENT = "Active Talent Specialization"
	local WIN_CRITERIA_INACTIVE_SPEC = "Inactive Talent Specialization"
	local WIN_CRITERIA_NONE = "None"
	local function SpecFromOption(option)
		if option==WIN_CRITERIA_NONE then return end
		local activeSpecName = select(2, GetSpecializationInfo(GetSpecialization()))
		local inactiveSpec = GetSpecialization(false, false, GetActiveSpecGroup()==1 and 2 or 1)
		local inactiveSpecName 
		if inactiveSpec then
			inactiveSpecName = select(2, GetSpecializationInfo(inactiveSpec))
		end
		local pvp
		local capture = option:match(L["(.*) %(PvP%)"])

		if capture then 
			pvp = true
		end
		if option==WIN_CRITERIA_CURRENT or capture==WIN_CRITERIA_CURRENT then
				return SpecFromLocalizedName(activeSpecName), pvp and L["%s (PvP)"]:format(activeSpecName) or activeSpecName, pvp
		elseif option==WIN_CRITERIA_INACTIVE_SPEC or capture==WIN_CRITERIA_INACTIVE_SPEC then
			if inactiveSpecName then
				return SpecFromLocalizedName(inactiveSpecName), pvp and L["%s (PvP)"]:format(inactiveSpecName) or inactiveSpecName, pvp
			end
		else
			local capture = option:match(L["(.*) %(PvP%)"])
			if capture then
				return SpecFromLocalizedName(capture), option, true
			end
			return SpecFromLocalizedName(option), option
		end
	end
	
	local WIN_CRITERIA_COIN = "Highest Vendor Price"
	local function WinCriteriaIterator(invariant, control)
		if not control then control = 0 end
		
		while true do
			control = control + 1
			local option = invariant[control]
			if not option then return end
			local spec, specName, pvp
			if option==WIN_CRITERIA_COIN then
				local criterion = GetCreateTable()
				criterion.Predicate = CoinPredicate
				criterion.GetScore = CoinCompare
				criterion.AdornReward = CoinRewardAdorner
				return control, WIN_CRITERIA_COIN, criterion
			else
				spec, specName, pvp = SpecFromOption(option)
			end
			local alreadyIterated
			if spec then
				for i=1,control-1 do
					local sfo, option, pfo = SpecFromOption(invariant[i])
					if spec==sfo and pvp==pfo then
						alreadyIterated = true
						break
					end
				end
			end
			if spec and not alreadyIterated then
				local criterion = GetCreateTable()
				criterion.specNum = spec
				criterion.pvp = pvp
				criterion.specName = specName
				criterion.Predicate = StandardPredicate
				criterion.GetScore = StandardCompare
				criterion.AdornReward = StandardRewardAdorner
				criterion.AdornLootRoll = StandardLootRollAdorner
				criterion.AdornEncounterJournal = StandardItemButtonAdorner
				criterion.AdornVendorItem = StandardItemButtonAdorner
				criterion.AdornLoot = StandardItemButtonAdorner
				criterion.SettleTie = StandardTiebreaker
				criterion.AdornTooltip = StandardTooltipAdorner
				return control, specName, criterion
			end
		end
	end
	
	function GA:IterateWinCriteria()
		return WinCriteriaIterator, DugisGuideViewer.chardb[DGV_GAWINCRITERIACUSTOM].options
	end
	
	local function Repaint(tooltip)
		tooltip:Show()
		local tipTextLeft = tooltip:GetName().."TextLeft"
		for i = 2, tooltip:NumLines() do
			local fontString = _G[tipTextLeft..i]
			_, relativeTo, _, xOfs, _ = fontString:GetPoint(0)
			fontString:ClearAllPoints()
			fontString:SetPoint("TOPLEFT", relativeTo, "BOTTOMLEFT", xOfs, -2)
		end
	end
	
	local function ItemIsInBag(link)
		for control,iteratedItemLink in ItemIterator,ITEM_ITERATOR_SKIP_ALL_EXTERNAL do
			if iteratedItemLink==link and control.bags then 
				control:Pool()
				return true 
			end
		end
	end
	
	local function IsNewItemTooltip(scores, link, newLink)
		if newLink~=link then
			return true
		end
	end
	
	local function PoolScores(scores)
		if scores then
			scores:TryReleaseLifetime(PoolScores)
			for _,score in scores:IPairs() do
				if type(score)=="table" then
					score:Pool()
				end
			end
			scores:Pool()
		end
	end
	
	local function ProcessTooltipRoutine(tooltip, link)
		local cacheReaction = TryGetCacheReaction("ProcessTooltipRoutine")
		local scores
		if not cacheReaction then
			local reqLevel = select(5, GetItemInfo(link))
			local playerLevel = UnitLevel("player")
			if reqLevel and playerLevel and reqLevel>playerLevel and ItemIsInBag(link) then return end
			for index, option,criterion in GA:IterateWinCriteria() do
				criterion:BindToAutoroutineLifetime(tPool)
				local score, altWinner, altScore = EvaluateWinCriteron(criterion, link)
				if score then
					if not scores then
						scores = GetCreateTable():BindToAutoroutineLifetime(PoolScores)
					end
					if altWinner then
						scores[index] = GetCreateTable(score, altWinner, altScore)
					else
						scores[index] = score
					end
				end
				criterion:Pool()
			end
			if scores then 
				scores:TryReleaseLifetime(PoolScores)
			end
			RegisterReaction()
				:InvokePassively()
				:WithAction(PoolScores, scores)
				:WithPredicate(IsNewItemTooltip, link)
				:SetCache("ProcessTooltipRoutine", scores)
		else
			scores = cacheReaction:UnpackCache()
		end
		if not scores then return end
		for index, option,criterion in GA:IterateWinCriteria() do
			criterion:BindToAutoroutineLifetime(tPool)
			local score, altWinner, altScore = scores[index]
			if score then
				if type(score)=="table" then
					score, altWinner, altScore = score:Unpack()
				end
				if criterion.AdornTooltip then
					criterion:AdornTooltip(tooltip, link, altWinner, score, altScore)
				else
					FallbackTooltipAdorner(tooltip, option)
				end
			end
			criterion:Pool()
		end
		
		Repaint(tooltip)
	end
	
	function ProcessTooltip(tooltip, name, link, ...)
		if tooltip:GetName():match("ShoppingTooltip") then return end

		local cacheReaction = TryGetCacheReaction("ProcessTooltipRoutine")
		if cacheReaction then
			cacheReaction:TryInvoke(link)
			cacheReaction = TryGetCacheReaction("ProcessTooltipRoutine")
		end
		if not cacheReaction then
			if not GetRunningAutoroutine("ProcessTooltipRoutine") then
				BeginAutoroutine("ProcessTooltipRoutine", ProcessTooltipRoutine, tooltip, link)
			end
		else
			ProcessTooltipRoutine(tooltip, link)
		end
	end

	local orig_GetNumEquipmentSets = GetNumEquipmentSets
	local orig_GetEquipmentSetInfo = GetEquipmentSetInfo
	local orig_GetEquipmentSetInfoByName = GetEquipmentSetInfoByName
	local orig_GetEquipmentSetItemIDs = GetEquipmentSetItemIDs
	local equipmentSetDataTable = {}
	local equipmentSetIdTable = {}
	setmetatable(equipmentSetIdTable, {
		__index = function(self, i)
			local link = rawget(equipmentSetDataTable, i)
			if i==INVSLOT_RANGED then return 0 end
			if i==INVSLOT_BODY or i==INVSLOT_TABARD then return EQUIPMENT_SET_IGNORED_SLOT end
			return link and DGV:GetItemIdFromLink(link) or EQUIPMENT_SET_IGNORED_SLOT, link
		end,
	})
	
	local bagUpdateReaction, levelUpReaction, activeSpecReaction, smartSetReaction, rewardShowReaction, questHideReaction, adornerParentShowReaction, equipExecutedReaction, 
		lootRollShowReaction, encounterJournalUpdateReaction, vendorUpdateReaction, lootUpdateReaction
	function GA:Load()
		TipHooker:Hook(ProcessTooltip, "item")
		TipHooker:RegisterCustomTooltip("item", "WorldMapTooltip")
        
        --Outfitter bugfix
        if Outfitter then
            hooksecurefunc(Outfitter, "Item_CheckboxClicked", function()
                GA.lastOutfitterClickedTime = GetTime()
            end)
        end
	
		local function SmartSetShown()
			if DugisGuideViewer.armoryloaded or DugisGuideViewer.outfitterloaded or DugisGuideViewer.arkinventoryloaded then 
				return false 
			else 
				return DGV:UserSetting(DGV_GASMARTSETTARGET)~=WIN_CRITERIA_NONE
			end
		end
		
		function GetNumEquipmentSets()
            if isCalledByBag_nonAddon() then
                return orig_GetNumEquipmentSets()
            end          
        
			local add = SmartSetShown() and 1 or 0
			return orig_GetNumEquipmentSets()+add
		end
		
		local function IsInOtherSlot(itemId, slot)
			local otherSlot
			if slot==INVSLOT_TRINKET1 then
				otherSlot = INVSLOT_TRINKET2
			elseif slot==INVSLOT_TRINKET2 then
				otherSlot = INVSLOT_TRINKET1
			elseif slot==INVSLOT_FINGER1 then
				otherSlot = INVSLOT_FINGER2
			elseif slot==INVSLOT_FINGER2 then
				otherSlot = INVSLOT_FINGER1
			else return
			end
			local link = GetInventoryItemLink("player", otherSlot)
			return link and DGV:GetItemIdFromLink(link)==itemId
		end
		
		local function SmartSetIsEquipped(cachedOnly)
			local result = GA:GetSpecDataTable(nil, nil, equipmentSetDataTable, nil, nil, cachedOnly)
			if not result and cachedOnly and not GetRunningAutoroutine("CacheEquipmentSetDataTableRoutine") then
				BeginAutoroutine("CacheEquipmentSetDataTableRoutine", GA.GetSpecDataTable, GA, nil, nil, equipmentSetDataTable):OnCompletion(PaperDollEquipmentManagerPane_Update)
				return 
			end
			for slot,link in nextValidSlot, true do
				local setLink = equipmentSetDataTable[slot]
				local setId = equipmentSetIdTable[slot]
				local id = link and DGV:GetItemIdFromLink(link)
				if 
					setLink and
					(not link or setId~=id) and
					not IsInOtherSlot(setId, slot)
				then 
					return false
				end
			end
			return true
		end
		
		local function GetSpecIcon()
			return (select(4, GetSpecializationInfo((SpecFromOption(DGV:UserSetting(DGV_GASMARTSETTARGET))))))
		end
		
		-- name, icon, setID, isEquipped, numItems, numEquipped, numInventory, numMissing, numIgnored = GetEquipmentSetInfo(index)
		-- Arguments:
		-- index - Index of an equipment set (between 1 and GetNumEquipmentSets()) (number)
		-- Returns:
		-- name - Name of the equipment set (string)
		-- icon - Path to an icon texture for the equipment set (string)
		-- setID - Internal ID number for the set (not used elsewhere in API) (number)
		-- isEquipped - If the set is equipped returns true, if not, false (boolean)
		-- numItems - Number of items in the set (number)
		-- numEquipped - Number of items in the set currently equipped (number)
		-- numInventory - Number of items from the set in current bags (number)
		-- numMissing - Number of items missing from the set (current bags) (number)
		-- numIgnored - Number of ignored slots (number)
		function GetEquipmentSetInfo(index)
            if isCalledByBag_nonAddon() then
                return orig_GetEquipmentSetInfo(index)
            end            
        
			if index==1 and SmartSetShown() then
				local cacheReaction = TryGetCacheReaction("GetEquipmentSetInfo") --keep a cache until next update.  Some addons call this a lot.
				if cacheReaction then
					return cacheReaction:UnpackCache()
				end
				
				local isEquipped = SmartSetIsEquipped(true)
				return RegisterStopwatchReaction(0):SetCache("GetEquipmentSetInfo",
					L["Dugi Smart Set"], 
					GetSpecIcon(), 
					MAX_EQUIPMENT_SETS_PER_PLAYER, 
					isEquipped, 
					16, 
					isEquipped and 16 or 0, 
					isEquipped and 0 or 16, 
					0, 
					2):UnpackCache()
			else
				return orig_GetEquipmentSetInfo(SmartSetShown() and index-1 or index)
			end
		end
		
		-- Returns information about an equipment set
		-- See also Equipment Manager functions.
		-- Signature:
		-- icon, setID, isEquipped, numItems, numEquipped, unknown, numMissing, numIgnored = GetEquipmentSetInfoByName("name")
		-- Arguments:
		-- name - Name of an equipment set (case sensitive) (string)
		-- Returns:
		-- icon - Path to an icon texture for the equipment set (string)
		-- setID - Internal ID number for the set (not used elsewhere in API) (number)
		-- isEquipped - If the set is equipped returns true, if not, false (boolean)
		-- numItems - Number of items in the set (number)
		-- numEquipped - Number of items in the set currently equipped (number)
		-- unknown - Unknown, always seem to be 0 (number)
		-- numMissing - Number of items missing from the set (current bags) (number)
		-- numIgnored - Number of ignored slots (number)
		function GetEquipmentSetInfoByName(name)
            if isCalledByBag_nonAddon() then
                return orig_GetEquipmentSetInfoByName(name)
            end        
        
			if name==L["Dugi Smart Set"] and SmartSetShown() then
				local isEquipped = SmartSetIsEquipped(true)
--DGV:DebugFormat("GetEquipmentSetInfoByName", "isEquipped", isEquipped)
				return GetSpecIcon(), MAX_EQUIPMENT_SETS_PER_PLAYER, isEquipped, 16, isEquipped and 16 or 0, 0, 0, 2
			else
				return orig_GetEquipmentSetInfoByName(name)
			end
		end
		
		local function GetItemForTable(uniqueInventorySlot, spec, pvp, enforceArmorSpecSubclass, uncapped)
			local sfo, option, pfo = SpecFromOption(DGV:UserSetting(DGV_GASMARTSETTARGET))
			spec = spec or sfo
			pvp = pvp or pfo
			local winner, winScore, altWinner, altScore, armorSpecStatValue = GetCurrentBestInSlot(uniqueInventorySlot, spec, pvp, nil, ITEM_ITERATOR_SKIP_ALL_EXTERNAL, enforceArmorSpecSubclass, uncapped)
			return winner, altWinner, armorSpecStatValue, (winScore or 0)+(altScore or 0)
		end
		
		local function PoolCachedDataTable(reaction, ...)
			local dataTable = reaction:UnpackCache()
			if not dataTable:IsBoundToAutoroutineLifetime() then
--DGV:DebugFormat("PoolCachedDataTable", "dataTable", tostring(dataTable))
				dataTable:Pool()
				return
			end
--DGV:DebugFormat("PoolCachedDataTable cacheInValid")
			dataTable.cacheInValid = true

		end
		
		function GA:GetSpecDataTable(spec, pvp, preferredTable, enforceArmorSpecSubclass, uncapped, cachedOnly)
--DGV:DebugFormat("GetSpecDataTable 1", "spec", spec)
			local sfo, option, pfo = SpecFromOption(DGV:UserSetting(DGV_GASMARTSETTARGET))
			spec = spec or sfo
			pvp = pvp or pfo
			local cacheKey = strformat("%s%d%s%s%s%s", "GetSpecDataTable", spec, pvp and "true" or "false", tostring(preferredTable), tostring(enforceArmorSpecSubclass), uncapped and "true" or "false")
			local cacheReaction = TryGetCacheReaction(cacheKey)
			if cacheReaction then
				return cacheReaction:UnpackCache()
			end
			if cachedOnly then return end
			local dataTable = preferredTable and wipe(preferredTable) or GetCreateTable()
--DGV:DebugFormat("GetSpecDataTable", "dataTable", tostring(dataTable))
			dataTable.ArmorSpecStatTotal , dataTable.ScoreTotal = 0,0
			for unique,inv1,inv2 in NextUniqueInventorySlot do
				local winner, altWinner, armorSpecStatValue, score = GetItemForTable(unique, spec, pvp, enforceArmorSpecSubclass, uncapped)
				dataTable.ArmorSpecStatTotal = dataTable.ArmorSpecStatTotal + (armorSpecStatValue or 0)
				dataTable.ScoreTotal = dataTable.ScoreTotal + score
				dataTable[inv1] = winner
				if inv2 then
					dataTable[inv2] = altWinner
				end
			end
			
			local reaction = RegisterStopwatchReaction(2):Or(RegisterReaction("BAG_UPDATE")):SetCache(cacheKey, dataTable)
			if not preferredTable then
				reaction:WithAction(PoolCachedDataTable)
			end
			return dataTable
		end
		
        --Underscore in the function name is used to avoid detecting "Bagnon" in the stacktrace the test function name
        function isCalledByBag_nonAddon()
            local stack = debugstack()
            local isCalledByBagnonAddon = (string.find(stack, "Bagnon") ~= nil)
            return  isCalledByBagnonAddon
        end
        
		-- Returns a table listing the items in an equipment set
		-- See also Equipment Manager functions.
		-- Signature:
		-- itemIDs = GetEquipmentSetItemIDs("name")
		-- Arguments:
		-- name - Name of an equipment set (case sensitive) (string)
		-- Returns:
		-- itemIDs - A table listing the itemIDs of the set's contents, keyed by inventoryID (table)
		--EQUIPMENT_SET_IGNORED_SLOT 
		function GetEquipmentSetItemIDs(name)
            if isCalledByBag_nonAddon() then
                return orig_GetEquipmentSetItemIDs(name)
            end
        
			if name==L["Dugi Smart Set"] then
				GA:GetSpecDataTable(nil, nil, equipmentSetDataTable)
				return equipmentSetIdTable
			else
				return orig_GetEquipmentSetItemIDs(name)
			end
		end
		
		function PaperDollFrame_IgnoreSlotsForSet (setName)
			local set = GetEquipmentSetItemIDs(setName);
			for slot, item in ipairs(set) do
				if ( item == EQUIPMENT_SET_IGNORED_SLOT ) then
					EquipmentManagerIgnoreSlotForSave(slot);
					itemSlotButtons[slot].ignored = true;
					PaperDollItemSlotButton_Update(itemSlotButtons[slot]);
				end
			end
		end
		
		PaperDollEquipmentManagerPane:HookScript("OnUpdate", function ()
			if GA.loaded then
				for i = 1, #PaperDollEquipmentManagerPane.buttons do
					local button = PaperDollEquipmentManagerPane.buttons[i]
					if button.name==L["Dugi Smart Set"] then
						button.DeleteButton:Hide()
						button.EditButton:Hide()
					end
				end
				if PaperDollEquipmentManagerPane.selectedSetName==L["Dugi Smart Set"] then
					PaperDollEquipmentManagerPaneSaveSet:Disable()
				end
			end
		end)
		
		local function RunAdditionalAction(action)
			EquipmentManager_RunAction(action)
			action:Pool()
			--ClearCursor() --was preventing BoE equip
		end
		
		local function EquipmentChangedPredicate(reaction, event, slotOrElapsed, hasItem, ...)
			--DGV:DebugFormat("EquipmentChangedPredicate", "event", event, "slotOrElapsed", slotOrElapsed, "hasItem", hasItem, "reaction.requestedSlots", reaction.requestedSlots)
			if event=="time" and reaction.requestedSlots then
				return true
			elseif event=="PLAYER_EQUIPMENT_CHANGED" and hasItem and reaction.requestedSlots then
				reaction.requestedSlots:RemoveFirst(slotOrElapsed)
				return #reaction.requestedSlots==0
			end
		end
		
		local function EquipmentChangedAction(reaction, event, slotOrElapsed, hasItem, ...)
			if equipExecutedReaction.requestedSlots then
				equipExecutedReaction.requestedSlots:Pool()
				equipExecutedReaction.requestedSlots = nil
			end
			equipExecutedReaction:Dispose()
			equipExecutedReaction = nil
		end
		
		local EQUIP_ITEM, UNEQUIP_ITEM, SWAP_ITEM = 1,2,3
		local function ExecuteEquip(slot, action)
			ClearCursor()
			if (slot==INVSLOT_MAINHAND or slot==INVSLOT_OFFHAND) and action.player and not action.bags then --we may not be able to swap weapons in place
				if slot==action.slot then return end --already holding
				local requestedHand = slot
				action.type = UNEQUIP_ITEM
				action.invSlot = slot;
				EquipmentManager_RunAction(action)
				ClearCursor()
				local additionalAction = GetCreateTable()
				additionalAction.player = true
				additionalAction.slot = action.slot
				additionalAction.invSlot = slot
				additionalAction.type = EQUIP_ITEM
				QueueInvocation(RunAdditionalAction, additionalAction)
				return
			else
				action.type = (GetInventoryItemID("player", slot) and SWAP_ITEM) or EQUIP_ITEM;
				action.invSlot = slot;
				EquipmentManager_RunAction(action)
				--ClearCursor() --was preventing BoE equip
			end
			if not equipExecutedReaction then
				equipExecutedReaction = RegisterReaction("PLAYER_EQUIPMENT_CHANGED")
					:Or(RegisterStopwatchReaction(5))
					:WithPredicate(EquipmentChangedPredicate)
					:WithAction(EquipmentChangedAction)
			end
			if not equipExecutedReaction.requestedSlots then
				equipExecutedReaction.requestedSlots = GetCreateTable()
			end
			equipExecutedReaction:Reset()
			equipExecutedReaction.requestedSlots:Insert(slot)
		end
		
		local function IsSecondSlot(slot)
			return slot==INVSLOT_OFFHAND or slot==INVSLOT_FINGER2 or slot==INVSLOT_TRINKET2
		end
		
		local function GetCopyEquipAction(action, copy)
			local copy = copy or GetCreateTable()
			copy.slot = action.slot
			copy.bag = action.bag
			copy.player = action.player
			copy.bank = action.bank
			copy.bags = action.bags
			return copy
		end
		
		local function FindEquip(slot, itemLink, skip)
			local lastMatch
			for control,iteratedItemLink in ItemIterator,skip do
				if itemLink==iteratedItemLink then
					if IsSecondSlot(slot) then
						lastMatch = GetCopyEquipAction(control, lastMatch)
					else
						ExecuteEquip(slot, control)
						control:Pool()
						return true
					end
				end
			end
			if lastMatch then
				ExecuteEquip(slot, lastMatch)
				lastMatch:Pool()
				return true
			end
		end
		
		local function Equip(slot, itemLink)
			if itemLink~=nil and not ItemIsBanned(itemLink) then
				if not FindEquip(slot, itemLink, bit.bor(ITEM_ITERATOR_SKIP_EQUIPPED, ITEM_ITERATOR_SKIP_ALL_EXTERNAL)) then
					FindEquip(slot, itemLink, ITEM_ITERATOR_SKIP_ALL_EXTERNAL)
				end
			end
		end
		
		local function ContinueEquipRoutine(showPrompt, continueFromSlot)
			if SmartSetIsEquipped() then return end
			GA:GetSpecDataTable(nil, nil, equipmentSetDataTable)
			local diff = GetCreateTable()
			for slot,itemLink in next,equipmentSetDataTable,equipmentSetDataTable[continueFromSlot] and continueFromSlot do
				if type(slot)=="number" then
					local currentItemLink = GetInventoryItemLink("player", slot)
					local currentItemId = currentItemLink and DGV:GetItemIdFromLink(currentItemLink)
					local id = itemLink and DGV:GetItemIdFromLink(itemLink)
					if itemLink and id~=currentItemId and not IsInOtherSlot(id, slot) then
						diff:Insert(slot)
					end
				end
			end
			local continue, showPrompt, remaining = nil, showPrompt, #diff
			for _,slot in diff:IPairs() do
				local itemLink = equipmentSetDataTable[slot]
				continue, showPrompt, remaining = GA:Equip(slot,itemLink,showPrompt,remaining)
				if not continue then break end
			end
			diff:Pool()
		end
		
		local function ContinueEquip(showPrompt, continueFromSlot)
			if GetRunningAutoroutine("ContinueEquipRoutine") then return end
			QueueAutoroutine("ContinueEquipRoutine", ContinueEquipRoutine, showPrompt, continueFromSlot)
		end
		
		local function ClearCompareLines()
			if not DugisEquipPromptFrame.compare then return end
			for _,fontString in ipairs(DugisEquipPromptFrame.compare) do
				fontString:Hide()
			end
		end
		
		local function AddSetCompareLine(text, r, g, b, a)
			if not DugisEquipPromptFrame.compare then DugisEquipPromptFrame.compare = {} end
			local toSet
			for _,fontString in ipairs(DugisEquipPromptFrame.compare) do
				if not fontString:IsShown() then 
					toSet = fontString
					break
				end
			end
			if not toSet then
				toSet = DugisEquipPromptFrame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
				toSet:SetJustifyH("LEFT")
				toSet:SetJustifyV("TOP")
				tinsert(DugisEquipPromptFrame.compare, toSet)
				if #DugisEquipPromptFrame.compare==1 then
					toSet:SetPoint("TOPLEFT", DugisEquipPromptFrame.recommended, "TOPRIGHT", 15, 0)
				else
					toSet:SetPoint("TOPLEFT", DugisEquipPromptFrame.compare[#DugisEquipPromptFrame.compare-1], "BOTTOMLEFT")
				end
			end
			toSet:SetHeight(13)
			toSet:SetWidth(1000)
			toSet:SetText(text)
			local width = toSet:GetStringWidth()
			if width>170 then
				toSet:SetHeight(13+math.floor(width/160)*13)
			end
			if r then
				toSet:SetTextColor(r,g,b)
			end
			toSet:SetWidth(170)
			toSet:Show()
		end
		
		function GA:GetSlotBackgroundInfo(slot)
			local slotFrame = ListContains(slot, 
				function(frame)
					return (GetInventorySlotInfo(strsub(frame:GetName(),10)));
				end,
				PaperDollItemsFrame:GetChildren())
			return _G[strupper(strsub(slotFrame:GetName(), 10))], slotFrame.backgroundTextureName 
		end
		
		local tempIgnoreCache = {}
		function GA:Equip(slot, itemLink, showPrompt, remaining)
			if tContains(tempIgnoreCache, itemLink..slot) then return end --avoids nagging over and over for the same piece in the same slot without long term ban listing (reset by manual gear set equip or reload ui)
			local currentItemLink = GetInventoryItemLink("player", slot)
			remaining = remaining and remaining-1
			if currentItemLink==itemLink then
				return true, showPrompt, remaining
			end
			if --[[not currentItemLink or]] not showPrompt or not DGV:UserSetting(DGV_SHOWAUTOEQUIPPROMPT) then --commented to show prompt if slot is empty
				Equip(slot, itemLink)
				return true, showPrompt, remaining
			else
                DugisEquipPromptFrame.slot = slot
				DugisEquipPromptFrame.recommended.item = itemLink
				DugisEquipPromptFrame.recommended.title = L["Equip recommended item:"]
				DugisEquipPromptFrame.action = "EQUIP"
				DugisEquipItemHighlight:SetPoint("TOPLEFT", DugisEquipPromptFrame.recommended.itemButton, "TOPLEFT", -8, 7)
				DugisEquipItemHighlight:Show()
				
				DugisEquipPromptFrame.forAll:Enable()
				DugisEquipPromptFrame.forAll.text:SetTextColor(1.0, 0.82, 0)
				if remaining and remaining>0 then
					DugisEquipPromptFrame.forAll:SetChecked(false)
					DugisEquipPromptFrame.forAll.text:SetText(L["Do above for remaining %d items"]:format(remaining))
					DugisEquipPromptFrame.forAll:Show()
				else
					DugisEquipPromptFrame.forAll:Hide()
				end
				DugisEquipPromptFrame.blacklist:SetChecked(false)
				DugisEquipPromptFrame.blacklist.text:SetText(L["Add %s to ban list"]:format(itemLink))
				DugisEquipPromptFrame.blacklist.text:SetWidth(352)
				DugisEquipPromptFrame.blacklist.text:SetJustifyH("LEFT")
				
				ClearCompareLines()
				local statTable = GetCreateTable()
				if currentItemLink then
					DugisEquipPromptFrame.existing.item = currentItemLink
					DugisEquipPromptFrame.existing.title = L["Or keep equipped item:"]
					GetItemStatDelta(itemLink, currentItemLink, statTable)
					AddSetCompareLine(ITEM_DELTA_DESCRIPTION)
				else
					DugisEquipPromptFrame.existing.item = nil
					DugisEquipPromptFrame.existing.title = L["Or leave slot empty:"]
					GetItemStats(itemLink, statTable)
					AddSetCompareLine(L["Item has the following stats:"])
				end
				DugisGuideViewer:HideLargeWindow()
				DugisEquipPromptFrame:Show()
				DugisEquipPromptFrame.compare[1]:Hide()
				for stat, value in pairs(statTable) do
					if stat~="n" and _G[stat] and type(value)=="number" then
						DugisEquipPromptFrame.compare[1]:Show()
						local color = "ff00ff00"
						if value < 0 then
							color = "ffff2020"
						end
						if mod(value, 1)==0 then
							AddSetCompareLine(L["|c%s%d|r %s"]:format(color, value, _G[stat]), 1, 1, 1) --Localization: enUS uses number-space-statname
						else
							AddSetCompareLine(L["|c%s%.1f|r %s"]:format(color, value, _G[stat]), 1, 1, 1)
						end
					end
				end
				statTable:Pool()
			end
		end
		
		local function EquipmentChangedContinueEquipPredicate(reaction, requestedSlot, event, slot, hasItem)
			return hasItem and requestedSlot==slot
		end
		
		local function EquipmentChangedContinueEquipAction(reaction, requestedSlot, event, slot, hasItem)
			ContinueEquip(true, requestedSlot)
		end
		
		function GA:OnPromptHidden(prompt)
			prompt.action = not prompt.blacklist:GetChecked() and prompt.action
			local quit = (prompt.forAll:GetChecked() and prompt.action == "SKIP") or prompt.action == "CANCEL"
			local showPrompt = not prompt.forAll:GetChecked()
			if prompt.blacklist:GetChecked() then
				if not DGV.chardb.GA_Blacklist then DGV.chardb.GA_Blacklist = {} end
				DGV.chardb.GA_Blacklist[DGV:GetItemIdFromLink(prompt.recommended.item)] = true
			end
			if prompt.action == "EQUIP" then
				if not showPrompt then
					ContinueEquip(false, prompt.slot)
				else
					RegisterReaction("PLAYER_EQUIPMENT_CHANGED"):WithPredicate(EquipmentChangedContinueEquipPredicate):WithAction(EquipmentChangedContinueEquipAction, prompt.slot):Once()
				end
				Equip(prompt.slot, prompt.recommended.item)
				
				return
			end
			if prompt.action == "SKIP" then
				tinsert(tempIgnoreCache, prompt.recommended.item..prompt.slot)
			end
			if not quit then
				ContinueEquip(showPrompt, prompt.slot)
			end
		end
		
		function GA:OnGearOptionClicked(button)
			if button==DugisEquipPromptFrame.recommended then
				DugisEquipPromptFrame.action="EQUIP"
			else
				DugisEquipPromptFrame.action="SKIP"
			end
		end
		
		local function AutoEquipEnabled()
			return DGV:UserSetting(DGV_AUTOEQUIPSMARTSET)
		end
		
		function GA.AutoEquipSmartSet(reaction, clearTempIgnore, button)
			if not InCombatLockdown() then
				if DGV:UserSetting(DGV_GASMARTSETTARGET)==WIN_CRITERIA_NONE or (not AutoEquipEnabled() and not button) then return end
				if clearTempIgnore then
					wipe(tempIgnoreCache)
				end
				ContinueEquip(true, nil)
			else
				DoOutOfCombat(GA.AutoEquipSmartSet, reaction, clearTempIgnore)
			end
		end
		
		local function NoEquipInProgress()
			return not DugisEquipPromptFrame:IsShown() and (not equipExecutedReaction or equipExecutedReaction.invoked)
		end
		
		local lastBUFire
		local function BagUpdatePredicate()
			local elapsed = GetTime()
			if lastBUFire==elapsed then return end
			lastBUFire = elapsed
			return AutoEquipEnabled() and NoEquipInProgress()
		end
		
		bagUpdateReaction = RegisterReaction("BAG_UPDATE", BagUpdatePredicate, function()
            
        --Outfitter bugfix
        if GA.lastOutfitterClickedTime == nil or (GetTime() - GA.lastOutfitterClickedTime) > 4 then
            GA.AutoEquipSmartSet()
        end
        
        end):Defer()
		--levelUpReaction = RegisterReaction("PLAYER_LEVEL_UP", AutoEquipEnabled, GA.AutoEquipSmartSet, true)
		activeSpecReaction = RegisterReaction("ACTIVE_TALENT_GROUP_CHANGED", AutoEquipEnabled, GA.AutoEquipSmartSet, true)
		
		local function SmartSetPredicate(reaction, clearTempIgnore, setName)
			return setName==L["Dugi Smart Set"]
		end
		smartSetReaction = RegisterFunctionReaction("EquipmentManager_EquipSet", SmartSetPredicate, GA.AutoEquipSmartSet, true)
		if AutoEquipEnabled() then QueueInvocation(GA.AutoEquipSmartSet) end
		
		local function HideRewardGuidance()
			DugisCoinRewardAdornment:Hide()
			DugisGreenArrowRewardAdornment:Hide()
			DugisYellowArrowRewardAdornment:Hide()
		end
		
		local function EvaluateRewards()
			if QuestFrameRewardPanel:IsShown() then
				local questId = GetQuestID()
				local questLogIndex
				if questId then 
					questLogIndex = GetQuestLogIndexByID(questId);				 
					SelectQuestLogEntry(questLogIndex); --Blizzard bug? need this since GetNumQuestLogChoices or GetNumQuestChoices always returns 0 otherwise. 
				end
			end
			
			HideRewardGuidance()
			local selectionMade
			for _, option,criterion in GA:IterateWinCriteria() do
				criterion:BindToAutoroutineLifetime(tPool)
				local winScore, winLink, winFrame, unresolvableTie
				for _, link, frame in GA.ItemChoiceIterator do
					local score = EvaluateWinCriteron(criterion, link)
					if score and (not winScore or winScore<score) then
						winScore = score
						winLink = link
						winFrame = frame
					elseif criterion.SettleTie and score and winScore==score then
						winLink = criterion:SettleTie(winLink, link)
						winFrame = winLink==link and frame or winFrame
						winScore = winLink==link and score or winScore
					elseif not criterion.SettleTie and score and winScore==score then
						unresolvableTie = true
					end
				end
				if winLink then
					if not selectionMade then
                        
                        if Storyline_NPCFrame and Storyline_NPCFrame:IsShown() then
                            local buttonToBeHighlighted = GetStorylineButtonByRewardName(winFrame.Name:GetText())
                            
                            if buttonToBeHighlighted then
                                if glowRewardFrame == nil then
                                    CreateFrame("Frame", "glowRewardFrame", buttonToBeHighlighted)
                                    texture = glowRewardFrame:CreateTexture()
                                    texture:SetAllPoints()
                                    texture:SetBlendMode("ADD")
                                    texture:SetTexture("Interface\\QuestFrame\\UI-QuestItemHighlight")  
                                end
                                
                                glowRewardFrame:SetWidth(256)
                                glowRewardFrame:SetHeight(64)
                                glowRewardFrame:SetFrameStrata("DIALOG") 
                                buttonToBeHighlighted:SetFrameLevel(500)
                               
                                glowRewardFrame:SetPoint("TOPLEFT", buttonToBeHighlighted, "TOPLEFT", -8, 7);

                                glowRewardFrame:Show()
                            else
                                if glowRewardFrame then
                                    glowRewardFrame:Hide()
                                end
                            end
                        end
                    
						QueueInvocation(winFrame:GetScript("OnClick"), winFrame)
						selectionMade = true
					end
					criterion:AdornReward(winLink, winFrame)
				end
				criterion:Pool()
			end
		end
        
        GA.EvaluateRewards = EvaluateRewards
		
		local function ShouldShowQuestItems()
			local getNumChoices = QuestInfoFrame.questLog and GetNumQuestLogChoices or GetNumQuestChoices
			return getNumChoices()>1 --one choice is no choice at all 
		end
		
		local lastRewardFrameShow
		local function DeferredRewardFrameShow(frame, elapsed) --first QuestInfoRewardsFrame:Show gets spammed
			if lastRewardFrameShow~=elapsed then
				lastRewardFrameShow = elapsed
				InterruptAutoroutine("EvaluateRewards")
				QueueAutoroutine("EvaluateRewards", EvaluateRewards)
			end
		end
		rewardShowReaction = RegisterMemberFunctionReaction(QuestInfoRewardsFrame, "Show", ShouldShowQuestItems):
			Or(RegisterMemberFunctionReaction(MapQuestInfoRewardsFrame, "Show", ShouldShowQuestItems)):
			WithAction(DeferredRewardFrameShow):Defer():InvokePassively()
		questHideReaction = RegisterMemberFunctionReaction(QuestInfoRewardsFrame, "Hide"):WithAction(HideRewardGuidance)
		adornerParentShowReaction = RegisterMemberFunctionReaction(QuestInfoRewardsFrame, "Show"):WithAction(HideRewardGuidance)
		
		local function HideLootRollGuidance()
			for i=1,NUM_GROUP_LOOT_FRAMES do
				local lootFrame = _G["GroupLootFrame"..i]
				if lootFrame and lootFrame.dugisGreenArrow then
					lootFrame.dugisGreenArrow:Hide()
				end
			end
		end
		
		local function EvaluateLootRollRoutine()
			HideLootRollGuidance()
			for _, option,criterion in GA:IterateWinCriteria() do
				criterion:BindToAutoroutineLifetime(tPool)
				for _, link, frame in GA.LootRollIterator do
					local score = EvaluateWinCriteron(criterion, link)
					if score and criterion.AdornLootRoll then
						criterion:AdornLootRoll(link, frame)
					end
				end
				criterion:Pool()
			end
		end
		
		local function EvaluateLootRoll()
			InterruptAutoroutine("EvaluateLootRollRoutine")
			QueueAutoroutine("EvaluateLootRollRoutine", EvaluateLootRollRoutine)
		end
		
		lootRollShowReaction = RegisterFunctionReaction("GroupLootFrame_OpenNewFrame"):WithAction(EvaluateLootRoll)
		
		local orig_GetLootRollTimeLeft, orig_GetLootRollItemLink, orig_GetLootRollItemInfo
		local function UndoMockGroupLoot()
			DGV:DebugFormat("UndoMockGroupLoot")
			GroupLootContainer_RemoveFrame(GroupLootContainer, GroupLootFrame1)
			GetLootRollTimeLeft = orig_GetLootRollTimeLeft
			GetLootRollItemLink = orig_GetLootRollItemLink
			GetLootRollItemInfo = orig_GetLootRollItemInfo
			orig_GetLootRollTimeLeft, orig_GetLootRollItemLink, orig_GetLootRollItemInfo = nil, nil, nil
		end
		
		local function OverrideGetLootRollTimeLeft(durationMillis)
			orig_GetLootRollTimeLeft = GetLootRollTimeLeft
			local nowMillis = GetTime()*100
			GetLootRollTimeLeft = function()
				return durationMillis - (GetTime()*100-nowMillis)
			end
		end
		
		local function OverrideGetLootRollItemLink(item)
			orig_GetLootRollItemLink = GetLootRollItemLink
			GetLootRollItemLink = function() return item end
		end
		
		local function OverrideGetLootRollItemInfo(item)
			orig_GetLootRollItemInfo = GetLootRollItemInfo
			GetLootRollItemInfo = function() 
				local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType,

					itemStackCount, itemEquipLoc, itemTexture, itemSellPrice =
					GetItemInfo(item)	
				return itemTexture, itemName, 1, itemRarity, 1, 1, 1, 1
			end
		end
		
		function MockGroupLoot(item, duration)
			DGV:DebugFormat("MockGroupLoot", "item",item,"duration", duration)
			if orig_GetLootRollTimeLeft then return end
			local durationMillis = duration*100
			OverrideGetLootRollTimeLeft(durationMillis)
			OverrideGetLootRollItemLink(item)
			OverrideGetLootRollItemInfo(item)
			GroupLootFrame_OpenNewFrame(1, durationMillis)
			RegisterStopwatchReaction(duration):Once():WithAction(UndoMockGroupLoot)
		end
		
		local function HideEncounterJournalGuidance()
			local scrollFrame = EncounterJournal.encounter.info.lootScroll;
			local items = scrollFrame.buttons;
			 
			for _,button in ipairs(items) do
				if button.dugisGreenArrow then
					button.dugisGreenArrow:Hide()
				end
				if button.dugisYellowArrow then
					button.dugisYellowArrow:Hide()
				end
			end
		end
		
		local function EvaluateEncounterJournalRoutine()
			HideEncounterJournalGuidance()
-- if DGV.currentAutoroutine then
-- DGV:DebugFormat("EvaluateEncounterJournalRoutine 1", "time", DGV.GetTicks()-DGV.currentAutoroutine.startTime)
-- end
			if 
				EncounterJournal and
				EncounterJournal:IsShown() and
				EncounterJournal.encounter.info.lootScroll:IsShown()
			then
				local greenedSlots = GetCreateTable():BindToAutoroutineLifetime(tPool)
				for slot,inv1,inv2 in NextUniqueInventorySlot do
					for criterionIndex, option,criterion in GA:IterateWinCriteria() do
						criterion:BindToAutoroutineLifetime(tPool)
						if criterion.AdornEncounterJournal then
-- if DGV.currentAutoroutine then
-- DGV:DebugFormat("EvaluateEncounterJournalRoutine 2", "time", DGV.GetTicks()-DGV.currentAutoroutine.startTime, "slot", slot, "criterionIndex", criterionIndex)
-- end
							local winningItem, winningScore, altWinner, altScore = GetCurrentBestInSlot(slot, criterion.specNum, criterion.pvp, nil, nil, nil, nil, true)
-- if DGV.currentAutoroutine then
-- DGV:DebugFormat("EvaluateEncounterJournalRoutine 3", "time", DGV.GetTicks()-DGV.currentAutoroutine.startTime, "slot", slot, "criterionIndex", criterionIndex)
-- end
							
							for _, link, frame in GA.EncounterJournalIterator do
								if criterion:Predicate(link, unpack(criterion)) then
									if slot==INVSLOT_MAINHAND and link==altWinner then 
										slot = INVSLOT_OFFHAND
										winningItem = link
									end
									
									if link==winningItem then
										if frame then
											criterion:AdornEncounterJournal(link, frame, (greenedSlots[slot] and "yellow") or "green")
										end
										greenedSlots[slot] = true
									elseif link==altWinner then
										if frame then
											criterion:AdornEncounterJournal(link, frame, "yellow")
										end
									end
								end
								YieldAutoroutine()
							end
						end
						criterion:Pool()
					end
				end
				greenedSlots:Pool()
			end
		end
		
		local function EvaluateEncounterJournal()
			InterruptAutoroutine("EvaluateEncounterJournal")
			QueueAutoroutine("EvaluateEncounterJournal", EvaluateEncounterJournalRoutine)
		end
		
		RegisterFunctionReaction("ToggleEncounterJournal"):Once():WithAction(function()
			encounterJournalUpdateReaction = RegisterMemberFunctionReaction("EncounterJournal.encounter.info.lootScroll", "update")
				:Or(RegisterFunctionReaction("EncounterJournal_LootUpdate")):WithAction(EvaluateEncounterJournal)
		end)
		
		local function HideVendorGuidance()
			for i=1, MERCHANT_ITEMS_PER_PAGE, 1 do
				local itemButton = _G["MerchantItem"..i.."ItemButton"]
				if itemButton then
					if itemButton.dugisGreenArrow then
						itemButton.dugisGreenArrow:Hide()
					end
					if itemButton.dugisYellowArrow then
						itemButton.dugisYellowArrow:Hide()
					end
				end
			end
		end
		
		local function EvaluateVendorRoutine()
			HideVendorGuidance()
			if MerchantFrame:IsShown() then
				local greenedSlots = GetCreateTable():BindToAutoroutineLifetime(tPool)
				for slot,inv1,inv2 in NextUniqueInventorySlot do
					for criterionIndex, option, criterion in GA:IterateWinCriteria() do
						criterion:BindToAutoroutineLifetime(tPool)
						if criterion.AdornVendorItem then
							local winningItem, winningScore, altWinner, altScore = GetCurrentBestInSlot(slot, criterion.specNum, criterion.pvp, nil, nil, nil, nil, true)
							for _, link, frame in GA.VendorIterator do
								if criterion:Predicate(link, unpack(criterion)) then
									if slot==INVSLOT_MAINHAND and link==altWinner then 
										slot = INVSLOT_OFFHAND
										winningItem = link
									end
									
									if link==winningItem then
										if frame then
											criterion:AdornVendorItem(link, frame, (greenedSlots[slot] and "yellow") or "green")
										end
										greenedSlots[slot] = true
									elseif link==altWinner then
										if frame then
											criterion:AdornVendorItem(link, frame, "yellow")
										end
									end
								end
								YieldAutoroutine()
							end
						end
						criterion:Pool()
					end
				end
				greenedSlots:Pool()
			end
		end
		
		local function EvaluateVendor()
			InterruptAutoroutine("EvaluateVendor")
			QueueAutoroutine("EvaluateVendor", EvaluateVendorRoutine)
		end
		
		vendorUpdateReaction =  RegisterFunctionReaction("MerchantFrame_UpdateMerchantInfo"):WithAction(EvaluateVendor)
		
		local function HideLootGuidance()
			for i=1, LOOTFRAME_NUMBUTTONS  do
				local itemButton = _G["LootButton"..i];
				if itemButton then
					if itemButton.dugisGreenArrow then
						itemButton.dugisGreenArrow:Hide()
					end
					if itemButton.dugisYellowArrow then
						itemButton.dugisYellowArrow:Hide()
					end
				end
			end
		end
		
		local function EvaluateLootRoutine()
			HideLootGuidance()
			if LootFrame:IsShown() then
				local greenedSlots = GetCreateTable():BindToAutoroutineLifetime(tPool)
				for _, option,criterion in GA:IterateWinCriteria() do
					criterion:BindToAutoroutineLifetime(tPool)
					local winScore, winLink, winFrame, winSlot
					for _, link, frame in GA.LootIterator do
						local score,_,_,uniqueInventorySlot = EvaluateWinCriteron(criterion, link)
						if score and (not winScore or winScore<score) then
							winScore = score
							winLink = link
							winFrame = frame
							winSlot = uniqueInventorySlot
						elseif criterion.SettleTie and score and winScore==score then
							winLink = criterion:SettleTie(winLink, link)
							winFrame = winLink==link and frame or winFrame
							winScore = winLink==link and score or winScore
							winSlot = uniqueInventorySlot
						end
					end
					if winLink and winFrame then
						criterion:AdornLoot(winLink, winFrame, (greenedSlots[winSlot] and "yellow") or "green")
					end
					if winSlot then
						greenedSlots[winSlot] = true
					end
					criterion:Pool()
				end
				greenedSlots:Pool()
			end
		end
		
		local function EvaluateLoot()
			InterruptAutoroutine("EvaluateLoot")
			QueueAutoroutine("EvaluateLoot", EvaluateLootRoutine)
		end
		
		lootUpdateReaction =  RegisterFunctionReaction("LootFrame_Update"):WithAction(EvaluateLoot)
		
		if DGV.Debug then
			DGV:RegisterTest(
				function(suite)
					--suite.mocks
					--suite.setUp
					--suite.tearDown
					local function justReturn(arg1, arg2, arg3, arg4, arg5, arg6, ...)
						return ...
					end
					suite.testVisitCSV = function(state)
						local joined = strjoin("test", VisitCSV(justReturn, nil, nil, nil, nil, nil, nil, "1,two,3", "four,5,six"))
						local expected = "1testtwotest3testfourtest5testsix"
						DGV:ShouldEqual(expected, joined)
					end
					suite.testMathSum = function(state)
						DGV:ShouldEqual(6, math.sum(1,2,3))
					end
					suite.testItemIteratorWithArgITEM_ITERATOR_SKIP_EQUIPPEDShouldNotGivePlayerInventory = function(state)
						local playerInventoryFound = false
						for control,iteratedItemLink in ItemIterator,ITEM_ITERATOR_SKIP_EQUIPPED do
							playerInventoryFound = playerInventoryFound or (control.player and not control.bags)
						end
						DGV:Shouldnt(playerInventoryFound)
					end
					return "GearAdvisorConditionlessTests"
				end)
		end
	end
	
	function GA:Unload()
		TipHooker:Unhook(ProcessTooltip, "item")
		bagUpdateReaction:Dispose()
		--levelUpReaction:Dispose()
		activeSpecReaction:Dispose()
		smartSetReaction:Dispose()
		rewardShowReaction:Dispose()
		questHideReaction:Dispose()
		adornerParentShowReaction:Dispose()
		lootRollShowReaction:Dispose()
		vendorUpdateReaction:Dispose()
		lootUpdateReaction:Dispose()
		if encounterJournalUpdateReaction then
			encounterJournalUpdateReaction:Dispose()
		end
		if equipExecutedReaction then
			if equipExecutedReaction.requestedSlots then
				equipExecutedReaction.requestedSlots:Pool()
				equipExecutedReaction.requestedSlots = nil
			end
			equipExecutedReaction:Dispose()
			equipExecutedReaction = nil
		end
		GetNumEquipmentSets = orig_GetNumEquipmentSets
		GetEquipmentSetInfo = orig_GetEquipmentSetInfo
	end
	

	function GA:OnModulesLoaded()
		if DGV.Debug then
			--[[local]] sumStatComparisonTable = { -- General
				["slotMap"] = {},
				-- ["HEALTH"] = {
					-- blizzardSumFunc = function() return UnitHealthMax("player") end,
					-- estFunc = sumHealth,
					-- tolerance = .9
				-- },
				--[[["POWER"] = {
					updateFunc = function(statFrame, unit) PaperDollFrame_SetPower(statFrame, unit); end
				},
				["ALTERNATEMANA"] = {
					-- Only appears for Druids when in shapeshift form
					updateFunc = function(statFrame, unit) PaperDollFrame_SetAlternateMana(statFrame, unit); end
				}]]
				order = {
					"STRENGTH", "AGILITY", "STAMINA", "INTELLECT", "SPIRIT", "MASTERY", "EXPERTISE", --"MELEE_AP", 
					"HITCHANCE", "SPELL_HITCHANCE", "HASTE", "ARMOR", "DODGE", "PARRY", "CRITCHANCE", --"MELEE_DPS"
				},
				["MASTERY"] = {
					blizzardSumFunc = GetMastery,
					estFunc = sumMastery,
					modCoefficientFunc = function() return StatLogic:GetStatMod("MOD_MASTERY") end,
					sumKey = "MASTERY",
				},
				--[[["ITEMLEVEL"] = {
					updateFunc = function(statFrame, unit) PaperDollFrame_SetItemLevel(statFrame, unit); end
				},
				["MOVESPEED"] = {
					updateFunc = function(statFrame, unit) PaperDollFrame_SetMovementSpeed(statFrame, unit); end
				},]]
				 
				-- Base stats
				["STRENGTH"] = {
					blizzardSumFunc = function() return UnitStat("player", 1) end,
					estFunc = sumStrength,
					modCoefficientFunc = function() return StatLogic:GetStatMod("MOD_STR") end,
					sumKey = "STR",
				},
				["AGILITY"] = {
					blizzardSumFunc = function() return UnitStat("player", 2) end,
					estFunc = sumAgility,
					modCoefficientFunc = function() return StatLogic:GetStatMod("MOD_AGI") end,
					sumKey = "AGI",
				},
				["STAMINA"] = {
					blizzardSumFunc = function() return UnitStat("player", 3) end,
					estFunc = sumStamina,
					modCoefficientFunc = function() return StatLogic:GetStatMod("MOD_STA") end,
					sumKey = "STA",
				},
				["INTELLECT"] = {
					blizzardSumFunc = function() return UnitStat("player", 4) end,
					estFunc = sumIntellect,
					modCoefficientFunc = function() return StatLogic:GetStatMod("MOD_INT") end,
					sumKey = "INT",
				},
				["SPIRIT"] = {
					blizzardSumFunc = function() return UnitStat("player", 5) end,
					estFunc = sumSpirit,
					modCoefficientFunc = function() return StatLogic:GetStatMod("MOD_SPI") end,
					sumKey = "SPI",
				},
				 
				-- Melee
				--[[["MELEE_DAMAGE"] = {
					updateFunc = function(statFrame, unit) PaperDollFrame_SetDamage(statFrame, unit); end
				},]]
				["MELEE_DPS"] = {
					blizzardSumFunc = function()
						local speed, offhandSpeed = UnitAttackSpeed("player");
						local minDamage, maxDamage, minOffHandDamage, maxOffHandDamage, physicalBonusPos, physicalBonusNeg, percent = UnitDamage("player");
						minDamage = (minDamage / percent) - physicalBonusPos - physicalBonusNeg;
						maxDamage = (maxDamage / percent) - physicalBonusPos - physicalBonusNeg;
						local baseDamage = (minDamage + maxDamage) * 0.5;
						local fullDamage = (baseDamage + physicalBonusPos + physicalBonusNeg) * percent;
						return max(fullDamage,1) / speed
					end,
					estFunc = sumMeleeDPS,
					shouldSkipTest = function(self, itemLink, slot) return slot==INVSLOT_MAINHAND end --weapon won't be gone, it will be replaced by fist dps
				},
				["MELEE_AP"] = {
					blizzardSumFunc = function()
						local base, posBuff, negBuff = UnitAttackPower("player");
						--local damageBonus =  max((base+posBuff+negBuff), 0)/ATTACK_POWER_MAGIC_NUMBER;
						return base, posBuff, negBuff
					end,
					estFunc = sumMeleeAttackPower,
					modCoefficientFunc = function() return StatLogic:GetStatMod("MOD_AP") end,
					sumKey = "AP",
				},
				--[[["MELEE_ATTACKSPEED"] = {
					updateFunc = function(statFrame, unit) PaperDollFrame_SetAttackSpeed(statFrame, unit); end
				},]]
				["HASTE"] = {
					blizzardSumFunc = GetMeleeHaste,
					estFunc = sumMeleeHaste
				},
				["HITCHANCE"] = {
					blizzardSumFunc = function() return GetCombatRatingBonus(CR_HIT_MELEE) + GetHitModifier() end,
					estFunc = sumMeleeHit,
					sumKey = "MELEE_HIT_RATING",
					assert = "ShouldBeWithinTolerance",
					[1] = 0.000001,
					[2] = "Testing item melee hit chance"
				}, 
				["CRITCHANCE"] = {
					blizzardSumFunc =  GetCritChance,
					estFunc = sumMeleeCrit,
					sumKey = "MELEE_CRIT_RATING",
					assert = "ShouldBeWithinTolerance",
					[1] = 0.00001,
					[2] = "Testing item melee crit chance"
				},
				["EXPERTISE"] = { --TODO: figure out how to handle offhand
					blizzardSumFunc = function()
						local expertise, offhandExpertise, rangedExpertise = GetExpertise();
						return expertise, offhandExpertise
					end,
					estFunc = sumExpertise,
					sumKey = "EXPERTISE_RATING",
					assert = "ShouldBeWithinTolerance",
					[1] = 0.000001,
					[2] = "Testing item expertise"
				}, 
				--[[["ENERGY_REGEN"] = {
					updateFunc = function(statFrame, unit) PaperDollFrame_SetEnergyRegen(statFrame, unit); end
				},
				["RUNE_REGEN"] = {
					updateFunc = function(statFrame, unit) PaperDollFrame_SetRuneRegen(statFrame, unit); end
				},
				 
				-- Ranged
				["RANGED_DAMAGE"] = {
					updateFunc = function(statFrame, unit) PaperDollFrame_SetRangedDamage(statFrame, unit); end
				},
				["RANGED_DPS"] = {
					updateFunc = function(statFrame, unit) PaperDollFrame_SetRangedDPS(statFrame, unit); end
				},
				["RANGED_AP"] = {
					updateFunc = function(statFrame, unit) PaperDollFrame_SetRangedAttackPower(statFrame, unit); end
				},
				["RANGED_ATTACKSPEED"] = {
					updateFunc = function(statFrame, unit) PaperDollFrame_SetRangedAttackSpeed(statFrame, unit); end
				},
				["RANGED_CRITCHANCE"] = {
					updateFunc = function(statFrame, unit) PaperDollFrame_SetRangedCritChance(statFrame, unit); end
				},
				["RANGED_HITCHANCE"] = {
					updateFunc = function(statFrame, unit) PaperDollFrame_SetRangedHitChance(statFrame, unit); end
				}, 
				["RANGED_HASTE"] = {
					updateFunc = function(statFrame, unit) PaperDollFrame_SetRangedHaste(statFrame, unit); end
				},
				["FOCUS_REGEN"] = {
					updateFunc = function(statFrame, unit) PaperDollFrame_SetFocusRegen(statFrame, unit); end
				},
				 
				-- Spell
				["SPELLDAMAGE"] = {
					updateFunc = function(statFrame, unit) PaperDollFrame_SetSpellBonusDamage(statFrame, unit); end
				},
				["SPELLHEALING"] = {
					updateFunc = function(statFrame, unit) PaperDollFrame_SetSpellBonusHealing(statFrame, unit); end
				},
				["SPELL_HASTE"] = {
					updateFunc = function(statFrame, unit) PaperDollFrame_SetSpellHaste(statFrame, unit); end
				},]]
				["SPELL_HITCHANCE"] = {
					blizzardSumFunc = function() return GetCombatRatingBonus(CR_HIT_SPELL) + GetSpellHitModifier() end,
					estFunc = sumSpellHit,
					sumKey = "SPELL_HIT_RATING",
					assert = "ShouldBeWithinTolerance",
					[1] = 0.000001,
					[2] = "Testing item spell hit chance"
				}, 
				--[[["MANAREGEN"] = {
					updateFunc = function(statFrame, unit) PaperDollFrame_SetManaRegen(statFrame, unit); end
				},
				["COMBATMANAREGEN"] = {
					updateFunc = function(statFrame, unit) PaperDollFrame_SetCombatManaRegen(statFrame, unit); end
				},
				["SPELLCRIT"] = {
					updateFunc = function(statFrame, unit) PaperDollFrame_SetSpellCritChance(statFrame, unit); end
				},]]
				 
				-- Defense
				["ARMOR"] = {
					blizzardSumFunc = function()
						local base, effectiveArmor, armor, posBuff, negBuff = UnitArmor("player")
						return effectiveArmor
					end,
					estFunc = sumArmor
				},
				["DODGE"] = {
					blizzardSumFunc = GetDodgeChance,
					estFunc = sumDodge,
				},
				["PARRY"] = {
					blizzardSumFunc = GetParryChance,
					estFunc = sumParry,
				},

				--[[["BLOCK"] = {
					updateFunc = function(statFrame, unit) PaperDollFrame_SetBlock(statFrame, unit); end
				},
				["RESILIENCE_REDUCTION"] = {
					updateFunc = function(statFrame, unit) PaperDollFrame_SetResilience(statFrame, unit); end
				},
				["PVP_POWER"] = {
					updateFunc = function(statFrame, unit) PaperDollFrame_SetPvpPower(statFrame, unit); end
				},
				["RESILIENCE_CRIT"] = {
					-- TODO
					updateFunc = function(statFrame, unit) PaperDollFrame_SetResilience(statFrame, unit); end
				},]]
			}
			--[[local slotNameTable = {
				"AmmoSlot", -- Ranged ammunition slot
				"BackSlot", -- Back (cloak) slot
				--"Bag0Slot", -- Backpack slot
				--"Bag1Slot", -- First bag slot
				--"Bag2Slot", -- Second bag slot
				--"Bag3Slot", -- Third bag slot
				"ChestSlot", -- Chest slot
				"FeetSlot", -- Feet (boots) slot
				"Finger0Slot", -- First finger (ring) slot
				"Finger1Slot", -- Second finger (ring) slot
				"HandsSlot", -- Hand (gloves) slot
				"HeadSlot", -- Head (helmet) slot
				"LegsSlot", -- Legs (pants) slot
				"MainHandSlot", -- Main hand weapon slot
				"NeckSlot", -- Necklace slot
				"RangedSlot", -- Ranged weapon or relic slot
				"SecondaryHandSlot", -- Off-hand (weapon, shield, or held item) slot
				--"ShirtSlot", -- Shirt slot
				"ShoulderSlot", -- Shoulder slot
				--"TabardSlot", -- Tabard slot
				"Trinket0Slot", -- First trinket slot
				"Trinket1Slot", -- Second trinket slot
				"WaistSlot", -- Waist (belt) slot
				"WristSlot", -- Wrist (bracers) slot
			}]]
			
			local automatingGearTest = false
			local slotsFree = 0
			for i=BACKPACK_CONTAINER,NUM_BAG_SLOTS do
				slotsFree = slotsFree+GetContainerNumFreeSlots(i)
			end
			if slotsFree>0 and not InCombatLockdown() then automatingGearTest = true end

			--[[DGV:RegisterTest(
				function(suite)
					--suite.setUp
					suite.tearDown = function(state, event, slot, hasItem)
						for key,statTbl in pairs(sumStatComparisonTable) do -- update blizzardTotal and lastCoefficient
							if statTbl.blizzardSumFunc then
								statTbl.blizzardTotal = statTbl.blizzardSumFunc()
								statTbl.lastCoefficient = statTbl.modCoefficientFunc and statTbl.modCoefficientFunc()
							end
						end
						if hasItem then
							sumStatComparisonTable.slotMap[slot] = GetInventoryItemLink("player", slot)
						end
						if automatingGearTest and not hasItem then --prevents re-equip of unslotted item after initial testing
							QueueInvocation(EquipItemByName, sumStatComparisonTable.slotMap[slot]) --invocation queued, EquipItemByName doesnt work within the PLAYER_EQUIPMENT_CHANGED event
						end
						if automatingGearTest and hasItem then
							local nextSlot, nextLink = nextValidSlot(nil, slot) --kickoff next automated test
							if nextSlot then
								sumStatComparisonTable.slotMap[nextSlot] = nextLink
								QueueInvocation(EquipmentManager_RunAction, EquipmentManager_UnequipItemInSlot(nextSlot))
							else
								automatingGearTest = false
							end
						end
					end
					suite.testWhenSlotIsUnequipped_ItemStatsSumShouldEqualBlizzardStatDifferences = function(state, event, slot, hasItem)
						if not hasItem then
							local itemLink = sumStatComparisonTable.slotMap[slot]
							for _, key in ipairs(sumStatComparisonTable.order) do
								local statTbl = sumStatComparisonTable[key]
								if statTbl.blizzardSumFunc then
									--if item changes the coefficient, we cant test it reliably, 
									--since some server-side stat changes first floor the base stat
									if 
										(not statTbl.modCoefficientFunc or statTbl.lastCoefficient==statTbl.modCoefficientFunc()) and
										(not statTbl.shouldSkipTest or not statTbl:shouldSkipTest(itemLink, slot))
									then 
										local bs = statTbl.blizzardSumFunc()
										local blizzardDifference = (statTbl.blizzardTotal or 0) - bs
										local itemSums = StatLogic:GetSum(itemLink)
										local actual = statTbl.estFunc(itemSums,nil,itemLink,slot) or 0
										--DGV:DebugFormat("testWhenSlotIsUnequipped...", "slot", slot, "item", itemLink, "stat", key, "expected", blizzardDifference, "actual", actual)
										if statTbl.assert then
											DGV[statTbl.assert](DGV, blizzardDifference, actual, unpack(statTbl))
										else
											DGV:ShouldBeWithinTolerance(blizzardDifference, actual, 1, string.format("Testing %s %s",itemLink,key)) --tolerate an unknown round difference for blizzardTotal
										end
									end
								end
							end

						end
					end
					
					return "IntegrationTest_GivenACharacterWhenEquipmentRemoved"
				end, "PLAYER_EQUIPMENT_CHANGED")

			for key,statTbl in pairs(sumStatComparisonTable) do
				if statTbl.blizzardSumFunc then
					statTbl.blizzardTotal = statTbl.blizzardSumFunc() --init total
					statTbl.lastCoefficient = statTbl.modCoefficientFunc and statTbl.modCoefficientFunc() --init coefficient values
				end
			end

			local firstSlot, itemLink = nextValidSlot()
			if firstSlot then
				sumStatComparisonTable.slotMap[firstSlot] = itemLink
				EquipmentManager_RunAction(EquipmentManager_UnequipItemInSlot(firstSlot))
			end]]
		end
	end
end
--[[
GetItemStats("itemLink" [, returnTable])
id, texture, checkRelic = GetInventorySlotInfo("slotName")
Arguments:

slotName - Name of an inventory slot to query (string)
AmmoSlot - Ranged ammunition slot
BackSlot - Back (cloak) slot
Bag0Slot - Backpack slot
Bag1Slot - First bag slot
Bag2Slot - Second bag slot
Bag3Slot - Third bag slot
ChestSlot - Chest slot
FeetSlot - Feet (boots) slot
Finger0Slot - First finger (ring) slot
Finger1Slot - Second finger (ring) slot
HandsSlot - Hand (gloves) slot
HeadSlot - Head (helmet) slot
LegsSlot - Legs (pants) slot
MainHandSlot - Main hand weapon slot
NeckSlot - Necklace slot
RangedSlot - Ranged weapon or relic slot
SecondaryHandSlot - Off-hand (weapon, shield, or held item) slot
ShirtSlot - Shirt slot
ShoulderSlot - Shoulder slot
TabardSlot - Tabard slot
Trinket0Slot - First trinket slot
Trinket1Slot - Second trinket slot
WaistSlot - Waist (belt) slot
WristSlot - Wrist (bracers) slot]]

--StatLogic:GetEffectFromRating same as GetCombatRatingBonus
--GetExpertise includes racial bonuses, StatLogic:GetEffectFromRating does not.  
--LibStatLogic does not mod spell hit/expertise based upon racial weapon specializations.
--GetHitModifier, GetSpellHitModifier, and GetExpertise perform this sort of function, but only apply to equipped items, current level, etc.

--[[function GetMeleeMissChance(levelOffset, special)
    if (levelOffset < 0 or levelOffset > 3) then
        return 0;
    end
    local chance = BASE_MISS_CHANCE_PHYSICAL[levelOffset];
    chance = chance - GetCombatRatingBonus(CR_HIT_MELEE) - GetHitModifier();
    if (IsDualWielding() and not special) then
        chance = chance + DUAL_WIELD_HIT_PENALTY;
    end
    if (chance < 0) then
        chance = 0;
    elseif (chance > 100) then
        chance = 100;
    end
    return chance;
end
 
function GetRangedMissChance(levelOffset, special)
    if (levelOffset < 0 or levelOffset > 3) then
        return 0;
    end
    local chance = BASE_MISS_CHANCE_PHYSICAL[levelOffset];
    chance = chance - GetCombatRatingBonus(CR_HIT_RANGED) - GetHitModifier();
    if (chance < 0) then
        chance = 0;
    elseif (chance > 100) then
        chance = 100;
    end
    return chance;
end
 
function GetSpellMissChance(levelOffset, special)
    if (levelOffset < 0 or levelOffset > 3) then
        return 0;
    end
    local chance = BASE_MISS_CHANCE_SPELL[levelOffset];
    chance = chance - GetCombatRatingBonus(CR_HIT_SPELL) - GetSpellHitModifier();
    if (chance < 0) then
        chance = 0;
    elseif (chance > 100) then
        chance = 100;
    end
    return chance;
end
 
function GetEnemyDodgeChance(levelOffset)
    if (levelOffset < 0 or levelOffset > 3) then
        return 0;
    end
    local chance = BASE_ENEMY_DODGE_CHANCE[levelOffset];
    local offhandChance = BASE_ENEMY_DODGE_CHANCE[levelOffset];
    local rangedChance = BASE_ENEMY_DODGE_CHANCE[levelOffset];
    local expertisePct, offhandExpertisePct, rangedExpertisePct = GetExpertise();
    chance = chance - expertisePct;
    offhandChance = offhandChance - offhandExpertisePct;
    rangedChance = rangedChance - rangedExpertisePct;
    if (chance < 0) then
        chance = 0;
    elseif (chance > 100) then
        chance = 100;
    end
    if (offhandChance < 0) then
        offhandChance = 0;
    elseif (offhandChance > 100) then
        offhandChance = 100;
    end
    if (rangedChance < 0) then
        rangedChance = 0;
    elseif (rangedChance > 100) then
        rangedChance = 100;
    end
    return chance, offhandChance, rangedChance;
end
 
function GetEnemyParryChance(levelOffset)
    if (levelOffset < 0 or levelOffset > 3) then
        return 0;
    end
    local chance = BASE_ENEMY_PARRY_CHANCE[levelOffset];
    local offhandChance = BASE_ENEMY_PARRY_CHANCE[levelOffset];
    local expertisePct, offhandExpertisePct = GetExpertise();
    local mainhandDodge = BASE_ENEMY_DODGE_CHANCE[levelOffset];
    local offhandDodge = BASE_ENEMY_DODGE_CHANCE[levelOffset];
     
    expertisePct = expertisePct - mainhandDodge;
    if ( expertisePct < 0 ) then
        expertisePct = 0;
    end
    chance = chance - expertisePct;
    if (chance < 0) then
        chance = 0;
    elseif (chance > 100) then
        chance = 100;
    end
     
    offhandExpertisePct = offhandExpertisePct - offhandDodge;
    if ( offhandExpertisePct < 0 ) then
        offhandExpertisePct = 0;
    end
    offhandChance = offhandChance - offhandExpertisePct;
    if (offhandChance < 0) then
        offhandChance = 0;
    elseif (offhandChance > 100) then
        offhandChance = 100;
    end
     
    return chance, offhandChance;
end]]


--[[
from http://www.wowace.com/paste/832.txt
ITEM_MOD_AGILITY = "%c%d Agility"
ITEM_MOD_AGILITY_SHORT = "Agility"
ITEM_MOD_ARMOR_PENETRATION_RATING = "Increases your armor penetration rating by %d."
ITEM_MOD_ARMOR_PENETRATION_RATING_SHORT = "Armor Penetration Rating"
ITEM_MOD_ATTACK_POWER = "Increases attack power by %d."
ITEM_MOD_ATTACK_POWER_SHORT = "Attack Power"
ITEM_MOD_BLOCK_RATING = "Increases your shield block rating by %d."
ITEM_MOD_BLOCK_RATING_SHORT = "Block Rating"
ITEM_MOD_BLOCK_VALUE = "Increases your shield value by %d."
ITEM_MOD_BLOCK_VALUE_SHORT = "Block Value"
ITEM_MOD_CRIT_MELEE_RATING = "Improves melee critical strike rating by %d."
ITEM_MOD_CRIT_MELEE_RATING_SHORT = "Critical Strike Rating (Melee)"
ITEM_MOD_CRIT_RANGED_RATING = "Improves ranged critical strike rating by %d."
ITEM_MOD_CRIT_RANGED_RATING_SHORT = "Critical Strike Rating (Ranged)"
ITEM_MOD_CRIT_RATING = "Improves critical strike rating by %d."
ITEM_MOD_CRIT_RATING_SHORT = "Critical Strike Rating"
ITEM_MOD_CRIT_SPELL_RATING = "Improves spell critical strike rating by %d."
ITEM_MOD_CRIT_SPELL_RATING_SHORT = "Critical Strike Rating (Spell)"
ITEM_MOD_CRIT_TAKEN_MELEE_RATING = "Improves melee critical avoidance rating by %d."
ITEM_MOD_CRIT_TAKEN_MELEE_RATING_SHORT = "Critical Strike Avoidance Rating (Melee)"
ITEM_MOD_CRIT_TAKEN_RANGED_RATING = "Improves ranged critical avoidance rating by %d."
ITEM_MOD_CRIT_TAKEN_RANGED_RATING_SHORT = "Critical Strike Avoidance Rating (Ranged)"
ITEM_MOD_CRIT_TAKEN_RATING = "Improves critical avoidance rating by %d."
ITEM_MOD_CRIT_TAKEN_RATING_SHORT = "Critical Strike Avoidance Rating"
ITEM_MOD_CRIT_TAKEN_SPELL_RATING = "Improves spell critical avoidance rating by %d."
ITEM_MOD_CRIT_TAKEN_SPELL_RATING_SHORT = "Critical Strike Avoidance Rating (Spell)"
ITEM_MOD_DAMAGE_PER_SECOND_SHORT = "Damage Per Second"
ITEM_MOD_DEFENSE_SKILL_RATING = "Increases defense rating by %d."
ITEM_MOD_DEFENSE_SKILL_RATING_SHORT = "Defense Rating"
ITEM_MOD_DODGE_RATING = "Increases your dodge rating by %d."
ITEM_MOD_DODGE_RATING_SHORT = "Dodge Rating"
ITEM_MOD_EXPERTISE_RATING = "Increases your expertise rating by %d."
ITEM_MOD_EXPERTISE_RATING_SHORT = "Expertise Rating"
ITEM_MOD_FERAL_ATTACK_POWER = "Increases attack power by %d in Cat, Bear, Dire Bear, and Moonkin forms only."
ITEM_MOD_FERAL_ATTACK_POWER_SHORT = "Attack Power In Forms"
ITEM_MOD_HASTE_MELEE_RATING = "Improves melee haste rating by %d."
ITEM_MOD_HASTE_MELEE_RATING_SHORT = "Haste Rating (Melee)"
ITEM_MOD_HASTE_RANGED_RATING = "Improves ranged haste rating by %d."
ITEM_MOD_HASTE_RANGED_RATING_SHORT = "Haste Rating (Ranged)"
ITEM_MOD_HASTE_RATING = "Improves haste rating by %d."
ITEM_MOD_HASTE_RATING_SHORT = "Haste Rating"
ITEM_MOD_HASTE_SPELL_RATING = "Improves spell haste rating by %d."
ITEM_MOD_HASTE_SPELL_RATING_SHORT = "Haste Rating (Spell)"
ITEM_MOD_HEALTH = "%c%d Health"
ITEM_MOD_HEALTH_REGEN_SHORT = "Health Per 5 Sec."
ITEM_MOD_HEALTH_REGENERATION = "Restores %d health per 5 sec."
ITEM_MOD_HEALTH_REGENERATION_SHORT = "Health Regeneration"
ITEM_MOD_HEALTH_SHORT = "Health"
ITEM_MOD_HIT_MELEE_RATING = "Improves melee hit rating by %d."
ITEM_MOD_HIT_MELEE_RATING_SHORT = "Hit Rating (Melee)"
ITEM_MOD_HIT_RANGED_RATING = "Improves ranged hit rating by %d."
ITEM_MOD_HIT_RANGED_RATING_SHORT = "Hit Rating (Ranged)"
ITEM_MOD_HIT_RATING = "Improves hit rating by %d."
ITEM_MOD_HIT_RATING_SHORT = "Hit Rating"
ITEM_MOD_HIT_SPELL_RATING = "Improves spell hit rating by %d."
ITEM_MOD_HIT_SPELL_RATING_SHORT = "Hit Rating (Spell)"
ITEM_MOD_HIT_TAKEN_MELEE_RATING = "Improves melee hit avoidance rating by %d."
ITEM_MOD_HIT_TAKEN_MELEE_RATING_SHORT = "Hit Avoidance Rating (Melee)"
ITEM_MOD_HIT_TAKEN_RANGED_RATING = "Improves ranged hit avoidance rating by %d."
ITEM_MOD_HIT_TAKEN_RANGED_RATING_SHORT = "Hit Avoidance Rating (Ranged)"
ITEM_MOD_HIT_TAKEN_RATING = "Improves hit avoidance rating by %d."
ITEM_MOD_HIT_TAKEN_RATING_SHORT = "Hit Avoidance Rating"
ITEM_MOD_HIT_TAKEN_SPELL_RATING = "Improves spell hit avoidance rating by %d."
ITEM_MOD_HIT_TAKEN_SPELL_RATING_SHORT = "Hit Avoidance Rating (Spell)"
ITEM_MOD_INTELLECT = "%c%d Intellect"
ITEM_MOD_INTELLECT_SHORT = "Intellect"
ITEM_MOD_MANA = "%c%d Mana"
ITEM_MOD_MANA_REGENERATION = "Restores %d mana per 5 sec."
ITEM_MOD_MANA_REGENERATION_SHORT = "Mana Regeneration"
ITEM_MOD_MANA_SHORT = "Mana"
ITEM_MOD_MELEE_ATTACK_POWER_SHORT = "Melee Attack Power"
ITEM_MOD_PARRY_RATING = "Increases your parry rating by %d."
ITEM_MOD_PARRY_RATING_SHORT = "Parry Rating"
ITEM_MOD_POWER_REGEN0_SHORT = "Mana Per 5 Sec."
ITEM_MOD_POWER_REGEN1_SHORT = "Rage Per 5 Sec."
ITEM_MOD_POWER_REGEN2_SHORT = "Focus Per 5 Sec."
ITEM_MOD_POWER_REGEN3_SHORT = "Energy Per 5 Sec."
ITEM_MOD_POWER_REGEN4_SHORT = "Happiness Per 5 Sec."
ITEM_MOD_POWER_REGEN5_SHORT = "Runes Per 5 Sec."
ITEM_MOD_POWER_REGEN6_SHORT = "Runic Power Per 5 Sec."
ITEM_MOD_RANGED_ATTACK_POWER = "Increases ranged attack power by %d."
ITEM_MOD_RANGED_ATTACK_POWER_SHORT = "Ranged Attack Power"
ITEM_MOD_RESILIENCE_RATING = "Improves your resilience rating by %d."
ITEM_MOD_RESILIENCE_RATING_SHORT = "Resilience Rating"
ITEM_MOD_SPELL_DAMAGE_DONE = "Increases damage done by magical spells and effects by up to %d."
ITEM_MOD_SPELL_DAMAGE_DONE_SHORT = "Bonus Damage"
ITEM_MOD_SPELL_HEALING_DONE = "Increases healing done by magical spells and effects by up to %d."
ITEM_MOD_SPELL_HEALING_DONE_SHORT = "Bonus Healing"
ITEM_MOD_SPELL_PENETRATION = "Increases spell penetration by %d."
ITEM_MOD_SPELL_PENETRATION_SHORT = "Spell Penetration"
ITEM_MOD_SPELL_POWER = "Increases spell power by %d."
ITEM_MOD_SPELL_POWER_SHORT = "Spell Power"
ITEM_MOD_SPIRIT = "%c%d Spirit"
ITEM_MOD_SPIRIT_SHORT = "Spirit"
ITEM_MOD_STAMINA = "%c%d Stamina"
ITEM_MOD_STAMINA_SHORT = "Stamina"
ITEM_MOD_STRENGTH = "%c%d Strength"
ITEM_MOD_STRENGTH_SHORT = "Strength"
EMPTY_SOCKET_META = "Meta Socket"
EMPTY_SOCKET = "Level %d Socket"
EMPTY_SOCKET_RED = "Red Socket"
EMPTY_SOCKET_BLUE = "Blue Socket"
EMPTY_SOCKET_YELLOW = "Yellow Socket"
EMPTY_SOCKET_NO_COLOR = "Prismatic Socket"

RESISTANCE_NONE = "None"
RESISTANCE_TYPE0 = "armor"
RESISTANCE_TYPE1 = "holy"
RESISTANCE_TYPE2 = "fire"
RESISTANCE_TYPE3 = "nature"
RESISTANCE_TYPE4 = "frost"
RESISTANCE_TYPE5 = "shadow"
RESISTANCE_TYPE6 = "arcane"

RESISTANCE0_NAME = "Armor"
RESISTANCE1_NAME = "Holy Resistance"
RESISTANCE2_NAME = "Fire Resistance"
RESISTANCE3_NAME = "Nature Resistance"
RESISTANCE4_NAME = "Frost Resistance"
RESISTANCE5_NAME = "Shadow Resistance"
RESISTANCE6_NAME = "Arcane Resistance"]]

--[[
from a LibStatLogic L.StatIDLookup dump
["StatIDLookup"] = {
		["Critical Strike (Spell)"] = {
			"SPELL_CRIT_RATING", -- [1]

		},
		["Scope (Damage)"] = {
			"RANGED_DMG", -- [1]
		},
		["% Shield Block Value"] = {
			"MOD_BLOCK_VALUE", -- [1]
		},
		["Increases the damage done by Fire spells and effects"] = {
			"FIRE_SPELL_DMG", -- [1]
		},
		["Improves ranged critical strike"] = {
			"RANGED_CRIT_RATING", -- [1]
		},
		["Increases your critical strike"] = {
			"MELEE_CRIT_RATING", -- [1]
			"RANGED_CRIT_RATING", -- [2]
			"SPELL_CRIT_RATING", -- [3]
		},
		["Shadow and Frost Spell Power"] = {
			"SHADOW_SPELL_DMG", -- [1]
			"FROST_SPELL_DMG", -- [2]
		},
		["Critical Strike (Ranged)"] = {
			"RANGED_CRIT_RATING", -- [1]
		},
		["increases your hit"] = {
			"MELEE_HIT_RATING", -- [1]
			"RANGED_HIT_RATING", -- [2]
			"SPELL_HIT_RATING", -- [3]
		},
		["Hit Avoidance (Melee)"] = {
			"MELEE_HIT_AVOID_RATING", -- [1]
		},
		["Damage"] = {
			"SPELL_DMG", -- [1]
		},
		["improves spell hit"] = {
			"SPELL_HIT_RATING", -- [1]
		},
		["increases damage done to undead by magical spells and effects.  it also allows the acquisition of scourgestones on behalf of the argent dawn"] = {
			"SPELL_DMG_UNDEAD", -- [1]
		},
		["Frost Resistance"] = {
			"FROST_RES", -- [1]
		},
		["Improves melee hit"] = {
			"MELEE_HIT_RATING", -- [1]
		},
		["mining"] = {
			"MINING", -- [1]
		},
		["Hit (Ranged)"] = {
			"RANGED_HIT_RATING", -- [1]
		},
		["increases damage done to undead by magical spells and effects"] = {
			"SPELL_DMG_UNDEAD", -- [1]
		},
		["Improves spell critical avoidance"] = {
			"SPELL_CRIT_AVOID_RATING", -- [1]
		},
		["critical strike (melee)"] = {
			"MELEE_CRIT_RATING", -- [1]
		},
		["cooking skill increased"] = {
			"COOKING", -- [1]
		},
		["shadow spell damage"] = {
			"SHADOW_SPELL_DMG", -- [1]
		},
		["improves melee critical strike"] = {
			"MELEE_CRIT_RATING", -- [1]
		},
		["MP"] = {
			"MANA", -- [1]
		},
		["improves ranged critical strike"] = {
			"RANGED_CRIT_RATING", -- [1]
		},
		["Increases your armor penetration"] = {
			"ARMOR_PENETRATION_RATING", -- [1]
		},
		["skinning; does not need to be equipped"] = {
			"SKINNING", -- [1]
		},
		["experience gained from killing monsters and completing quests increased%"] = false,
		["mana regeneration"] = {
			"COMBAT_MANA_REGEN", -- [1]
		},
		["Healing and Spell Damage"] = {
			"SPELL_DMG", -- [1]
			"HEAL", -- [2]
		},
		["increases attack powerwhen fighting undead.  it also allows the acquisition of scourgestones on behalf of the argent dawn"] = {
			"AP_UNDEAD", -- [1]
		},
		["Holy Damage"] = {
			"HOLY_SPELL_DMG", -- [1]
		},
		["Stamina"] = {
			"STA", -- [1]
		},
		["HP"] = {
			"HEALTH", -- [1]
		},
		["Attack Power versus Undead"] = {
			"AP_UNDEAD", -- [1]
		},
		["hit avoidance (spell)"] = {
			"SPELL_HIT_AVOID_RATING", -- [1]
		},
		["Shadow Resistance"] = {
			"SHADOW_RES", -- [1]
		},
		["Weapon Damage"] = {
			"MELEE_DMG", -- [1]
		},
		["Spirit"] = {
			"SPI", -- [1]
		},
		["increases damage done by arcane spells and effects"] = {
			"ARCANE_SPELL_DMG", -- [1]
		},
		["Increases the damage done by Frost spells and effects"] = {
			"FROST_SPELL_DMG", -- [1]
		},
		["Haste (Ranged)"] = {
			"RANGED_HASTE_RATING", -- [1]
		},
		["improves spell hit avoidance"] = {
			"SPELL_HIT_AVOID_RATING", -- [1]
		},
		["Health"] = {
			"HEALTH", -- [1]
		},
		["Shadow Spell Damage"] = {
			"SHADOW_SPELL_DMG", -- [1]
		},
		["stamina"] = {
			"STA", -- [1]
		},
		["increases the damage dealt by your crusader strike ability%"] = false,
		["fire spell damage"] = {
			"FIRE_SPELL_DMG", -- [1]
		},
		["hit (spell)"] = {
			"SPELL_HIT_RATING", -- [1]
		},
		["Spell Damage"] = {
			"SPELL_DMG", -- [1]
		},
		["Attack Power In Forms"] = {
			"FERAL_AP", -- [1]
		},
		["mp"] = {
			"MANA", -- [1]
		},
		["Block"] = {
			"BLOCK_RATING", -- [1]
		},
		["Spell Power"] = {
			"SPELL_DMG", -- [1]
			"HEAL", -- [2]
		},
		["Attack Power when fighting Undead"] = {
			"AP_UNDEAD", -- [1]
		},
		["Improves spell hit"] = {
			"SPELL_HIT_RATING", -- [1]
		},
		["Nature Spell Damage"] = {
			"NATURE_SPELL_DMG", -- [1]
		},
		["Mining; does not need to be equipped"] = {
			"MINING", -- [1]
		},
		["Mining"] = {
			"MINING", -- [1]
		},
		["shadow resist"] = {
			"SHADOW_RES", -- [1]
		},
		["Improves spell hit avoidance"] = {
			"SPELL_HIT_AVOID_RATING", -- [1]
		},
		["health"] = {
			"HEALTH", -- [1]
		},
		["Cooking skill increased"] = {
			"COOKING", -- [1]
		},
		[" to All Resistances"] = {
			"ARCANE_RES", -- [1]
			"FIRE_RES", -- [2]
			"FROST_RES", -- [3]
			"NATURE_RES", -- [4]
			"SHADOW_RES", -- [5]
		},
		["Increases damage done to Undead by magical spells and effects.  It also allows the acquisition of Scourgestones on behalf of the Argent Dawn"] = {
			"SPELL_DMG_UNDEAD", -- [1]
		},
		["Mana"] = {
			"MANA", -- [1]
		},
		["hit (ranged)"] = {
			"RANGED_HIT_RATING", -- [1]
		},
		["Hit (Melee)"] = {
			"MELEE_HIT_RATING", -- [1]
		},
		["Expertise"] = {
			"EXPERTISE_RATING", -- [1]
		},
		["Improves critical avoidance"] = {
			"MELEE_CRIT_AVOID_RATING", -- [1]
			"RANGED_CRIT_AVOID_RATING", -- [2]
			"SPELL_CRIT_AVOID_RATING", -- [3]
		},
		["dodge"] = {
			"DODGE_RATING", -- [1]
		},
		["block"] = {
			"BLOCK_RATING", -- [1]
		},
		["to"] = false,
		["Improves ranged haste"] = {
			"RANGED_HASTE_RATING", -- [1]
		},
		["fire resist"] = {
			"FIRE_RES", -- [1]
		},
		["increases attack powerin cat, bear, dire bear, and moonkin forms only"] = {
			"FERAL_AP", -- [1]
		},
		["increases your pvp power"] = {
			"PVP_POWER", -- [1]
		},
		["frost resistance"] = {
			"FROST_RES", -- [1]
		},
		["skinning skill increased"] = {
			"SKINNING", -- [1]
		},
		["improves critical avoidance"] = {
			"MELEE_CRIT_AVOID_RATING", -- [1]
			"RANGED_CRIT_AVOID_RATING", -- [2]
			"SPELL_CRIT_AVOID_RATING", -- [3]
		},
		["Dodge"] = {
			"DODGE_RATING", -- [1]
		},
		["Fire Resist"] = {
			"FIRE_RES", -- [1]
		},
		["spell damage"] = {
			"SPELL_DMG", -- [1]
		},
		["Arcane Resist"] = {
			"ARCANE_RES", -- [1]
		},
		["increases the damage done by arcane spells and effects"] = {
			"ARCANE_SPELL_DMG", -- [1]
		},
		["Intellect"] = {
			"INT", -- [1]
		},
		["increases your pvp resilience"] = {
			"RESILIENCE_RATING", -- [1]
		},
		["Haste (Spell)"] = {
			"SPELL_HASTE_RATING", -- [1]
		},
		["increases ranged attack power"] = {
			"RANGED_AP", -- [1]
		},
		["Nature Damage"] = {
			"NATURE_SPELL_DMG", -- [1]
		},
		["Skinning skill increased"] = {
			"SKINNING", -- [1]
		},
		["Increases attack powerwhen fighting Demons"] = {
			"AP_DEMON", -- [1]
		},
		["Increases attack powerwhen fighting Undead"] = {
			"AP_UNDEAD", -- [1]
		},
		["shadow and frost spell power"] = {
			"SHADOW_SPELL_DMG", -- [1]
			"FROST_SPELL_DMG", -- [2]
		},
		["Increases damage done by Fire spells and effects"] = {
			"FIRE_SPELL_DMG", -- [1]
		},
		["Shadow resistance"] = {
			"SHADOW_RES", -- [1]
		},
		["all resistances"] = {
			"ARCANE_RES", -- [1]
			"FIRE_RES", -- [2]
			"FROST_RES", -- [3]
			"NATURE_RES", -- [4]
			"SHADOW_RES", -- [5]
		},
		["Improves ranged critical avoidance"] = {
			"RANGED_CRIT_AVOID_RATING", -- [1]
		},
		["increases your expertise"] = {
			"EXPERTISE_RATING", -- [1]
		},
		["Critical Strike"] = {
			"MELEE_CRIT_RATING", -- [1]
			"RANGED_CRIT_RATING", -- [2]
			"SPELL_CRIT_RATING", -- [3]
		},
		["intellect"] = {
			"INT", -- [1]
		},
		["Herbalism"] = {
			"HERBALISM", -- [1]
		},
		["Increases ranged attack power"] = {
			"RANGED_AP", -- [1]
		},
		["nature damage"] = {

			"NATURE_SPELL_DMG", -- [1]
		},
		["scope (critical strike rating)"] = {
			"RANGED_CRIT_RATING", -- [1]
		},
		["attack power"] = {
			"AP", -- [1]
		},
		["Armor"] = {
			"BONUS_ARMOR", -- [1]
		},
		["increases damage done by holy spells and effects"] = {
			"HOLY_SPELL_DMG", -- [1]
		},
		["Increases your PvP power"] = {
			"PVP_POWER", -- [1]
		},
		["Skinning"] = {
			"SKINNING", -- [1]
		},
		["Fire Damage"] = {
			"FIRE_SPELL_DMG", -- [1]
		},
		["Improves ranged hit avoidance"] = {
			"RANGED_HIT_AVOID_RATING", -- [1]
		},
		["Attack Power"] = {
			"AP", -- [1]
		},
		["Arcane and Fire Spell Power"] = {
			"ARCANE_SPELL_DMG", -- [1]
			"FIRE_SPELL_DMG", -- [2]
		},
		["frost damage"] = {
			"FROST_SPELL_DMG", -- [1]
		},
		["Arcane Damage"] = {
			"ARCANE_SPELL_DMG", -- [1]
		},
		["Hit Avoidance (Spell)"] = {
			"SPELL_HIT_AVOID_RATING", -- [1]
		},
		["Critical Strike (Melee)"] = {
			"MELEE_CRIT_RATING", -- [1]
		},
		["Increases the damage dealt by your Crusader Strike ability%"] = false,
		["holy resistance"] = {
			"HOLY_RES", -- [1]
		},
		["Scope (Critical Strike Rating)"] = {
			"RANGED_CRIT_RATING", -- [1]
		},
		["Critical Strike Avoidance"] = {
			"MELEE_CRIT_AVOID_RATING", -- [1]
			"RANGED_CRIT_AVOID_RATING", -- [2]
			"SPELL_CRIT_AVOID_RATING", -- [3]
		},
		["haste"] = {
			"MELEE_HASTE_RATING", -- [1]
			"RANGED_HASTE_RATING", -- [2]
			"SPELL_HASTE_RATING", -- [3]
		},
		["attack power in forms"] = {
			"FERAL_AP", -- [1]
		},
		["holy damage"] = {
			"HOLY_SPELL_DMG", -- [1]
		},
		["Frost Resist"] = {
			"FROST_RES", -- [1]
		},
		["Increases your mastery"] = {
			"MASTERY_RATING", -- [1]
		},
		["Improves hit avoidance"] = {
			"MELEE_HIT_AVOID_RATING", -- [1]
			"RANGED_HIT_AVOID_RATING", -- [2]
			"SPELL_HIT_AVOID_RATING", -- [3]
		},
		["increases your haste"] = {
			"MELEE_HASTE_RATING", -- [1]
			"RANGED_HASTE_RATING", -- [2]
			"SPELL_HASTE_RATING", -- [3]
		},
		[" to all resistances"] = {
			"ARCANE_RES", -- [1]
			"FIRE_RES", -- [2]
			"FROST_RES", -- [3]
			"NATURE_RES", -- [4]
			"SHADOW_RES", -- [5]
		},
		["nature resistance"] = {
			"NATURE_RES", -- [1]
		},
		["pvp resilience"] = {
			"RESILIENCE_RATING", -- [1]
		},
		["Nature Resist"] = {
			"NATURE_RES", -- [1]
		},
		["Increases ranged attack speed"] = false,
		["pvp power"] = {
			"PVP_POWER", -- [1]
		},
		["Damage Spells"] = {
			"SPELL_DMG", -- [1]
		},
		["increases your mastery"] = {
			"MASTERY_RATING", -- [1]
		},
		["% threat"] = {
			"MOD_THREAT", -- [1]
		},
		["Increases your PvP resilience"] = {
			"RESILIENCE_RATING", -- [1]
		},
		["increases healing"] = {
			"HEAL", -- [1]
		},
		["increases defense"] = {
			"DEFENSE_RATING", -- [1]
		},
		["Increases the Holy damage of your Judgments"] = false,
		["Increases your haste"] = {
			"MELEE_HASTE_RATING", -- [1]
			"RANGED_HASTE_RATING", -- [2]
			"SPELL_HASTE_RATING", -- [3]
		},
		["Healing"] = {
			"HEAL", -- [1]
		},
		["Increases damage done by Holy spells and effects"] = {
			"HOLY_SPELL_DMG", -- [1]
		},
		["Increases damage done by Frost spells and effects"] = {
			"FROST_SPELL_DMG", -- [1]
		},
		["increases the damage done by fire spells and effects"] = {
			"FIRE_SPELL_DMG", -- [1]
		},
		["shadow resistance"] = {
			"SHADOW_RES", -- [1]
		},
		["weapon damage"] = {
			"MELEE_DMG", -- [1]
		},
		["attack power when fighting undead"] = {
			"AP_UNDEAD", -- [1]
		},
		["Mastery"] = {
			"MASTERY_RATING", -- [1]
		},
		["Improves ranged hit"] = {
			"RANGED_HIT_RATING", -- [1]
		},
		["Increases your expertise"] = {
			"EXPERTISE_RATING", -- [1]
		},
		["Increases spell power"] = {
			"SPELL_DMG", -- [1]
			"HEAL", -- [2]
		},
		["critical strike avoidance (ranged)"] = {
			"RANGED_CRIT_AVOID_RATING", -- [1]
		},
		["hit avoidance (ranged)"] = {
			"RANGED_HIT_AVOID_RATING", -- [1]
		},
		["Improves spell haste"] = {
			"SPELL_HASTE_RATING", -- [1]
		},
		["increases ranged attack speed"] = false,
		["increases your healing"] = {
			"HEAL", -- [1]
		},
		["hp"] = {
			"HEALTH", -- [1]
		},
		["expertise"] = {
			"EXPERTISE_RATING", -- [1]
		},
		["spell healing"] = {
			"HEAL", -- [1]
		},
		["ranged attack power"] = {
			"RANGED_AP", -- [1]
		},
		["Agility"] = {
			"AGI", -- [1]
		},
		["Increases your parry"] = {
			"PARRY_RATING", -- [1]
		},
		["damage"] = {
			"SPELL_DMG", -- [1]
		},
		["fishing skill increased"] = {
			"FISHING", -- [1]
		},
		["damage spells"] = {
			"SPELL_DMG", -- [1]
		},
		["attack power versus undead"] = {
			"AP_UNDEAD", -- [1]
		},
		["critical strike avoidance"] = {
			"MELEE_CRIT_AVOID_RATING", -- [1]
			"RANGED_CRIT_AVOID_RATING", -- [2]
			"SPELL_CRIT_AVOID_RATING", -- [3]
		},
		["improves melee hit"] = {
			"MELEE_HIT_RATING", -- [1]
		},
		["critical strike (ranged)"] = {
			"RANGED_CRIT_RATING", -- [1]
		},
		["Increases attack power"] = {
			"AP", -- [1]
		},
		["hit avoidance (melee)"] = {
			"MELEE_HIT_AVOID_RATING", -- [1]
		},
		["agility"] = {
			"AGI", -- [1]
		},
		["healing"] = {
			"HEAL", -- [1]
		},
		["improves spell critical avoidance"] = {
			"SPELL_CRIT_AVOID_RATING", -- [1]
		},
		["experience gained is increased%"] = false,
		["increases the damage done by shadow spells and effects"] = {
			"SHADOW_SPELL_DMG", -- [1]
		},
		["Increases your dodge"] = {
			"DODGE_RATING", -- [1]
		},
		["Increases spell penetration"] = {
			"SPELLPEN", -- [1]
		},
		["improves hit avoidance"] = {
			"MELEE_HIT_AVOID_RATING", -- [1]
			"RANGED_HIT_AVOID_RATING", -- [2]
			"SPELL_HIT_AVOID_RATING", -- [3]
		},
		["mastery"] = {
			"MASTERY_RATING", -- [1]
		},
		["Spell Damage and Healing"] = {
			"SPELL_DMG", -- [1]
			"HEAL", -- [2]
		},
		["Hit (Spell)"] = {
			"SPELL_HIT_RATING", -- [1]
		},
		["Increases the damage done by Shadow spells and effects"] = {
			"SHADOW_SPELL_DMG", -- [1]
		},
		["haste (ranged)"] = {
			"RANGED_HASTE_RATING", -- [1]
		},
		["nature spell damage"] = {
			"NATURE_SPELL_DMG", -- [1]
		},
		["defense"] = {
			"DEFENSE_RATING", -- [1]
		},
		["increases spell power"] = {
			"SPELL_DMG", -- [1]
			"HEAL", -- [2]
		},
		["Increases your healing"] = {
			"HEAL", -- [1]
		},
		["Haste"] = {
			"MELEE_HASTE_RATING", -- [1]
			"RANGED_HASTE_RATING", -- [2]
			"SPELL_HASTE_RATING", -- [3]
		},
		["Increases damage done by Arcane spells and effects"] = {
			"ARCANE_SPELL_DMG", -- [1]
		},
		["Hit Avoidance"] = {
			"MELEE_HIT_AVOID_RATING", -- [1]
			"RANGED_HIT_AVOID_RATING", -- [2]
			"SPELL_HIT_AVOID_RATING", -- [3]
		},
		["improves ranged critical avoidance"] = {
			"RANGED_CRIT_AVOID_RATING", -- [1]
		},
		["arcane resist"] = {
			"ARCANE_RES", -- [1]
		},
		["Increases damage done by Shadow spells and effects"] = {
			"SHADOW_SPELL_DMG", -- [1]
		},
		["hit"] = {
			"MELEE_HIT_RATING", -- [1]
			"RANGED_HIT_RATING", -- [2]
			"SPELL_HIT_RATING", -- [3]
		},
		["Fishing skill increased"] = {
			"FISHING", -- [1]
		},
		["increases your parry"] = {
			"PARRY_RATING", -- [1]
		},
		["increases your shield block"] = {
			"BLOCK_RATING", -- [1]
		},
		["fire resistance"] = {
			"FIRE_RES", -- [1]
		},
		["spell power"] = {
			"SPELL_DMG", -- [1]
			"HEAL", -- [2]
		},
		["Fire Spell Damage"] = {
			"FIRE_SPELL_DMG", -- [1]
		},
		["Improves spell critical strike"] = {
			"SPELL_CRIT_RATING", -- [1]
		},
		["Haste (Melee)"] = {
			"MELEE_HASTE_RATING", -- [1]
		},
		["Fire Resistance"] = {
			"FIRE_RES", -- [1]
		},
		["Increases damage done by Nature spells and effects"] = {
			"NATURE_SPELL_DMG", -- [1]
		},
		["Frost Spell Damage"] = {
			"FROST_SPELL_DMG", -- [1]
		},
		["Critical Strike Avoidance (Ranged)"] = {
			"RANGED_CRIT_AVOID_RATING", -- [1]
		},
		["hit (melee)"] = {
			"MELEE_HIT_RATING", -- [1]
		},
		["increases your dodge"] = {
			"DODGE_RATING", -- [1]
		},
		["increases spell penetration"] = {
			"SPELLPEN", -- [1]
		},
		["Damage per Second"] = {

			"DPS", -- [1]
		},
		["critical strike avoidance (melee)"] = {
			"MELEE_CRIT_AVOID_RATING", -- [1]
		},
		["sec"] = false,
		["increases attack powerwhen fighting undead"] = {
			"AP_UNDEAD", -- [1]
		},
		["increases attack powerwhen fighting demons"] = {
			"AP_DEMON", -- [1]
		},
		["increases damage and healing done by magical spells and effects of all party members within 30 yards"] = {
			"SPELL_DMG", -- [1]
			"HEAL", -- [2]
		},
		["Herbalism; does not need to be equipped"] = {
			"HERBALISM", -- [1]
		},
		["increases damage done by frost spells and effects"] = {
			"FROST_SPELL_DMG", -- [1]
		},
		["frost resist"] = {
			"FROST_RES", -- [1]
		},
		["Mana Regeneration"] = {
			"COMBAT_MANA_REGEN", -- [1]
		},
		["critical strike avoidance (spell)"] = {
			"SPELL_CRIT_AVOID_RATING", -- [1]
		},
		["Hit Avoidance (Ranged)"] = {
			"RANGED_HIT_AVOID_RATING", -- [1]
		},
		["Healing Spells"] = {
			"HEAL", -- [1]
		},
		["Frost Damage"] = {
			"FROST_SPELL_DMG", -- [1]
		},
		["arcane resistance"] = {
			"ARCANE_RES", -- [1]
		},
		["increases the damage done by holy spells and effects"] = {
			"HOLY_SPELL_DMG", -- [1]
		},
		["restores health per 5 sec"] = {
			"COMBAT_HEALTH_REGEN", -- [1]
		},
		["increases damage and healing done by magical spells and effects"] = {
			"SPELL_DMG", -- [1]
			"HEAL", -- [2]
		},
		["arcane spell damage"] = {
			"ARCANE_SPELL_DMG", -- [1]
		},
		["Improves melee haste"] = {
			"MELEE_HASTE_RATING", -- [1]
		},
		["improves melee hit avoidance"] = {
			"MELEE_HIT_AVOID_RATING", -- [1]
		},
		["herbalism"] = {
			"HERBALISM", -- [1]
		},
		["damage and healing spells"] = {
			"SPELL_DMG", -- [1]
			"HEAL", -- [2]
		},
		["Increases damage done to Undead and Demons by magical spells and effects"] = {
			"SPELL_DMG_UNDEAD", -- [1]
			"SPELL_DMG_DEMON", -- [2]
		},
		["increases healing donemagical spells and effects"] = {
			"HEAL", -- [1]
		},
		["Fishing"] = {
			"FISHING", -- [1]
		},
		["% shield block value"] = {
			"MOD_BLOCK_VALUE", -- [1]
		},
		["Strength"] = {
			"STR", -- [1]
		},
		["parry"] = {
			"PARRY_RATING", -- [1]
		},
		["nature resist"] = {
			"NATURE_RES", -- [1]
		},
		["Improves melee critical avoidance"] = {
			"MELEE_CRIT_AVOID_RATING", -- [1]
		},
		["armor"] = {
			"BONUS_ARMOR", -- [1]
		},
		["increases the damage done by nature spells and effects"] = {
			"NATURE_SPELL_DMG", -- [1]
		},
		["increases attack powerwhen fighting undead and demons"] = {
			"AP_UNDEAD", -- [1]
			"AP_DEMON", -- [2]
		},
		["health regeneration"] = {
			"COMBAT_HEALTH_REGEN", -- [1]
		},
		["healing and spell damage"] = {
			"SPELL_DMG", -- [1]
			"HEAL", -- [2]
		},
		["fishing"] = {
			"FISHING", -- [1]
		},
		["increases your effective stealth level"] = {
			"STEALTH_LEVEL", -- [1]
		},
		["Increases the damage done by Nature spells and effects"] = {
			"NATURE_SPELL_DMG", -- [1]
		},
		["spell penetration"] = {
			"SPELLPEN", -- [1]
		},
		["Holy Resistance"] = {
			"HOLY_RES", -- [1]
		},
		["Restores mana per 5 sec"] = {
			"COMBAT_MANA_REGEN", -- [1]
		},
		["Holy Spell Damage"] = {
			"HOLY_SPELL_DMG", -- [1]
		},
		["skinning"] = {
			"SKINNING", -- [1]
		},
		["fire damage"] = {
			"FIRE_SPELL_DMG", -- [1]
		},
		["Your attacks ignoreof your opponent's armor"] = {
			"IGNORE_ARMOR", -- [1]
		},
		["Increases healing done by magical spells and effects of all party members within 30 yards"] = {
			"HEAL", -- [1]
		},
		["increases damage done to undead and demons by magical spells and effects"] = {
			"SPELL_DMG_UNDEAD", -- [1]
			"SPELL_DMG_DEMON", -- [2]
		},
		["improves melee haste"] = {
			"MELEE_HASTE_RATING", -- [1]
		},
		["mana"] = {
			"MANA", -- [1]

		},

		["arcane damage"] = {
			"ARCANE_SPELL_DMG", -- [1]
		},
		["Shadow Damage"] = {
			"SHADOW_SPELL_DMG", -- [1]
		},
		["increases the holy damage of your judgments"] = false,
		["increases healing done by magical spells and effects of all party members within 30 yards"] = {
			"HEAL", -- [1]
		},
		["your attacks ignoreof your opponent's armor"] = {
			"IGNORE_ARMOR", -- [1]

		},
		["damage donefor all magical spells"] = {

			"SPELL_DMG", -- [1]
		},
		["Increases your effective stealth level"] = {
			"STEALTH_LEVEL", -- [1]
		},
		["Spell Healing"] = {
			"HEAL", -- [1]
		},
		["critical strike"] = {
			"MELEE_CRIT_RATING", -- [1]
			"RANGED_CRIT_RATING", -- [2]
			"SPELL_CRIT_RATING", -- [3]
		},
		["Critical Strike Avoidance (Melee)"] = {
			"MELEE_CRIT_AVOID_RATING", -- [1]
		},
		["Nature Resistance"] = {
			"NATURE_RES", -- [1]
		},
		["improves ranged hit avoidance"] = {
			"RANGED_HIT_AVOID_RATING", -- [1]
		},
		["hit avoidance"] = {
			"MELEE_HIT_AVOID_RATING", -- [1]
			"RANGED_HIT_AVOID_RATING", -- [2]
			"SPELL_HIT_AVOID_RATING", -- [3]
		},
		["increases the critical effect chance of your flash of light%"] = false,
		["armor penetration"] = {
			"ARMOR_PENETRATION_RATING", -- [1]
		},
		["Increases healing done"] = {
			"HEAL", -- [1]
		},
		["shadow damage"] = {
			"SHADOW_SPELL_DMG", -- [1]
		},
		["improves melee critical avoidance"] = {
			"MELEE_CRIT_AVOID_RATING", -- [1]
		},
		["Arcane Spell Damage"] = {
			"ARCANE_SPELL_DMG", -- [1]
		},
		["improves spell haste"] = {
			"SPELL_HASTE_RATING", -- [1]
		},
		["Improves melee critical strike"] = {
			"MELEE_CRIT_RATING", -- [1]
		},
		["Increases damage and healing done by magical spells and effects"] = {
			"SPELL_DMG", -- [1]
			"HEAL", -- [2]
		},
		["Increases damage done to Undead by magical spells and effects"] = {
			"SPELL_DMG_UNDEAD", -- [1]
		},
		["restores mana per 5 sec"] = {
			"COMBAT_MANA_REGEN", -- [1]
		},
		["healing spells"] = {
			"HEAL", -- [1]
		},
		["increases your armor penetration"] = {
			"ARMOR_PENETRATION_RATING", -- [1]
		},
		["haste (melee)"] = {
			"MELEE_HASTE_RATING", -- [1]
		},
		["spell damage and healing"] = {
			"SPELL_DMG", -- [1]
			"HEAL", -- [2]
		},
		["Arcane Resistance"] = {
			"ARCANE_RES", -- [1]
		},
		["Skinning; does not need to be equipped"] = {
			"SKINNING", -- [1]
		},
		["Increases attack powerwhen fighting Undead and Demons"] = {
			"AP_UNDEAD", -- [1]
			"AP_DEMON", -- [2]
		},
		["Increases attack powerin Cat, Bear, Dire Bear, and Moonkin forms only"] = {
			"FERAL_AP", -- [1]
		},
		["herbalism; does not need to be equipped"] = {
			"HERBALISM", -- [1]
		},
		["% Threat"] = {
			"MOD_THREAT", -- [1]
		},
		["Defense"] = {
			"DEFENSE_RATING", -- [1]
		},
		["Increases healing donemagical spells and effects"] = {
			"HEAL", -- [1]
		},
		["Experience gained from killing monsters and completing quests increased%"] = false,
		["increases damage done by fire spells and effects"] = {
			"FIRE_SPELL_DMG", -- [1]
		},
		["increases damage done by nature spells and effects"] = {
			"NATURE_SPELL_DMG", -- [1]
		},
		["Ranged Attack Power"] = {
			"RANGED_AP", -- [1]
		},
		["scope (damage)"] = {
			"RANGED_DMG", -- [1]
		},
		["increases the damage done by frost spells and effects"] = {
			"FROST_SPELL_DMG", -- [1]
		},
		["Shadow Resist"] = {
			"SHADOW_RES", -- [1]
		},
		["damage per second"] = {
			"DPS", -- [1]
		},
		["Increases the critical effect chance of your Flash of Light%"] = false,
		["improves ranged haste"] = {
			"RANGED_HASTE_RATING", -- [1]
		},
		["Increases attack powerwhen fighting Undead.  It also allows the acquisition of Scourgestones on behalf of the Argent Dawn"] = {
			"AP_UNDEAD", -- [1]
		},
		["PvP Power"] = {
			"PVP_POWER", -- [1]
		},
		["haste (spell)"] = {
			"SPELL_HASTE_RATING", -- [1]
		},
		["mining; does not need to be equipped"] = {
			"MINING", -- [1]
		},
		["Increases damage and healing done by magical spells and effects of all party members within 30 yards"] = {
			"SPELL_DMG", -- [1]
			"HEAL", -- [2]
		},
		["Spell Penetration"] = {
			"SPELLPEN", -- [1]

		},
		["Improves melee hit avoidance"] = {
			"MELEE_HIT_AVOID_RATING", -- [1]
		},
		["increases attack power"] = {
			"AP", -- [1]
		},
		["Increases defense"] = {
			"DEFENSE_RATING", -- [1]
		},
		["increases healing done"] = {
			"HEAL", -- [1]
		},
		["spirit"] = {
			"SPI", -- [1]
		},
		["Increases the damage done by Arcane spells and effects"] = {
			"ARCANE_SPELL_DMG", -- [1]
		},
		["improves spell critical strike"] = {
			"SPELL_CRIT_RATING", -- [1]
		},
		["PvP Resilience"] = {
			"RESILIENCE_RATING", -- [1]
		},
		["Damage and Healing Spells"] = {
			"SPELL_DMG", -- [1]
			"HEAL", -- [2]
		},
		["holy spell damage"] = {
			"HOLY_SPELL_DMG", -- [1]
		},
		["increases your critical strike"] = {
			"MELEE_CRIT_RATING", -- [1]
			"RANGED_CRIT_RATING", -- [2]
			"SPELL_CRIT_RATING", -- [3]
		},
		["healing Spells"] = {
			"HEAL", -- [1]
		},
		["Experience gained is increased%"] = false,
		["critical strike (spell)"] = {
			"SPELL_CRIT_RATING", -- [1]
		},
		["Increases Healing"] = {
			"HEAL", -- [1]
		},
		["Armor Penetration"] = {
			"ARMOR_PENETRATION_RATING", -- [1]
		},
		["arcane and fire spell power"] = {
			"ARCANE_SPELL_DMG", -- [1]
			"FIRE_SPELL_DMG", -- [2]
		},
		["Health Regeneration"] = {
			"COMBAT_HEALTH_REGEN", -- [1]
		},
		["all stats"] = {
			"STR", -- [1]
			"AGI", -- [2]
			"STA", -- [3]
			"INT", -- [4]
			"SPI", -- [5]
		},
		["Increases your hit"] = {
			"MELEE_HIT_RATING", -- [1]
			"RANGED_HIT_RATING", -- [2]
			"SPELL_HIT_RATING", -- [3]
		},
		["Critical Strike Avoidance (Spell)"] = {
			"SPELL_CRIT_AVOID_RATING", -- [1]
		},
		["strength"] = {
			"STR", -- [1]
		},
		["Parry"] = {
			"PARRY_RATING", -- [1]
		},
		["Increases the damage done by Holy spells and effects"] = {
			"HOLY_SPELL_DMG", -- [1]
		},
		["Restores health per 5 sec"] = {
			"COMBAT_HEALTH_REGEN", -- [1]
		},
		["Increases your shield block"] = {
			"BLOCK_RATING", -- [1]
		},
		["Hit"] = {
			"MELEE_HIT_RATING", -- [1]
			"RANGED_HIT_RATING", -- [2]
			"SPELL_HIT_RATING", -- [3]
		},
		["increases damage done by shadow spells and effects"] = {
			"SHADOW_SPELL_DMG", -- [1]

		},
		["All Resistances"] = {
			"ARCANE_RES", -- [1]
			"FIRE_RES", -- [2]
			"FROST_RES", -- [3]
			"NATURE_RES", -- [4]
			"SHADOW_RES", -- [5]
		},
		["frost spell damage"] = {
			"FROST_SPELL_DMG", -- [1]
		},
		["improves ranged hit"] = {
			"RANGED_HIT_RATING", -- [1]
		},
	},
}
]]